/*
 *  source code metrics counter
 *  Copyright (C) 2015  NEC Corporation.
 *  
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;

namespace CodeMetricsGui
{
    class CDMtrGuiPath
    {
        /// <summary>
        /// JgfBNg̎擾
        /// </summary>
        static public string CDMtrPathGetCurrentDirectory()
        {
            string strRetPath;
            strRetPath = "";

            try
            {
                strRetPath = System.IO.Directory.GetCurrentDirectory();
            }
            catch (Exception ex)
            {
                strRetPath = "";
                CDMtrGuiDebug.write(ex.ToString());
            }
            return strRetPath;
        }

        /// <summary>
        /// e|fBNg擾
        /// </summary>
        static public string CDMtrPathGetTempDirectory()
        {
            string strRetPath;
            strRetPath = "";

            try
            {
                strRetPath = System.IO.Path.GetTempPath();
            }
            catch (Exception ex)
            {
                strRetPath = "";
                CDMtrGuiDebug.write(ex.ToString());
            }
            return strRetPath;
        }

        /// <summary>
        /// t@CpXfBNg擾
        /// </summary>
        static public string CDMtrPathGetDirName(string strPath)
        {
            string strRetPath;
            strRetPath = "";

            if (CDMtrPathIsExistDir(strPath))
            {
                strRetPath = strPath;
            }
            else
            {
                try
                {
                    strRetPath = System.IO.Path.GetDirectoryName(strPath);
                }
                catch (Exception ex)
                {
                    strRetPath = "";
                    CDMtrGuiDebug.write(ex.ToString());
                }
            }

            return strRetPath;
        }

        /// <summary>
        /// pX
        /// </summary>
        static public string CDMtrPathCombine(string strPath1, string strPath2)
        {
            string strRetPath;
            strRetPath = System.IO.Path.Combine(strPath1, strPath2);
            return strRetPath;
        }

        /// <summary>
        /// t@CpXA_CAȎOIpX擾
        /// </summary>
        static public string CDMtrPathGetSelectDialog(string strTextBox)
        {
            string strSelectPath;
            strSelectPath = "";

            if (strTextBox != "")
            {
                strSelectPath = CDMtrPathGetDirName(strTextBox);
                if (strSelectPath == "")
                {
                    strSelectPath = CDMtrPathGetCurrentDirectory();
                }
            }
            else
            {
                strSelectPath = CDMtrPathGetCurrentDirectory();
            }

            return strSelectPath;
        }

        /// <summary>
        /// t@CpXƃXg{bNX_CAȎOIpX擾
        /// </summary>
        static public string CDMtrPathGetSelectDialog(String strTextBox, ListBox lbList)
        {
            string strSelectPath;

            if (strTextBox != "")
            {
                strSelectPath = CDMtrPathGetDirName(strTextBox);
                if (strSelectPath == "")
                {
                    strSelectPath = CDMtrPathGetCurrentDirectory();
                }
            }
            else
            {
                if (lbList.Items.Count > 0)
                {
                    strSelectPath = CDMtrPathGetDirName(lbList.Items[lbList.Items.Count - 1].ToString());
                    if (strSelectPath == "")
                    {
                        strSelectPath = CDMtrPathGetCurrentDirectory();
                    }
                }
                else
                {
                    strSelectPath = CDMtrPathGetCurrentDirectory();
                }
            }
            return strSelectPath;
        }

        /// <summary>
        /// fBNg݂邩
        /// </summary>
        static public bool CDMtrPathIsExistDir(string strPath)
        {
            return System.IO.Directory.Exists(strPath);
        }

        /// <summary>
        /// t@C݂邩
        /// </summary>
        static public bool CDMtrPathIsExistFile(string strPath)
        {
            return System.IO.File.Exists(strPath);
        }

    }
}
