/*
 *  source code metrics counter
 *  Copyright (C) 2015  NEC Corporation.
 *  
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;

namespace CodeMetricsGui
{
    class CDMtrGuiProp
    {

        private string strPropPath;

        private string strAppName;

        private const int BUFF_SIZE = 1024;

        /// <summary>
        /// RXgN^
        /// </summary>
        public CDMtrGuiProp(string strPropPath, string strAppName)
        {
            this.strPropPath = strPropPath;
            this.strAppName = strAppName;
        }

        /// <summary>
        /// API錾 ini̧ٓǍ݊֐錾
        /// </summary>
        [DllImport("kernel32.dll", EntryPoint = "GetPrivateProfileString")]
        private static extern uint GetPrivateProfileString(
              string lpApplicationName
            , string lpKeyName
            , string lpDefault
            , System.Text.StringBuilder StringBuilder
            , uint nSize
            , string lpFileName);

        /// <summary>
        /// API錾 iniُ̧݊֐錾
        /// </summary>
        [DllImport("kernel32.dll", EntryPoint = "WritePrivateProfileString")]
        private static extern uint WritePrivateProfileString(
              string lpApplicationName
            , string lpEntryName
            , string lpEntryString
            , string lpFileName);


        /// <summary>
        /// ݒt@C̑區ږݒ
        /// </summary>
        public void CDMtrPropSetAppName(string strAppName)
        {
            this.strAppName = strAppName;
            return;
        }

        /// <summary>
        /// t@C擾
        /// </summary>
        public string CDMtrPropReadValue(string strKeyName, string strDefault)
        {
			string strVal;
            uint iLength;

			strVal = strDefault;
            try
            {
                System.Text.StringBuilder sb = new System.Text.StringBuilder(BUFF_SIZE);
                if (sb != null)
                {
                    iLength = GetPrivateProfileString(this.strAppName, strKeyName, strDefault, sb, (uint)sb.Capacity, this.strPropPath);
                    strVal = sb.ToString();
                }
            }
            catch (Exception ex)
            {
                CDMtrGuiDebug.write(ex.ToString());
            }
            return strVal;

        }

        /// <summary>
        /// t@Cɏo͂
        /// </summary>
        public void CDMtrPropValue(string strKeyName, string strVal)
        {
            try
            {
                WritePrivateProfileString(this.strAppName, strKeyName, strVal, this.strPropPath);
            }
            catch (System.Security.SecurityException ex)
            {
                CDMtrGuiDebug.write(ex.ToString());
            }
            catch (System.Exception ex)
            {
                CDMtrGuiDebug.write(ex.ToString());
            }
            return;
        }

        /// <summary>
        /// ZNV(區)ׂč폜
        /// </summary>
        public void CDMtrPropDeleteSection(string strAppName){
            try
            {
                WritePrivateProfileString(strAppName, null, null, this.strPropPath);
            }
            catch(System.Security.SecurityException ex)
            {
                CDMtrGuiDebug.write(ex.ToString());
            }
            catch (System.Exception ex)
            {
                CDMtrGuiDebug.write(ex.ToString());
            }

            return;
        }

    }
}
