﻿/*
 *  source code metrics counter
 *  Copyright (C) 2015  NEC Corporation.
 *  
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

using System;
using System.Collections.Generic;
using System.Windows.Forms;
using System.Threading;
using System.Globalization;

namespace CodeMetricsGui
{
    static class Program
    {
        /// <summary>
        /// アプリケーションのメイン エントリ ポイントです。
        /// </summary>
        [STAThread]
        static void Main()
        {
            try
            {
                Application.EnableVisualStyles();
                Application.SetCompatibleTextRenderingDefault(false);

                if (CDMtrGui.CDMtrIsEnableExecute())
                {
                    Application.Run(new CDMtrGui());

                }
                else
                {
                    CDMtrGuiDialog.CDMtrDialogWarn(CodeMetricsGui.Properties.Resources.Program_01);
                }
            }
            catch (System.Security.SecurityException)
            {
                CDMtrGuiDialog.CDMtrDialogErr(CodeMetricsGui.Properties.Resources.Program_02);
            }
            catch (Exception ex)
            {
                CDMtrGuiDialog.CDMtrDialogErr(ex.Message);
            }
        }
    }
}