/*
 * ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Rhino code, released
 * May 6, 1999.
 *
 * The Initial Developer of the Original Code is
 * Netscape Communications Corporation.
 * Portions created by the Initial Developer are Copyright (C) 1997-1999
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *   Igor Bukanov, igor@fastmail.fm
 *   Norris Boyd,
 *   NEC Corporation.
 *
 * Alternatively, the contents of this file may be used under the terms of
 * the GNU General Public License Version 2 or later (the "GPL"), in which
 * case the provisions of the GPL are applicable instead of those above. If
 * you wish to allow use of your version of this file only under the terms of
 * the GPL and not to allow others to use your version of this file under the
 * MPL, indicate your decision by deleting the provisions above and replacing
 * them with the notice and other provisions required by the GPL. If you do
 * not delete the provisions above, a recipient may use your version of this
 * file under either the MPL or the GPL.
 *
 * ***** END LICENSE BLOCK ***** */

package com.nec.jp.ncmeter.struct;

/**
 * 行単位での構造メトリクス保持テーブル
 */
public class NCMMetricsTable {

    public static final int LINEDTL_STATUS_NORMAL = 0;

    public static final int LINEDTL_STATUS_ERROR = 1;

    public static final int LINEDTL_STATUS_ERROR_PARSE = 2;

    public static final int LINEDTL_NAMESPACE_DELIM_NONE = 0x00000000;

    public static final int LINEDTL_NAMESPACE_DELIM_START = 0x00000001;

    public static final int LINEDTL_NAMESPACE_DELIM_END = 0x00000002;

    public static final int LINEDTL_CLASS_DELIM_NONE = 0x00000000;

    public static final int LINEDTL_CLASS_DELIM_START = 0x00000001;

    public static final int LINEDTL_CLASS_DELIM_END = 0x00000002;

    public static final int LINEDTL_FUNC_DELIM_NONE = 0x00000000;

    public static final int LINEDTL_FUNC_DELIM_START = 0x00000001;

    public static final int LINEDTL_FUNC_DELIM_END = 0x00000002;

    public static final int LINEDTL_FUNC_LINE_IN = 1;

    public static final int LINEDTL_FUNC_LINE_OUT = 0;

    public static final int LINEDTL_EFFECTIVE_LINE = 1;

    public static final int LINEDTL_EFFECTIVE_NONE = 0;

    public static final int LINEDTL_COMMENT_LINE = 1;

    public static final int LINEDTL_COMMENT_BLOCK = 2;

    public static final int LINEDTL_COMMENT_NONE = 0;

    public static final int LINEDTL_BLANK_LINE = 1;

    public static final int LINEDTL_BLANK_NONE = 0;

    public static final int LINEDTL_ELOC_KIND_CODE = 1;

    public static final int LINEDTL_ELOC_KIND_PREP = 2;

    public static final int LINEDTL_ELOC_KIND_SKIP = 3;

    public static final int LINEDTL_ELOC_KIND_OTHER = 0;

    public static final int LINEDTL_PREP_NONE = 0;

    public static final int LINEDTL_PREP_CONST = 1;

    public static final int LINEDTL_PREP_EXTSOURCE = 2;

    public static final int LINEDTL_PREP_IF = 3;

    public static final int LINEDTL_PREP_REGION = 4;

    public static final int LINEDTL_PREP_EXTCHKSUM = 5;

    public static final int LINEDTL_PREP_OTHER = 6;

    public static final int LINEDTL_CLOC_KIND_NOMAL = 0x00000001;

    public static final int LINEDTL_CLOC_KIND_NONE = 0x00000000;

    public static final int LINEDTL_CONTINUATION_LINE = 1;

    public static final int LINEDTL_CONTINUATION_NONE = 0;

    public static final int LINEDTL_COMMENT_CONTINUATION_TRUE = 1;

    public static final int LINEDTL_COMMENT_CONTINUATION_NONE = 0;

    public int line_number;

    public int status;

    public int namespace_delim;

    public int class_delim;

    public int func_delim;

    public int func_id;

    public int func_line;

    public int effective_line;

    public int comment_line;

    public int blank_line;

    public int eloc_kind;

    public int prep_kind;

    public int cloc_kind;

    public int statements;

    public int control_statements;

    public int cyclowc;

    public int control_kind;

    public int branches;

    public int cndops;

    public int nest_level;

    public int line_continuation;

    public int comment_continuation;

    public int attibute_line;

    public int evals;

    public int evalr;

    public int avals;

    public int iStartOffset;

    public int iEndOffset;
}
