/*
 *  source code metrics counter
 *  Copyright (C) 2015  NEC Corporation.
 *  
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
#ifndef CDMTRCNTLANG_H_
#define CDMTRCNTLANG_H_

typedef struct tag_LANG_VALUE_TREE {
    struct tag_LANG_VALUE_TREE *next;
    _TCHAR *pcValue;
}
_LANG_VALUE_TREE;

typedef struct tag_LANG_INFO {
    int iLangType;
    _TCHAR *pcLangName;

    _LANG_VALUE_TREE *ptFileNames;


    _LANG_VALUE_TREE *ptFirstLineID;
} _LANG_INFO;

extern void CDMtrCntLangInitInfo(void);
extern int CDMtrCntLangRegDefault(void);
extern int CDMtrCntLangRegInfo(int iLangType, const _TCHAR *pcLangName, _TCHAR *pcFileNames);
extern int CDMtrCntLangExistRegName(const _TCHAR *pcLangName);
extern void CDMtrCntLangFreeInfo(void);
extern int CDMtrCntLangGetTypeFromLangName(const _TCHAR *pcLangName);
extern int CDMtrCntLangGetTypeFromFileName(int iExceptBinaryMode, const _TCHAR *pcFileName, _TCHAR **ppcLangName);

#endif
