/*
 *  source code metrics counter
 *  Copyright (C) 2015  NEC Corporation.
 *  
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
#include <stdlib.h>

#include <tchar.h>

#ifndef CDMTRCNTXREFDATA_H_
#define CDMTRCNTXREFDATA_H_

#define XREF_ID_LEN XREF_DIR_LEN + XREF_SEPARATOR + XREF_POSITION * 2 + 1
#define XREF_SEPARATOR 2
#define XREF_POSITION  7
#define XREF_NAME_LEN 1024
#define XREF_CATEGORY_LEN 20
#define XREF_DSPEC_LEN 20
#define XREF_TYPE_LEN 50

#define XREF_DIR_LEN 2048
#define XREF_FILE_LEN 2048

#define CSV_STRBUFF_SIZE 256

#define XREF_MODIFIED_LEN 20
#define XREF_VARIABLE_LEN 5

#define XREF_S_CATEGORY_TYPEDEF _T("typedef")
#define XREF_S_CATEGORY_NAMESPACE _T("namespace")
#define XREF_S_CATEGORY_CLASS _T("class")
#define XREF_S_CATEGORY_ENUM _T("enum")
#define XREF_S_CATEGORY_ENUMERATOR _T("enumerator")
#define XREF_S_CATEGORY_FUNCTION _T("function")
#define XREF_S_CATEGORY_VARIABLE _T("variable")

#define XREF_S_CATEGORY_FUNCTION_INITIAL _T('f')
#define XREF_S_CATEGORY_VARIABLE_INITIAL _T('v')

#define XREF_D_DSPEC_FRIEND _T("friend")
#define XREF_D_DSPEC_AUTO _T("auto")
#define XREF_D_DSPEC_REGISTER _T("register")
#define XREF_D_DSPEC_STATIC _T("static")
#define XREF_D_DSPEC_EXTERN _T("extern")
#define XREF_D_DSPEC_MUTABLE _T("mutable")
#define XREF_D_DSPEC_INLINE _T("inline")
#define XREF_D_DSPEC_VIRTUAL _T("virtual")
#define XREF_D_DSPEC_EXPLICIT _T("explicit")

#define XREF_D_DSPEC_STATIC_INITIAL _T('s')

#define XREF_A_CATEGORY_DECL _T("decl")
#define XREF_A_CATEGORY_DEFINITION _T("definition")

#define XREF_A_MODIFIED_MODIFIED _T("modified")
#define XREF_A_MODIFIED_MODIFIED_INITIAL _T('m')

#define XREF_VARIABLE_TYPE_P _T("P")
#define XREF_VARIABLE_TYPE_L _T("L")
#define XREF_VARIABLE_TYPE_G _T("G")
#define XREF_VARIABLE_TYPE_P_INITAL _T('P')
#define XREF_VARIABLE_TYPE_L_INITAL _T('L')
#define XREF_VARIABLE_TYPE_G_INITAL _T('G')

#define XREF_S_CATEGORY_VARIABLE_BIT	0x00
#define XREF_S_CATEGORY_FUNCTION_BIT	0x01
#define XREF_D_DSPEC_STATIC_BIT			0x02
#define XREF_A_CATEGORY_DECL_BIT		0x04
#define XREF_A_CATEGORY_DEFINITION_BIT	0x08
#define XREF_A_MODIFIED_MODIFIED_BIT	0x10
#define XREF_VARIABLE_TYPE_P_BIT		0x20
#define XREF_VARIABLE_TYPE_L_BIT		0x40
#define XREF_VARIABLE_TYPE_G_BIT		0x60
#define XREF_IS_POINTER_BIT				0x80



typedef struct xrefData {

    _TCHAR s_id[XREF_ID_LEN];

    _TCHAR s_name[XREF_NAME_LEN];

    _TCHAR s_category[XREF_CATEGORY_LEN];

    _TCHAR d_dspec[XREF_DSPEC_LEN];

    _TCHAR d_type[XREF_TYPE_LEN];

    _TCHAR a_category[XREF_CATEGORY_LEN];

    _TCHAR a_dir[XREF_DIR_LEN];

    _TCHAR a_file[XREF_FILE_LEN];

    _TCHAR a_id[XREF_ID_LEN];

    _TCHAR a_func[XREF_NAME_LEN];

    _TCHAR a_modified[XREF_MODIFIED_LEN];

    _TCHAR variable_type[XREF_VARIABLE_LEN];


    unsigned int s_id_hash;

    unsigned int s_name_hash;

    unsigned int a_id_hash;

    unsigned int a_func_hash;


    unsigned int bitFlag;

} xrefData;


#endif
