/*
 *  source code metrics counter
 *  Copyright (C) 2015  NEC Corporation.
 *  
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
#define _CRT_SECURE_NO_WARNINGS
#include <windows.h>
#include <stdio.h>
#include <string.h>
#include <tchar.h>

#include "CDMtrCmn.h"
#include "CDMtrExtCmn.h"
#include "CDMtrLibCmnW.h"
#include "CDMtrLibFileW.h"
#include "CDMtrLibUtilW.h"
#include "CDMtrLibSystemW.h"
#include "CDMtrCntMain.h"
#include "CDMtrCntLang.h"
#include "CDMtrCntFunc.h"
#include "CDMtrCntCallProc.h"
#include "CDMtrCntCK.h"
#include "CDMtrCntOutputCSV.h"
#include "CDMtrMessage.h"

/*----------------------------------------------------------------------------*/
/* static function declaration                                                */
/*----------------------------------------------------------------------------*/
static int cdmtrCntCKIsClassOrJarFile( _TCHAR *PathName );
static int cdmtrCntCKCreateClassPath(_FileList *pFileList, _TCHAR *pcListFileName, int iFileType, _FileTree **pptFileTree);
static void cdmtrCntCKFileTreeFree(_FileTree **pptFileTree);

/*----------------------------------------------------------------------------*/
/* global function                                                            */
/*----------------------------------------------------------------------------*/
/*!
    @brief      CKgNX𑪒肷
*/
int CDMtrCntCKDoCkProcess(_FileList *pcFileName, _FileList *pcOptFileName)
{
    int iRet = RET_NG;
    int iFuncRet;
    _TCHAR *pcCommand = NULL;
    _TCHAR *pcTempClassPath = NULL;
    _TCHAR *pcTempOptClassPath = NULL;
    _TCHAR *pcTemp5 = NULL;
    _TCHAR *pcErrOutFile = NULL;
    _TCHAR *pcOptionDebug = _T(" ");
    _TCHAR *pcOptionDebug2 = _T(" ");
    _FileTree *ptFileTree = NULL;
    _FileTree *ptTree = NULL;
    _FileTree *ptTreeNext = NULL;
    FILE *fp = NULL;
    int iExitCode = 0;
    _TCHAR *pcJavaExecStdOut = NULL;
    _TCHAR *pcJavaExecErrOut = NULL;
    if ((pcFileName == NULL) || (pcOptFileName == NULL)) {
        goto FUNC_END;
    }
    if (pcTempClassPath == NULL) {
        iFuncRet = CDMtrLibUtilCreateStringW(&pcTempClassPath, pcTempFolderName, FOLDER_SEPALATE, TEMP_FILE_CLASS_PATH, NULL);
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
    }
    iFuncRet = cdmtrCntCKCreateClassPath(pcFileName, pcTempClassPath, CK_TYPE_TARGET, &ptFileTree);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }
    if (pcTempOptClassPath == NULL) {
        iFuncRet = CDMtrLibUtilCreateStringW(&pcTempOptClassPath, pcTempFolderName, FOLDER_SEPALATE, TEMP_FILE_OPTCLASS_PATH, NULL);
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
    }
    iFuncRet = cdmtrCntCKCreateClassPath(pcOptFileName, pcTempOptClassPath, CK_TYPE_OPTION, NULL);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }
    if (iDebug == DEBUG_ON) {
        pcOptionDebug = STRUCT_OPTION_DEBUG;
    }
    if (iSpsDebug == DEBUG_ON) {
        pcOptionDebug2 = STRUCT_OPTION_DEBUG2;
    }
    iFuncRet = CDMtrLibUtilCreateStringW(&pcErrOutFile,
                                         pcTempFolderName,
                                         FOLDER_SEPALATE,
                                         TEMP_FILE_ERROUTPUT,
                                         NULL);
    iFuncRet = CDMtrLibUtilCreateStringW(&pcJavaExecStdOut,
                                         pcTempFolderName,
                                         FOLDER_SEPALATE,
                                         TEMP_FILE_JAVAEXE_STD,
                                         NULL);
    iFuncRet = CDMtrLibUtilCreateStringW(&pcJavaExecErrOut,
                                         pcTempFolderName,
                                         FOLDER_SEPALATE,
                                         TEMP_FILE_JAVAEXE_ERR,
                                         NULL);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }
    CDMtrLibUtilFreeW((void **)&pcTemp5);
    iFuncRet = CDMtrLibUtilCreateStringW(&pcTemp5, pcTempFolderName, FOLDER_SEPALATE, TEMP_FILE5, NULL);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }
    CDMtrLibUtilFreeW((void **)&pcCommand);
    if (iDebug == DEBUG_ON) {
        pcOptionDebug = STRUCT_OPTION_DEBUG;
    }
    if (iSpsDebug == DEBUG_ON) {
        pcOptionDebug2 = STRUCT_OPTION_DEBUG2;
        iFuncRet = CDMtrLibUtilCreateStringW(&pcCommand,
                                             pcCkJAVAPath,
                                             pcOptionDebug, pcOptionDebug2,
                                             _T(" --debug_output \""), pcTempFolderName,
                                             _T("\" --error_output \""), pcErrOutFile,
                                             _T("\" --metric_file \""), pcTemp5,
                                             _T("\" --opt_class \""), pcTempOptClassPath,
                                             _T("\" \""), pcTempClassPath, _T("\""),
                                             NULL);
    } else {
        iFuncRet = CDMtrLibUtilCreateStringW(&pcCommand,
                                             pcCkJAVAPath,
                                             pcOptionDebug,
                                             _T(" --error_output \""), pcErrOutFile,
                                             _T("\" --metric_file \""), pcTemp5,
                                             _T("\" --opt_class \""), pcTempOptClassPath,
                                             _T("\" \""), pcTempClassPath, _T("\""),
                                             NULL);
    }
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }
#ifdef _UNIT_TEST_CK_
    iFuncRet = CDMtrCntOutputCSVCkFileToOutFile("metric_file.csv");
#else
    iFuncRet = CDMtrCntCallCreateProcess(CK_JAVA, pcCommand, pcJavaExecStdOut, pcJavaExecErrOut, &iExitCode);
#endif
    if (iExitCode == 1) {
        CDMtrCntMainShowFile(pcJavaExecStdOut);
        CDMtrCntMainShowFile(pcJavaExecErrOut);
    }
    if (CDMtrLibFileIsFile(pcErrOutFile) == RET_TRUE) {
        CDMtrCntMainShowFile(pcErrOutFile);
    }
    if ((iFuncRet != RET_OK) || ((iNumOfFiles > 0) && ((fp = _tfopen(pcTemp5, _T("r"))) == NULL)))  {
        CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000160, pcCkJAVAPath); //* MSG_LOG_ID_C_00000160
        iFuncRet = CDMtrCntCallJavaVersion(pcJAVAExeVersion, pcErrOutFile);
        if (iFuncRet != RET_OK) {
            CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000273); //* MSG_LOG_ID_C_00000273
        } else {
            CDMtrCntMainShowFile(pcErrOutFile);
            goto FUNC_END;
        }
    } else {
        iRet = RET_OK;
    }
    if (iRet == RET_OK) {
#ifndef _UNIT_TEST_CK_
        iFuncRet = CDMtrCntOutputCSVCkFileToOutFile(pcTemp5);
        if (iFuncRet == RET_NG) {
            iRet = RET_NG;
            goto FUNC_END;
        }
#endif
    }
FUNC_END:
    if (iRet != RET_OK) {
        if (iNumOfFiles > 0) {
            ptTree = ptFileTree;
            while (ptTree != NULL) {
                ptTreeNext = ptTree->pNext;
                CDMtrCntOutputCSVErrFileToOutFile(ptTree->pFileName, ptTree->pLangName);
                ptTree = ptTreeNext;
            }
        }
    }
    if (fp != NULL) {
        fclose(fp);
    }
    CDMtrLibUtilFreeW((void **)&pcTemp5);
    CDMtrLibUtilFreeW((void **)&pcCommand);
    CDMtrLibUtilFreeW((void **)&pcErrOutFile);
    CDMtrLibUtilFreeW((void **)&pcTempClassPath);
    CDMtrLibUtilFreeW((void **)&pcTempOptClassPath);
    cdmtrCntCKFileTreeFree(&ptFileTree);
    CDMtrLibUtilFreeW((void **)&pcJavaExecStdOut);
    CDMtrLibUtilFreeW((void **)&pcJavaExecErrOut);
    return iRet;
}

/*----------------------------------------------------------------------------*/
/* static function                                                            */
/*----------------------------------------------------------------------------*/
/*!
    @brief      w肳ꂽt@CNXt@C܂JARt@Cł邩mF
*/
static int cdmtrCntCKIsClassOrJarFile( _TCHAR *PathName )
{
    _TCHAR *p = NULL;
    _TCHAR *tail = NULL;
    if (PathName == NULL) {
        return LANG_TYPE_UNKNOW;
    }
    tail = PathName + _tcslen(PathName);
    if (tail == NULL) {
        return LANG_TYPE_UNKNOW;
    }
    for (p = tail; p >= PathName; p--) {
        if ( _T('.') == *p ) {
            if (_tcsncmp(p + 1, _T("class"), 5) == 0)  {
                return LANG_TYPE_CLASS;
            } else if (_tcsncmp(p + 1, _T("jar"), 3) == 0) {
                return LANG_TYPE_JAR;
            }
        }
    }
    return LANG_TYPE_UNKNOW;
}

/*!
    @brief          NXt@CpXꗗ쐬
*/
static int cdmtrCntCKCreateClassPath(_FileList *pFileList, _TCHAR *pcListFileName, int iFileType, _FileTree **pptFileTree)
{
    int iRet = RET_NG;
    int iFuncRet;
    _TCHAR *pcLangName = NULL;
    _FileList *pSubFileList = NULL;
    int iLangType;
    int iClassOrJavaType;
    FILE *fp = NULL;
    int i, j;
    _FileTree dmyTree;
    _FileTree *ptFileTreeFirst = NULL;
    _FileTree *ptFileTree = NULL;
    _FileTree *ptFileTreeTmp = NULL;
    int iPathLen;
    const _TCHAR *pcFileNameLogOut = NULL;
    const _TCHAR *pcSubFileNameLogOut = NULL;
    char *cOutBuffer = NULL;
    if ((pFileList == NULL) || (pcListFileName == NULL)) {
        CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000161); //* MSG_LOG_ID_C_00000161
        goto FUNC_END;
    }
    ptFileTreeFirst = &dmyTree;
    ptFileTreeFirst->pNext = NULL;
    ptFileTreeTmp = ptFileTreeFirst;
    if ((fp = _tfopen(pcListFileName, _T("w"))) == NULL) {
        CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000162, pcListFileName); //* MSG_LOG_ID_C_00000162
        goto FUNC_END;
    }
    if (pFileList->count > 0) {
        if (iFileType == CK_TYPE_TARGET) {
            if (pptFileTree == NULL) {
                CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000163); //* MSG_LOG_ID_C_00000163
                goto FUNC_END;
            }
            *pptFileTree = NULL;
            if (iShowDetails == DETAILS_SHOW) {
                CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000274); //* MSG_LOG_ID_C_00000274
            }
        } else if (iFileType == CK_TYPE_OPTION) {
            if (iShowDetails == DETAILS_SHOW) {
                CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000275); //* MSG_LOG_ID_C_00000275
            }
        } else {
            CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000164); //* MSG_LOG_ID_C_00000164
            goto FUNC_END;
        }
    }
    for (i = 0; i < pFileList->count; i++) {
        iFuncRet = CDMtrLibFileGetFileList(pFileList->filename[i], &pSubFileList);
        pcFileNameLogOut = CDMtrLibFileRemoveLongPathMarkW(pFileList->filename[i]);
        if (iFuncRet != RET_OK) {
            CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000165, pcFileNameLogOut); //* MSG_LOG_ID_C_00000165
            goto FUNC_END;
        }
        if (pSubFileList->count == 0) {
            CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000166, pcFileNameLogOut); //* MSG_LOG_ID_C_00000166
        } else {
            for (j = 0; j < pSubFileList->count; j++) {
                pcSubFileNameLogOut = CDMtrLibFileRemoveLongPathMarkW(pSubFileList->filename[j]);
                if (iFileType == CK_TYPE_TARGET) {
                    iLangType = CDMtrCntLangGetTypeFromFileName(CDMTR_TRUE, pSubFileList->filename[j], &pcLangName);
                    if (iDebug == DEBUG_ON) {
                        CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000276, pcSubFileNameLogOut); //* MSG_LOG_ID_C_00000276
                        CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000277, pcLangName); //* MSG_LOG_ID_C_00000277
                        CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000278, iLangType); //* MSG_LOG_ID_C_00000278
                    }
                    iClassOrJavaType = cdmtrCntCKIsClassOrJarFile(pSubFileList->filename[j]);
                    if (((iLangType == LANG_TYPE_CLASS) && (iClassOrJavaType == LANG_TYPE_CLASS)) ||
                            ((iLangType == LANG_TYPE_JAR) && (iClassOrJavaType == LANG_TYPE_JAR))) {
                        cOutBuffer = CDMtrLibUtilConvertStringW(ENCODING_UTF_8, L"%s\n", pcSubFileNameLogOut);
                        if (cOutBuffer != NULL) {
                            fputs(cOutBuffer, fp);
                            CDMtrLibUtilFreeW((void **)&cOutBuffer);
                        }
                        if (iShowDetails == DETAILS_SHOW) {
                            CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000279, pcSubFileNameLogOut); //* MSG_LOG_ID_C_00000279
                        }
                        iNumOfFiles++;
                        ptFileTree = (_FileTree *)malloc(sizeof(_FileTree));
                        if (ptFileTree == NULL) {
                            goto FUNC_END;
                        }
                        memset(ptFileTree, 0x00, sizeof(_FileTree));
                        iPathLen = _tcslen(pSubFileList->filename[j]);
                        iFuncRet = CDMtrLibUtilMallocW((void **) & (ptFileTree->pFileName), (iPathLen + 1) * sizeof(_TCHAR));
                        if (iFuncRet != RET_OK ) {
                            goto FUNC_END;
                        }
                        _tcsncpy(ptFileTree->pFileName, pSubFileList->filename[j], iPathLen);
                        ptFileTree->pLangName = pcLangName;
                        pcLangName = NULL;
                        ptFileTree->pNext = NULL;
                        ptFileTreeTmp->pNext = ptFileTree;
                        ptFileTreeTmp = ptFileTree;
                    } else {
                        if (iShowDetails == DETAILS_SHOW) {
                            CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000280, pcSubFileNameLogOut); //* MSG_LOG_ID_C_00000280
                        }
                    }
                } else if (iFileType == CK_TYPE_OPTION) {
                    iClassOrJavaType = cdmtrCntCKIsClassOrJarFile(pSubFileList->filename[j]);
                    if (iClassOrJavaType == LANG_TYPE_CLASS || iClassOrJavaType == LANG_TYPE_JAR) {
                        cOutBuffer = CDMtrLibUtilConvertStringW(ENCODING_UTF_8, L"%s\n", pcSubFileNameLogOut);
                        if (cOutBuffer != NULL) {
                            fputs(cOutBuffer, fp);
                            CDMtrLibUtilFreeW((void **)&cOutBuffer);
                        }
                        if (iShowDetails == DETAILS_SHOW) {
                            CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000281, pcSubFileNameLogOut); //* MSG_LOG_ID_C_00000281
                        }
                    } else {
                        if (iShowDetails == DETAILS_SHOW) {
                            CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000282, pcSubFileNameLogOut); //* MSG_LOG_ID_C_00000282
                        }
                    }
                }
                if (pcLangName != NULL) {
                    CDMtrLibUtilFreeW((void **)&pcLangName);
                    pcLangName = NULL;
                }
            }
        }
        if (pSubFileList != NULL) {
            CDMtrLibFileFreeFileList(&pSubFileList);
            pSubFileList = NULL;
        }
    }
    iRet = RET_OK;
    if (pptFileTree != NULL) {
        *pptFileTree = ptFileTreeFirst->pNext;
    }
FUNC_END:
    if (iRet != RET_OK) {
        CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000167); //* MSG_LOG_ID_C_00000167
    }
    if (pSubFileList != NULL) {
        CDMtrLibFileFreeFileList(&pSubFileList);
        pSubFileList = NULL;
    }
    if (pcLangName != NULL) {
        CDMtrLibUtilFreeW((void **)&pcLangName);
    }
    if (fp != NULL) {
        fflush(fp);
        fclose(fp);
    }
    return iRet;
}

/*!
    @brief          t@Cc[̃
*/
static void cdmtrCntCKFileTreeFree(_FileTree **pptFileTree)
{
    _FileTree *ptTree = NULL;
    _FileTree *ptTreeNext = NULL;
    if (pptFileTree == NULL) {
        return;
    }
    ptTree = *pptFileTree;
    while (ptTree != NULL) {
        ptTreeNext = ptTree->pNext;
        CDMtrLibUtilFreeW((void **) & (ptTree->pFileName));
        CDMtrLibUtilFreeW((void **) & (ptTree->pLangName));
        CDMtrLibUtilFreeW((void **) & (ptTree));
        ptTree = ptTreeNext;
    }
    return;
}
