/*
 *  source code metrics counter
 *  Copyright (C) 2015  NEC Corporation.
 *  
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <windows.h>
#include <process.h>
#include <errno.h>
#include <direct.h>

#include "CDMtrCmn.h"
#include "CDMtrExtCmn.h"
#include "CDMtrLibCmnW.h"
#include "CDMtrLibFileW.h"
#include "CDMtrLibUtilW.h"
#include "CDMtrLibSystemW.h"
#include "CDMtrCntMain.h"
#include "CDMtrCntCallProc.h"
#include "CDMtrMessage.h"

/*----------------------------------------------------------------------------*/
/* static variable declaration                                                */
/*----------------------------------------------------------------------------*/
static int giChildProcessID = 0;
static HANDLE g_hSemaphore = NULL;

/*----------------------------------------------------------------------------*/
/* global function                                                            */
/*----------------------------------------------------------------------------*/
/*!
    @brief      VBp[TĂяo
*/
int CDMtrCntCallVBParser(_TCHAR *pcStructVBPath,
                         _TCHAR *pcOptionDebug,
                         _TCHAR *pcOptionDebug2,
                         _TCHAR *pcErrOutFile,
                         _TCHAR *pcTempFolderName,
                         _TCHAR *pcNkfFile,
                         _TCHAR *chSourceID)
{
    int iRet, iFuncRet;
    _TCHAR *pcCommand = NULL;
    iRet = RET_NG;
    iFuncRet = CDMtrLibUtilCreateStringW(&pcCommand,
                                         pcStructVBPath,
                                         pcOptionDebug, pcOptionDebug2,
                                         ((giStmtMode == CDMTR_TRUE) ? _T(" --stmt ") : _T("")),
                                         _T(" --e \""), pcErrOutFile,
                                         _T("\" --m \""), pcTempFolderName,
                                         _T("\" --t \""), pcNkfFile,
                                         _T("\" --n \""), chSourceID,
                                         _T("\""),
                                         NULL);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }
    iFuncRet = CDMtrCntCallCreateProcess(NULL, pcCommand, NULL, NULL, NULL);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }
    iRet = RET_OK;
FUNC_END:
    if (pcCommand != NULL) {
        CDMtrLibUtilFreeW((void **)&pcCommand);
    }
    return iRet;
}


/*!
    @brief      JSp[TĂяo
*/
int CDMtrCntCallJSParser(_TCHAR *pcStructJSPath,
                         _TCHAR *pcOptionDebug,
                         _TCHAR *pcOptionDebug2,
                         _TCHAR *pcErrOutFile,
                         _TCHAR *pcTempFolderName,
                         _TCHAR *pcTargetFile,
                         _TCHAR *chSourceID,
                         _TCHAR *pcOptionCharset,
                         _TCHAR *pcInputFile)
{
    int iRet, iFuncRet;
    _TCHAR *pcCommand = NULL;
    iRet = RET_NG;
    iFuncRet = CDMtrLibUtilCreateStringW(&pcCommand,
                                         pcStructJSPath,
                                         pcOptionDebug, pcOptionDebug2,
                                         _T(" --m \""), pcTempFolderName,
                                         _T("\" --n \""), chSourceID,
                                         _T("\" -version 170 "),
                                         pcOptionCharset,
                                         _T(" \""), pcInputFile,
                                         _T("\""), NULL);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }
    iFuncRet = CDMtrCntCallCreateProcess(NULL, pcCommand, NULL, pcErrOutFile, NULL);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }
    iRet = RET_OK;
FUNC_END:
    if (pcCommand != NULL) {
        CDMtrLibUtilFreeW((void **)&pcCommand);
    }
    return iRet;
}



/*!
    @brief      Javas̃o[W擾
*/
int CDMtrCntCallJavaVersion(_TCHAR *pcJavaExeVersion,
                            _TCHAR *pcErrOutFile)
{
    int iRet, iFuncRet;
    _TCHAR *pcCommand = NULL;
    iRet = RET_NG;
    iFuncRet = CDMtrLibUtilCreateStringW(&pcCommand,
                                         pcJavaExeVersion,
                                         NULL);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }
    iFuncRet = CDMtrCntCallCreateProcess(JAVA_VERSION_CMD, pcCommand, NULL, pcErrOutFile, NULL);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }
    iRet = RET_OK;
FUNC_END:
    if (pcCommand != NULL) {
        CDMtrLibUtilFreeW((void **)&pcCommand);
    }
    return iRet;
}


/*!
    @brief      w肳ꂽR}hs
*/
int CDMtrCntCallCreateProcess(_TCHAR *pcExe, _TCHAR *pcCommand, _TCHAR *pcFileName, _TCHAR *pcErrFile, int *piExitCode)
{
    int iRet = RET_NG;
    int iFuncRet = 0;
    PROCESS_INFORMATION pi;
    STARTUPINFO si;
    SECURITY_ATTRIBUTES sa;
    HANDLE hFile = NULL;
    HANDLE hErrFile = NULL;
    DWORD iExitCode = 0;
    const _TCHAR *pcFileNameLogOut = NULL;
    const _TCHAR *pcErrFileLogOut = NULL;
    pcFileNameLogOut = CDMtrLibFileRemoveLongPathMarkW(pcFileName);
    pcErrFileLogOut  = CDMtrLibFileRemoveLongPathMarkW(pcErrFile);
    if (iDebug == DEBUG_ON) {
        CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000011, pcCommand); //* MSG_LOG_ID_C_00000011
        CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000012, pcFileNameLogOut); //* MSG_LOG_ID_C_00000012
        CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000013, pcErrFileLogOut); //* MSG_LOG_ID_C_00000013
    }
    memset(&sa, 0, sizeof(SECURITY_ATTRIBUTES));
    sa.lpSecurityDescriptor = NULL;
    sa.nLength = sizeof(SECURITY_ATTRIBUTES);
    sa.bInheritHandle = TRUE;
    memset(&pi, 0, sizeof(PROCESS_INFORMATION));
    memset(&si, 0, sizeof(STARTUPINFO));
    si.cb = sizeof(STARTUPINFO);
    si.dwFlags = STARTF_USESTDHANDLES;
    WaitForSingleObject(g_hSemaphore, INFINITE);
    if (pcFileName != NULL) {
        hFile = CreateFile(pcFileName, GENERIC_WRITE, FILE_SHARE_READ, &sa, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
        if (hFile == NULL) {
            iRet = RET_NG;
            CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000001); //* MSG_LOG_ID_C_00000001
            goto FUNC_END;
        }
        si.hStdOutput = hFile;
    } else {
        si.hStdOutput = NULL;
    }
    if (pcErrFile != NULL) {
        hErrFile = CreateFile(pcErrFile, GENERIC_WRITE, FILE_SHARE_READ, &sa, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
        if (hErrFile == NULL) {
            iRet = RET_NG;
            CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000002); //* MSG_LOG_ID_C_00000002
            goto FUNC_END;
        }
        si.hStdError = hErrFile;
    } else {
        si.hStdError = NULL;
    }
    if ((giPerformance & PERFORMANCE_LVL6) > 0) {
        CDMtrLibCmnLogOut(_T("[PERF],%#x,0,CALL PROCESS <%s>,61,0\n"), PERFORMANCE_LVL6, pcExe); //* MSG_LOG_ID_C_00000014
    }
    MACRO_PERFORMANCE_PUTLOG(PERFORMANCE_LVL6, _T("CallProcess <S>,61,1")); //* MSG_LOG_ID_C_00000020
    iFuncRet = CreateProcess(NULL, pcCommand, NULL, NULL, TRUE, 0, NULL, NULL, &si, &pi);
    if (iFuncRet == 0) {
        CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000003, GetLastError()); //* MSG_LOG_ID_C_00000003
        goto FUNC_END;
    }
    giChildProcessID = pi.dwProcessId;
    WaitForSingleObject(pi.hProcess, INFINITE);
    iFuncRet = GetExitCodeProcess(pi.hProcess, &iExitCode);
    MACRO_PERFORMANCE_PUTLOG(PERFORMANCE_LVL6, _T("CallProcess <E>,61,2")); //* MSG_LOG_ID_C_00000021
    MACRO_MEMORY_PUTLOG(MEMORY_LVL1, pcExe, pcCommand, pi.hProcess, pi.dwProcessId);
    MACRO_MEMORY_PUTLOG(MEMORY_LVL1, DEFINE_MEMORY_NCMETER_NAME, _T(""), NULL, GetCurrentProcessId());
    CloseHandle(pi.hProcess);
    CloseHandle(pi.hThread);
    if (hFile != NULL) {
        CloseHandle(hFile);
        hFile = NULL;
    }
    if (hErrFile != NULL) {
        CloseHandle(hErrFile);
        hErrFile = NULL;
    }
    if (iFuncRet == 0) {
        CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000004, GetLastError()); //* MSG_LOG_ID_C_00000004
        goto FUNC_END;
    }
    if (iDebug == DEBUG_ON) {
        CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000015, iExitCode); //* MSG_LOG_ID_C_00000015
    }
    if (iExitCode == RET_OK) {
        iRet = RET_OK;
    } else {
        iRet = RET_NG;
        if (pcExe != NULL) {
            if (_tcscmp(pcExe, MACROANALIZER) == 0) {
                if (iExitCode == 2) {
                    iRet = RET_OK;
                }
            } else if (_tcscmp(pcExe, DIFF) == 0) {
                if (iExitCode == 1) {
                    iRet = RET_OK;
                }
            } else if (_tcscmp(pcExe, BEAUTIFIER) == 0) {
                if (iExitCode == 1) {
                    iRet = RET_OK;
                }
            }
        }
    }
FUNC_END:
    if (hFile != NULL) {
        CloseHandle(hFile);
    }
    if (hErrFile != NULL) {
        CloseHandle(hErrFile);
    }
    giChildProcessID = 0;
    if (piExitCode != NULL) {
        *piExitCode = iExitCode;
    }
    return iRet;
}

/*!
    @brief qvZX폜
*/
void CDMtrCntCallProcessKill()
{
    int iFuncRet = 0;
    g_hSemaphore = CreateSemaphore(NULL, 0, 1, NULL);
    if (giChildProcessID > 0) {
        HWND hHandle;
        hHandle = OpenProcess(PROCESS_TERMINATE, FALSE, giChildProcessID);
        if (hHandle != NULL) {
            iFuncRet = WaitForSingleObject(hHandle, 0);
            if (iFuncRet != WAIT_OBJECT_0) {
                if (TerminateProcess(hHandle, 0) != 0) {
                    if (iDebug == DEBUG_ON) {
                        CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000016, giChildProcessID); //* MSG_LOG_ID_C_00000016
                    }
                } else {
                    CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000017, giChildProcessID); //* MSG_LOG_ID_C_00000017
                }
            }
            WaitForSingleObject(hHandle, INFINITE);
            CloseHandle(hHandle);
        }
    }
    CloseHandle(g_hSemaphore);
    return ;
}
