/*
 *  source code metrics counter
 *  Copyright (C) 2015  NEC Corporation.
 *  
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <tchar.h>

#include <Windows.h>
#include <shlwapi.h>
#ifdef _MBCS
#include <mbstring.h>
#endif

#include "CDMtrCmn.h"
#include "CDMtrExtCmn.h"

#include "CDMtrLibCmnW.h"
#include "CDMtrLibUtilW.h"
#include "CDMtrLibFileW.h"
#include "CDMtrLibSystemW.h"

#include "CDMtrCntMain.h"
#include "CDMtrCntCallProc.h"
#include "CDMtrCntFunc.h"
#include "CDMtrCntLineCount.h"
#include "CDMtrCntLog.h"
#include "CDMtrMessage.h"


#define FUNC_DQ_LENGTH 2

extern int giDiffBlankFlg;
extern _TCHAR *pcDiffPath;
extern _TCHAR *pcTempFolderName;

int CDMtrCntFuncCreateFuncInfoFile(_FUNCINFOFILE_OPT *ptFuncOpt);
int CDMtrCntFuncCreateFuncList( _TCHAR *pcFilePath, _LINECOUNT_LIST *ptLineList);
int CDMtrCntFuncDoFuncMatching( _TCHAR *cpBaseFilePath, _TCHAR *cpDistFilePath, _LINECOUNT_LIST *ptBaseList, _LINECOUNT_LIST *ptDistList, _FUNC_MATCHING_LIST *ptFuncMatchingList, int *piFileDiffKind );
int CDMtrCntFuncSetDeleteDiffLineCount(_LINECOUNT_LIST *ptLinlist);
int CDMtrCntFuncSetAddDiffLineCount(_LINECOUNT_LIST *ptLinlist);
void CDMtrCntFuncFreeChain(_LINECOUNT_LIST *ptLineList);
void CDMtrCntFuncFreeChainMatchingList(_FUNC_MATCHING_LIST *ptList);


enum {
    FUNC_CSV_CONTINUE_TOKEN,
    FUNC_CSV_END_TOKEN,
    FUNC_CSV_END_LINE
};

enum {
    SPLIT_FUNC_DATA_ID,
    SPLIT_FUNC_DATA_START_INDEX,
    SPLIT_FUNC_DATA_END_INDEX,
    SPLIT_FUNC_DATA_FUNCNAME,
    SPLIT_FUNC_DATA_PARAM
};

/*!
    @brief          ֐rpt@Co
*/
int cdmtrCntFuncPutFuncFile(FILE *pfFile, long *plFileIndex, const long lStartLine, const long lEndLine, const _TCHAR *pcOutPath)
{
    FILE *pfOutfile = NULL;
    char cBuffer[BUFF_LINE_SIZE];
    int iRet = RET_NG;
    errno_t erno = 0;
    if (pfFile == NULL || pcOutPath == NULL) {
        CDMtrLibCmnTrcLogOut(MSG_LOG_ID_C_00000033, pcOutPath); //* MSG_LOG_ID_C_00000033
        goto FUNC_END;
    }
    if (lStartLine > lEndLine) {
        CDMtrLibCmnTrcLogOut(MSG_LOG_ID_C_00000034, pcOutPath); //* MSG_LOG_ID_C_00000034
        goto FUNC_END;
    }
    if (*plFileIndex > lStartLine) {
        if (fseek(pfFile, 0L, SEEK_SET) != 0) {
            CDMtrLibCmnTrcLogOut(MSG_LOG_ID_C_00000035, pcOutPath); //* MSG_LOG_ID_C_00000035
            goto FUNC_END;
        }
        (*plFileIndex) = 0;
    }
    memset(cBuffer, 0x00, sizeof(char)*BUFF_LINE_SIZE);
    MACRO_PERFORMANCE_PUTLOG(PERFORMANCE_LVL7, _T("OpenFile : [temp_lc_funcXXXX.tmp] <S>")); //* MSG_LOG_ID_C_00000044
    if ((erno = _tfopen_s(&pfOutfile, pcOutPath, _T("w"))) != 0) {
        CDMtrLibCmnTrcLogOut(MSG_LOG_ID_C_00000036, pcOutPath); //* MSG_LOG_ID_C_00000036
        goto FUNC_END;
    }
    MACRO_PERFORMANCE_PUTLOG(PERFORMANCE_LVL7, _T("OpenFile : [temp_lc_funcXXXX.tmp] <E>")); //* MSG_LOG_ID_C_00000045
    while (1) {
        if (fgets(cBuffer, BUFF_LINE_SIZE, pfFile) == NULL) {
            break;
        }
        (*plFileIndex)++;
        if (*plFileIndex < lStartLine) {
            continue ;
        }
        MACRO_PERFORMANCE_PUTLOG(PERFORMANCE_LVL7, _T("WriteFile(fputts) : [temp_lc_funcXXXX.tmp] <S>")); //* MSG_LOG_ID_C_00000046
        if (fputs(cBuffer, pfOutfile) < 0) {
            break;
        }
        MACRO_PERFORMANCE_PUTLOG(PERFORMANCE_LVL7, _T("WriteFile(fputts) : [temp_lc_funcXXXX.tmp] <E>")); //* MSG_LOG_ID_C_00000047
        if (*plFileIndex >= lEndLine) {
            iRet = RET_OK;
            break;
        }
    }
FUNC_END:
    MACRO_PERFORMANCE_PUTLOG(PERFORMANCE_LVL7, _T("CloseFile : [temp_lc_funcXXXX.tmp] <S>")); //* MSG_LOG_ID_C_00000048
    if (pfOutfile) {
        fclose(pfOutfile);
        pfOutfile = NULL;
    }
    MACRO_PERFORMANCE_PUTLOG(PERFORMANCE_LVL7, _T("CloseFile : [temp_lc_funcXXXX.tmp] <E>")); //* MSG_LOG_ID_C_00000049
    return iRet;
}

/*!
    @brief      CJEgXg̉
*/
void CDMtrCntFuncFreeChain(_LINECOUNT_LIST *ptLineList)
{
    _LINECOUNT_LIST *temp = NULL;
    do {
        if (ptLineList != NULL) {
            CDMtrLibUtilFreeW((void **)&ptLineList->tFuncData.pcName);
            CDMtrLibUtilFreeW((void **)&ptLineList->tFuncData.pcParam);
            CDMtrLibUtilFreeW((void **)&ptLineList->ptDiffData);
            temp = ptLineList->next;
            free(ptLineList);
        }
        ptLineList = temp;
    } while (temp != NULL);
}

/*!
    @brief      ֐}b`OXg̉
*/
void CDMtrCntFuncFreeChainMatchingList(_FUNC_MATCHING_LIST *ptList)
{
    _FUNC_MATCHING_LIST *temp = NULL;
    do {
        if (ptList != NULL) {
            temp = ptList->next;
            free(ptList);
        }
        ptList = temp;
    } while (temp != NULL);
}
/*!
    @brief          ֐t@CToken؂o
*/
static int cdmtrCntFuncGetNextCsvToken(
    _TCHAR    **cppTokenBuff,
    _TCHAR     *cpReadBuff,
    int         iReadKind,
    int        *ipCurrent,
    long       *lpTokenSize,
    int        *ipTokenRet)
{
    int iRet = RET_OK;
    int iStatus = FUNC_CSV_CONTINUE_TOKEN;
    int iStartPos = *ipCurrent;
    int iReadSize = 0;
    int iReadIndex = 0;
    int iLoopEnd = 0;
    long lBeforeTokenSize = *lpTokenSize;
    _TCHAR *temp = NULL;
    for (iReadIndex = *ipCurrent; iReadIndex < BUFF_LINE_LENGTH; iReadIndex++) {
        switch (cpReadBuff[iReadIndex]) {
        case _T('\n'):
            iStatus = FUNC_CSV_END_LINE;
            break;
        case _T('\0'):
            iLoopEnd = CDMTR_TRUE;
            break;
        case _T(','):
            if (iReadKind != SPLIT_FUNC_DATA_PARAM) {
                iStatus = FUNC_CSV_END_TOKEN;
                iReadIndex++;
                break;
            }
        default:
            (*lpTokenSize) = *lpTokenSize + 1;
            iReadSize++;
            continue;
        }
        if ((iLoopEnd == CDMTR_TRUE) || (iStatus != FUNC_CSV_CONTINUE_TOKEN)) {
            break;
        }
    }
    temp = (_TCHAR *)realloc((*cppTokenBuff), sizeof(_TCHAR) * (*lpTokenSize + 1));
    if (temp == NULL) {
        CDMtrLibUtilFreeW((void **)cppTokenBuff);
        iRet = RET_NG;
        goto FUNC_END;
    } else {
        *cppTokenBuff = temp;
    }
    _tcsncpy(&((*cppTokenBuff)[lBeforeTokenSize]), &cpReadBuff[iStartPos], iReadSize);
    (*cppTokenBuff)[*lpTokenSize] = _T('\0');
    if ( iStatus != FUNC_CSV_CONTINUE_TOKEN ) {
        *lpTokenSize = 0;
    }
    if ( (iStatus == FUNC_CSV_END_LINE) || (iStatus == FUNC_CSV_CONTINUE_TOKEN) ) {
        *ipCurrent = 0;
    } else {
        *ipCurrent = iReadIndex;
    }
    *ipTokenRet = iStatus;
FUNC_END:
    return iRet;
}

/*!
    @brief          ֐񃊃Xg̐
*/
int CDMtrCntFuncCreateFuncList(
    _TCHAR *pcFilePath,
    _LINECOUNT_LIST *ptLineList)
{
    int iRet;
    long lTokenSize, lLength;
    int iReadKind, iCurrent, iTokenRet;
    TCHAR *cpTokenData;
    _TCHAR cpReadBuff[BUFF_LINE_LENGTH];
    _LINECOUNT_LIST *ptCurrentList, *ptNewList, *ptPreList;
    FILE   *fpReadFile;
    if ( ( pcFilePath == NULL ) ||
            ( ptLineList == NULL ) ) {
        return RET_NG;
    }
    iRet = RET_OK;
    fpReadFile = NULL;
    ptCurrentList = ptNewList = ptPreList = NULL;
    iReadKind = SPLIT_FUNC_DATA_ID;
    iTokenRet = FUNC_CSV_END_LINE;
    lTokenSize = 0;
    lLength = 0;
    iCurrent = 0;
    cpTokenData = NULL;
    MACRO_PERFORMANCE_PUTLOG(PERFORMANCE_LVL7, _T("OpenFile : [temp_funclist_XXXX.tmp] <S>")); //* MSG_LOG_ID_C_00000050
    if ((fpReadFile = _tfopen(pcFilePath, _T("r, ccs=UTF-8"))) == NULL) {
        CDMtrLibCmnTrcLogOut(MSG_LOG_ID_C_00000037, pcFilePath); //* MSG_LOG_ID_C_00000037
        iRet = RET_NG;
        goto FUNC_END;
    }
    MACRO_PERFORMANCE_PUTLOG(PERFORMANCE_LVL7, _T("OpenFile : [temp_funclist_XXXX.tmp] <E>")); //* MSG_LOG_ID_C_00000051
    ptCurrentList = ptLineList;
    ptPreList = ptCurrentList;
    while ( 1 ) {
        if ( (iTokenRet == FUNC_CSV_CONTINUE_TOKEN) || (iTokenRet == FUNC_CSV_END_LINE) ) {
            if ( _fgetts(cpReadBuff, (int)BUFF_LINE_LENGTH, fpReadFile) == NULL) {
                if ( feof(fpReadFile) == 0 ) {
                    iRet = RET_NG;
                } else {
                    if (iReadKind == SPLIT_FUNC_DATA_PARAM) {
                        lLength = _tcslen(cpTokenData);
                        if ( lLength > FUNC_DQ_LENGTH) {
                            lLength = lLength - FUNC_DQ_LENGTH + 1;
                            ptCurrentList->tFuncData.pcParam = (_TCHAR *)malloc(lLength * sizeof(_TCHAR));
                            if (ptCurrentList->tFuncData.pcParam == NULL) {
                                iRet = RET_NG;
                                goto FUNC_END;
                            }
                            _tcsncpy(ptCurrentList->tFuncData.pcParam, &cpTokenData[1], (lLength - 1));
                            ptCurrentList->tFuncData.pcParam[lLength - 1] = _T('\0');
                        }
                    } else if (iReadKind != SPLIT_FUNC_DATA_ID) {
                        iRet = RET_NG;
                    }
                }
                goto FUNC_END;
            }
        }
        iRet = cdmtrCntFuncGetNextCsvToken(&cpTokenData, cpReadBuff, iReadKind, &iCurrent, &lTokenSize, &iTokenRet);
        if (iRet == RET_NG) {
            goto FUNC_END;
        }
        switch ( iTokenRet ) {
        case  FUNC_CSV_CONTINUE_TOKEN:
            break;
        case  FUNC_CSV_END_TOKEN:
            switch (iReadKind) {
            case SPLIT_FUNC_DATA_ID:
                if ( ( ptCurrentList->tFuncData.lID = _ttol(cpTokenData) ) <= 0 ) {
                    iRet = RET_NG;
                    goto FUNC_END;
                }
                break;
            case SPLIT_FUNC_DATA_START_INDEX:
                if ( ( ptCurrentList->tFuncData.lStart = _ttol(cpTokenData) ) <= 0 ) {
                    iRet = RET_NG;
                    goto FUNC_END;
                }
                break;
            case SPLIT_FUNC_DATA_END_INDEX:
                if ( ( ptCurrentList->tFuncData.lEnd = _ttol(cpTokenData) ) <= 0 ) {
                    iRet = RET_NG;
                    goto FUNC_END;
                }
                break;
            case SPLIT_FUNC_DATA_FUNCNAME:
                lLength = _tcslen(cpTokenData);
                if ( lLength > FUNC_DQ_LENGTH) {
                    ptCurrentList->tFuncData.lNameLen = lLength - FUNC_DQ_LENGTH;
                    lLength = ptCurrentList->tFuncData.lNameLen + 1;
                    ptCurrentList->tFuncData.pcName = (_TCHAR *)malloc(lLength * sizeof(_TCHAR));
                    if (ptCurrentList->tFuncData.pcName == NULL) {
                        iRet = RET_NG;
                        goto FUNC_END;
                    }
                    _tcsncpy(ptCurrentList->tFuncData.pcName, &cpTokenData[1], lLength - 1);
                    ptCurrentList->tFuncData.pcName[lLength - 1] = _T('\0');
                } else {
                    CDMtrLibCmnTrcLogOut(MSG_LOG_ID_C_00000038); //* MSG_LOG_ID_C_00000038
                    iRet = RET_NG;
                    goto FUNC_END;
                }
                break;
            case SPLIT_FUNC_DATA_PARAM:
            default:
                iRet = RET_NG;
                goto FUNC_END;
                break;
            }
            iReadKind++;
            break;
        case  FUNC_CSV_END_LINE:
            if ( iReadKind == SPLIT_FUNC_DATA_PARAM) {
                lLength = _tcslen(cpTokenData);
                if ( lLength > FUNC_DQ_LENGTH) {
                    lLength = lLength - FUNC_DQ_LENGTH + 1;
                    ptCurrentList->tFuncData.pcParam = (_TCHAR *)malloc(lLength * sizeof(_TCHAR));
                    if (ptCurrentList->tFuncData.pcParam == NULL) {
                        iRet = RET_NG;
                        goto FUNC_END;
                    }
                    _tcsncpy(ptCurrentList->tFuncData.pcParam, &cpTokenData[1], lLength - 1);
                    ptCurrentList->tFuncData.pcParam[lLength - 1] = _T('\0');
                }
            } else {
                iRet = RET_NG;
                goto FUNC_END;
            }
            iReadKind = SPLIT_FUNC_DATA_ID;
            ptNewList = ( _LINECOUNT_LIST *)malloc( sizeof(_LINECOUNT_LIST) );
            if (ptNewList == NULL) {
                iRet = RET_NG;
                goto FUNC_END;
            }
            memset(ptNewList, 0x00, sizeof(_LINECOUNT_LIST));
            ptCurrentList->next = ptNewList;
            ptPreList = ptCurrentList;
            ptCurrentList = ptNewList;
            break;
        default:
            iRet = RET_NG;
            goto FUNC_END;
            break;
        }
    }
FUNC_END:
    if ( fpReadFile != NULL ) {
        fclose(fpReadFile);
    }
    CDMtrLibUtilFreeW((void **)&cpTokenData);
    if (iRet == RET_NG) {
        CDMtrCntFuncFreeChain(ptLineList->next);
        ptLineList->next = NULL;
    } else {
        if ( ptLineList != ptCurrentList ) {
            if ( ptCurrentList->tFuncData.lID == 0) {
                CDMtrCntFuncFreeChain(ptCurrentList);
                ptPreList->next = NULL;
            }
        }
    }
    return iRet;
}


/*!
    @brief      ֐t@C
*/
int CDMtrCntFuncCreateFuncInfoFile(_FUNCINFOFILE_OPT *ptFuncOpt)
{
    _TCHAR *pcCommand;
    _TCHAR *pcDirPath, *pcFName;
    int uiLenName;
    int iRet = RET_OK;
    pcCommand = NULL;
    pcDirPath = NULL;
    pcFName = NULL;
    uiLenName = _tcslen(ptFuncOpt->pcLogoutFilePath);
    iRet = CDMtrLibUtilMallocW((void **)&pcDirPath, (uiLenName + 1) * sizeof(_TCHAR));
    if (iRet != RET_OK) {
        goto FUNC_END;
    }
    iRet = CDMtrLibFileGetDirName(ptFuncOpt->pcLogoutFilePath, pcDirPath);
    if (iRet != RET_OK) {
        goto FUNC_END;
    }
    uiLenName = _tcslen(ptFuncOpt->pcLogoutFilePath);
    iRet = CDMtrLibUtilMallocW((void **)&pcFName, (uiLenName + 1) * sizeof(_TCHAR));
    if (iRet != RET_OK) {
        goto FUNC_END;
    }
    iRet = CDMtrLibFileGetFileName(ptFuncOpt->pcLogoutFilePath, pcFName);
    if (iRet != RET_OK) {
        goto FUNC_END;
    }
    CDMtrLibUtilFreeW((void **)&pcCommand);
    iRet = CDMtrLibUtilCreateStringW(&pcCommand,
                                     ptFuncOpt->pcStructExePath,
                                     ptFuncOpt->pcOptDebug2,
                                     _T(" --out_format \""), ptFuncOpt->pcOptOutFormat,
                                     _T("\" --lang_name \""), ptFuncOpt->pcOptLangName,
                                     _T("\" --lang_type \""), ptFuncOpt->pcOptLangType,
                                     _T("\" --file_path \""), pcDirPath,
                                     _T("\" --file_name \""), pcFName,
                                     _T("\" --metric_file \""), ptFuncOpt->pcOutputPath,
                                     _T("\" --metric_skip \""), ptFuncOpt->pcOptMetricSkip,
                                     _T("\" --error_output \""), ptFuncOpt->pcErrPath,
                                     _T("\" --func_opt \""), ptFuncOpt->pcOptFuncOpt,
                                     _T("\" --qrt_flg \""), ptFuncOpt->pcOptQrtFlg,
                                     _T("\" \""),
                                     ptFuncOpt->pcFilePath,
                                     _T("\""),
                                     NULL);
    if ( iRet == RET_NG ) {
        CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000029); //* MSG_LOG_ID_C_00000029
        goto FUNC_END;
    }
    iRet = CDMtrCntCallCreateProcess(STRUCT_SMP, pcCommand, NULL, NULL, NULL);
    if (iRet == RET_NG) {
        CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000030, ptFuncOpt->pcStructExePath); //* MSG_LOG_ID_C_00000030
        goto FUNC_END;
    }
FUNC_END:
    CDMtrLibUtilFreeW((void **)&pcCommand);
    CDMtrLibUtilFreeW((void **)&pcDirPath);
    CDMtrLibUtilFreeW((void **)&pcFName);
    return iRet;
}


/*!
    @brief          ǉ֐̍CJEgݒ肷
*/
int CDMtrCntFuncSetAddDiffLineCount(_LINECOUNT_LIST *ptLinlist)
{
    if ( ptLinlist->ptDiffData == NULL) {
        ptLinlist->ptDiffData = (_DIFFLINES *)malloc(sizeof(_DIFFLINES));
        if ( ptLinlist->ptDiffData == NULL) {
            CDMtrLibCmnTrcLogOut(MSG_LOG_ID_C_00000039); //* MSG_LOG_ID_C_00000039
            return RET_NG;
        }
        memset(ptLinlist->ptDiffData, 0x00, sizeof(_DIFFLINES));
    }
    if ( !giDiffBlankFlg ) {
        ptLinlist->ptDiffData->tDiffTotal.ulAdd = ptLinlist->tLCData.ulTLOC - ptLinlist->tLCData.ulBlank;
        ptLinlist->ptDiffData->tDiffEloc.ulAdd = ptLinlist->tLCData.ulELOC;
        ptLinlist->ptDiffData->tDiffCloc.ulAdd = ptLinlist->tLCData.ulCLOC;
        ptLinlist->ptDiffData->tDiffBloc.ulAdd = 0;
        ptLinlist->ptDiffData->tDiffSkip.ulAdd = ptLinlist->tLCData.ulUndef;
    } else {
        ptLinlist->ptDiffData->tDiffTotal.ulAdd = ptLinlist->tLCData.ulTLOC;
        ptLinlist->ptDiffData->tDiffEloc.ulAdd = ptLinlist->tLCData.ulELOC;
        ptLinlist->ptDiffData->tDiffCloc.ulAdd = ptLinlist->tLCData.ulCLOC;
        ptLinlist->ptDiffData->tDiffBloc.ulAdd = ptLinlist->tLCData.ulBlank;
        ptLinlist->ptDiffData->tDiffSkip.ulAdd = ptLinlist->tLCData.ulUndef;
    }
    return RET_OK;
}
/*!
    @brief          폜֐̍CJEgݒ肷
*/
int CDMtrCntFuncSetDeleteDiffLineCount(_LINECOUNT_LIST *ptLinlist)
{
    if ( ptLinlist->ptDiffData == NULL) {
        ptLinlist->ptDiffData = (_DIFFLINES *)malloc(sizeof(_DIFFLINES));
        if ( ptLinlist->ptDiffData == NULL) {
            return RET_NG;
        }
        memset(ptLinlist->ptDiffData, 0x00, sizeof(_DIFFLINES));
    }
    if ( !giDiffBlankFlg ) {
        ptLinlist->ptDiffData->tDiffTotal.ulDel = ptLinlist->tLCData.ulTLOC - ptLinlist->tLCData.ulBlank;
        ptLinlist->ptDiffData->tDiffEloc.ulDel = ptLinlist->tLCData.ulELOC;
        ptLinlist->ptDiffData->tDiffCloc.ulDel = ptLinlist->tLCData.ulCLOC;
        ptLinlist->ptDiffData->tDiffBloc.ulDel = 0;
        ptLinlist->ptDiffData->tDiffSkip.ulDel = ptLinlist->tLCData.ulUndef;
    } else {
        ptLinlist->ptDiffData->tDiffTotal.ulDel = ptLinlist->tLCData.ulTLOC;
        ptLinlist->ptDiffData->tDiffEloc.ulDel = ptLinlist->tLCData.ulELOC;
        ptLinlist->ptDiffData->tDiffCloc.ulDel = ptLinlist->tLCData.ulCLOC;
        ptLinlist->ptDiffData->tDiffBloc.ulDel = ptLinlist->tLCData.ulBlank;
        ptLinlist->ptDiffData->tDiffSkip.ulDel = ptLinlist->tLCData.ulUndef;
    }
    return RET_OK;
}


/*!
    @brief          ֐̍rs
*/
static int cdmtrCntFuncCompareFunc(
    _FILE_STATUS           *ptFileStatus,
    _TCHAR                 *cpBaseOutFilePath,
    _TCHAR                 *cpDistOutFilePath,
    _LINECOUNT_LIST        *ptBaseList,
    _LINECOUNT_LIST        *ptDistList,
    int                    *ipDiffCheck )

{
    int iRet = RET_OK;
    _TCHAR *pcCommand, *pcTempDiffStdOut, *pcTempErrOut;
    MACRO_PERFORMANCE_PUTLOG(PERFORMANCE_LVL4, _T("CompareFuncs,42,1")); //* MSG_LOG_ID_C_00000052
    iRet = cdmtrCntFuncPutFuncFile( ptFileStatus->fpBase, &(ptFileStatus->lBaseFileIndex),
                                    ptBaseList->tFuncData.lStart, ptBaseList->tFuncData.lEnd,  cpBaseOutFilePath );
    if ( iRet != RET_OK ) {
        return iRet;
    }
    MACRO_PERFORMANCE_PUTLOG(PERFORMANCE_LVL4, _T("Created ComparingFile [old],42,2")); //* MSG_LOG_ID_C_00000053
    iRet = cdmtrCntFuncPutFuncFile( ptFileStatus->fpDist, &(ptFileStatus->lDistFileIndex),
                                    ptDistList->tFuncData.lStart, ptDistList->tFuncData.lEnd, cpDistOutFilePath);
    if ( iRet != RET_OK) {
        return iRet;
    }
    MACRO_PERFORMANCE_PUTLOG(PERFORMANCE_LVL4, _T("Created ComparingFile [new],42,3")); //* MSG_LOG_ID_C_00000054
    pcCommand = NULL;
    pcTempDiffStdOut = NULL;
    pcTempErrOut = NULL;
    iRet = CDMtrLibFileSetDirFileName(pcTempFolderName, TEMP_FILE_DIFFRET, &pcTempDiffStdOut);
    if (iRet != RET_OK) {
        goto FUNC_END;
    }
    iRet = CDMtrLibFileSetDirFileName(pcTempFolderName, TEMP_FILE_ERROUTPUT, &pcTempErrOut);
    if (iRet != RET_OK) {
        goto FUNC_END;
    }
    if (!giDiffBlankFlg) {
        iRet = CDMtrLibUtilCreateStringW(&pcCommand,
                                         pcDiffPath, _T(" -b \""), cpBaseOutFilePath, _T("\" \""), cpDistOutFilePath, _T("\""), NULL);
    } else {
        iRet = CDMtrLibUtilCreateStringW(&pcCommand,
                                         pcDiffPath, _T(" \""), cpBaseOutFilePath, _T("\" \""), cpDistOutFilePath, _T("\""), NULL);
    }
    if (iRet != RET_OK) {
        CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000031); //* MSG_LOG_ID_C_00000031
        goto FUNC_END;
    }
    iRet = CDMtrCntCallCreateProcess(DIFF, pcCommand, pcTempDiffStdOut, pcTempErrOut, NULL);
    MACRO_PERFORMANCE_PUTLOG(PERFORMANCE_LVL4, _T("Called diff.exe (FUNC),42,4")); //* MSG_LOG_ID_C_00000055
    if (iRet != RET_OK) {
        if (iDebug == DEBUG_ON) {
            CDMtrCntLogLogOutErrExec(pcTempErrOut);
        }
        CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000032, pcDiffPath); //* MSG_LOG_ID_C_00000032
        goto FUNC_END;
    }
    if (ptDistList->ptDiffData == NULL) {
        ptDistList->ptDiffData = (_DIFFLINES *)malloc(sizeof(_DIFFLINES));
        if (ptDistList->ptDiffData == NULL) {
            iRet = RET_NG;
            goto FUNC_END;
        }
        memset(ptDistList->ptDiffData, 0x00, sizeof(_DIFFLINES));
    }
    iRet = CDMtrCntLineCountDiffFileCheck(pcTempDiffStdOut, &(ptDistList->tLCData), ptDistList->ptDiffData);
    if (iRet != RET_OK) {
        goto FUNC_END;
    }
    if ( ptDistList->ptDiffData->tDiffTotal.ulAdd == 0 && ptDistList->ptDiffData->tDiffTotal.ulDel == 0 &&
            ptDistList->ptDiffData->tDiffTotal.ulModAdd == 0 && ptDistList->ptDiffData->tDiffTotal.ulModDel == 0) {
        *ipDiffCheck = CDMTR_FALSE;
    } else {
        *ipDiffCheck = CDMTR_TRUE;
    }
FUNC_END:
    CDMtrLibUtilFreeW((void **)&pcCommand);
    CDMtrLibUtilFreeW((void **)&pcTempDiffStdOut);
    CDMtrLibUtilFreeW((void **)&pcTempErrOut);
    MACRO_PERFORMANCE_PUTLOG(PERFORMANCE_LVL4, _T("Added MatchingList (MOD/EQU Func),42,5")); //* MSG_LOG_ID_C_00000056
    return iRet;
}

/*!
    @brief          ֐}b`O̐
*/
static int cdmtrCntFuncCreateMatchingData(
    int iFunckind,
    _LINECOUNT_LIST        *ptBaseList,
    _LINECOUNT_LIST        *ptDistList,
    _FUNC_MATCHING_LIST    *ptFuncMatchingList)
{
    _FUNC_MATCHING_LIST *temp;
    temp = ( _FUNC_MATCHING_LIST *)malloc( sizeof(_FUNC_MATCHING_LIST) );
    if (temp == NULL) {
        CDMtrLibCmnTrcLogOut(MSG_LOG_ID_C_00000040); //* MSG_LOG_ID_C_00000040
        return RET_NG;
    }
    temp->iFlg = FUNC_NONE;
    temp->ptBaseList = NULL;
    temp->ptDistList = NULL;
    temp->next = NULL;
    ptFuncMatchingList->next = temp;
    ptFuncMatchingList->ptBaseList = ptBaseList;
    ptFuncMatchingList->ptDistList = ptDistList;
    ptFuncMatchingList->iFlg = iFunckind;
    return RET_OK;
}

/*!
    @brief          ֐}b`ÕXgւ̓o^s
*/
static int cdmtrCntFuncAddMatchingList(
    int                     iFunckind,
    _LINECOUNT_LIST        *ptBaseList,
    _LINECOUNT_LIST        *ptDistList,
    _FUNC_MATCHING_LIST    *ptFuncMatchingList,
    _FILE_STATUS           *ptFileStatus,
    _TCHAR                 *cpBaseOutFilePath,
    _TCHAR                 *cpDistOutFilePath)
{
    int iRet = RET_OK;
    int iFlg = FUNC_NONE;
    int iDiffCheck = CDMTR_FALSE;
    switch ( iFunckind ) {
    case FUNC_NONE:
        ptFuncMatchingList->ptBaseList = ptBaseList;
        ptFuncMatchingList->ptDistList = ptDistList;
        ptFuncMatchingList->iFlg = iFunckind;
        ptFuncMatchingList->ptDistList->ptDiffData = (_DIFFLINES *)malloc(sizeof(_DIFFLINES));
        if ( ptFuncMatchingList->ptDistList->ptDiffData == NULL) {
            return RET_NG;
        }
        memset(ptFuncMatchingList->ptDistList->ptDiffData, 0x00, sizeof(_DIFFLINES));
        return iRet;
    case FUNC_MATCH:
        iFlg = iFunckind;
        break;
    case FUNC_ADD:
    case FUNC_ADD_VS_NONE:
        if ( ptDistList->iInvalidFlg == CDMTR_TRUE) {
            iFlg = FUNC_INVALID_ADD;
            ptBaseList = NULL;
            break;
        }
        iRet = CDMtrCntFuncSetAddDiffLineCount(ptDistList);
        if (iRet == RET_NG) {
            return iRet;
        }
        iFlg = iFunckind;
        break;
    case FUNC_DEL:
    case FUNC_DEL_VS_NONE:
        if ( ptBaseList->iInvalidFlg == CDMTR_TRUE) {
            iFlg = FUNC_INVALID_DEL;
            ptDistList = NULL;
            break;
        }
        iRet = CDMtrCntFuncSetDeleteDiffLineCount(ptBaseList);
        if (iRet == RET_NG) {
            return iRet;
        }
        iFlg = iFunckind;
        break;
    default:
        iRet = RET_NG;
        CDMtrLibCmnTrcLogOut(MSG_LOG_ID_C_00000041); //* MSG_LOG_ID_C_00000041
        return iRet;
    }
    if ( iFlg == FUNC_MATCH ) {
        if ( ( ptDistList->iInvalidFlg == CDMTR_TRUE ) &&
                ( ptBaseList->iInvalidFlg == CDMTR_TRUE ) ) {
            iFlg = FUNC_INVALID;
        } else if ( ( ptDistList->iInvalidFlg == CDMTR_TRUE ) &&
                    ( ptBaseList->iInvalidFlg == CDMTR_FALSE ) ) {
            iRet = CDMtrCntFuncSetDeleteDiffLineCount(ptBaseList);
            if (iRet == RET_NG) {
                return iRet;
            }
            iFlg = FUNC_DEL_VS_INVALID;
        } else if ( ( ptDistList->iInvalidFlg == CDMTR_FALSE ) &&
                    ( ptBaseList->iInvalidFlg == CDMTR_TRUE ) ) {
            iRet = CDMtrCntFuncSetAddDiffLineCount(ptDistList);
            if (iRet == RET_NG) {
                return iRet;
            }
            iFlg = FUNC_ADD_VS_INVALID;
        } else {
            iRet = cdmtrCntFuncCompareFunc(ptFileStatus, cpBaseOutFilePath, cpDistOutFilePath,
                                           ptBaseList, ptDistList, &iDiffCheck);
            if ( iRet != RET_OK ) {
                return iRet;
            }
            if ( iDiffCheck == CDMTR_FALSE ) {
                iFlg = FUNC_MATCH_EQU;
            } else {
                iFlg = FUNC_MATCH_MOD;
            }
        }
    }
    iRet = cdmtrCntFuncCreateMatchingData(iFlg, ptBaseList, ptDistList, ptFuncMatchingList);
    return iRet;
}

/*!
    @brief          ֐}b`Os
*/
int CDMtrCntFuncDoFuncMatching(
    _TCHAR                 *cpBaseFilePath,
    _TCHAR                 *cpDistFilePath,
    _LINECOUNT_LIST        *ptBaseList,
    _LINECOUNT_LIST        *ptDistList,
    _FUNC_MATCHING_LIST    *ptFuncMatchingList,
    int                    *piFileDiffKind
)
{
    int iRet;
    _LINECOUNT_LIST *ptBaseCurrent, *ptDistCurrent, *startPos;
    _FUNC_MATCHING_LIST *ptFuncMatchingListCurrent, *ptFuncMatchingListPre;
    int iMatchingFlg;
    _TCHAR *cpBaseOutFilePath, *cpDistOutFilePath;
    errno_t erno = 0;
    _FILE_STATUS stFileStatus;
    int iCurrentPosFlg = CDMTR_FALSE;
    ptBaseCurrent = ptBaseList;
    ptDistCurrent = ptDistList;
    ptFuncMatchingListCurrent = ptFuncMatchingList;
    ptFuncMatchingListPre = ptFuncMatchingList;
    stFileStatus.fpBase = stFileStatus.fpDist = NULL;
    stFileStatus.lBaseFileIndex = stFileStatus.lDistFileIndex = 0;
    cpBaseOutFilePath = cpDistOutFilePath = NULL;
    iRet = RET_OK;
    iMatchingFlg = CDMTR_FALSE;
    *piFileDiffKind = FILE_EQU;
    if ( ptBaseCurrent->tFuncData.lID == 0 ) {
        if ( ptDistCurrent->tFuncData.lID == 0 ) {
            iRet = cdmtrCntFuncAddMatchingList(FUNC_NONE, ptBaseCurrent, ptDistCurrent, ptFuncMatchingListCurrent, &stFileStatus, cpBaseOutFilePath, cpDistOutFilePath);
        } else {
            *piFileDiffKind = FILE_MOD;
            while (ptDistCurrent != NULL) {
                iRet = cdmtrCntFuncAddMatchingList(FUNC_ADD_VS_NONE, ptBaseCurrent, ptDistCurrent, ptFuncMatchingListCurrent, &stFileStatus, cpBaseOutFilePath, cpDistOutFilePath);
                if ( iRet != RET_OK ) {
                    break;
                }
                ptFuncMatchingListPre = ptFuncMatchingListCurrent;
                ptFuncMatchingListCurrent = ptFuncMatchingListCurrent->next;
                ptDistCurrent = ptDistCurrent->next;
            }
        }
        MACRO_PERFORMANCE_PUTLOG(PERFORMANCE_LVL3, _T("Created MatchingList (NoFuncFile),33,2")); //* MSG_LOG_ID_C_00000057
        goto FUNC_END;
    }
    if ( ptDistCurrent->tFuncData.lID == 0 ) {
        *piFileDiffKind = FILE_MOD;
        while (ptBaseCurrent != NULL) {
            iRet = cdmtrCntFuncAddMatchingList(FUNC_DEL_VS_NONE, ptBaseCurrent, ptDistCurrent, ptFuncMatchingListCurrent, &stFileStatus, cpBaseOutFilePath, cpDistOutFilePath);
            if ( iRet != RET_OK ) {
                break;
            }
            ptFuncMatchingListPre = ptFuncMatchingListCurrent;
            ptFuncMatchingListCurrent = ptFuncMatchingListCurrent->next;
            ptBaseCurrent = ptBaseCurrent->next;
        }
        MACRO_PERFORMANCE_PUTLOG(PERFORMANCE_LVL3, _T("Created MatchingList (NoFuncFile),33,2")); //* MSG_LOG_ID_C_00000058
        goto FUNC_END;
    }
    iRet = CDMtrLibFileSetDirFileName(pcTempFolderName, TEMP_FILE_SPLIT_BASE, &cpBaseOutFilePath);
    if (iRet != RET_OK) {
        goto FUNC_END;
    }
    iRet = CDMtrLibFileSetDirFileName(pcTempFolderName, TEMP_FILE_SPLIT_DIST, &cpDistOutFilePath);
    if (iRet != RET_OK) {
        goto FUNC_END;
    }
    MACRO_PERFORMANCE_PUTLOG(PERFORMANCE_LVL7, _T("OpenFile : [temp_lc_ret_base.tmp] <S>")); //* MSG_LOG_ID_C_00000059
    if ((erno = _tfopen_s(&(stFileStatus.fpBase), cpBaseFilePath, _T("r"))) != 0) {
        CDMtrLibCmnTrcLogOut(MSG_LOG_ID_C_00000042, cpBaseFilePath); //* MSG_LOG_ID_C_00000042
        iRet = RET_NG;
        goto FUNC_END;
    }
    MACRO_PERFORMANCE_PUTLOG(PERFORMANCE_LVL7, _T("OpenFile : [temp_lc_ret_base.tmp] <E>")); //* MSG_LOG_ID_C_00000060
    MACRO_PERFORMANCE_PUTLOG(PERFORMANCE_LVL7, _T("OpenFile : [temp_lc_ret_dist.tmp] <S>")); //* MSG_LOG_ID_C_00000061
    if ((erno = _tfopen_s(&(stFileStatus.fpDist), cpDistFilePath, _T("r"))) != 0) {
        CDMtrLibCmnTrcLogOut(MSG_LOG_ID_C_00000043, cpDistFilePath); //* MSG_LOG_ID_C_00000043
        iRet = RET_NG;
        goto FUNC_END;
    }
    MACRO_PERFORMANCE_PUTLOG(PERFORMANCE_LVL7, _T("OpenFile : [temp_lc_ret_dist.tmp] <E>")); //* MSG_LOG_ID_C_00000062
    startPos = ptBaseList;
    while (ptDistCurrent != NULL) {
        ptBaseCurrent = startPos;
        iCurrentPosFlg = CDMTR_FALSE;
        do {
            if ( ptBaseCurrent->iChkFlg != CDMTR_TRUE ) {
                if (iCurrentPosFlg == CDMTR_FALSE) {
                    iCurrentPosFlg = CDMTR_TRUE;
                    startPos = ptBaseCurrent;
                }
                if ( ptDistCurrent->tFuncData.lNameLen == ptBaseCurrent->tFuncData.lNameLen ) {
                    if ( _tcsnccmp( ptDistCurrent->tFuncData.pcName,
                                    ptBaseCurrent->tFuncData.pcName,
                                    ptDistCurrent->tFuncData.lNameLen ) == 0 ) {
                        iMatchingFlg = CDMTR_TRUE;
                        break;
                    }
                }
            }
            ptBaseCurrent = ptBaseCurrent->next;
        } while ( ptBaseCurrent != NULL);
        if ( iMatchingFlg == CDMTR_TRUE ) {
            iRet = cdmtrCntFuncAddMatchingList(FUNC_MATCH, ptBaseCurrent, ptDistCurrent, ptFuncMatchingListCurrent, &stFileStatus, cpBaseOutFilePath, cpDistOutFilePath);
            if ( iRet != RET_OK ) {
                goto FUNC_END;
            }
            if ( ptFuncMatchingListCurrent->iFlg != FUNC_MATCH_EQU && ptFuncMatchingListCurrent->iFlg != FUNC_INVALID ) {
                *piFileDiffKind = FILE_MOD;
            }
            ptBaseCurrent->iChkFlg = CDMTR_TRUE;
            ptDistCurrent->iChkFlg = CDMTR_TRUE;
        } else {
            iRet = cdmtrCntFuncAddMatchingList(FUNC_ADD, NULL, ptDistCurrent, ptFuncMatchingListCurrent, &stFileStatus, cpBaseOutFilePath, cpDistOutFilePath);
            if ( iRet != RET_OK ) {
                goto FUNC_END;
            }
            *piFileDiffKind = FILE_MOD;
        }
        ptFuncMatchingListPre = ptFuncMatchingListCurrent;
        ptFuncMatchingListCurrent = ptFuncMatchingListCurrent->next;
        ptDistCurrent = ptDistCurrent->next;
        iMatchingFlg = CDMTR_FALSE;
    }
    ptBaseCurrent = ptBaseList;
    while (ptBaseCurrent != NULL) {
        if ( ptBaseCurrent->iChkFlg != CDMTR_TRUE ) {
            iRet = cdmtrCntFuncAddMatchingList(FUNC_DEL, ptBaseCurrent, NULL, ptFuncMatchingListCurrent, &stFileStatus, cpBaseOutFilePath, cpDistOutFilePath);
            if ( iRet != RET_OK ) {
                goto FUNC_END;
            }
            *piFileDiffKind = FILE_MOD;
            ptFuncMatchingListPre = ptFuncMatchingListCurrent;
            ptFuncMatchingListCurrent = ptFuncMatchingListCurrent->next;
        }
        ptBaseCurrent = ptBaseCurrent->next;
    }
    MACRO_PERFORMANCE_PUTLOG(PERFORMANCE_LVL3, _T("Created MatchingList (RunMatching),33,2")); //* MSG_LOG_ID_C_00000063
FUNC_END:
    if ( stFileStatus.fpBase != NULL ) {
        fclose(stFileStatus.fpBase);
        stFileStatus.fpBase = NULL;
    }
    if ( stFileStatus.fpDist != NULL ) {
        fclose(stFileStatus.fpDist);
        stFileStatus.fpDist = NULL;
    }
    stFileStatus.lBaseFileIndex = stFileStatus.lDistFileIndex = 0;
    CDMtrLibUtilFreeW((void **)&cpBaseOutFilePath);
    CDMtrLibUtilFreeW((void **)&cpDistOutFilePath);
    if ( ptFuncMatchingListPre != ptFuncMatchingListCurrent ) {
        CDMtrCntFuncFreeChainMatchingList(ptFuncMatchingListCurrent);
        ptFuncMatchingListPre->next = NULL;
    }
    if (iRet == RET_NG) {
        CDMtrCntFuncFreeChainMatchingList(ptFuncMatchingList->next);
        ptFuncMatchingList->next = NULL;
    }
    return iRet;
}
