/*
 *  source code metrics counter
 *  Copyright (C) 2015  NEC Corporation.
 *  
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
#define _CRT_SECURE_NO_WARNINGS
#include <windows.h>
#include <stdio.h>
#include <string.h>
#include <tchar.h>

#include "CDMtrCmn.h"
#include "CDMtrExtCmn.h"
#include "CDMtrStmt.h"
#include "CDMtrLibCmnW.h"
#include "CDMtrLibFileW.h"
#include "CDMtrLibUtilW.h"
#include "CDMtrLibSystemW.h"
#include "CDMtrLibOptW.h"
#include "CDMtrCntMain.h"
#include "CDMtrCntFormat.h"
#include "CDMtrCntFunc.h"
#include "CDMtrCntLang.h"
#include "CDMtrCntCallProc.h"
#include "CDMtrCntLineCount.h"
#include "CDMtrCntPreFormat.h"
#include "CDMtrCntLog.h"
#include "CDMtrCntOutputCSV.h"
#include "CDMtrCntExtTool.h"
#include "CDMtrLibFileW.h"

#include "CDMtrSps.h"
#include "CDMtrMessage.h"

/*----------------------------------------------------------------------------*/
/* static function declaration                                                */
/*----------------------------------------------------------------------------*/
static int cdmtrCntLineCountDoCount(_TCHAR *pcFileName);
static int cdmtrCntLineCountCheckLangType(int iLangType, int *piStmtLang, const _TCHAR *pcFileNameLogOut);
static int cdmtrCntLineCountGetStatementNum(int iLangType, long *plStmtNum, int iStmtLang, _TCHAR *pcFileName, const _TCHAR *pcFileNameLogOut, _TCHAR *pcErrOutFile);
static int cdmtrCntLineCountExecMacroAnalizer(_TCHAR *pcFileName, _TCHAR *pcTarget, _TCHAR **ppcResult, _TCHAR *pcErrOutFile);
static void cdmtrCntLineCountExecLineCounter(_TCHAR *pcLangName, _TCHAR *pcTarget, const _TCHAR *pcFileNameLogOut);
static int cdmtrCntLineCountDoDiff(_TCHAR *pcBaseFile, _TCHAR *pcDistFile);
static int cdmtrCntLineCountCheckLangTypeDiffmode(int iLangType, const _TCHAR *pcDistFileLogOut);
static int cdmtrCntLineCountExecTextFile(_TCHAR *pcBaseFile, _TCHAR *pcDistFile, _TCHAR *pcLangName);
static int cdmtrCntLineCountExecMacroAnalizerDiffmode(_TCHAR *pcBaseFile, _TCHAR *pcDistFile,
        _TCHAR **ppcTemp4Base, _TCHAR **ppcTemp4Dist,
        _TCHAR *pcNkfBaseFile, _TCHAR *pcNkfDistFile,
        const _TCHAR *pcBaseFileLogOut, const _TCHAR *pcDistFileLogOut,
        _TCHAR *pcErrOutFile);
static int cdmtrCntLineCountCreateMacroAnalizerCommand(_TCHAR *pcFile,
        _TCHAR *pcResult,
        _TCHAR *pcNkfFile,
        _TCHAR *pcErrOutFile);
static int cdmtrCntLineCountDoDiffSrc(const _TCHAR *pcBaseFile,
                                      const _TCHAR *pcDistFile,
                                      const _TCHAR *pcBaseFilePath,
                                      const _TCHAR *pcDistFilePath,
                                      const _TCHAR *pcLangName);
static int cdmtrCntLineCountCreateInfoFile(const _TCHAR *pcBaseFile,
        const _TCHAR *pcDistFile,
        const _TCHAR *pcLangName,
        int iIsBaseFile,
        int iIsDistFile,
        _DoDiffSrc *ptParam);
static int cdmtrCntLineCountExistBothFile(const _TCHAR *pcBaseFile,
        const _TCHAR *pcDistFile,
        const _TCHAR *pcLangName,
        _DoDiffSrc *ptParam);
static int cdmtrCntLineCountDoDiffTxt(const _TCHAR *pcBaseFile,
                                      const _TCHAR *pcDistFile,
                                      const _TCHAR *pcBaseFilePath,
                                      const _TCHAR *pcDistFilePath,
                                      const _TCHAR *pcLangName);
static void cdmtrCntLineCountDiffCount(int iADDFlg, int iMODFlg, _DIFFDETAIL *ptDiffDetail);
static int cdmtrCntLineCountDiffFileCheckTxt(_TCHAR *pcFileName, long lSize, _DIFFLINES *ptDiffLines);
static int cdmtrCntLineCountExecuteLC(_LCEXT_OPT *ptLcOpt, _TCHAR *pcStdOut, int iDetail, _LINECOUNT_LIST *ptLineCountList);
static void cdmtrCntLineCountLCOptInit();

/*----------------------------------------------------------------------------*/
/* global function                                                            */
/*----------------------------------------------------------------------------*/
/*!
    @brief      {s𑪒肷
*/
int CDMtrCntLineCountDoCountProcess(_FileList *pcFileName)
{
    int iRet = RET_NG;
    int iFuncRet;
    int i, j;
    _FileList *pFileList = NULL;
    const _TCHAR *pcFileNameLogOut = NULL;
    for (j = 0; j < pcFileName->count; j++) {
        iFuncRet = CDMtrLibFileGetFileList(pcFileName->filename[j], &pFileList);
        pcFileNameLogOut = CDMtrLibFileRemoveLongPathMarkW(pcFileName->filename[j]);
        if (iFuncRet != RET_OK) {
            CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000127, pcFileNameLogOut); //* MSG_LOG_ID_C_00000127
            goto FUNC_END;
        }
        if (pFileList->count == 0) {
            CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000128, pcFileNameLogOut); //* MSG_LOG_ID_C_00000128
        } else {
            for (i = 0; i < pFileList->count; i++) {
                iFuncRet = cdmtrCntLineCountDoCount(pFileList->filename[i]);
                if (iFuncRet == RET_NG) {
                }
            }
        }
        if (pFileList != NULL) {
            CDMtrLibFileFreeFileList(&pFileList);
            pFileList = NULL;
        }
    }
    iRet = RET_OK;
FUNC_END:
    if (pFileList != NULL) {
        CDMtrLibFileFreeFileList(&pFileList);
        pFileList = NULL;
    }
    return iRet;
}

/*!
    @brief      s𑪒肷
*/
int CDMtrCntLineCountDoDiffProcess(_FileList *pcFileName)
{
    int iRet = RET_NG;
    int iFuncRet;
    int i;
    _TCHAR *cBaseFile = NULL;
    _TCHAR *cDistFile = NULL;
    _FileList *pBaseFileList = NULL;
    _FileList *pDistFileList = NULL;
    _TCHAR *pcBaseFileName = NULL;
    _TCHAR *pcDistFileName = NULL;
    const _TCHAR *pcBaseFileLogOut = NULL;
    const _TCHAR *pcDistFileLogOut = NULL;
    cBaseFile = pcFileName->filename[0];
    cDistFile = pcFileName->filename[1];
    pcBaseFileLogOut = CDMtrLibFileRemoveLongPathMarkW(cBaseFile);
    pcDistFileLogOut = CDMtrLibFileRemoveLongPathMarkW(cDistFile);
    if (CDMtrLibUtilCheckPrefixW(cBaseFile, LONGPATH_UNC_PREFIX) != NULL) {
        CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000236, pcBaseFileLogOut); //* MSG_LOG_ID_C_00000236
        iRet = RET_OK;
        goto FUNC_END;
    } else if (CDMtrLibUtilCheckPrefixW(cDistFile, LONGPATH_UNC_PREFIX) != NULL) {
        CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000237, pcDistFileLogOut); //* MSG_LOG_ID_C_00000237
        iRet = RET_OK;
        goto FUNC_END;
    }
    if (CDMtrLibFileIsFile(cBaseFile) && CDMtrLibFileIsFile(cDistFile)) {
        iFuncRet = cdmtrCntLineCountDoDiff(cBaseFile, cDistFile);
        if (iFuncRet == RET_NG) {
        }
    } else if (CDMtrLibFileIsDir(cBaseFile) && CDMtrLibFileIsDir(cDistFile)) {
        MACRO_PERFORMANCE_PUTLOG(PERFORMANCE_LVL2, _T("Create FileList (diff) <S> ,22,1")); //* MSG_LOG_ID_C_00000399
        iFuncRet = CDMtrLibFileGetFileList(cDistFile, &pDistFileList);
        if (iFuncRet != RET_OK) {
            CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000135, pcDistFileLogOut); //* MSG_LOG_ID_C_00000135
            goto FUNC_END;
        }
        iFuncRet = CDMtrLibFileGetFileList(cBaseFile, &pBaseFileList);
        if (iFuncRet != RET_OK) {
            CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000136, pcBaseFileLogOut); //* MSG_LOG_ID_C_00000136
            goto FUNC_END;
        }
        MACRO_PERFORMANCE_PUTLOG(PERFORMANCE_LVL2, _T("Create FileList (diff) <E> ,22,2")); //* MSG_LOG_ID_C_00000400
        for (i = 0; i < pDistFileList->count; i++) {
            CDMtrLibUtilFreeW((void **)&pcBaseFileName);
            iFuncRet = CDMtrLibFileSetDirFileName(cBaseFile,
                                                  (pDistFileList->filename[i] + _tcslen(cDistFile)),
                                                  &pcBaseFileName);
            if (iFuncRet != RET_OK) {
                goto FUNC_END;
            }
            iFuncRet = cdmtrCntLineCountDoDiff(pcBaseFileName, pDistFileList->filename[i]);
            if (iFuncRet == RET_NG) {
            }
        }
        for (i = 0; i < pBaseFileList->count; i++) {
            CDMtrLibUtilFreeW((void **)&pcDistFileName);
            iFuncRet = CDMtrLibFileSetDirFileName(cDistFile,
                                                  (pBaseFileList->filename[i] + _tcslen(cBaseFile)),
                                                  &pcDistFileName);
            if (iFuncRet != RET_OK) {
                goto FUNC_END;
            }
            if (CDMtrLibFileIsFile(pcDistFileName)) {
                continue;
            } else {
                iFuncRet = cdmtrCntLineCountDoDiff(pBaseFileList->filename[i], pcDistFileName);
                if (iFuncRet == RET_NG) {
                }
            }
        }
    } else {
        if (!CDMtrLibFileIsFile(cBaseFile) && !CDMtrLibFileIsDir(cBaseFile)) {
            CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000137, pcBaseFileLogOut); //* MSG_LOG_ID_C_00000137
            goto FUNC_END;
        }
        if (!CDMtrLibFileIsFile(cDistFile) && !CDMtrLibFileIsDir(cDistFile)) {
            CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000138, pcDistFileLogOut); //* MSG_LOG_ID_C_00000138
            goto FUNC_END;
        } else {
            CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000139); //* MSG_LOG_ID_C_00000139
            goto FUNC_END;
        }
    }
    iRet = RET_OK;
FUNC_END:
    if (pBaseFileList != NULL) {
        CDMtrLibFileFreeFileList(&pBaseFileList);
        pBaseFileList = NULL;
    }
    if (pDistFileList != NULL) {
        CDMtrLibFileFreeFileList(&pDistFileList);
        pDistFileList = NULL;
    }
    CDMtrLibUtilFreeW((void **)&pcBaseFileName);
    CDMtrLibUtilFreeW((void **)&pcDistFileName);
    return iRet;
}

/*!
    @brief          rʂ獷s̃JEgs(\[XR[ht@C)
*/
int CDMtrCntLineCountDiffFileCheck(_TCHAR *pcFileName, _LINECOUNT *ptCountLines, _DIFFLINES *ptDiffLines)
{
    int iRet = RET_NG;
    int iFuncRet;
    FILE *fp = NULL;
    _TCHAR *pcBuff = NULL;
    _TCHAR *p = NULL;
    int iADDFlg;
    int iMODFlg;
    iADDFlg = CDMTR_FALSE;
    iMODFlg = CDMTR_FALSE;
    if ((fp = _tfopen(pcFileName, _T("r"))) == NULL) {
        CDMtrLibCmnTrcLogOut(MSG_LOG_ID_C_00000390, pcFileName); //* MSG_LOG_ID_C_00000390
        goto FUNC_END;
    }
    iFuncRet = CDMtrLibUtilMallocW((void **)&pcBuff, BUFF_LINE_SIZE);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }
    while (_fgetts(pcBuff, BUFF_LINE_LENGTH, fp) != NULL) {
        p = pcBuff;
        if (*p == DIFF_START_DEL) {
            iADDFlg = CDMTR_FALSE;
        } else if (*p == DIFF_START_ADD) {
            iADDFlg = CDMTR_TRUE;
        } else if (CDMtrLibUtilIsDigit(*p)) {
            if (giDiffCountMode == DIFF_COUNT_EXT) {
                iMODFlg = CDMTR_FALSE;
                while (!IS_NULL_CHAR(p)) {
                    if (*p == _T('c')) {
                        iMODFlg = CDMTR_TRUE;
                        break;
                    } else if (*p == _T('a') || *p == _T('d')) {
                        iMODFlg = CDMTR_FALSE;
                        break;
                    } else {
                        p++;
                    }
                }
            } else {
                iMODFlg = CDMTR_FALSE;
            }
            continue;
        } else {
            continue;
        }
        p += 2;
        switch (*p) {
        case DIFF_LCDETAIL_CODE:
        case DIFF_LCDETAIL_PREP:
            cdmtrCntLineCountDiffCount(iADDFlg, iMODFlg, &(ptDiffLines->tDiffEloc));
            break;
        case DIFF_LCDETAIL_DOC:
        case DIFF_LCDETAIL_REM:
            cdmtrCntLineCountDiffCount(iADDFlg, iMODFlg, &(ptDiffLines->tDiffCloc));
            break;
        case DIFF_LCDETAIL_BLANK:
            cdmtrCntLineCountDiffCount(iADDFlg, iMODFlg, &(ptDiffLines->tDiffBloc));
            break;
        case DIFF_LCDETAIL_SKIP:
            cdmtrCntLineCountDiffCount(iADDFlg, iMODFlg, &(ptDiffLines->tDiffSkip));
            break;
        default:
            break;
        }
    }
    if (!iSkipChangeFlg) {
        ptDiffLines->tDiffEloc.ulAdd += ptDiffLines->tDiffSkip.ulAdd;
        ptDiffLines->tDiffEloc.ulDel += ptDiffLines->tDiffSkip.ulDel;
        ptDiffLines->tDiffEloc.ulModAdd += ptDiffLines->tDiffSkip.ulModAdd;
        ptDiffLines->tDiffEloc.ulModDel += ptDiffLines->tDiffSkip.ulModDel;
        memset(&(ptDiffLines->tDiffSkip), 0x00, sizeof(_DIFFDETAIL));
    } else {
    }
    ptDiffLines->tDiffEloc.ulEqu =
        ptCountLines->ulELOC - ptDiffLines->tDiffEloc.ulAdd - ptDiffLines->tDiffEloc.ulModAdd;
    ptDiffLines->tDiffCloc.ulEqu =
        ptCountLines->ulCLOC - ptDiffLines->tDiffCloc.ulAdd - ptDiffLines->tDiffCloc.ulModAdd;
    if (giDiffBlankFlg) {
        ptDiffLines->tDiffBloc.ulEqu =
            ptCountLines->ulBlank - ptDiffLines->tDiffBloc.ulAdd - ptDiffLines->tDiffBloc.ulModAdd;
    } else {
        ptDiffLines->tDiffBloc.ulEqu = 0;
    }
    ptDiffLines->tDiffSkip.ulEqu =
        ptCountLines->ulUndef - ptDiffLines->tDiffSkip.ulAdd - ptDiffLines->tDiffSkip.ulModAdd;
    ptDiffLines->tDiffTotal.ulEqu = ptDiffLines->tDiffEloc.ulEqu + ptDiffLines->tDiffCloc.ulEqu +
                                    ptDiffLines->tDiffBloc.ulEqu + ptDiffLines->tDiffSkip.ulEqu;
    ptDiffLines->tDiffTotal.ulAdd = ptDiffLines->tDiffEloc.ulAdd + ptDiffLines->tDiffCloc.ulAdd +
                                    ptDiffLines->tDiffBloc.ulAdd + ptDiffLines->tDiffSkip.ulAdd;
    ptDiffLines->tDiffTotal.ulDel = ptDiffLines->tDiffEloc.ulDel + ptDiffLines->tDiffCloc.ulDel +
                                    ptDiffLines->tDiffBloc.ulDel + ptDiffLines->tDiffSkip.ulDel;
    ptDiffLines->tDiffTotal.ulModAdd = ptDiffLines->tDiffEloc.ulModAdd + ptDiffLines->tDiffCloc.ulModAdd +
                                       ptDiffLines->tDiffBloc.ulModAdd + ptDiffLines->tDiffSkip.ulModAdd;
    ptDiffLines->tDiffTotal.ulModDel = ptDiffLines->tDiffEloc.ulModDel + ptDiffLines->tDiffCloc.ulModDel +
                                       ptDiffLines->tDiffBloc.ulModDel + ptDiffLines->tDiffSkip.ulModDel;
    iRet = RET_OK;
FUNC_END:
    if (fp) {
        fclose(fp);
        fp = NULL;
    }
    CDMtrLibUtilFreeW((void **)&pcBuff);
    return iRet;
}

/*----------------------------------------------------------------------------*/
/* static function                                                            */
/*----------------------------------------------------------------------------*/
/*!
    @brief      {s𑪒肷(Pt@C̑)
*/
static int cdmtrCntLineCountDoCount(_TCHAR *pcFileName)
{
    int iRet = RET_NG;
    int iFuncRet = RET_NG;
    _TCHAR *pcTemp4 = NULL;
    _TCHAR *pcNkfFile = NULL;
    _TCHAR *pcErrOutFile = NULL;
    _LINECOUNT_LIST tLCInfo;
    int iLangType = 0;
    _TCHAR *pcLangName = NULL;
    int iStmtLang = CDMtrStmtLangModeInit;
    long lStmtNum = 0;
    long *plStmtNum = NULL;
    const _TCHAR *pcFileNameLogOut = NULL;
    pcLangName = NULL;

    /** Oo͗pt@CpXݒ肵ďo͂s */
    pcFileNameLogOut = CDMtrLibFileRemoveLongPathMarkW(pcFileName);
    CDMtrLibCmnSetTargetName(pcFileNameLogOut);
    iSourceID++;
    if (iDebug == DEBUG_ON) {
        CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000221); //* MSG_LOG_ID_C_00000221
        CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000222, pcFileNameLogOut); //* MSG_LOG_ID_C_00000222
        CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000223, iSourceID); //* MSG_LOG_ID_C_00000223
    }

    /** ʂ擾Ďʖ̏s */
    iLangType = CDMtrCntLangGetTypeFromFileName(giExceptBinaryMode, pcFileName, &pcLangName);
    iFuncRet = cdmtrCntLineCountCheckLangType(iLangType, &iStmtLang, pcFileNameLogOut);
    if (iFuncRet == RET_SKIP) {
        iRet = RET_OK;
        goto FUNC_END;
    }

    /** STMTvL𔻒f */
    if (giStmtMode != CDMTR_TRUE) {
        iStmtLang = CDMtrStmtLangModeInit;
    }
    if (iDebug == DEBUG_ON) {
        CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000226, pcFileNameLogOut); //* MSG_LOG_ID_C_00000226
        CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000227, pcLangName); //* MSG_LOG_ID_C_00000227
        CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000228, iLangType); //* MSG_LOG_ID_C_00000228
    }

    /** WG[o͗pt@CpX쐬 */
    iFuncRet = CDMtrLibUtilCreateStringW(&pcErrOutFile,
                                         pcTempFolderName,
                                         FOLDER_SEPALATE,
                                         TEMP_FILE_ERROUTPUT,
                                         NULL);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }
    memset(&tLCInfo, 0x00, sizeof(_LINECOUNT_LIST));

    /** ς݃t@CJEg */
    iNumOfFiles++;
    if (iShowDetails == DETAILS_SHOW) {
        CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000229, pcFileNameLogOut); //* MSG_LOG_ID_C_00000229
    }

    /** NKFs */
    iFuncRet = CDMtrCntExtToolExecNkf(pcFileName, DIFF_NONE, iLangType, CDMTR_TRUE, CDMTR_FALSE, &pcNkfFile, pcErrOutFile);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }
    /* NKF̃t@C\ */
    if (iDebug == DEBUG_ON) {
        CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000230, pcNkfFile); //* MSG_LOG_ID_C_00000230
    }

    /** KvɉăXe[gg擾 */
    if (iStmtLang != 0) {
        iFuncRet = cdmtrCntLineCountGetStatementNum(iLangType, &lStmtNum, iStmtLang, pcNkfFile, pcFileNameLogOut, pcErrOutFile);
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
        plStmtNum = &lStmtNum;
    }

    /** \[X`Kvȏꍇ͎{ */
    if (CDMtrCntExtToolIsExecBeautifier(iLangType)) {
        iFuncRet = CDMtrCntExtToolExecBeautifier(DIFF_NONE, pcLangName, &pcNkfFile, pcErrOutFile);
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
    }

#ifndef OSS
    /** }NAiCU̎sKvȏꍇ͎s */
    if (CDMtrCntExtToolIsExecDef(iLangType)) {
        CDMtrLibUtilFreeW((void **)&pcTemp4);
        iFuncRet = cdmtrCntLineCountExecMacroAnalizer(pcFileName, pcNkfFile, &pcTemp4, pcErrOutFile);
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
    } else {
#endif //OSS
        /** ssv̏ꍇ́At@CRs[ */
        CDMtrLibUtilFreeW((void **)&pcTemp4);
        pcTemp4 = pcNkfFile;
        pcNkfFile = NULL;
#ifndef OSS
    }
#endif //OSS

    /** oCit@CȊO̓CJEgs */
    if (iLangType != LANG_TYPE_BIN) {
        cdmtrCntLineCountExecLineCounter(pcLangName, pcTemp4, pcFileNameLogOut);
        iFuncRet = cdmtrExtMain(&tLCInfo);
        if (iFuncRet != RET_OK) {
            if (iDebug == DEBUG_ON) {
                CDMtrCntLogLogOutErrExec(pcErrOutFile);
            }
            goto FUNC_END;
        } else {
            /** {,JEgo͂ */
            iFuncRet = CDMtrCntOutputCSVCountFileToOutFile(pcFileNameLogOut,
                       NULL,
                       NULL,
                       pcLangName,
                       plStmtNum,
                       & (tLCInfo.tLCData),
                       NULL,
                       NULL,
                       FUNC_NONE
                                                          );
            if (iFuncRet != RET_OK) {
                goto FUNC_END;
            }
        }
    }
    iNumOfSuccess++;
    iRet = RET_OK;
FUNC_END:
    if (iRet != RET_OK) {
        iFuncRet = CDMtrCntOutputCSVErrFileToOutFile(pcFileNameLogOut, pcLangName);
    }
    CDMtrLibCmnClearTargetName();
    CDMtrLibUtilFreeW((void **)&pcTemp4);
    CDMtrLibUtilFreeW((void **)&pcNkfFile);
    CDMtrLibUtilFreeW((void **)&pcErrOutFile);
    CDMtrLibUtilFreeW((void **)&pcLangName);
    return iRet;
}

/*!
    @brief          {šʂ𔻒f
*/
static int cdmtrCntLineCountCheckLangType(int iLangType, int *piStmtLang, const _TCHAR *pcFileNameLogOut)
{
    int iRet = RET_OK;

    switch (iLangType) {
    case LANG_TYPE_BIN:
    case LANG_TYPE_CLASS:
    case LANG_TYPE_JAR:
        /** XLbv */
        if (iShowDetails == DETAILS_SHOW) {
            CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000224, pcFileNameLogOut); //* MSG_LOG_ID_C_00000224
        }
        iRet = RET_SKIP;
        break;
    case LANG_TYPE_UNKNOW:
        /** XLbv */
        if (iShowDetails == DETAILS_SHOW) {
            CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000225, pcFileNameLogOut); //* MSG_LOG_ID_C_00000225
        }
        iRet = RET_SKIP;
        break;
    case LANG_TYPE_CPP:
    case LANG_TYPE_CPPH:
        *piStmtLang = CDMtrStmtLangModeCPP;
        break;
    case LANG_TYPE_C:
    case LANG_TYPE_CH:
        *piStmtLang = CDMtrStmtLangModeC;
        break;
    case LANG_TYPE_JAVA:
        *piStmtLang = CDMtrStmtLangModeJAVA;
        break;
    case LANG_TYPE_CS:
        *piStmtLang = CDMtrStmtLangModeCS;
        break;
    case LANG_TYPE_VB:
        *piStmtLang = CDMtrStmtLangModeVB;
        break;
    case LANG_TYPE_JS:
    case LANG_TYPE_ETC:
    default:
        break;
    }
    return iRet;
}

/*!
    @brief          Xe[gg̑s
*/
static int cdmtrCntLineCountGetStatementNum(int iLangType, long *plStmtNum, int iStmtLang, _TCHAR *pcFileName, const _TCHAR *pcFileNameLogOut, _TCHAR *pcErrOutFile)
{
    int iFuncRet = RET_NG;
    OUTINFO_T strOutTbl;
    int iStmtDebug = 0;
    _TCHAR *pcOptionDebug = _T(" ");
    _TCHAR *pcOptionDebug2 = _T(" ");

    /** Xe[gg擾̃fobO[hɊւݒs */
    if (iDebug == DEBUG_ON) {
        iStmtDebug = CDMtrStmtLogON;
        pcOptionDebug = STRUCT_OPTION_DEBUG;
        CDMtrLibCmnLogOut(_T("\n")); //* MSG_LOG_ID_C_00000231
        CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000232); //* MSG_LOG_ID_C_00000232
    } else {
        iStmtDebug = CDMtrStmtLogOFF;
    }
    if (iSpsDebug == DEBUG_ON) {
        pcOptionDebug2 = STRUCT_OPTION_DEBUG2;
    }

    switch (iLangType) {
    case LANG_TYPE_VB:
        /* VB̏ꍇAp[TĂяoăXe[gg擾 */
#if NEED_SOURCE_ID
        _stprintf(chSourceID, SOURCEID_FMT, iSourceID);
#endif
        iFuncRet = CDMtrCntCallVBParser(pcStructVBPath,
                                        pcOptionDebug, pcOptionDebug2,
                                        pcErrOutFile,
                                        pcTempFolderName,
                                        pcFileName,
                                        chSourceID);
        if (iDebug == DEBUG_ON || iSpsDebug == DEBUG_ON) {
            CDMtrCntLogLogOutErrExec(pcErrOutFile);
        }
        if (iFuncRet != RET_OK) {
            CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000129, pcStructVBPath); //* MSG_LOG_ID_C_00000129
            return RET_NG;
        }

        /* Wv */
        iFuncRet = CDMtrCntPreFormatAggregateFile(pcTempFolderName,
                   chSourceID,
                   &strOutTbl);
        if (iFuncRet != RET_OK) {
            CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000130, pcFileNameLogOut); //* MSG_LOG_ID_C_00000130
            return RET_NG;
        }
        *plStmtNum = strOutTbl.iCnt[OUTINFO_STMT];
        break;
    default:
        /** ̑̏ꍇ̓Xe[ggvp[TĂяo */
        iFuncRet = CDMtrStmtCountStatement(pcFileName, pcErrOutFile, iStmtLang, &iStmtDebug, plStmtNum);
        if (iStmtDebug == DEBUG_ON) {
            CDMtrCntLogLogOutErrExec(pcErrOutFile);
        }
        if (iFuncRet != 0) {
            CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000131); //* MSG_LOG_ID_C_00000131
            return RET_NG;
        }
        break;
    }

    if (iDebug == DEBUG_ON) {
        CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000233); //* MSG_LOG_ID_C_00000233
        CDMtrLibCmnLogOut(_T("\n")); //* MSG_LOG_ID_C_00000234
    }

    return RET_OK;
}

/*!
    @brief          }NAiCUs({s)
*/
static int cdmtrCntLineCountExecMacroAnalizer(_TCHAR *pcFileName, _TCHAR *pcTarget, _TCHAR **ppcResult, _TCHAR *pcErrOutFile)
{
    int iRet = RET_NG;
    int iFuncRet = RET_NG;

    /** o͌ʗpt@C쐬 */
    CDMtrLibUtilFreeW((void **)ppcResult);
    iFuncRet = CDMtrLibUtilCreateStringW(ppcResult, pcTempFolderName, FOLDER_SEPALATE, TEMP_FILE4, NULL);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }

    /** }NAiCU[p̃R}h쐬Ďs(IWit@C) */
    iFuncRet = cdmtrCntLineCountCreateMacroAnalizerCommand(pcFileName, *ppcResult, pcTarget, pcErrOutFile);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }

    iRet = RET_OK;
    return iRet;

FUNC_END:
    CDMtrLibUtilFreeW((void **)ppcResult);
    return iRet;
}

/*!
    @brief          {sJEg
*/
static void cdmtrCntLineCountExecLineCounter(_TCHAR *pcLangName, _TCHAR *pcTarget, const _TCHAR *pcFileNameLogOut)
{
    cdmtrCntLineCountLCOptInit();
    gtOptInfo_lc.pcInputpath = (_TCHAR *)pcTarget;
    gtOptInfo_lc.pcLangName  = (_TCHAR *)pcLangName;

    /** ncmassIvV(-header)Ή */
    if (giOutHeaderFlg == CDMTR_TRUE) {
        gtOptInfo_lc.iHeaderFlg = CDMTR_TRUE;
    }

    /** vpeBt@Cw肪ꍇ̓vpeBt@C(pX)n */
    if (iProfileFlag == CDMTR_TRUE) {
        if (pcProfFileName != NULL) {
            gtOptInfo_lc.pcProppath = (_TCHAR *)pcProfFileName;
        }
    }

    /** dlRgJEgIvṼ`FbN */
    if (!giDocFlag) {
        gtOptInfo_lc.iDocFlg = CDMTR_FALSE;
    }

    /** Rgw̑啶E̋ʃIvṼ`FbN */
    if (!giCmntCaseFlag) {
        gtOptInfo_lc.iCmntCaseFlg = CDMTR_FALSE;
    } else {
        gtOptInfo_lc.iCmntCaseFlg = CDMTR_TRUE;
    }

    /** ڍ׃fobO̓fobOIvVONɐݒ肷 */
    if (giMoreDebug == DEBUG_ON) {
        gtOptInfo_lc.giDebug = CDMTR_TRUE;
        CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000235, pcFileNameLogOut); //* MSG_LOG_ID_C_00000235
    }
    return;
}

/*!
    @brief      s𑪒肷(Pt@C̑)
    @param[in]  pcBaseFile  IWit@C("\\?\"tA΃pX)
    @param[in]  pcDistFile  ύXt@C("\\?\"tA΃pX)
    @retval     RET_OK      I
    @retval     RET_NG      ُI
*/
static int cdmtrCntLineCountDoDiff(_TCHAR *pcBaseFile, _TCHAR *pcDistFile)
{
    int iRet = RET_NG;
    int iFuncRet = RET_NG;
    _TCHAR *pcTemp4Dist = NULL;
    _TCHAR *pcTemp4Base = NULL;
    _TCHAR *pcNkfBaseFile = NULL;
    _TCHAR *pcNkfDistFile = NULL;
    _TCHAR *pcLangName = NULL;
    _TCHAR *pcErrOutFile = NULL;
    int iLangType = 0;
    const _TCHAR *pcBaseFileLogOut = NULL;
    const _TCHAR *pcDistFileLogOut = NULL;
    int iPerfLogFlg = CDMTR_FALSE;

    /** Oo͗pt@CpXݒ肵ďo͂s */
    pcBaseFileLogOut = CDMtrLibFileRemoveLongPathMarkW(pcBaseFile);
    pcDistFileLogOut = CDMtrLibFileRemoveLongPathMarkW(pcDistFile);
    MACRO_PERFORMANCE_PUTLOG(PERFORMANCE_LVL2, _T("DoDiff <S> ,23,1,0")); //* MSG_LOG_ID_C_00000401
    CDMtrLibCmnClearTargetName();
    iSourceID++;
    if (iDebug == DEBUG_ON) {
        CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000238); //* MSG_LOG_ID_C_00000238
        CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000239, pcBaseFileLogOut); //* MSG_LOG_ID_C_00000239
        CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000240, pcDistFileLogOut); //* MSG_LOG_ID_C_00000240
        CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000241, iSourceID); //* MSG_LOG_ID_C_00000241
    }

    /** ʂ擾Ďʖ̏s */
    if (!CDMtrLibFileIsFile(pcDistFile)) {
        iLangType = CDMtrCntLangGetTypeFromFileName(giExceptBinaryMode, pcBaseFile, &pcLangName);
    } else {
        iLangType = CDMtrCntLangGetTypeFromFileName(giExceptBinaryMode, pcDistFile, &pcLangName);
    }
    globaliLangType = iLangType;
    iFuncRet = cdmtrCntLineCountCheckLangTypeDiffmode(iLangType, pcDistFileLogOut);
    if (iFuncRet == RET_SKIP) {
        iRet = RET_OK;
        goto FUNC_END;
    }

    if (iDebug == DEBUG_ON) {
        CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000245, pcDistFileLogOut); //* MSG_LOG_ID_C_00000245
        CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000246, pcLangName); //* MSG_LOG_ID_C_00000246
        CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000247, iLangType); //* MSG_LOG_ID_C_00000247
    }

    /** WG[o͗pt@CpX쐬 */
    iFuncRet = CDMtrLibUtilCreateStringW(&pcErrOutFile,
                                         pcTempFolderName,
                                         FOLDER_SEPALATE,
                                         TEMP_FILE_ERROUTPUT,
                                         NULL);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }

    /** ς݃t@CJEg */
    iNumOfFiles++;
    if (iShowDetails == DETAILS_SHOW) {
        CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000248, pcBaseFileLogOut, pcDistFileLogOut); //* MSG_LOG_ID_C_00000248
    }

    /** eLXg[h̏s */
    switch (iLangType) {
    case LANG_TYPE_TXT:
        iRet = cdmtrCntLineCountExecTextFile(pcBaseFile, pcDistFile, pcLangName);
        goto FUNC_END;
        break;
    default:
        break;
    }

    MACRO_PERFORMANCE_PUTLOG(PERFORMANCE_LVL2, _T("File Convert <S> ,24,1")); //* MSG_LOG_ID_C_00000408
    iPerfLogFlg = CDMTR_TRUE;

    /** NKFs */
    if (CDMtrLibFileIsFile(pcBaseFile)) {
        iFuncRet = CDMtrCntExtToolExecNkf(pcBaseFile, DIFF_BASE, iLangType, CDMTR_TRUE, CDMTR_FALSE, &pcNkfBaseFile, pcErrOutFile);
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
    } else {
        pcNkfBaseFile = NULL;
    }
    /* NKF̃t@C\ */
    if (iDebug == DEBUG_ON) {
        CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000251, pcNkfBaseFile); //* MSG_LOG_ID_C_00000251
    }

    if (CDMtrLibFileIsFile(pcDistFile)) {
        iFuncRet = CDMtrCntExtToolExecNkf(pcDistFile, DIFF_DIST, iLangType, CDMTR_TRUE, CDMTR_FALSE, &pcNkfDistFile, pcErrOutFile);
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
    } else {
        pcNkfDistFile = NULL;
    }
    /* NKF̃t@C\ */
    if (iDebug == DEBUG_ON) {
        CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000252, pcNkfDistFile); //* MSG_LOG_ID_C_00000252
    }

    /** \[X`Kvȏꍇ͎{ */
    if (CDMtrCntExtToolIsExecBeautifier(iLangType)) {
        if (CDMtrLibFileIsFile(pcNkfBaseFile)) {
            CDMtrLibCmnSetTargetName(pcBaseFileLogOut);
            iFuncRet = CDMtrCntExtToolExecBeautifier(DIFF_BASE, pcLangName, &pcNkfBaseFile, pcErrOutFile);
            if (iFuncRet != RET_OK) {
                goto FUNC_END;
            }
            CDMtrLibCmnClearTargetName();
        }
        if (CDMtrLibFileIsFile(pcNkfDistFile)) {
            CDMtrLibCmnSetTargetName(pcDistFileLogOut);
            iFuncRet = CDMtrCntExtToolExecBeautifier(DIFF_DIST, pcLangName, &pcNkfDistFile, pcErrOutFile);
            if (iFuncRet != RET_OK) {
                goto FUNC_END;
            }
            CDMtrLibCmnClearTargetName();
        }
    }

#ifndef OSS
    /** }NAiCU̎sKvȏꍇ͎s */
    if ((iDiffMode != OPTION_DIFF_FUNC) && (CDMtrCntExtToolIsExecDef(iLangType))) {
        iFuncRet = cdmtrCntLineCountExecMacroAnalizerDiffmode(pcBaseFile, pcDistFile,
                   &pcTemp4Base, &pcTemp4Dist,
                   pcNkfBaseFile, pcNkfDistFile,
                   pcBaseFileLogOut, pcDistFileLogOut,
                   pcErrOutFile);
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
    } else {
#endif //OSS
        /** ssv̏ꍇ́At@CRs[ */
        CDMtrLibUtilFreeW((void **)&pcTemp4Base);
        pcTemp4Base = pcNkfBaseFile;
        pcNkfBaseFile = NULL;
        CDMtrLibUtilFreeW((void **)&pcTemp4Dist);
        pcTemp4Dist = pcNkfDistFile;
        pcNkfDistFile = NULL;
#ifndef OSS
    }
#endif //OSS

    /** CJEgs */
    MACRO_PERFORMANCE_PUTLOG(PERFORMANCE_LVL2, _T("File Convert <E> ,24,2")); //* MSG_LOG_ID_C_00000409
    iFuncRet = cdmtrCntLineCountDoDiffSrc(pcTemp4Base, pcTemp4Dist, pcBaseFile, pcDistFile, pcLangName);
    MACRO_PERFORMANCE_PUTLOG(PERFORMANCE_LVL2, _T("DoDiff (Src) finish ,23,2,3")); //* MSG_LOG_ID_C_00000410
    iPerfLogFlg = CDMTR_FALSE;
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }
    iNumOfSuccess++;
    iRet = RET_OK;
FUNC_END:
    if (iRet != RET_OK) {
        iFuncRet = CDMtrCntOutputCSVErrFileToOutFile(pcDistFileLogOut, pcLangName);
        if (iPerfLogFlg == CDMTR_TRUE) {
            MACRO_PERFORMANCE_PUTLOG(PERFORMANCE_LVL2, _T("File Convert <E> err ,24,3")); //* MSG_LOG_ID_C_00000411
            MACRO_PERFORMANCE_PUTLOG(PERFORMANCE_LVL2, _T("DoDiff (Src) err ,23,2,5")); //* MSG_LOG_ID_C_00000412
        }
    }
    CDMtrLibCmnClearTargetName();
    CDMtrLibUtilFreeW((void **)&pcTemp4Dist);
    CDMtrLibUtilFreeW((void **)&pcTemp4Base);
    CDMtrLibUtilFreeW((void **)&pcNkfBaseFile);
    CDMtrLibUtilFreeW((void **)&pcNkfDistFile);
    CDMtrLibUtilFreeW((void **)&pcLangName);
    CDMtrLibUtilFreeW((void **)&pcErrOutFile);
    return iRet;
}

/*!
    @brief          šʂ𔻒f
*/
static int cdmtrCntLineCountCheckLangTypeDiffmode(int iLangType, const _TCHAR *pcDistFileLogOut)
{
    int iRet = RET_OK;

    switch (iLangType) {
    case LANG_TYPE_BIN:
    case LANG_TYPE_CLASS:
    case LANG_TYPE_JAR:
        /** XLbv */
        if (iShowDetails == DETAILS_SHOW) {
            CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000242, pcDistFileLogOut); //* MSG_LOG_ID_C_00000242
        }
        iRet = RET_SKIP;
        MACRO_PERFORMANCE_PUTLOG(PERFORMANCE_LVL2, _T("DoDiff (Not Target File) ,23,2,1")); //* MSG_LOG_ID_C_00000402
        break;
    case LANG_TYPE_UNKNOW:
        /** XLbv */
        if (iShowDetails == DETAILS_SHOW) {
            CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000243, pcDistFileLogOut); //* MSG_LOG_ID_C_00000243
        }
        iRet = RET_SKIP;
        MACRO_PERFORMANCE_PUTLOG(PERFORMANCE_LVL2, _T("DoDiff (Not Target File) ,23,2,1")); //* MSG_LOG_ID_C_00000403
        break;
    case LANG_TYPE_CPPH:
    case LANG_TYPE_CH:
    case LANG_TYPE_JAVA:
    case LANG_TYPE_CS:
    case LANG_TYPE_VB:
    case LANG_TYPE_JS:
    case LANG_TYPE_TXT:
    case LANG_TYPE_ETC:
        if (iDiffMode == OPTION_DIFF_FUNC) {
            if (iShowDetails == DETAILS_SHOW) {
                CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000244, pcDistFileLogOut); //* MSG_LOG_ID_C_00000244
            }
            iRet = RET_SKIP;
            MACRO_PERFORMANCE_PUTLOG(PERFORMANCE_LVL2, _T("DoDiff (Not Target File) ,23,2,1")); //* MSG_LOG_ID_C_00000404
        }
        break;
    default:
        break;
    }
    return iRet;
}

/*!
    @brief          eLXgt@C̍s𑪒肷
*/
static int cdmtrCntLineCountExecTextFile(_TCHAR *pcBaseFile, _TCHAR *pcDistFile, _TCHAR *pcLangName)
{
    int iRet = RET_NG;
    int iFuncRet = RET_NG;
    _TCHAR *pcTmpBaseFile = NULL;
    _TCHAR *pcTmpDistFile = NULL;

    /** Ώۃt@C݂ꍇ́ApX̕ϊsB(IWit@C) */
    if (CDMtrLibFileIsFile(pcBaseFile)) {
        iFuncRet = CDMtrLibFileConvertAccessiblePathW(pcBaseFile, TEMP_FILE_BASE, pcTempFolderName, CDMTR_TRUE, &pcTmpBaseFile);
        if (iFuncRet != RET_OK) {
            MACRO_PERFORMANCE_PUTLOG(PERFORMANCE_LVL2, _T("DoDiff (TXT) err ,23,2,4")); //* MSG_LOG_ID_C_00000405
            goto FUNC_END;
        }
    } else {
        pcTmpBaseFile = NULL;
    }
    if (iDebug == DEBUG_ON) {
        CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000249, pcTmpBaseFile); //* MSG_LOG_ID_C_00000249
    }

    /** Ώۃt@C݂ꍇ́ApX̕ϊsB(ϊt@C) */
    if (CDMtrLibFileIsFile(pcDistFile)) {
        iFuncRet = CDMtrLibFileConvertAccessiblePathW(pcDistFile, TEMP_FILE_DIST, pcTempFolderName, CDMTR_TRUE, &pcTmpDistFile);
        if (iFuncRet != RET_OK) {
            MACRO_PERFORMANCE_PUTLOG(PERFORMANCE_LVL2, _T("DoDiff (TXT) err ,23,2,4")); //* MSG_LOG_ID_C_00000406
            goto FUNC_END;
        }
    } else {
        pcTmpDistFile = NULL;
    }

    if (iDebug == DEBUG_ON) {
        CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000250, pcTmpDistFile); //* MSG_LOG_ID_C_00000250
    }

    /** eLXg[h̍s */
    iFuncRet = cdmtrCntLineCountDoDiffTxt(pcTmpBaseFile, pcTmpDistFile, pcBaseFile, pcDistFile, pcLangName);
    if (iFuncRet == RET_OK) {
        iNumOfSuccess++;
    }
    MACRO_PERFORMANCE_PUTLOG(PERFORMANCE_LVL2, _T("DoDiff (TXT) finish ,23,2,2")); //* MSG_LOG_ID_C_00000407

    iRet = RET_OK;
FUNC_END:
    CDMtrLibUtilFreeW((void **)&pcTmpBaseFile);
    CDMtrLibUtilFreeW((void **)&pcTmpDistFile);

    return iRet;
}

/*!
    @brief          }NAiCUs(s)
*/
static int cdmtrCntLineCountExecMacroAnalizerDiffmode(_TCHAR *pcBaseFile, _TCHAR *pcDistFile,
        _TCHAR **ppcTemp4Base, _TCHAR **ppcTemp4Dist,
        _TCHAR *pcNkfBaseFile, _TCHAR *pcNkfDistFile,
        const _TCHAR *pcBaseFileLogOut, const _TCHAR *pcDistFileLogOut,
        _TCHAR *pcErrOutFile)
{
    int iRet = RET_NG;
    int iFuncRet = RET_NG;

    /** o͌ʗpt@C쐬 */
    CDMtrLibUtilFreeW((void **)ppcTemp4Dist);
    iFuncRet = CDMtrLibUtilCreateStringW(ppcTemp4Dist, pcTempFolderName, FOLDER_SEPALATE, TEMP_FILE4_DIST, NULL);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }
    CDMtrLibUtilFreeW((void **)ppcTemp4Base);
    iFuncRet = CDMtrLibUtilCreateStringW(ppcTemp4Base, pcTempFolderName, FOLDER_SEPALATE, TEMP_FILE4_BASE, NULL);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }

    /** }NAiCU[p̃R}h쐬Ďs(IWit@C) */
    if (CDMtrLibFileIsFile(pcNkfBaseFile)) {
        CDMtrLibCmnSetTargetName(pcBaseFileLogOut);
        iFuncRet = cdmtrCntLineCountCreateMacroAnalizerCommand(pcBaseFile, *ppcTemp4Base, pcNkfBaseFile, pcErrOutFile);
        CDMtrLibCmnClearTargetName();
    } else {
        CDMtrLibUtilFreeW((void **)ppcTemp4Base);
        iFuncRet = CDMtrLibUtilCreateStringW(ppcTemp4Base, pcNkfBaseFile, NULL);
    }
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }

    /** }NAiCU[p̃R}h쐬Ďs(ύXt@C) */
    if (CDMtrLibFileIsFile(pcNkfDistFile)) {
        CDMtrLibCmnSetTargetName(pcDistFileLogOut);
        iFuncRet = cdmtrCntLineCountCreateMacroAnalizerCommand(pcDistFile, *ppcTemp4Dist, pcNkfDistFile, pcErrOutFile);
        CDMtrLibCmnClearTargetName();
    } else {
        CDMtrLibUtilFreeW((void **)ppcTemp4Dist);
        iFuncRet = CDMtrLibUtilCreateStringW(ppcTemp4Dist, pcNkfDistFile, NULL);
    }
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }

    iRet = RET_OK;
    return iRet;

FUNC_END:
    CDMtrLibUtilFreeW((void **)ppcTemp4Base);
    CDMtrLibUtilFreeW((void **)ppcTemp4Dist);

    return iRet;
}

/*!
    @brief          }NAiCUR}h쐬Ďs
*/
static int cdmtrCntLineCountCreateMacroAnalizerCommand(_TCHAR *pcFile,
        _TCHAR *pcResult,
        _TCHAR *pcNkfFile,
        _TCHAR *pcErrOutFile)
{
    int iRet = RET_NG;
    int iFuncRet = RET_NG;
    _TCHAR *pcTemp1 = NULL;
    _TCHAR *pcTemp2 = NULL;
    _TCHAR *pcTemp3 = NULL;
    _TCHAR *pcCommand = NULL;

    /** spe|t@C쐬 */
    iFuncRet = CDMtrLibUtilCreateStringW(&pcTemp1, pcTempFolderName, FOLDER_SEPALATE, TEMP_FILE1, NULL);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }
    iFuncRet = CDMtrLibUtilCreateStringW(&pcTemp2, pcTempFolderName, FOLDER_SEPALATE, TEMP_FILE2, NULL);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }
    iFuncRet = CDMtrLibUtilCreateStringW(&pcTemp3, pcTempFolderName, FOLDER_SEPALATE, TEMP_FILE3, NULL);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }

    /** }NAiCU[p̃R}h쐬 */
    iFuncRet = CDMtrCntExtToolCreateMacroAnalizerCommand(&pcCommand, pcFile, pcTemp1, pcTemp2, pcTemp3, pcNkfFile);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }

    /** }NAiCU[p̃R}hs */
    iFuncRet = CDMtrCntCallCreateProcess(MACROANALIZER, pcCommand, NULL, NULL, NULL);
    if (iFuncRet != RET_OK) {
        if (iDebug == DEBUG_ON) {
            CDMtrCntLogLogOutErrExec(pcTemp2);
        }
        CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000133, pcMacroAnalizerPath); //* MSG_LOG_ID_C_00000133 (MSG_LOG_ID_C_00000142, MSG_LOG_ID_C_00000144)
        goto FUNC_END;
    }

    /** sedR}h쐬 */
    CDMtrLibUtilFreeW((void **)&pcCommand);
    iFuncRet = CDMtrCntExtToolCreateSedCommand(&pcCommand, pcTemp3, pcResult, pcNkfFile);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }

    /** sedR}hs */
    iFuncRet = CDMtrCntCallCreateProcess(SEDTOOL, pcCommand, pcErrOutFile, NULL, NULL);
    if (iFuncRet != RET_OK) {
        if (iDebug == DEBUG_ON) {
            CDMtrCntLogLogOutErrExec(pcErrOutFile);
        }
        CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000134, pcSedToolPath); //* MSG_LOG_ID_C_00000134 (MSG_LOG_ID_C_00000143, MSG_LOG_ID_C_00000145)
        goto FUNC_END;
    }
    iRet = RET_OK;

FUNC_END:
    CDMtrLibUtilFreeW((void **)&pcTemp1);
    CDMtrLibUtilFreeW((void **)&pcTemp2);
    CDMtrLibUtilFreeW((void **)&pcTemp3);
    CDMtrLibUtilFreeW((void **)&pcCommand);

    return iRet;
}

/*!
    @brief      \[XR[ht@C̍s𑪒肷
*/
static int cdmtrCntLineCountDoDiffSrc(const _TCHAR *pcBaseFile,
                                      const _TCHAR *pcDistFile,
                                      const _TCHAR *pcBaseFilePath,
                                      const _TCHAR *pcDistFilePath,
                                      const _TCHAR *pcLangName)
{
    int iRet = RET_NG;
    int iFuncRet = RET_NG;
    _LCEXT_OPT tLcExtOpt;
    _TCHAR cResStatus[DIFF_STATUS_SIZE + 1];
    _LINECOUNT_LIST *ptBaseCountLinesList = NULL;
    _LINECOUNT_LIST *ptDistCountLinesList = NULL;
    int iIsBaseFile = RET_FALSE;
    int iIsDistFile = RET_FALSE;
    _DoDiffSrc tParam;

    memset(&tLcExtOpt, 0x00, sizeof(_LCEXT_OPT));
    memset(cResStatus, 0x00, (DIFF_STATUS_SIZE + 1)*sizeof(_TCHAR));
    memset(&tParam, 0x00, sizeof(_DoDiffSrc));

    /** Oo͗pt@CpXݒ肵ďo͂s */
    tParam.pcBaseFilePathLogOut = CDMtrLibFileRemoveLongPathMarkW(pcBaseFilePath);
    tParam.pcDistFilePathLogOut = CDMtrLibFileRemoveLongPathMarkW(pcDistFilePath);
    iFuncRet = CDMtrLibUtilMallocW((void **)&ptBaseCountLinesList, sizeof(_LINECOUNT_LIST));
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }
    iFuncRet = CDMtrLibUtilMallocW((void **)&ptDistCountLinesList, sizeof(_LINECOUNT_LIST));
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }

    /** CJEgڍ׍so͗pt@CpX쐬 */
    iFuncRet = CDMtrLibFileSetDirFileName(pcTempFolderName, TEMP_FILE_LCRET_BASE, &(tParam.pcBaseDetail));
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }
    iFuncRet = CDMtrLibFileSetDirFileName(pcTempFolderName, TEMP_FILE_LCRET_DIST, &(tParam.pcDistDetail));
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }

    /** rɃ_CNVt@CpX쐬 */
    iFuncRet = CDMtrLibFileSetDirFileName(pcTempFolderName, TEMP_FILE_DIFFRET, &(tParam.pcTempDiffStdOut));
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }

    /** WG[o͗pt@CpX쐬 */
    iFuncRet = CDMtrLibFileSetDirFileName(pcTempFolderName, TEMP_FILE_ERROUTPUT, &(tParam.pcTempErrOut));
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }

    /* t@CLݒ肷 */
    iIsBaseFile = CDMtrLibFileIsFile(pcBaseFile);
    iIsDistFile = CDMtrLibFileIsFile(pcDistFile);

    /** ֐̑Ή{ */
    if ( iDiffMode == OPTION_DIFF_FUNC ) {
        iFuncRet = cdmtrCntLineCountCreateInfoFile(pcBaseFile, pcDistFile, pcLangName, iIsBaseFile, iIsDistFile, &tParam);
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
    }

    if (iIsBaseFile && iIsDistFile) {
        /** IWit@CƕύXt@C̗݂ꍇ̍菈s */
        iFuncRet = cdmtrCntLineCountExistBothFile(pcBaseFile, pcDistFile, pcLangName, &tParam);
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
    } else if (iIsBaseFile) {
        /** IWit@Ĉݑ݂ꍇ */
        _tcscpy(cResStatus, DIFF_STATUS_DEL);

        /** Ot@Cݒ肷 */
        CDMtrLibCmnSetTargetName(tParam.pcBaseFilePathLogOut);

        /** R}hIvVݒ肷 */
        tLcExtOpt.pcTargetFile = (_TCHAR *)pcBaseFile;
        tLcExtOpt.pcLangName = (_TCHAR *)pcLangName;

        /** CJEg{ */
        if ( iDiffMode == OPTION_DIFF_FUNC ) {
            tLcExtOpt.pcDiffFuncPath = tParam.pcTempFuncBaseData;
        }
        iFuncRet = cdmtrCntLineCountExecuteLC(&tLcExtOpt, tParam.pcBaseDetail, CDMTR_FALSE, ptBaseCountLinesList);
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }

        /** ʂo͂ */
        iFuncRet = CDMtrCntOutputCSVDiffListToOutfile( tParam.pcDistFilePathLogOut,
                   tParam.pcBaseFilePathLogOut,
                   pcLangName,
                   cResStatus,
                   ptBaseCountLinesList);
    } else if (iIsDistFile) {
        /** ύXt@Ĉݑ݂ꍇ */
        _tcscpy(cResStatus, DIFF_STATUS_NEW);

        /** Ot@Cݒ肷 */
        CDMtrLibCmnSetTargetName(tParam.pcDistFilePathLogOut);

        /** R}hIvVݒ肷 */
        tLcExtOpt.pcTargetFile = (_TCHAR *)pcDistFile;
        tLcExtOpt.pcLangName = (_TCHAR *)pcLangName;

        /** CJEg{ */
        if ( iDiffMode == OPTION_DIFF_FUNC ) {
            tLcExtOpt.pcDiffFuncPath = tParam.pcTempFuncDistData;
        }
        iFuncRet = cdmtrCntLineCountExecuteLC(&tLcExtOpt, tParam.pcDistDetail, CDMTR_FALSE, ptDistCountLinesList);
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }

        /** ʂo͂ */
        iFuncRet = CDMtrCntOutputCSVDiffListToOutfile( tParam.pcDistFilePathLogOut,
                   tParam.pcBaseFilePathLogOut,
                   pcLangName,
                   cResStatus,
                   ptDistCountLinesList);
    } else {
        goto FUNC_END;
    }
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }
    iRet = RET_OK;
FUNC_END:
    CDMtrLibCmnClearTargetName();
    CDMtrLibUtilFreeW((void **) & (tParam.pcTempFuncBaseData));
    CDMtrLibUtilFreeW((void **) & (tParam.pcTempFuncDistData));
    CDMtrLibUtilFreeW((void **) & (tParam.pcBaseDetail));
    CDMtrLibUtilFreeW((void **) & (tParam.pcDistDetail));
    CDMtrLibUtilFreeW((void **) & (tParam.pcTempDiffStdOut));
    CDMtrLibUtilFreeW((void **) & (tParam.pcTempErrOut));
    CDMtrCntFuncFreeChain(ptBaseCountLinesList);
    CDMtrCntFuncFreeChain(ptDistCountLinesList);
    return iRet;
}

/*!
    @brief          ֐t@C쐬
*/
static int cdmtrCntLineCountCreateInfoFile(const _TCHAR *pcBaseFile,
        const _TCHAR *pcDistFile,
        const _TCHAR *pcLangName,
        int iIsBaseFile,
        int iIsDistFile,
        _DoDiffSrc *ptParam)
{
    int iRet = RET_NG;
    int iFuncRet = RET_NG;
    int iLangType, iCntLangType;
    _TCHAR langTypeBuf[8] = {0};
    _FUNCINFOFILE_OPT tFuncFileOpt;

    /** --debug2IvVǉB */
    if (iSpsDebug == DEBUG_ON) {
        tFuncFileOpt.pcOptDebug2 = STRUCT_OPTION_DEBUG2;
    } else {
        tFuncFileOpt.pcOptDebug2 = _T(" ");
    }

    /** C/C++ȈՌvʃc[IvV擾 ("--lang_name") */
    tFuncFileOpt.pcOptLangName = (_TCHAR *)pcLangName;

    /** gqŗLIvVݒ肷 */
    iLangType = globaliLangType;
    if ( iLangType == LANG_TYPE_CPP ) {
        iCntLangType = SPS_LANG_TYPE_CPP;
    } else if ( iLangType == LANG_TYPE_C ) {
        iCntLangType = SPS_LANG_TYPE_C;
    } else {
        goto FUNC_END;
    }

    /** iLangType10iɕϊ */
    iFuncRet = _itot_s(iCntLangType, langTypeBuf, sizeof(langTypeBuf) / sizeof(_TCHAR), 10);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }

    /** IvVw */
    tFuncFileOpt.pcOptLangType = langTypeBuf;
    tFuncFileOpt.pcOptOutFormat = OUT_FORMAT_FUNC;
    tFuncFileOpt.pcOptFuncOpt = FUNC_OPTION_PARAM;
    tFuncFileOpt.pcOptMetricSkip = (iSkipChangeFlg == 0) ? _T("old") : _T("new");
    tFuncFileOpt.pcOptQrtFlg = (giQrtOutFlg == CDMTR_TRUE) ? _T("EXCEL") : _T("NONE");
    tFuncFileOpt.pcErrPath = ptParam->pcTempErrOut;
    tFuncFileOpt.pcStructExePath = pcStructSmpPath;
    MACRO_PERFORMANCE_PUTLOG(PERFORMANCE_LVL3, _T("Create FuncInfoFile ,31,1")); //* MSG_LOG_ID_C_00000413

    if (iIsBaseFile) {
        /** ύXO֐t@CpX𐶐 */
        iFuncRet = CDMtrLibFileSetDirFileName(pcTempFolderName, TEMP_FUNC_DATA_BASE, &(ptParam->pcTempFuncBaseData));
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }

        /** ֐t@CpIvVݒ肷 */
        tFuncFileOpt.pcFilePath = (_TCHAR *)pcBaseFile;
        tFuncFileOpt.pcLogoutFilePath = (_TCHAR *)(ptParam->pcBaseFilePathLogOut);
        tFuncFileOpt.pcOutputPath = ptParam->pcTempFuncBaseData;

        /** ֐t@C𐶐 */
        iFuncRet = CDMtrCntFuncCreateFuncInfoFile(&tFuncFileOpt);
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
    }
    MACRO_PERFORMANCE_PUTLOG(PERFORMANCE_LVL3, _T("Created FuncInfoFile [old],31,2")); //* MSG_LOG_ID_C_00000414

    if (iIsDistFile) {
        /** ύX֐t@CpX𐶐 */
        iFuncRet = CDMtrLibFileSetDirFileName(pcTempFolderName, TEMP_FUNC_DATA_DIST, &(ptParam->pcTempFuncDistData));
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }

        /** ֐t@CpIvVݒ肷 */
        tFuncFileOpt.pcFilePath = (_TCHAR *)pcDistFile;
        tFuncFileOpt.pcLogoutFilePath = (_TCHAR *)(ptParam->pcDistFilePathLogOut);
        tFuncFileOpt.pcOutputPath = ptParam->pcTempFuncDistData;

        /** ֐t@C𐶐 */
        iFuncRet = CDMtrCntFuncCreateFuncInfoFile(&tFuncFileOpt);
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
    }
    MACRO_PERFORMANCE_PUTLOG(PERFORMANCE_LVL3, _T("Created FuncInfoFile [new],31,3")); //* MSG_LOG_ID_C_00000415

    iRet = RET_OK;
FUNC_END:
    return iRet;
}

/*!
    @brief          t@CύX/ύX̍s𑪒肷
*/
static int cdmtrCntLineCountExistBothFile(const _TCHAR *pcBaseFile,
        const _TCHAR *pcDistFile,
        const _TCHAR *pcLangName,
        _DoDiffSrc *ptParam)
{
    int iRet = RET_NG;
    int iFuncRet = RET_NG;
    _TCHAR *pcCommand = NULL;
    _LCEXT_OPT tLcExtOpt;
    _TCHAR cResStatus[DIFF_STATUS_SIZE + 1];
    _DIFFLINES tDiffLines;
    _LINECOUNT_LIST *ptBaseCountLinesList = NULL;
    _LINECOUNT_LIST *ptDistCountLinesList = NULL;
    _FUNC_MATCHING_LIST tFuncMatchingList;
    int iFileDiffKind = FILE_EQU;

    memset(&tLcExtOpt, 0x00, sizeof(_LCEXT_OPT));
    memset(cResStatus, 0x00, (DIFF_STATUS_SIZE + 1)*sizeof(_TCHAR));
    memset(&tDiffLines, 0x00, sizeof(_DIFFLINES));
    memset(&tFuncMatchingList, 0x00, sizeof(_FUNC_MATCHING_LIST));

    iFuncRet = CDMtrLibUtilMallocW((void **)&ptBaseCountLinesList, sizeof(_LINECOUNT_LIST));
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }
    iFuncRet = CDMtrLibUtilMallocW((void **)&ptDistCountLinesList, sizeof(_LINECOUNT_LIST));
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }

    /** Ot@Cݒ肷(IWit@C) */
    CDMtrLibCmnSetTargetName(ptParam->pcBaseFilePathLogOut);

    /** R}hIvVݒ肷 */
    tLcExtOpt.pcTargetFile = (_TCHAR *)pcBaseFile;
    tLcExtOpt.pcLangName = (_TCHAR *)pcLangName;

    /** IWit@Cɑ΂ăCJEg{ */
    if ( iDiffMode == OPTION_DIFF_FUNC ) {
        tLcExtOpt.pcDiffFuncPath = ptParam->pcTempFuncBaseData;
    }
    iFuncRet = cdmtrCntLineCountExecuteLC(&tLcExtOpt, ptParam->pcBaseDetail, CDMTR_TRUE, ptBaseCountLinesList);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }

    /** Ot@Cݒ肷(ύXt@C) */
    CDMtrLibCmnSetTargetName(ptParam->pcDistFilePathLogOut);

    /** R}hIvVݒ肷 */
    tLcExtOpt.pcTargetFile = (_TCHAR *)pcDistFile;
    tLcExtOpt.pcLangName = (_TCHAR *)pcLangName;

    /** ύXt@Cɑ΂ăCJEg{ */
    if ( iDiffMode == OPTION_DIFF_FUNC ) {
        tLcExtOpt.pcDiffFuncPath = ptParam->pcTempFuncDistData;
    }
    iFuncRet = cdmtrCntLineCountExecuteLC(&tLcExtOpt, ptParam->pcDistDetail, CDMTR_TRUE, ptDistCountLinesList);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }

    MACRO_PERFORMANCE_PUTLOG(PERFORMANCE_LVL3, _T("DiffMetrics (for MOD/EQU File) ,33,1")); //* MSG_LOG_ID_C_00000416
    MACRO_PERFORMANCE_PUTLOG(PERFORMANCE_LVL4, _T("CompareFiles ,41,1")); //* MSG_LOG_ID_C_00000417
    if ( iDiffMode != OPTION_DIFF_FUNC ) {
        /** diffR}h쐬 */
        if (!giDiffBlankFlg) {
            iFuncRet = CDMtrLibUtilCreateStringW(&pcCommand,
                                                 pcDiffPath, _T(" -b \""), ptParam->pcBaseDetail, _T("\" \""), ptParam->pcDistDetail, _T("\""), NULL);
        } else {
            iFuncRet = CDMtrLibUtilCreateStringW(&pcCommand,
                                                 pcDiffPath, _T(" \""), ptParam->pcBaseDetail, _T("\" \""), ptParam->pcDistDetail, _T("\""), NULL);
        }
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }

        /** diffR}hs */
        iFuncRet = CDMtrCntCallCreateProcess(DIFF, pcCommand, ptParam->pcTempDiffStdOut, ptParam->pcTempErrOut, NULL);
        MACRO_PERFORMANCE_PUTLOG(PERFORMANCE_LVL4, _T("Called diff.exe (FILE),41,2")); //* MSG_LOG_ID_C_00000418
        if (iFuncRet != RET_OK) {
            if (iDebug == DEBUG_ON) {
                CDMtrCntLogLogOutErrExec(ptParam->pcTempErrOut);
            }
            CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000146, pcDiffPath); //* MSG_LOG_ID_C_00000146
            goto FUNC_END;
        }

        /** ǉƍ폜JEg */
        iFuncRet = CDMtrCntLineCountDiffFileCheck(ptParam->pcTempDiffStdOut, &(ptDistCountLinesList->tLCData), &(tDiffLines));
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }

        /** ʂ𔻒肵ďo͂ */
        if (tDiffLines.tDiffTotal.ulAdd == 0 && tDiffLines.tDiffTotal.ulDel == 0 &&
                tDiffLines.tDiffTotal.ulModAdd == 0 && tDiffLines.tDiffTotal.ulModDel == 0) {
            _tcscpy(cResStatus, DIFF_STATUS_EXIST);
        } else {
            _tcscpy(cResStatus, DIFF_STATUS_CHANGED);
        }
        iFuncRet = CDMtrCntOutputCSVCountFileToOutFile(ptParam->pcDistFilePathLogOut,
                   ptParam->pcBaseFilePathLogOut,
                   NULL,
                   pcLangName,
                   NULL,
                   & (ptDistCountLinesList->tLCData),
                   &tDiffLines,
                   cResStatus,
                   FUNC_NONE
                                                      );
        MACRO_PERFORMANCE_PUTLOG(PERFORMANCE_LVL4, _T("Completed output (CompareFiles),41,3")); //* MSG_LOG_ID_C_00000419
    } else {
        iFuncRet = CDMtrCntFuncDoFuncMatching( (_TCHAR *)(ptParam->pcBaseDetail),
                                               (_TCHAR *)(ptParam->pcDistDetail),
                                               ptBaseCountLinesList,
                                               ptDistCountLinesList,
                                               &tFuncMatchingList,
                                               &iFileDiffKind);
        if ( iFuncRet == RET_NG) {
            goto FUNC_END;
        }
        if ( iFileDiffKind == FILE_EQU ) {
            _tcscpy(cResStatus, DIFF_STATUS_EXIST);
        } else {
            _tcscpy(cResStatus, DIFF_STATUS_CHANGED);
        }
        CDMtrCntOutputCSVMatchingListToOutfile( ptParam->pcDistFilePathLogOut,
                                                ptParam->pcBaseFilePathLogOut,
                                                pcLangName,
                                                cResStatus,
                                                &tFuncMatchingList);
        MACRO_PERFORMANCE_PUTLOG(PERFORMANCE_LVL4, _T("Completed output (CompareFiles),41,3")); //* MSG_LOG_ID_C_00000420
    }
    MACRO_PERFORMANCE_PUTLOG(PERFORMANCE_LVL3, _T("Completed output (for MOD/EQU File),33,3")); //* MSG_LOG_ID_C_00000421

    iRet = RET_OK;
FUNC_END:
    CDMtrLibUtilFreeW((void **)&pcCommand);
    CDMtrCntFuncFreeChain(ptBaseCountLinesList);
    CDMtrCntFuncFreeChain(ptDistCountLinesList);
    CDMtrCntFuncFreeChainMatchingList(tFuncMatchingList.next);

    return iRet;
}

/*!
    @brief      eLXgt@C̍s𑪒肷
*/
static int cdmtrCntLineCountDoDiffTxt(const _TCHAR *pcBaseFile,
                                      const _TCHAR *pcDistFile,
                                      const _TCHAR *pcBaseFilePath,
                                      const _TCHAR *pcDistFilePath,
                                      const _TCHAR *pcLangName)
{
    int iRet = RET_NG;
    int iFuncRet = RET_NG;
    int iExitCode = 0;
    const _TCHAR *pcStatus = NULL;
    const _TCHAR *pcBaseFileTmp = NULL;
    _TCHAR *pcTempDiffStdOut = NULL;
    _TCHAR *pcTempErrOut = NULL;
    long lTLOC = 0;
    _DIFFLINES tDiffLines;
    _LINECOUNT tCountLines;
    _TCHAR *pcCommand = NULL;
    const _TCHAR *pcDistFilePathLogOut = NULL;

    memset(&tDiffLines, 0x00, sizeof(_DIFFLINES));
    memset(&tCountLines, 0x00, sizeof(_LINECOUNT));
    pcDistFilePathLogOut = CDMtrLibFileRemoveLongPathMarkW(pcDistFilePath);
    pcBaseFileTmp = CDMtrLibFileRemoveLongPathMarkW(pcBaseFilePath);
    CDMtrLibCmnSetTargetName(pcDistFilePathLogOut);
    iFuncRet = CDMtrLibFileSetDirFileName(pcTempFolderName, TEMP_FILE_DIFFRET, &pcTempDiffStdOut);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }
    iFuncRet = CDMtrLibFileSetDirFileName(pcTempFolderName, TEMP_FILE_ERROUTPUT, &pcTempErrOut);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }
    if (CDMtrLibFileIsFile(pcBaseFile) && CDMtrLibFileIsFile(pcDistFile)) {
        lTLOC = CDMtrLibFileGetLineOfFileW(pcDistFile);
        if (lTLOC < 0) {
            goto FUNC_END;
        }
        tCountLines.ulTLOC = (unsigned long)lTLOC;
        iFuncRet = CDMtrLibUtilCreateStringW(&pcCommand, pcDiffPath, _T(" -a \""), pcBaseFile, _T("\" \""), pcDistFile, _T("\""), NULL);
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
        iFuncRet = CDMtrCntCallCreateProcess(DIFF, pcCommand, pcTempDiffStdOut, pcTempErrOut, &iExitCode);
        if (iFuncRet != RET_OK) {
            if (iDebug == DEBUG_ON) {
                CDMtrCntLogLogOutErrExec(pcTempErrOut);
            }
            CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000147, pcDiffPath); //* MSG_LOG_ID_C_00000147
            goto FUNC_END;
        }
        switch (iExitCode) {
        case 0:
            pcStatus = DIFF_STATUS_EXIST;
            tDiffLines.tDiffTotal.ulEqu = (unsigned long)lTLOC;
            break;
        case 1:
            pcStatus = DIFF_STATUS_CHANGED;
            if (giDiffCountMode == DIFF_COUNT_EXT) {
                cdmtrCntLineCountDiffFileCheckTxt(pcTempDiffStdOut, lTLOC, &(tDiffLines));
            }
            break;
        default:
            goto FUNC_END;
        }
    } else if (CDMtrLibFileIsFile(pcBaseFile)) {
        pcStatus = DIFF_STATUS_DEL;
        lTLOC = CDMtrLibFileGetLineOfFileW(pcBaseFile);
        if (lTLOC < 0) {
            goto FUNC_END;
        }
        tDiffLines.tDiffTotal.ulDel = (unsigned long)lTLOC;
    } else if (CDMtrLibFileIsFile(pcDistFile)) {
        pcStatus = DIFF_STATUS_NEW;
        lTLOC = CDMtrLibFileGetLineOfFileW(pcDistFile);
        if (lTLOC < 0) {
            goto FUNC_END;
        }
        tCountLines.ulTLOC = (unsigned long)lTLOC;
        tDiffLines.tDiffTotal.ulAdd = (unsigned long)lTLOC;
        pcBaseFileTmp = NULL;
    } else {
        goto FUNC_END;
    }
    iFuncRet = CDMtrCntOutputCSVCountFileToOutFile(pcDistFilePathLogOut,
               pcBaseFileTmp,
               NULL,
               pcLangName,
               NULL,
               &tCountLines,
               &tDiffLines,
               pcStatus,
               FUNC_NONE
                                                  );
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }
    iRet = RET_OK;
FUNC_END:
    CDMtrLibCmnClearTargetName();
    CDMtrLibUtilFreeW((void **)&pcTempDiffStdOut);
    CDMtrLibUtilFreeW((void **)&pcTempErrOut);
    CDMtrLibUtilFreeW((void **)&pcCommand);
    return iRet;
}

/*!
    @brief          ڍ׍s񂩂獷s̃JEgs
*/
static void cdmtrCntLineCountDiffCount(int iADDFlg, int iMODFlg, _DIFFDETAIL *ptDiffDetail)
{
    if (iMODFlg) {
        if (iADDFlg) {
            ptDiffDetail->ulModAdd++;
        } else {
            ptDiffDetail->ulModDel++;
        }
    } else {
        if (iADDFlg) {
            ptDiffDetail->ulAdd++;
        } else {
            ptDiffDetail->ulDel++;
        }
    }
    return ;
}

/*!
    @brief          rʂ獷s̃JEgs(eLXgt@C)
*/
static int cdmtrCntLineCountDiffFileCheckTxt(_TCHAR *pcFileName, long lSize, _DIFFLINES *ptDiffLines)
{
    int iRet = RET_NG;
    int iFuncRet = RET_NG;
    FILE *fp = NULL;
    _TCHAR *pcBuff = NULL;
    _TCHAR *p = NULL;
    int iADDFlg;
    int iMODFlg;
    iADDFlg = CDMTR_FALSE;
    iMODFlg = CDMTR_FALSE;
    if ((fp = _tfopen(pcFileName, _T("r"))) == NULL) {
        CDMtrLibCmnTrcLogOut(MSG_LOG_ID_C_00000391, pcFileName); //* MSG_LOG_ID_C_00000391
        goto FUNC_END;
    }
    iFuncRet = CDMtrLibUtilMallocW((void **)&pcBuff, BUFF_LINE_SIZE);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }
    while (_fgetts(pcBuff, BUFF_LINE_LENGTH, fp) != NULL) {
        p = pcBuff;
        if (*p == DIFF_START_DEL) {
            iADDFlg = CDMTR_FALSE;
        } else if (*p == DIFF_START_ADD) {
            iADDFlg = CDMTR_TRUE;
        } else if (CDMtrLibUtilIsDigit(*p)) {
            if (giDiffCountMode == DIFF_COUNT_EXT) {
                iMODFlg = CDMTR_FALSE;
                while (!IS_NULL_CHAR(p)) {
                    if (*p == _T('c')) {
                        iMODFlg = CDMTR_TRUE;
                        break;
                    } else if (*p == _T('a') || *p == _T('d')) {
                        iMODFlg = CDMTR_FALSE;
                        break;
                    } else {
                        p++;
                    }
                }
            } else {
                iMODFlg = CDMTR_FALSE;
            }
            continue;
        } else {
            continue;
        }
        cdmtrCntLineCountDiffCount(iADDFlg, iMODFlg, &(ptDiffLines->tDiffTotal));
    }
    ptDiffLines->tDiffTotal.ulEqu =
        lSize - ptDiffLines->tDiffTotal.ulAdd - ptDiffLines->tDiffTotal.ulModAdd;
    iRet = RET_OK;
FUNC_END:
    if (fp) {
        fclose(fp);
        fp = NULL;
    }
    CDMtrLibUtilFreeW((void **)&pcBuff);
    return iRet;
}

/*!
    @brief          {s̃JEgs(sp)
*/
static int cdmtrCntLineCountExecuteLC(_LCEXT_OPT *ptLcOpt, _TCHAR *pcStdOut, int iDetail, _LINECOUNT_LIST *ptLineCountList)
{
    int iRet = RET_NG;
    int iFuncRet = RET_NG;

    MACRO_PERFORMANCE_PUTLOG(PERFORMANCE_LVL3, _T("BasicLineCount(for diff) ,32,1")); //* MSG_LOG_ID_C_00000422
    if (ptLcOpt == NULL) {
        goto FUNC_END;
    }
    if (ptLcOpt->pcTargetFile == NULL ||
            ptLcOpt->pcLangName == NULL) {
        CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000178); //* MSG_LOG_ID_C_00000178
        goto FUNC_END;
    }
    cdmtrCntLineCountLCOptInit();
    gtOptInfo_lc.pcLangName = (_TCHAR *)ptLcOpt->pcLangName;
    gtOptInfo_lc.pcInputpath = (_TCHAR *)ptLcOpt->pcTargetFile;
    if (iDiffMode == OPTION_DIFF_FUNC) {
        gtOptInfo_lc.pcDiffFuncPath = (_TCHAR *)ptLcOpt->pcDiffFuncPath;
        iFuncRet = CDMtrCntFuncCreateFuncList(gtOptInfo_lc.pcDiffFuncPath, ptLineCountList);
        if (iFuncRet != RET_OK) {
            CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000179); //* MSG_LOG_ID_C_00000179
            goto FUNC_END;
        }
        MACRO_PERFORMANCE_PUTLOG(PERFORMANCE_LVL3, _T("Created FuncList,32,2")); //* MSG_LOG_ID_C_00000423
    }
    if (iProfileFlag == CDMTR_TRUE) {
        if (pcProfFileName != NULL) {
            gtOptInfo_lc.pcProppath = pcProfFileName;
        }
    }
    if (!giDocFlag) {
        gtOptInfo_lc.iDocFlg = CDMTR_FALSE;
    }
    if (!giCmntCaseFlag) {
        gtOptInfo_lc.iCmntCaseFlg = CDMTR_FALSE;
    } else {
        gtOptInfo_lc.iCmntCaseFlg = CDMTR_TRUE;
    }
    if (iDetail) {
        gtOptInfo_lc.iDetailFlg = CDMTR_TRUE;
    }
    if (giDiffBlankFlg) {
        gtOptInfo_lc.iDetailBlankFlg = CDMTR_TRUE;
    }
    if (pcStdOut != NULL) {
        MACRO_PERFORMANCE_PUTLOG(PERFORMANCE_LVL7, _T("OpenFile : [temp_lc_ret_XXXX.tmp] <S>")); //* MSG_LOG_ID_C_00000424
        if (NULL == (fp_diff_ret_file = _tfopen(pcStdOut, _T("w")))) {
            iRet = RET_NG;
            CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000180); //* MSG_LOG_ID_C_00000180
            goto FUNC_END;
        } else {
            if (_tcsstr(pcStdOut, TEMP_FILE_LCRET_BASE) != NULL) {
                gtOptInfo_lc.lc_ret_base = (_TCHAR *)pcStdOut;
                gtOptInfo_lc.iDiffStatusFlg = DIFF_BASE;
            } else if (_tcsstr(pcStdOut, TEMP_FILE_LCRET_DIST) != NULL) {
                gtOptInfo_lc.lc_ret_dist = (_TCHAR *)pcStdOut;
                gtOptInfo_lc.iDiffStatusFlg = DIFF_DIST;
            } else {
            }
        }
        MACRO_PERFORMANCE_PUTLOG(PERFORMANCE_LVL7, _T("OpenFile : [temp_lc_ret_XXXX.tmp] <E>")); //* MSG_LOG_ID_C_00000425
    } else {
    }
    iFuncRet = cdmtrExtMain(ptLineCountList);
    if (iFuncRet != RET_OK) {
        if (iDebug == DEBUG_ON) {
            CDMtrCntLogLogOutErrExec(pcStdOut);
        }
        goto FUNC_END;
    }
    iRet = RET_OK;
FUNC_END:
    if (fp_diff_ret_file != NULL) {
        MACRO_PERFORMANCE_PUTLOG(PERFORMANCE_LVL7, _T("CloseFile : [temp_lc_ret_XXXX.tmp] <S>")); //* MSG_LOG_ID_C_00000426
        fclose(fp_diff_ret_file);
        MACRO_PERFORMANCE_PUTLOG(PERFORMANCE_LVL7, _T("CloseFile : [temp_lc_ret_XXXX.tmp] <E>")); //* MSG_LOG_ID_C_00000427
    }
    MACRO_PERFORMANCE_PUTLOG(PERFORMANCE_LVL3, _T("Finished BasicLineCount(for diff),32,3")); //* MSG_LOG_ID_C_00000428
    return iRet;
}

/*!
    @brief      {sJEgIvV񏉊
*/
static void cdmtrCntLineCountLCOptInit()
{
    gtOptInfo_lc.iHeaderFlg = CDMTR_FALSE;
    gtOptInfo_lc.iDocFlg = CDMTR_TRUE;
    gtOptInfo_lc.iCmntCaseFlg = CDMTR_TRUE;
    gtOptInfo_lc.iLangType = LANG_TYPE_UNKNOW;
    gtOptInfo_lc.iDetailFlg = CDMTR_FALSE;
    gtOptInfo_lc.pcCommandLine = NULL;
    gtOptInfo_lc.pcInputpath = NULL;
    gtOptInfo_lc.pcProppath = NULL;
    gtOptInfo_lc.pcLangName = NULL;
    gtOptInfo_lc.lc_ret_base = NULL;
    gtOptInfo_lc.lc_ret_dist = NULL;
    gtOptInfo_lc.pcDiffFuncPath = NULL;
}
