/*
 *  source code metrics counter
 *  Copyright (C) 2015  NEC Corporation.
 *  
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
#define _CRT_SECURE_NO_WARNINGS
#include "CDMtrCmn.h"
#include "CDMtrLibOptW.h"
#include "CDMtrLibUtilW.h"
#include "CDMtrLibCmnW.h"
#include "CDMtrLibFileW.h"
#include "CDMtrLibSystemW.h"

#include "CDMtrCntMain.h"
#include "CDMtrCntExtTool.h"
#include "CDMtrMessage.h"


/*----------------------------------------------------------------------------*/
/* define                                                                     */
/*----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------*/
/* structure definition                                                       */
/*----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------*/
/* global variable declaration                                                */
/*----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------*/
/* static variable declaration                                                */
/*----------------------------------------------------------------------------*/
/*!
    @brief IvVe[u

    IvVƃIvVAp[^ێL`e[u
*/
static OptionInfo stOptionArray[] = {
    { OPTION_DIFF_BLANK,        OPTION_STR_DIFFBLANK,           OPT_HAS_PARAM },
    { OPTION_EXECUTION_ROW,     OPTION_STR_EXECUTION_ROW,       OPT_HAS_NOPARAM },
    { OPTION_DIFF_FILE,			OPTION_STR_DIFF_FILE,			OPT_HAS_NOPARAM },
    { OPTION_DIFF_FUNC,			OPTION_STR_DIFF_FUNC,			OPT_HAS_NOPARAM },
    { OPTION_EXECUTION_DIFF,    OPTION_STR_EXECUTION_DIFF,      OPT_HAS_NOPARAM },
    { OPTION_STRUCT_STD,        OPTION_STR_STRUCT_STD,          OPT_HAS_NOPARAM },
    { OPTION_STRUCT_SMP,        OPTION_STR_STRUCT_SMP,          OPT_HAS_NOPARAM },
    { OPTION_EXECUTION_STRUCT,  OPTION_STR_EXECUTION_STRUCT,    OPT_HAS_NOPARAM },
    { OPTION_EXECUTION_CK,		OPTION_STR_EXECUTION_CK,		OPT_HAS_NOPARAM },
    { OPTION_F_OUTPUT_MODE,     OPTION_STR_F_OUTPUT_MODE,       OPT_HAS_PARAM },
    { OPTION_TFO_OUTFILE,       OPTION_STR_TFO_OUTFILE,         OPT_HAS_PARAM },
    { OPTION_TFP_PROPFILE,      OPTION_STR_TFP_PROPFILE,        OPT_HAS_PARAM },
    { OPTION_D_MACRO,           OPTION_STR_D_MACRO,             OPT_HAS_PARAM },
    { OPTION_U_MACRO,           OPTION_STR_U_MACRO,             OPT_HAS_PARAM },
    { OPTION_I_DIR,             OPTION_STR_I_DIR,               OPT_HAS_PARAM },
    { OPTION_OPT_CLASS,         OPTION_STR_OPT_CLASS,           OPT_HAS_PARAM },
    { OPTION_V_SHOWDETAILS,     OPTION_STR_V_SHOWDETAILS,       OPT_HAS_NOPARAM },
    { OPTION_HELP_USAGE,        OPTION_STR_HELP_USAGE,          OPT_HAS_OPTPARAM },
    { OPTION_RESTYLE,           OPTION_STR_RESTYLE,             OPT_HAS_PARAM },
    { OPTION_STMT,              OPTION_STR_STMT,                OPT_HAS_NOPARAM },
    { OPTION_TTC,               OPTION_STR_TTC,                 OPT_HAS_PARAM },
    { OPTION_LCDEBUG,           OPTION_STR_LCDEBUG,             OPT_HAS_NOPARAM },
    { OPTION_SPS_DEBUG,         OPTION_STR_SPS_DEBUG,           OPT_HAS_NOPARAM },
    { OPTION_DEBUG,             OPTION_STR_DEBUG,               OPT_HAS_NOPARAM },
    { OPTION_HEADER_ADD,        OPTION_STR_HEADER_ADD,          OPT_HAS_NOPARAM },
    { OPTION_HEADER,            OPTION_STR_HEADER,              OPT_HAS_NOPARAM },
    { OPTION_MAKE,              OPTION_STR_MAKE,                OPT_HAS_NOPARAM },
    { OPTION_FOOTER,            OPTION_STR_FOOTER,              OPT_HAS_NOPARAM },
    { OPTION_STDATE,            OPTION_STR_STDATE,              OPT_HAS_PARAM },
    { OPTION_EDDATE,            OPTION_STR_EDDATE,              OPT_HAS_PARAM },
    { OPTION_CHARSET,           OPTION_STR_CHARSET,             OPT_HAS_PARAM },
    { OPTION_RESULT_CODE,       OPTION_STR_RESULT_CODE,         OPT_HAS_PARAM },
    { OPTION_LOG_CODE,          OPTION_STR_LOG_CODE,            OPT_HAS_PARAM },
    { OPTION_PERFORMANCE,       OPTION_STR_PERFORMANCE,         OPT_HAS_PARAM },
};

static _OPTFLAGS stOptFlags;
static int siFileCount = 0;
static int siOptFileCount = 0;
static _FileList *sptInFileNames = NULL;
static _FileList *sptInOptFileNames = NULL;

/*----------------------------------------------------------------------------*/
/* static function  declaration                                               */
/*----------------------------------------------------------------------------*/
static int cdmtrCntOptionsGetAbsolutePath(_TCHAR *pcParamStr, _TCHAR **pcFilePath, const _TCHAR **pcLogoutFilePath);
static int cdmtrCntOptionsAnalyzeF(_TCHAR *pcParamStr);
static int cdmtrCntOptionsAnalyzeD(_TCHAR *pcParamStr);
static int cdmtrCntOptionsAnalyzeU(_TCHAR *pcParamStr);
static int cdmtrCntOptionsAnalyzeI(_TCHAR *pcParamStr);
static int cdmtrCntOptionsAnalyzeOptclass(_TCHAR *pcParamStr);
static int cdmtrCntOptionsAnalyzeHelp(_TCHAR *pcParamStr, _SysLocale *ptSysLocale);
static int cdmtrCntOptionsAnalyzeRestyle(_TCHAR *pcParamStr);
static int cdmtrCntOptionsAnalyzeDiffblank(_TCHAR *pcParamStr);
static void cdmtrCntOptionsSetHeaderFoooterFlg(int iChkRes);

/*----------------------------------------------------------------------------*/
/* global function declaration                                                */
/*----------------------------------------------------------------------------*/
int CDMtrCntOptionsAnalyzeOption(int argc, _TCHAR *argv[], _SysLocale *ptSysLocale);
int CDMtrCntOptionsAnalyzeInputFiles(int argc, _TCHAR *argv[]);
int CDMtrCntOptionsCheckFile(void);
_FileList *CDMtrCntOptionsGetInputFiles(void);
_FileList *CDMtrCntOptionsGetOptFiles(void);
void CDMtrCntOptionsFreeFileList(void);
int CDMtrCntOptionsToolOptionStrcatSpace(void);

/*----------------------------------------------------------------------------*/
/* global function                                                            */
/*----------------------------------------------------------------------------*/
/*!
    @brief      IvV͂
*/
int CDMtrCntOptionsAnalyzeOption(int argc, _TCHAR *argv[], _SysLocale *ptSysLocale)
{
    int iRet = RET_NG;
    int iFuncRet = RET_NG;
    OptionType iChkRes;
    _TCHAR *pcParamStr = NULL;

    /**  */
    CDMtrLibOptInitGetParameter(stOptionArray, sizeof(stOptionArray) / sizeof(OptionInfo));
    memset(&stOptFlags, 0x00, sizeof(_OPTFLAGS));

    /* Oc[IvV̈̏ */
    CDMtrLibUtilFreeW((void **)&pcKnownOpts);
    CDMtrLibUtilFreeW((void **)&pcKnownOptsCmdBuf);

    /** IvV͂ */
    while (OPTION_END != (iChkRes = (OptionType)CDMtrLibOptGetParameter(argc, argv, &pcParamStr))) {
        switch (iChkRes) {
        case OPTION_ERROR:      // ̓G[
        case OPTION_NOINIT:     // G[
            goto FUNC_END;
            break;

        case OPTION_NOOPTION:
            /* IvVȊO̓͒ĺA͑Ώۃt@C(tH_)Ɣf */
            /* wl̊mF̓IvV͌ɍs߁A ł̓t@C(tH_)̂݃JEg */
            siFileCount++;
            break;

        case OPTION_MUSTPARAM:
            /* IvVp[^ݒG[ */
            CDMtrLibCmnErrLogOut(MSG_INVALID_MUSTPARAM, ERR_LOG_ID_EC_00000081, pcParamStr); //* MSG_LOG_ID_C_00000081
            CDMtrLibCmnErrLogOut(MSG_SHOW_MOREINFO, ERR_LOG_ID_EC_00000082); //* MSG_LOG_ID_C_00000082
            goto FUNC_END;
            break;

        case OPTION_EXECUTION_ROW:  /* -row */
            stOptFlags.bOpt_ExecutionMode = CDMTR_TRUE;
            iExecuteMode = ROW_MODE;
            break;

        case OPTION_DIFF_FILE:      /* -diff_file */
        case OPTION_DIFF_FUNC:      /* -diff_func */
        case OPTION_EXECUTION_DIFF: /* -diff */
            stOptFlags.bOpt_ExecutionMode = CDMTR_TRUE;
            iExecuteMode = DIFF_MODE;
            if (iChkRes != OPTION_EXECUTION_DIFF) {
                if (iChkRes == OPTION_DIFF_FUNC) {
                    iDiffMode = OPTION_DIFF_FUNC;
                } else {
                    iDiffMode = OPTION_DIFF_FILE;
                }
            }
            break;

        case OPTION_STRUCT_STD:         /* -struct_std */
#ifdef OSS
            /* -struct_std͎słȂ */
            CDMtrLibCmnErrLogOut(MSG_UNKNOWN_OPTION, ERR_LOG_ID_EC_00000816, OPTION_STR_STRUCT_STD); //* MSG_LOG_ID_C_00000816
            CDMtrLibCmnErrLogOut(MSG_SHOW_MOREINFO, ERR_LOG_ID_EC_00000817); //* MSG_LOG_ID_C_00000817
            goto FUNC_END;
            break;
#endif //OSS
        case OPTION_STRUCT_SMP:         /* -struct_smp */
        case OPTION_EXECUTION_STRUCT:   /* -struct */
            stOptFlags.bOpt_ExecutionMode = CDMTR_TRUE;
            iExecuteMode = STRUCT_MODE;
            if (iChkRes != OPTION_EXECUTION_STRUCT) {
                if (iChkRes == OPTION_STRUCT_SMP) {
                    iStructMode = OPTION_STRUCT_SMP;
                } else {
                    iStructMode = OPTION_STRUCT_STD;
                }
            }
            break;

        case OPTION_EXECUTION_CK:   /* -ck */
#ifdef OSS
            /* -ck͎słȂ */
            CDMtrLibCmnErrLogOut(MSG_UNKNOWN_OPTION, ERR_LOG_ID_EC_00000818, OPTION_STR_EXECUTION_CK); //* MSG_LOG_ID_C_00000818
            CDMtrLibCmnErrLogOut(MSG_SHOW_MOREINFO, ERR_LOG_ID_EC_00000819); //* MSG_LOG_ID_C_00000819
            goto FUNC_END;
#else
            stOptFlags.bOpt_ExecutionMode = CDMTR_TRUE;
            iExecuteMode = CK_MODE;
#endif //OSS
            break;

        case OPTION_F_OUTPUT_MODE:
            /* 茋ʃt@CtH[}bgw(-F) */
            iFuncRet = cdmtrCntOptionsAnalyzeF(pcParamStr);
            if (iFuncRet != RET_OK) {
                goto FUNC_END;
            }
            break;

        case OPTION_TFO_OUTFILE:
            /* 茋ʃt@Cw(-Tfo) */
            stOptFlags.bOpt_Tfo_Outfile = CDMTR_TRUE;
            /* 茋ʃt@Cݒ肷 */
            iFuncRet = cdmtrCntOptionsGetAbsolutePath(pcParamStr, &pcOutFileName, &pcOutFileNameLogOut);
            if (iFuncRet != RET_OK) {
                goto FUNC_END;
            }
            break;

        case OPTION_TFP_PROPFILE:
            /* vpeBt@Cw(-Tfp) */
            stOptFlags.bOpt_Tfp_Propfile = CDMTR_TRUE;
            /* vpeBt@Cݒ肷 */
            iFuncRet = cdmtrCntOptionsGetAbsolutePath(pcParamStr, &pcProfFileName, &pcProfFileNameLogOut);
            if (iFuncRet != RET_OK) {
                goto FUNC_END;
            }
            break;

        case OPTION_D_MACRO:
            /* `؂蕪}Nw(-D) */
            iFuncRet = cdmtrCntOptionsAnalyzeD(pcParamStr);
            if (iFuncRet != RET_OK) {
                goto FUNC_END;
            }
            break;

        case OPTION_U_MACRO:
            /* c[sIvVw(-U) */
            iFuncRet = cdmtrCntOptionsAnalyzeU(pcParamStr);
            if (iFuncRet != RET_OK) {
                goto FUNC_END;
            }
            break;

        case OPTION_I_DIR:
            /* CN[hpXw(-I) */
            iFuncRet = cdmtrCntOptionsAnalyzeI(pcParamStr);
            if (iFuncRet != RET_OK) {
                goto FUNC_END;
            }
            break;

        case OPTION_OPT_CLASS:
            /* ⏕NXw(-optclass) */
            iFuncRet = cdmtrCntOptionsAnalyzeOptclass(pcParamStr);
            if (iFuncRet != RET_OK) {
                goto FUNC_END;
            }
            break;

        case OPTION_HELP_USAGE:
            /* wv\w(--help) */
            iFuncRet = cdmtrCntOptionsAnalyzeHelp(pcParamStr, ptSysLocale);
            if (iFuncRet != RET_OK) {
                goto FUNC_END;
            }
            break;

        case OPTION_V_SHOWDETAILS:
            /* sO\w(-v) */
            iShowDetails = DETAILS_SHOW;
            break;

        case OPTION_SPS_DEBUG:
            /* fobOO(ڍ)o͎w(-debug2) */
            iSpsDebug = DEBUG_ON;
            break;

        case OPTION_DEBUG:
            /* fobOOo͎w(-debug) */
            iDebug = DEBUG_ON;
            break;

        case OPTION_LCDEBUG:
            /* ڍ׏񃍃Oo(-detail) */
            giMoreDebug = DEBUG_ON;
            break;

        case OPTION_RESTYLE:
            /* \[XR[h`w(-RESTYLE) */
            iFuncRet = cdmtrCntOptionsAnalyzeRestyle(pcParamStr);
            if (iFuncRet != RET_OK) {
                goto FUNC_END;
            }
            break;

        case OPTION_STMT:
            break;

        case OPTION_TTC:
            /* RpCw(-Ttc) */
            if (pcParamStr != NULL) {
                CDMtrLibUtilFreeW((void **)&gpcCompType);
                iFuncRet = CDMtrLibUtilCreateStringW(&gpcCompType, pcParamStr, NULL);
                if (iFuncRet != RET_OK) {
                    goto FUNC_END;
                }
            }
            break;

        case OPTION_HEADER:         // -headerw
        case OPTION_HEADER_ADD:     // -header_addw
        case OPTION_MAKE:           // -makew
        case OPTION_FOOTER:         // -footerw
            cdmtrCntOptionsSetHeaderFoooterFlg((int)iChkRes);
            break;

        case OPTION_STDATE:
            /* -STDATEw */
            if (pcParamStr != NULL) {
                CDMtrLibUtilFreeW((void **)&pcStartDate);
                pcStartDate = CDMtrLibUtilCopyString(pcParamStr);
                if (pcStartDate == NULL) {
                    goto FUNC_END;
                }
            }
            break;

        case OPTION_EDDATE:
            /* -EDDATEw */
            if (pcParamStr != NULL) {
                CDMtrLibUtilFreeW((void **)&pcEndDate);
                pcEndDate = CDMtrLibUtilCopyString(pcParamStr);
                if (pcEndDate == NULL) {
                    goto FUNC_END;
                }
            }
            break;

        case OPTION_CHARSET:
            break;

        case OPTION_DIFF_BLANK:
            /* s̋󔒂̈w(-diff_blank) */
            iFuncRet = cdmtrCntOptionsAnalyzeDiffblank(pcParamStr);
            if (iFuncRet != RET_OK) {
                goto FUNC_END;
            }
            break;

        case OPTION_RESULT_CODE:
            /* CSV`茋ʃt@C̕R[hw(-Qrc) */
            if (pcParamStr != NULL) {
                CDMtrLibUtilFreeW((void **)&pcQrc_option);
                pcQrc_option = CDMtrLibUtilCopyString(pcParamStr);
                if (pcQrc_option == NULL) {
                    goto FUNC_END;
                }
                CDMtrLibUtilFreeW((void **)&pcResultCodeOpts);
                pcResultCodeOpts = CDMtrLibUtilCheckOutputCharsetW(pcParamStr);
            }
            break;

        case OPTION_LOG_CODE:
            /* O̕R[hw(-Qlg) */
            if (pcParamStr != NULL) {
                CDMtrLibUtilFreeW((void **)&pcQlg_option);
                pcQlg_option = CDMtrLibUtilCopyString(pcParamStr);
                if (pcQlg_option == NULL) {
                    goto FUNC_END;
                }
                CDMtrLibUtilFreeW((void **)&pcLogCodeOpts);
                pcLogCodeOpts = CDMtrLibUtilCheckOutputCharsetW(pcParamStr);
            }
            break;

        case OPTION_PERFORMANCE:
            /* \胍Oo͎w(--performance) */
            if (pcParamStr != NULL) {
                giPerformance = _tcstol(pcParamStr, NULL, 0);
            }
            break;

        case OPTION_UNKNOWN:
        default:
            /* z肵ȂIvVw肳ĂꍇAG[ */
            CDMtrLibCmnErrLogOut(MSG_INVALID_OPTION, ERR_LOG_ID_EC_00000102, pcParamStr); //* MSG_LOG_ID_C_00000102
            CDMtrLibCmnErrLogOut(MSG_SHOW_MOREINFO, ERR_LOG_ID_EC_00000103); //* MSG_LOG_ID_C_00000103
            goto FUNC_END;
        }
        CDMtrLibUtilFreeW((void **)&pcParamStr);
    }
    CDMtrLibOptFinishGetParameter();
    iRet = RET_OK;
FUNC_END:
    CDMtrLibUtilFreeW((void **)&pcParamStr);
    return iRet;
}

/*!
    @brief      R}hɎw肳ꂽt@C(tH_)mF
*/
int CDMtrCntOptionsAnalyzeInputFiles(int argc, _TCHAR *argv[])
{
    int iRet = RET_NG;
    int iFuncRet = RET_NG;
    OptionType iChkRes = OPTION_NONE;
    _TCHAR *pcParamStr = NULL;
    _TCHAR *pcTargetPath = NULL;
    _TCHAR *pcAbsolutePath = NULL;

    /** 茋ʃt@C[Command Parameter]ɎsR}hݒ肷 */
    iFuncRet = CDMtrLibUtilCreateStringW(&pcCommandOptions, argv[0], NULL);
    if (iFuncRet != RET_OK) {
        CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000104); //* MSG_LOG_ID_C_00000104
        goto FUNC_END;
    }
    iFuncRet = CDMtrCntExtToolCreateCommandParameter(&stOptFlags);
    if (iFuncRet != RET_OK) {
        CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000105); //* MSG_LOG_ID_C_00000105
        goto FUNC_END;
    }

    /** ͑Ώۃt@C(tH_)̊i[̈ */
    iFuncRet = CDMtrLibUtilMallocW((void **)&sptInFileNames, sizeof(_FileList) + (siFileCount - 1) * sizeof (_TCHAR *));
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }
    sptInFileNames->count = 0;

    /** ⏕NXt@C̊i[̈ */
    iFuncRet = CDMtrLibUtilMallocW((void **)&sptInOptFileNames, sizeof(_FileList) + (siOptFileCount - 1) * sizeof (_TCHAR *));
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }
    sptInOptFileNames->count = 0;

    /** IvV͏ */
    CDMtrLibOptInitGetParameter(stOptionArray, sizeof(stOptionArray) / sizeof(OptionInfo));

    /** IvV͂ */
    while (OPTION_END != (iChkRes = (OptionType)CDMtrLibOptGetParameter(argc, argv, &pcParamStr))) {
        switch (iChkRes) {
        case OPTION_NOOPTION:
            /* ͑Ώۃt@C(tH_) */
            /* ΃pXɕϊ */
            iFuncRet = CDMtrLibFileGetAbsolutePath(pcParamStr, &pcTargetPath);
            if (iFuncRet != RET_OK) {
                goto FUNC_END;
            }

            /* 茋ʃt@C[Command Parameter]ɐݒ肷쐬 */
            iFuncRet = CDMtrLibUtilCreateStringW(&pcCommandOptions_OTHER, OPTION_SEPARATE_SPACE, CDMtrLibFileRemoveLongPathMarkW(pcTargetPath), NULL);
            if (iFuncRet != RET_OK) {
                CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000106); //* MSG_LOG_ID_C_00000106
                goto FUNC_END;
            }
            /* ͑Ώۃt@C(tH_)ɐݒ肷 */
            sptInFileNames->filename[sptInFileNames->count] = pcTargetPath;
            sptInFileNames->count++;
            pcTargetPath = NULL;    // ̈h~
            break;

        case OPTION_OPT_CLASS:
            /* ⏕NXt@C */
            /* ΃pXɕϊ */
            iFuncRet = CDMtrLibFileGetAbsolutePath(pcParamStr, &pcAbsolutePath);
            if (iFuncRet != RET_OK) {
                goto FUNC_END;
            }

            /* ⏕NXt@Cɐݒ肷 */
            sptInOptFileNames->filename[sptInOptFileNames->count] = pcAbsolutePath;
            sptInOptFileNames->count++;
            pcAbsolutePath = NULL;    // ̈h~
            break;

        default:
            break;
        }
        CDMtrLibUtilFreeW((void **)&pcParamStr);
    }
    iRet = RET_OK;
FUNC_END:
    CDMtrLibUtilFreeW((void **)&pcParamStr);
    CDMtrLibUtilFreeW((void **)&pcTargetPath);
    CDMtrLibUtilFreeW((void **)&pcAbsolutePath);
    CDMtrLibOptFinishGetParameter();
    return iRet;
}

/*!
    @brief      R}hɎw肳ꂽΏۃt@C(tH_)mF
*/
int CDMtrCntOptionsCheckFile(void)
{
    int iRet = RET_NG;

    /** R}hɎw肳ꂽ̓t@C(tH_)mF */
    if (sptInFileNames->count == 0) {
        if ((giOutHeaderFlg && !giOutFooterFlg) ||
                (!giOutHeaderFlg && giOutFooterFlg)
           ) {
        } else {
            CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000108); //* MSG_LOG_ID_C_00000108
            goto FUNC_END;
        }
    }

    /** s̏ꍇAR}hɎw肷̓t@C(tH_)͂Q */
    if (iExecuteMode == DIFF_MODE) {
        if (siFileCount != 2) {
            if ((giOutHeaderFlg && !giOutFooterFlg) ||
                    (!giOutHeaderFlg && giOutFooterFlg)
               ) {
            } else {
                CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000109); //* MSG_LOG_ID_C_00000109
                goto FUNC_END;
            }
        }
    }
    iRet = RET_OK;
FUNC_END:
    return iRet;
}

/*!
    @brief      R}hɎw肳ꂽΏۃt@C(tH_)Xg擾
*/
_FileList *CDMtrCntOptionsGetInputFiles(void)
{
    return sptInFileNames;
}

/*!
    @brief      R}hɎw肳ꂽ⏕NXt@CXg擾
*/
_FileList *CDMtrCntOptionsGetOptFiles(void)
{
    return sptInOptFileNames;
}

/*!
    @brief      t@CXg̉s
*/
void CDMtrCntOptionsFreeFileList(void)
{
    if (sptInFileNames != NULL) {
        CDMtrLibFileFreeFileList(&sptInFileNames);
        sptInFileNames = NULL;
    }
    if (sptInOptFileNames != NULL) {
        CDMtrLibFileFreeFileList(&sptInOptFileNames);
        sptInOptFileNames = NULL;
    }
    return;
}

/*!
    @brief      c[IvV̐ݒLmFƘÂ߂̃Zp[^ǉs
*/
int CDMtrCntOptionsToolOptionStrcatSpace(void)
{
    int iFuncRet = RET_NG;
    if (pcKnownOpts) {
        /* łɃc[IvVɕ񂪐ݒ肳ĂꍇA
        /* I[ɘA邽߁AZp[^(p)ǉ */

        /* c[IvVݒ肷 */
        iFuncRet = CDMtrLibUtilCreateStringW(&pcKnownOpts, OPTION_SEPARATE_SPACE, NULL);
        if (iFuncRet != RET_OK) {
            return RET_NG;
        }
        /* 茋ʃt@C[Command Parameter]ݒ肷 */
        iFuncRet = CDMtrLibUtilCopyStringToCmdOptBuffW(&pcKnownOptsCmdBuf, &szKnownOptsCmdBufSize , OPTION_SEPARATE_SPACE, NULL);
        if (iFuncRet != RET_OK) {
            return RET_NG;
        }
    }
    return RET_OK;
}

/*!
    @brief      w肳ꂽt@CpX΃pXƃOo͗ppXɕϊ
*/
static int cdmtrCntOptionsGetAbsolutePath(_TCHAR *pcParamStr, _TCHAR **pcFilePath, const _TCHAR **pcLogoutFilePath)
{
    int iRet = RET_NG;
    int iFuncRet = RET_NG;
    _TCHAR *pcAbsolutePath = NULL;

    /* mF */
    if (pcFilePath == NULL || pcLogoutFilePath == NULL) {
        return RET_NG;
    }

    /** ΃pXɕϊ */
    iFuncRet = CDMtrLibFileGetAbsolutePath(pcParamStr, &pcAbsolutePath);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;;
    }

    /* t@CpXݒ肷 */
    CDMtrLibUtilFreeW((void **)pcFilePath);
    iFuncRet = CDMtrLibUtilCreateStringW(pcFilePath, pcAbsolutePath, NULL);

    /* 茋ʃt@C(Oo͗p)ݒ肷 */
    *pcLogoutFilePath = (_TCHAR *)CDMtrLibFileRemoveLongPathMarkW(*pcFilePath);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }
    iRet = RET_OK;

FUNC_END:
    CDMtrLibUtilFreeW((void **)&pcAbsolutePath);
    if (iRet != RET_OK) {
        CDMtrLibUtilFreeW((void **)pcFilePath);
    }
    return iRet;
}


/*!
    @brief      茋ʃt@Co̓tH[}bgw(-F)IvV̉
*/
static int cdmtrCntOptionsAnalyzeF(_TCHAR *pcParamStr)
{
    int iFuncRet = RET_NG;

    /* 茋ʃt@CtH[}bg */
    CDMtrLibUtilFreeW((void **)&gpcOutputFormat);

    /* -FIvVw肳Ă邱ƂtOݒ肷 */
    stOptFlags.bOpt_F_OutputMode = CDMTR_TRUE;

    /** IvVp[^mF */
    if (_tcscmp(pcParamStr, OUT_FORMAT_STR_CSV) == 0) {
        /* CSV`w肳ꂽꍇ */
        iOutFileFormat = CSV_FORMAT;
        iFuncRet = CDMtrLibUtilCreateStringW(&gpcOutputFormat, pcParamStr, NULL);
    } else if (_tcscmp(pcParamStr, OUT_FORMAT_STR_XML) == 0) {
        /* XML`w肳ꂽꍇ */
        iOutFileFormat = XML_FORMAT;
        iFuncRet = CDMtrLibUtilCreateStringW(&gpcOutputFormat, pcParamStr, NULL);
    } else {
        /* ȊÕp[^̏ꍇG[ */
        CDMtrLibCmnErrLogOut(MSG_INVALID_PARAM, ERR_LOG_ID_EC_00000089, pcParamStr); //* MSG_LOG_ID_C_00000089
        CDMtrLibCmnErrLogOut(MSG_SHOW_MOREINFO, ERR_LOG_ID_EC_00000090); //* MSG_LOG_ID_C_00000090
        return RET_NG;
    }
    if (iFuncRet != RET_OK) {
        return RET_NG;
    }

    return RET_OK;
}

/*!
    @brief      `؂蕪}Nw(-D)IvV̉
*/
static int cdmtrCntOptionsAnalyzeD(_TCHAR *pcParamStr)
{
    int iRet = RET_NG;
    int iFuncRet = RET_NG;
    _TCHAR *p = NULL;
    _TCHAR *pStr = NULL;

    /* `ς݃}N؂蕪Lݒ(TRUE)ɐݒ肷 */
    CDMtrLibUtilFreeW((void **)&pcDef);
    iFuncRet = CDMtrLibUtilMallocW((void **)&pcDef, (_tcslen(CNT_STR_TRUE) + 1) * sizeof(_TCHAR));
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }
    _tcscpy(pcDef, CNT_STR_TRUE);

    /* c[IvV̐ݒLmFƘÂ߂̃Zp[^ǉs */
    iFuncRet = CDMtrCntOptionsToolOptionStrcatSpace();
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }

    /* c[IvVɃIvVݒ肷 */
    iFuncRet = CDMtrLibUtilCreateStringW(&pcKnownOpts, OPTION_HYPHEN, OPTION_STR_D_MACRO, OPTION_SEPARATE_SPACE, NULL);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }
    /* 茋ʃt@C[Command Parameter]ɃIvVݒ肷 */
    iFuncRet = CDMtrLibUtilCopyStringToCmdOptBuffW(&pcKnownOptsCmdBuf, &szKnownOptsCmdBufSize, OPTION_HYPHEN, OPTION_STR_D_MACRO, OPTION_SEPARATE_SPACE, NULL);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }

    /** p[^Ɏw肳ꂽlmF */
    p = _tcschr(pcParamStr, CHAR_EQUAL);
    if (p == NULL) {
        /* macro ̂ݎw肳ꂽꍇ (macro=defn`ł͂Ȃꍇ) */

        /* c[IvVɃp[^ݒ肷 */
        iFuncRet = CDMtrLibUtilCreateStringW(&pcKnownOpts, pcParamStr, NULL);
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
        /* 茋ʃt@C[Command Parameter]Ƀp[^ݒ肷 */
        iFuncRet = CDMtrLibUtilCopyStringToCmdOptBuffW(&pcKnownOptsCmdBuf, &szKnownOptsCmdBufSize, pcParamStr, NULL);
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
    } else {
        /* macro=defn w肳ꂽꍇ */
        /* macro="defn"`maext.exe/saext.exesIvVɐݒ肷 */

        /* c[IvV'='܂ł̃p[^ݒ肷 */
        iFuncRet = CDMtrLibUtilCreateStringW(&pStr, pcParamStr, NULL);
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
        p = _tcschr(pStr, _T('=')) + 1;
        *p = 0x00;
        iFuncRet = CDMtrLibUtilCreateStringW(&pcKnownOpts, pStr, NULL);
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
        iFuncRet = CDMtrLibUtilCopyStringToCmdOptBuffW(&pcKnownOptsCmdBuf, &szKnownOptsCmdBufSize, pStr, NULL);
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }

        /* c[IvV'='̃p[^""ň͂񂾕ݒ肷 */
        CDMtrLibUtilFreeW((void **)&pStr);
        iFuncRet = CDMtrLibUtilCreateStringW(&pStr, pcParamStr, NULL);
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
        p = _tcschr(pStr, _T('=')) + 1;
        iFuncRet = CDMtrLibUtilCreateStringW(&pcKnownOpts, DOUBLEQUOTATION, p, DOUBLEQUOTATION, NULL);
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
        iFuncRet = CDMtrLibUtilCopyStringToCmdOptBuffW(&pcKnownOptsCmdBuf, &szKnownOptsCmdBufSize, DOUBLEQUOTATION, p, DOUBLEQUOTATION, NULL);
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
    }
    iRet = RET_OK;
FUNC_END:
    CDMtrLibUtilFreeW((void **)&pStr);
    return iRet;
}


/*!
    @brief      c[IvV(-U)̉
*/
static int cdmtrCntOptionsAnalyzeU(_TCHAR *pcParamStr)
{
    int iRet = RET_NG;
    int iFuncRet = RET_NG;

    /* c[IvV̐ݒLmFƘÂ߂̃Zp[^ǉs */
    iFuncRet = CDMtrCntOptionsToolOptionStrcatSpace();
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }

    /** c[IvVɃIvVƃp[^ݒ肷 */
    iFuncRet = CDMtrLibUtilCreateStringW(&pcKnownOpts, OPTION_HYPHEN, OPTION_STR_U_MACRO, OPTION_SEPARATE_SPACE, pcParamStr, NULL);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }

    /** 茋ʃt@C[Command Parameter]ɃIvVƃp[^ݒ肷 */
    iFuncRet = CDMtrLibUtilCopyStringToCmdOptBuffW(&pcKnownOptsCmdBuf, &szKnownOptsCmdBufSize, OPTION_HYPHEN, OPTION_STR_U_MACRO, OPTION_SEPARATE_SPACE, pcParamStr, NULL);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }
    iRet = RET_OK;
FUNC_END:
    return iRet;
}

/*!
    @brief      CN[hpXw(-I)IvV̉
*/
static int cdmtrCntOptionsAnalyzeI(_TCHAR *pcParamStr)
{
    int iRet = RET_NG;
    int iFuncRet = RET_OK;
    _TCHAR *pcIDirParam = NULL;

    /* c[IvV̐ݒLmFƘÂ߂̃Zp[^ǉs */
    iFuncRet = CDMtrCntOptionsToolOptionStrcatSpace();
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }

    /** w肳ꂽpX𑽌܂܂ȂpXɕϊ */
    iFuncRet = CDMtrLibFileConvertIncludePathW(pcParamStr, &pcIDirParam);
    if (iFuncRet != RET_OK) {
        /* pXϊɎsꍇAIvVp[^Ɏw肳ꂽl̂܂܎gp */
        pcIDirParam = pcParamStr;
    }

    /** c[IvVɃIvVƃp[^ݒ肷 */
    iFuncRet = CDMtrLibUtilCreateStringW(&pcKnownOpts, OPTION_HYPHEN, OPTION_STR_I_DIR, OPTION_SEPARATE_SPACE, DOUBLEQUOTATION, pcIDirParam, DOUBLEQUOTATION, NULL);
    if (pcIDirParam != pcParamStr) {
        CDMtrLibUtilFreeW((void **)&pcIDirParam);
    }
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }

    /** 茋ʃt@C[Command Parameter]ɃIvVƃp[^ݒ肷 */
    iFuncRet = CDMtrLibUtilCopyStringToCmdOptBuffW(&pcKnownOptsCmdBuf, &szKnownOptsCmdBufSize, OPTION_HYPHEN, OPTION_STR_I_DIR, OPTION_SEPARATE_SPACE, DOUBLEQUOTATION, pcParamStr, DOUBLEQUOTATION, NULL);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }
    iRet = RET_OK;
FUNC_END:
    return iRet;

}

/*!
    @brief      ⏕NX(-optclass)IvV̉
*/
static int cdmtrCntOptionsAnalyzeOptclass(_TCHAR *pcParamStr)
{
    int iRet = RET_NG;
    int iFuncRet = RET_OK;

    /** ⏕NXJEgAbv */
    siOptFileCount++;

    /* c[IvV̐ݒLmFƘÂ߂̃Zp[^ǉs */
    iFuncRet = CDMtrCntOptionsToolOptionStrcatSpace();
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }

    /** c[IvVɃIvVƃp[^ݒ肷 */
    iFuncRet = CDMtrLibUtilCreateStringW(&pcKnownOpts, OPTION_HYPHEN, OPTION_STR_OPT_CLASS, OPTION_SEPARATE_SPACE, DOUBLEQUOTATION, pcParamStr, DOUBLEQUOTATION, NULL);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }
    /** 茋ʃt@C[Command Parameter]ɃIvVƃp[^ݒ肷 */
    iFuncRet = CDMtrLibUtilCopyStringToCmdOptBuffW(&pcKnownOptsCmdBuf, &szKnownOptsCmdBufSize, OPTION_HYPHEN, OPTION_STR_OPT_CLASS, OPTION_SEPARATE_SPACE, DOUBLEQUOTATION, pcParamStr, DOUBLEQUOTATION, NULL);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }
    iRet = RET_OK;
FUNC_END:
    return iRet;

}

/*!
    @brief      wv\(--help)IvV̉
*/
static int cdmtrCntOptionsAnalyzeHelp(_TCHAR *pcParamStr, _SysLocale *ptSysLocale)
{
    int iFuncRet = RET_NG;

    /** wv\tOݒ肷 */
    iShowHelp = HELP_SHOW;

    /* p[^mF */
    if (pcParamStr != NULL ) {
        /** p[^Ŏw肳ꂽꂪ\\Ȍł邩mF */
        if (CDMtrLibOptCheckDispLang(pcParamStr) != OPTION_END) {
            CDMtrLibCmnErrLogOut(MSG_INVALID_PARAM, ERR_LOG_ID_EC_00000093, pcParamStr); //* MSG_LOG_ID_C_00000093
            CDMtrLibCmnErrLogOut(MSG_SHOW_MOREINFO, ERR_LOG_ID_EC_00000094); //* MSG_LOG_ID_C_00000094
            return RET_NG;
        }
        CDMtrLibUtilTolowerW(pcParamStr);

        /** \ݒ肷 */
        if (ptSysLocale->pcUserDispLang != NULL) {
            CDMtrLibUtilFreeW((void **) & (ptSysLocale->pcUserDispLang));
        }
        iFuncRet = CDMtrLibUtilCreateStringW(&(ptSysLocale->pcUserDispLang), pcParamStr, NULL);
        if (iFuncRet != RET_OK) {
            return RET_NG;
        }
    }
    return RET_OK;
}


/*!
    @brief      \[XR[h`(-RESTYLE)IvV̉
*/
static int cdmtrCntOptionsAnalyzeRestyle(_TCHAR *pcParamStr)
{
    int iRet = RET_NG;
    int iFuncRet = RET_NG;

    stOptFlags.bOpt_RESTYLE = CDMTR_TRUE;

    CDMtrLibUtilFreeW((void **)&pcBeautifier);
    if (_tcscmp(pcParamStr, RESTYLE_MODE_STR_NONE) == 0) {
        /* `Ȃw肳ꂽꍇ */
        iFuncRet = CDMtrLibUtilMallocW((void **)&pcBeautifier, (_tcslen(CNT_STR_FALSE) + 1) * sizeof(_TCHAR));
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
        _tcscpy(pcBeautifier, CNT_STR_FALSE);
        giRestyleMode = RESTYLE_NONE;
        giRestyleBothFlg = CDMTR_FALSE;
    } else if (_tcscmp(pcParamStr, RESTYLE_MODE_STR_STD) == 0) {
        /* `肪w肳ꂽꍇ */
        iFuncRet = CDMtrLibUtilMallocW((void **)&pcBeautifier, (_tcslen(CNT_STR_TRUE) + 1) * sizeof(_TCHAR));
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
        _tcscpy(pcBeautifier, CNT_STR_TRUE);
        giRestyleMode = RESTYLE_STD;
        giRestyleBothFlg = CDMTR_FALSE;
    } else if (_tcscmp(pcParamStr, RESTYLE_MODE_STR_BOTH) == 0) {
        /* w肳ꂽꍇ */
        iFuncRet = CDMtrLibUtilMallocW((void **)&pcBeautifier, (_tcslen(CNT_STR_TRUE) + 1) * sizeof(_TCHAR));
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
        _tcscpy(pcBeautifier, CNT_STR_TRUE);
        giRestyleMode = RESTYLE_BOTH;
        giRestyleBothFlg = CDMTR_TRUE;
    } else {
        CDMtrLibCmnErrLogOut(MSG_INVALID_PARAM, ERR_LOG_ID_EC_00000095, pcParamStr); //* MSG_LOG_ID_C_00000095
        CDMtrLibCmnErrLogOut(MSG_SHOW_MOREINFO, ERR_LOG_ID_EC_00000096); //* MSG_LOG_ID_C_00000096
        goto FUNC_END;
    }
    iRet = RET_OK;
FUNC_END:
    return iRet;
}


/*!
    @brief      s̋󔒂̈w(-diff_blank)IvV̉
*/
static int cdmtrCntOptionsAnalyzeDiffblank(_TCHAR *pcParamStr)
{
    int iRet = RET_NG;
    int iFuncRet = RET_NG;

    /* c[IvV̐ݒLmFƘÂ߂̃Zp[^ǉs */
    iFuncRet = CDMtrCntOptionsToolOptionStrcatSpace();
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }

    /** s̋󔒂̈wݒ肷 */
    CDMtrLibUtilFreeW((void **)&pcDiffBlank);
    iFuncRet = CDMtrLibUtilCreateStringW(&pcDiffBlank, pcParamStr, NULL);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }

    /** c[IvVݒ肷 */
    CDMtrLibUtilTolowerW(pcDiffBlank);
    if (_tcscmp(pcDiffBlank, CNT_STR_TRUE) == 0) {
        /* true(肷)w肳ꂽꍇ */
        giDiffBlankFlg = CDMTR_TRUE;
        iFuncRet = CDMtrLibUtilCreateStringW(&pcKnownOpts, OPTION_HYPHEN, OPTION_STR_DIFFBLANK, OPTION_EQUAL, CNT_STR_TRUE, NULL);
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
        iFuncRet = CDMtrLibUtilCopyStringToCmdOptBuffW(&pcKnownOptsCmdBuf, &szKnownOptsCmdBufSize, OPTION_HYPHEN, OPTION_STR_DIFFBLANK, OPTION_EQUAL, CNT_STR_TRUE, NULL);
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
    } else if (_tcscmp(pcDiffBlank, CNT_STR_FALSE) == 0) {
        /* false(肵Ȃ)w肳ꂽꍇ */
        giDiffBlankFlg = CDMTR_FALSE;
        iFuncRet = CDMtrLibUtilCreateStringW(&pcKnownOpts, OPTION_HYPHEN, OPTION_STR_DIFFBLANK, OPTION_EQUAL, CNT_STR_FALSE, NULL);
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
        iFuncRet = CDMtrLibUtilCopyStringToCmdOptBuffW(&pcKnownOptsCmdBuf, &szKnownOptsCmdBufSize, OPTION_HYPHEN, OPTION_STR_DIFFBLANK, OPTION_EQUAL, CNT_STR_FALSE, NULL);
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
    } else {
        /* true/falseȊOw肳ꂽꍇAG[*/
        CDMtrLibCmnErrLogOut(MSG_INVALID_PARAM, ERR_LOG_ID_EC_00000100, pcParamStr); //* MSG_LOG_ID_C_00000100
        CDMtrLibCmnErrLogOut(MSG_SHOW_MOREINFO, ERR_LOG_ID_EC_00000101); //* MSG_LOG_ID_C_00000101
        goto FUNC_END;
    }
    iRet = RET_OK;
FUNC_END:
    return iRet;
}


/*!
    @brief      wb_[tb^[o̓tO̐ݒ
*/
static void cdmtrCntOptionsSetHeaderFoooterFlg(OptionType iChkRes)
{
    switch (iChkRes) {
    case OPTION_HEADER:
        /* -header w肳ꂽꍇ */
        giOutFileAdd = CDMTR_FALSE;     // 茋ʃt@CVK쐬
        giOutHeaderFlg = CDMTR_TRUE;    // 茋ʃt@Cփwb_[o
        giOutFooterFlg = CDMTR_FALSE;   // 茋ʃt@Cփtb^[o͂Ȃ
        break;

    case OPTION_HEADER_ADD:
        /* -header_add w肳ꂽꍇ */
        giOutFileAdd = CDMTR_TRUE;      // 茋ʃt@CǋL
        giOutHeaderFlg = CDMTR_TRUE;    // 茋ʃt@Cփwb_[o
        giOutFooterFlg = CDMTR_FALSE;   // 茋ʃt@Cփtb^[o͂Ȃ
        break;

    case OPTION_MAKE:
        /* -make w肳ꂽꍇ */
        giOutFileAdd = CDMTR_TRUE;      // 茋ʃt@CǋL
        giOutHeaderFlg = CDMTR_FALSE;   // 茋ʃt@Cփwb_[o͂Ȃ
        giOutFooterFlg = CDMTR_FALSE;   // 茋ʃt@Cփtb^[o͂Ȃ
        break;

    case OPTION_FOOTER:
        /* -footer w肳ꂽꍇ */
        giOutFileAdd = CDMTR_TRUE;      // 茋ʃt@CǋL
        giOutHeaderFlg = CDMTR_FALSE;   // 茋ʃt@Cփwb_[o͂Ȃ
        giOutFooterFlg = CDMTR_TRUE;    // 茋ʃt@Cփtb^[o
        break;
    default:
        break;
    }
    return;
}


