/*
 *  source code metrics counter
 *  Copyright (C) 2015  NEC Corporation.
 *  
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
#define _CRT_SECURE_NO_WARNINGS
#include <windows.h>
#include <string.h>
#include <tchar.h>
#include <stdio.h>

#include "CDMtrCmn.h"
#include "CDMtrExtCmn.h"
#include "CDMtrLibCmnW.h"
#include "CDMtrLibFileW.h"
#include "CDMtrLibUtilW.h"
#include "CDMtrLibPropW.h"
#include "CDMtrLibSystemW.h"
#include "CDMtrLibOptW.h"
#include "CDMtrCntMain.h"
#include "CDMtrCntLang.h"
#include "CDMtrCntFirstLine.h"
#include "CDMtrCntProperties.h"
#include "CDMtrCntExtTool.h"
#include "CDMtrCntCompileEnv.h"
#include "CDMtrMessage.h"
/*----------------------------------------------------------------------------*/
/* define                                                                     */
/*----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------*/
/* structure definition                                                       */
/*----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------*/
/* global variable declaration                                                */
/*----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------*/
/* static variable declaration                                                */
/*----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------*/
/* static function declaration                                                */
/*----------------------------------------------------------------------------*/
static int cdmtrCntPropertiesReadProfile(void);
static int cdmtrCntPropertiesReadProfileInit(_PropInfoList *ptProp);
static int cdmtrCntPropertiesReadProfileLang(_PropInfoList *ptPropList);
static int cdmtrCntPropertiesReadProfileFirstLine(_PropInfoList *ptPropList);
static int cdmtrCntPropertiesGetProfileString(_TCHAR *pcAttrName, _TCHAR *pcDefault, _PropInfoList *ptPropList, _TCHAR **pcReturnedString, int *piFoundKey);
static int cdmtrCntPropertiesFindProfileString(_TCHAR *pcAttrName, _PropInfoList *ptPropList);
static int cdmtrCntPropertiesCreateIncPath(const _TCHAR *pcVal, _TCHAR **ppcInc);
static int cdmtrCntPropertiesCreateSysInc(_TCHAR *pcStr, unsigned int uiLen, _TCHAR **ppcSysInc);
static int cdmtrCntPropertiesCheckLangAttr(const _TCHAR *pcName);
static int cdmtrCntPropertiesCheckProfileName(void);

/*----------------------------------------------------------------------------*/
/* global function declaration                                                */
/*----------------------------------------------------------------------------*/
int CDMtrCntPropertiesAnalyzeProperty(void);

/*----------------------------------------------------------------------------*/
/* global function                                                            */
/*----------------------------------------------------------------------------*/
/*!
    @brief      vpeB͂
*/
int CDMtrCntPropertiesAnalyzeProperty(void)
{
    int iRet = RET_NG;
    int iFuncRet = RET_NG;

    /** vpeBt@C̃pXmF */
    iFuncRet = cdmtrCntPropertiesCheckProfileName();
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }

    /** wRpCݒ肷 */
    iFuncRet = CDMtrCntCompileEnvSeparateTTCVersion(gpcCompType, &gpcCompTypeForC, &gpcCompTypeForJava);
    if (iFuncRet != RET_OK) {
        CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000107, gpcCompType); //* MSG_LOG_ID_C_00000107
        goto FUNC_END;
    }

    /** vpeBt@C͂ */
    iFuncRet = cdmtrCntPropertiesReadProfile();
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }
    iRet = RET_OK;

FUNC_END:
    return iRet;
}


/*----------------------------------------------------------------------------*/
/* static function                                                            */
/*----------------------------------------------------------------------------*/
/*!
    @brief      vpeBt@Cǂݍ
*/
static int cdmtrCntPropertiesReadProfile(void)
{
    int iRet;
    int iFuncRet;
    _PropInfoList *ptPropInitList;
    _PropInfoList *ptPropLangList;
    _PropInfoList *ptPropFirstLineList;
    iRet = RET_NG;
    ptPropInitList = NULL;
    ptPropLangList = NULL;
    ptPropFirstLineList = NULL;
    if (pcProfFileName != NULL) {
        iFuncRet = CDMtrLibPropGetList(pcProfFileName, _T("init"), &ptPropInitList);
        if (iFuncRet != RET_OK) {
        }
        iFuncRet = CDMtrLibPropGetList(pcProfFileName, _T("lang"), &ptPropLangList);
        if (iFuncRet != RET_OK) {
        }
        iFuncRet = CDMtrLibPropGetList(pcProfFileName, _T("firstline_str"), &ptPropFirstLineList);
        if (iFuncRet != RET_OK) {
        }
    } else {
        iProfileFlag = CDMTR_FALSE;
    }
    iFuncRet = cdmtrCntPropertiesReadProfileInit(ptPropInitList);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }
    iFuncRet = cdmtrCntPropertiesReadProfileLang(ptPropLangList);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }
    iFuncRet = cdmtrCntPropertiesReadProfileFirstLine(ptPropFirstLineList);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }
    iRet = RET_OK;
FUNC_END:
    CDMtrLibPropFreeList(&ptPropInitList);
    CDMtrLibPropFreeList(&ptPropLangList);
    CDMtrLibPropFreeList(&ptPropFirstLineList);
    return iRet;
}

/*!
    @brief          vpeBt@C[INIT]̍ڂݒ肷
*/
static int cdmtrCntPropertiesReadProfileInit(_PropInfoList *ptProp)
{
    int iRet = RET_NG;
    int iFuncRet;
    _TCHAR *pcVal;
    _TCHAR *pcOpt;
    int iFoundKey = CDMTR_FALSE;
    _TCHAR *chkCharset = NULL;
    _TCHAR *pcTmp = NULL;
    pcVal = NULL;
    
    // DOC
    iFuncRet = cdmtrCntPropertiesGetProfileString(_T("DOC"), CNT_STR_TRUE, ptProp, &pcDoc, &iFoundKey);
    if (iFuncRet == RET_NG) {
        goto FUNC_END;
    }
    if (_tcslen(pcDoc) == 0) {
        CDMtrLibUtilFreeW((void **)&pcDoc);
        iFuncRet = CDMtrLibUtilMallocW((void **)&pcDoc, (_tcslen(CNT_STR_TRUE) + 1) * sizeof(_TCHAR));
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
        _tcscpy(pcDoc, CNT_STR_TRUE);
    }
    CDMtrLibUtilTolowerW(pcDoc);
    if (_tcscmp(pcDoc, CNT_STR_FALSE) == 0) {
        giDocFlag = CDMTR_FALSE;
    }

    // DEF
#ifdef OSS
    if ( pcDef != NULL ) {
        CDMtrLibUtilFreeW((void **)&pcDef);
    }
#else
    iFuncRet = cdmtrCntPropertiesGetProfileString(_T("DEF"), CNT_STR_FALSE, ptProp, &pcDef, &iFoundKey);
    if (iFuncRet == RET_NG) {
        goto FUNC_END;
    }
    if (_tcslen(pcDef) == 0) {
        CDMtrLibUtilFreeW((void **)&pcDef);
#endif //OSS
        iFuncRet = CDMtrLibUtilMallocW((void **)&pcDef, (_tcslen(CNT_STR_FALSE) + 1) * sizeof(_TCHAR));
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
        _tcscpy(pcDef, CNT_STR_FALSE);
#ifndef OSS
    }
#endif //OSS
    CDMtrLibUtilTolowerW(pcDef);

    // PARSE
    iFuncRet = cdmtrCntPropertiesGetProfileString(_T("PARSE"), CNT_STR_SMP, ptProp, &pcParse, &iFoundKey);
    if (iFuncRet == RET_NG) {
        goto FUNC_END;
    }
    if (_tcslen(pcParse) == 0) {
        CDMtrLibUtilFreeW((void **)&pcParse);
        iFuncRet = CDMtrLibUtilMallocW((void **)&pcParse, (_tcslen(CNT_STR_SMP) + 1) * sizeof(_TCHAR));
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
        _tcscpy(pcParse, CNT_STR_SMP);
    }
    CDMtrLibUtilTolowerW(pcParse);
    if (iStructMode == 0) {
        if (_tcscmp(pcParse, CNT_STR_STANDARD) == 0) {
            iStructMode = OPTION_STRUCT_STD;
            pcOpt = OPTION_STR_STRUCT_STD;
        } else {
            iStructMode = OPTION_STRUCT_SMP;
            pcOpt = OPTION_STR_STRUCT_SMP;
        }
        if (iExecuteMode == STRUCT_MODE) {
#ifdef OSS
            if (iStructMode == OPTION_STRUCT_STD) {
                CDMtrLibCmnErrLogOut(MSG_INVALID_PROPERTY, ERR_LOG_ID_EC_00000821, PROP_PARSE); //* MSG_LOG_ID_C_00000821
                goto FUNC_END;
            }
#endif //OSS
            iFuncRet = CDMtrLibUtilCreateStringW(&pcCommandOptions_MODE, OPTION_SEPARATE_HYPHEN, pcOpt, NULL);
            if (iFuncRet != RET_OK) {
                goto FUNC_END;
            }
        }
    }

    // DIFF_PARSE
    iFuncRet = cdmtrCntPropertiesGetProfileString(_T("DIFF_PARSE"), CNT_STR_DIFF_FILE, ptProp, &pcDiffParse, &iFoundKey);
    if (iFuncRet == RET_NG) {
        goto FUNC_END;
    }
    if (_tcslen(pcDiffParse) == 0) {
        CDMtrLibUtilFreeW((void **)&pcDiffParse);
        iFuncRet = CDMtrLibUtilMallocW((void **)&pcDiffParse, (_tcslen(CNT_STR_DIFF_FILE) + 1) * sizeof(_TCHAR));
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
        _tcscpy(pcDiffParse, CNT_STR_DIFF_FILE);
    }
    CDMtrLibUtilTolowerW(pcDiffParse);
    if (iDiffMode == 0) {
        if (_tcscmp(pcDiffParse, CNT_STR_DIFF_FUNC) == 0) {
            iDiffMode = OPTION_DIFF_FUNC;
            pcOpt = OPTION_STR_DIFF_FUNC;
        } else {
            iDiffMode = OPTION_DIFF_FILE;
            pcOpt = OPTION_STR_DIFF_FILE;
        }
        if (iExecuteMode == DIFF_MODE) {
            iFuncRet = CDMtrLibUtilCreateStringW(&pcCommandOptions_MODE, OPTION_SEPARATE_HYPHEN, pcOpt, NULL);
            if (iFuncRet != RET_OK) {
                goto FUNC_END;
            }
        }
    }

    // SKIP
    iFuncRet = cdmtrCntPropertiesGetProfileString(_T("SKIP"), CNT_STR_NEW, ptProp, &pcSkip, &iFoundKey);
    if (iFuncRet == RET_NG) {
        goto FUNC_END;
    }
    if (_tcslen(pcSkip) == 0) {
        iSkipChangeFlg = CDMTR_TRUE;
        CDMtrLibUtilFreeW((void **)&pcSkip);
        iFuncRet = CDMtrLibUtilMallocW((void **)&pcSkip, (_tcslen(CNT_STR_NEW) + 1) * sizeof(_TCHAR));
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
        _tcscpy(pcSkip, CNT_STR_NEW);
    }
    CDMtrLibUtilTolowerW(pcSkip);
    if (_tcscmp(pcSkip, CNT_STR_OLD) == 0) {
        iSkipChangeFlg = CDMTR_FALSE;
    } else if (_tcscmp(pcSkip, CNT_STR_NEW) == 0) {
        iSkipChangeFlg = CDMTR_TRUE;
    } else {
        iSkipChangeFlg = CDMTR_TRUE;
        CDMtrLibUtilFreeW((void **)&pcSkip);
        iFuncRet = CDMtrLibUtilMallocW((void **)&pcSkip, (_tcslen(CNT_STR_NEW) + 1) * sizeof(_TCHAR));
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
        _tcscpy(pcSkip, CNT_STR_NEW);
    }

    // NKF
    iFuncRet = cdmtrCntPropertiesGetProfileString(_T("NKF"), CNT_STR_TRUE, ptProp, &pcNkf, &iFoundKey);
    if (iFuncRet == RET_NG) {
        goto FUNC_END;
    }
    if (_tcslen(pcNkf) == 0) {
        CDMtrLibUtilFreeW((void **)&pcNkf);
        iFuncRet = CDMtrLibUtilMallocW((void **)&pcNkf, (_tcslen(CNT_STR_TRUE) + 1) * sizeof(_TCHAR));
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
        _tcscpy(pcNkf, CNT_STR_TRUE);
    }
    CDMtrLibUtilTolowerW(pcNkf);
    if(_tcscmp(pcNkf, CNT_STR_TRUE) != 0 && _tcscmp(pcNkf, CNT_STR_FALSE) != 0){
        CDMtrLibUtilFreeW((void **)&pcNkf);
        iFuncRet = CDMtrLibUtilMallocW((void **)&pcNkf, (_tcslen(CNT_STR_TRUE) + 1) * sizeof(_TCHAR));
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
        _tcscpy(pcNkf, CNT_STR_TRUE);
    }

    // NKFEXE
    iFuncRet = cdmtrCntPropertiesGetProfileString(_T("NKFEXE"), pcNkfExeDefault, ptProp, &pcNkfExe, &iFoundKey);
    if (iFuncRet == RET_NG) {
        goto FUNC_END;
    }
    if (pcNkfExe == NULL) {
    } else {
        if (_tcslen(pcNkfExe) == 0) {
            CDMtrLibUtilFreeW((void **)&pcNkf);
            iFuncRet = CDMtrLibUtilMallocW((void **)&pcNkf, (_tcslen(CNT_STR_FALSE) + 1) * sizeof(_TCHAR));
            if (iFuncRet != RET_OK) {
                goto FUNC_END;
            }
            _tcscpy(pcNkf, CNT_STR_FALSE);
        } else {
            if (_tcscmp(pcNkf, CNT_STR_TRUE) == 0) {
                if (!CDMtrCntExtToolIsExtTool(pcNkfExe)) {
                    goto FUNC_END;
                }
                giProfileNKFEXESetting = CDMTR_TRUE;
            } else {
            }
        }
    }

    // BEAUTIFIER
    if (pcBeautifier == NULL) {
        iFuncRet = cdmtrCntPropertiesGetProfileString(_T("BEAUTIFIER"), _T("false"), ptProp, &pcBeautifier, &iFoundKey);
        if (iFuncRet == RET_NG) {
            goto FUNC_END;
        }
        if (_tcslen(pcBeautifier) == 0) {
            CDMtrLibUtilFreeW((void **)&pcBeautifier);
            iFuncRet = CDMtrLibUtilMallocW((void **)&pcBeautifier, (_tcslen(CNT_STR_FALSE) + 1) * sizeof(_TCHAR));
            if (iFuncRet != RET_OK) {
                goto FUNC_END;
            }
            _tcscpy(pcBeautifier, CNT_STR_FALSE);
        }
        CDMtrLibUtilTolowerW(pcBeautifier);
        if (_tcscmp(pcBeautifier, CNT_STR_TRUE) == 0) {
            giRestyleMode = RESTYLE_STD;
        } else {
            giRestyleMode = RESTYLE_NONE;
        }
        giRestyleBothFlg = CDMTR_FALSE;
    } else {
    }

    // BEAUTIFIEREXE
    iFuncRet = cdmtrCntPropertiesGetProfileString(_T("BEAUTIFIEREXE"), pcBeautifierExeDefault, ptProp, &pcBeautifierExe, &iFoundKey);
    if (iFuncRet == RET_NG) {
        goto FUNC_END;
    }
    if (_tcslen(pcBeautifierExe) == 0) {
        CDMtrLibUtilFreeW((void **)&pcBeautifier);
        iFuncRet = CDMtrLibUtilMallocW((void **)&pcBeautifier, (_tcslen(CNT_STR_FALSE) + 1) * sizeof(_TCHAR));
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
        _tcscpy(pcBeautifier, CNT_STR_FALSE);
        giRestyleMode = RESTYLE_NONE;
        giRestyleBothFlg = CDMTR_FALSE;
    } else {
        if (_tcscmp(pcBeautifier, CNT_STR_TRUE) == 0) {
            if (!CDMtrCntExtToolIsExtTool(pcBeautifierExe)) {
                goto FUNC_END;
            }
        }
    }

    // CMPVER
    iFuncRet = cdmtrCntPropertiesGetProfileString(_T("CMPVER"), NULL, ptProp, &gpcCompTypeForC, &iFoundKey);
    if (iFuncRet == RET_NG) {
        goto FUNC_END;
    }
    if (gpcCompTypeForC != NULL) {
        if (_tcslen(pcNkf) == 0) {
            CDMtrLibUtilFreeW((void **)&gpcCompTypeForC);
        }
    }

    // CMPVER_JAVA
    if (gpcCompTypeForJava == NULL) {
        iFuncRet = cdmtrCntPropertiesGetProfileString(_T("CMPVER_JAVA"), JAVA_VERSION_STR_1_5, ptProp, &gpcCompTypeForJava, &iFoundKey);
        if (iFuncRet == RET_NG) {
            goto FUNC_END;
        }
        if (_tcslen(gpcCompTypeForJava) == 0) {
            CDMtrLibUtilFreeW((void **)&gpcCompTypeForJava);
            iFuncRet = CDMtrLibUtilMallocW((void **)&gpcCompTypeForJava, (_tcslen(JAVA_VERSION_STR_1_5) + 1) * sizeof(_TCHAR));
            if (iFuncRet != RET_OK) {
                goto FUNC_END;
            }
            _tcscpy(gpcCompTypeForJava, JAVA_VERSION_STR_1_5);
        }
    }

    // JAVA_VM_OPTION_XMX
    iFuncRet = cdmtrCntPropertiesGetProfileString(_T("JAVA_VM_OPTION_XMX"), JAVA_APP_OPTION_XMX_DEFAULT, ptProp, &pcJAVAVmOptionXmx, &iFoundKey);
    if (iFuncRet == RET_NG) {
        goto FUNC_END;
    }
    if (_tcslen(pcJAVAVmOptionXmx) == 0) {
        CDMtrLibUtilFreeW((void **)&pcJAVAVmOptionXmx);
        iFuncRet = CDMtrLibUtilMallocW((void **)&pcJAVAVmOptionXmx, (_tcslen(JAVA_APP_OPTION_XMX_DEFAULT) + 1) * sizeof(_TCHAR));
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
        _tcscpy(pcJAVAVmOptionXmx, JAVA_APP_OPTION_XMX_DEFAULT);
    }

    // SYSINC
    iFuncRet = cdmtrCntPropertiesGetProfileString(_T("SYSINC"), NULL, ptProp, &pcVal, &iFoundKey);
    if (iFuncRet == RET_NG) {
        goto FUNC_END;
    }
    if (pcVal != NULL) {
        if (_tcslen(pcVal) == 0) {
            CDMtrLibUtilFreeW((void **)&pcVal);
        } else {
            iFuncRet = cdmtrCntPropertiesCreateIncPath(pcVal, &gpcSysInc);
            if (iFuncRet == RET_NG) {
                CDMtrLibUtilFreeW((void **)&pcVal);
            }
        }
    }

    // JAVAEXE
    iFuncRet = cdmtrCntPropertiesGetProfileString(_T("JAVAEXE"), NULL, ptProp, &pcJAVAExe, &iFoundKey);
    if (iFuncRet == RET_NG) {
        goto FUNC_END;
    }
    if ((pcJAVAExe != NULL) && (_tcslen(pcJAVAExe) != 0)) {
        if (!CDMtrCntExtToolIsExtTool(pcJAVAExe)) {
            goto FUNC_END;
        } else {
            CDMtrLibUtilFreeW((void **)&pcStructJAVAPath);
            iFuncRet = CDMtrLibUtilCreateStringW(&pcStructJAVAPath, pcJAVAExe, EXEC_JAVA_APP_OPTION,
                                                 DOUBLEQUOTATION, pcObjectPath, TOOL_PATH, STRUCT_JAVA, DOUBLEQUOTATION, NULL);
            if (iFuncRet != RET_OK) {
                goto FUNC_END;
            }
            CDMtrLibUtilFreeW((void **)&pcStructJSPath);
            iFuncRet = CDMtrLibUtilCreateStringW(&pcStructJSPath, pcJAVAExe, EXEC_JAVA_APP_OPTION,
                                                 DOUBLEQUOTATION, pcObjectPath, TOOL_PATH, STRUCT_JS, DOUBLEQUOTATION, NULL);
            if (iFuncRet != RET_OK) {
                goto FUNC_END;
            }
            CDMtrLibUtilFreeW((void **)&pcCkJAVAPath);
            iFuncRet = CDMtrLibUtilCreateStringW(&pcCkJAVAPath, pcJAVAExe, EXEC_CK_JAVA_APP_OPTION_XSS,
                                                 EXEC_CK_JAVA_APP_OPTION_XMX, pcJAVAVmOptionXmx, EXEC_CK_JAVA_APP_OPTION_JAR,
                                                 DOUBLEQUOTATION, pcObjectPath, TOOL_PATH, CK_JAVA, DOUBLEQUOTATION, NULL);
            if (iFuncRet != RET_OK) {
                goto FUNC_END;
            }
            CDMtrLibUtilFreeW((void **)&pcJAVAExeVersion);
            iFuncRet = CDMtrLibUtilCreateStringW(&pcJAVAExeVersion, pcJAVAExe, EXEC_JAVA_VERSION_CMD_OPTION, NULL);
            if (iFuncRet != RET_OK) {
                goto FUNC_END;
            }
        }
    } else {
        CDMtrLibUtilFreeW((void **)&pcCkJAVAPath);
        iFuncRet = CDMtrLibUtilCreateStringW(&pcCkJAVAPath, EXEC_CK_JAVA_APP, EXEC_CK_JAVA_APP_OPTION_XSS,
                                             EXEC_CK_JAVA_APP_OPTION_XMX, pcJAVAVmOptionXmx, EXEC_CK_JAVA_APP_OPTION_JAR,
                                             DOUBLEQUOTATION, pcObjectPath, TOOL_PATH, CK_JAVA, DOUBLEQUOTATION, NULL);
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
    }

    // DIFF_OPERATION_MODE
    if (cdmtrCntPropertiesFindProfileString(_T("DIFF_OPERATION_MODE"), ptProp)) {
        iFuncRet = cdmtrCntPropertiesGetProfileString(_T("DIFF_OPERATION_MODE"), CNT_STR_MODE_A, ptProp,
                   &pcDiffOpMode, &iFoundKey);
        if (iFuncRet == RET_NG) {
            goto FUNC_END;
        }
        if (_tcslen(pcDiffOpMode) == 0) {
            CDMtrLibUtilFreeW((void **)&pcDiffOpMode);
            iFuncRet = CDMtrLibUtilMallocW((void **)&pcDiffOpMode, (_tcslen(CNT_STR_MODE_A) + 1) * sizeof(_TCHAR));
            if (iFuncRet != RET_OK) {
                goto FUNC_END;
            }
            _tcscpy(pcDiffOpMode, CNT_STR_MODE_A);
        }
        CDMtrLibUtilToupperW(pcDiffOpMode);
        if (_tcscmp(pcDiffOpMode, CNT_STR_MODE_B) == 0) {
            if (pcDiffBlank == NULL) {
                giDiffBlankFlg = CDMTR_TRUE;
            }
            giDiffCountMode = DIFF_COUNT_EXT;
        } else {
            if (pcDiffBlank == NULL) {
                giDiffBlankFlg = CDMTR_FALSE;
            }
            giDiffCountMode = DIFF_COUNT_STD;
        }
    } else {
        // DIFF_BLANK
        if (pcDiffBlank == NULL) {
            iFuncRet = cdmtrCntPropertiesGetProfileString(_T("DIFF_BLANK"), CNT_STR_FALSE, ptProp, &pcDiffBlank, &iFoundKey);
            if (iFuncRet == RET_NG) {
                goto FUNC_END;
            }
            if (_tcslen(pcDiffBlank) == 0) {
                CDMtrLibUtilFreeW((void **)&pcDiffBlank);
                iFuncRet = CDMtrLibUtilMallocW((void **)&pcDiffBlank, (_tcslen(CNT_STR_FALSE) + 1) * sizeof(_TCHAR));
                if (iFuncRet != RET_OK) {
                    goto FUNC_END;
                }
                _tcscpy(pcDiffBlank, CNT_STR_FALSE);
            }
            CDMtrLibUtilTolowerW(pcDiffBlank);
            if (_tcscmp(pcDiffBlank, CNT_STR_TRUE) == 0) {
                giDiffBlankFlg = CDMTR_TRUE;
            } else {
                giDiffBlankFlg = CDMTR_FALSE;
            }
        }

        // DIFF_COUNT_MODE
        iFuncRet = cdmtrCntPropertiesGetProfileString(_T("DIFF_COUNT_MODE"), CNT_STR_STD, ptProp, &pcDiffCountMode, &iFoundKey);
        if (iFuncRet == RET_NG) {
            goto FUNC_END;
        }
        if (_tcslen(pcDiffCountMode) == 0) {
            CDMtrLibUtilFreeW((void **)&pcDiffCountMode);
            iFuncRet = CDMtrLibUtilMallocW((void **)&pcDiffCountMode, (_tcslen(CNT_STR_STD) + 1) * sizeof(_TCHAR));
            if (iFuncRet != RET_OK) {
                goto FUNC_END;
            }
            _tcscpy(pcDiffCountMode, CNT_STR_STD);
        }
        CDMtrLibUtilToupperW(pcDiffCountMode);
        if (_tcscmp(pcDiffCountMode, CNT_STR_EXT) == 0) {
            giDiffCountMode = DIFF_COUNT_EXT;
        } else {
            giDiffCountMode = DIFF_COUNT_STD;
        }

        // EXCEPT_BINARY
        iFuncRet = cdmtrCntPropertiesGetProfileString(_T("EXCEPT_BINARY"), CNT_STR_FALSE, ptProp, &pcExceptBinary, &iFoundKey);
        if (iFuncRet == RET_NG) {
            goto FUNC_END;
        }
        if (_tcslen(pcExceptBinary) == 0) {
            CDMtrLibUtilFreeW((void **)&pcExceptBinary);
            iFuncRet = CDMtrLibUtilMallocW((void **)&pcExceptBinary, (_tcslen(CNT_STR_FALSE) + 1) * sizeof(_TCHAR));
            if (iFuncRet != RET_OK) {
                goto FUNC_END;
            }
            _tcscpy(pcExceptBinary, CNT_STR_FALSE);
        }
        CDMtrLibUtilTolowerW(pcExceptBinary);
        if (_tcscmp(pcExceptBinary, CNT_STR_TRUE) == 0) {
            giExceptBinaryMode = CDMTR_TRUE;
        } else {
            giExceptBinaryMode = CDMTR_FALSE;
        }
    }

    // OUT_FORMAT
    if (gpcOutputFormat == NULL) {
        iFuncRet = cdmtrCntPropertiesGetProfileString(_T("OUT_FORMAT"), OUT_FORMAT_STR_CSV, ptProp, &gpcOutputFormat, &iFoundKey);
        if (iFuncRet == RET_NG) {
            goto FUNC_END;
        }
        if (_tcslen(gpcOutputFormat) == 0) {
            CDMtrLibUtilFreeW((void **)&gpcOutputFormat);
            iFuncRet = CDMtrLibUtilMallocW((void **)&gpcOutputFormat, (_tcslen(OUT_FORMAT_STR_CSV) + 1) * sizeof(_TCHAR));
            if (iFuncRet != RET_OK) {
                goto FUNC_END;
            }
            _tcscpy(gpcOutputFormat, OUT_FORMAT_STR_CSV);
        }
        CDMtrLibUtilTolowerW(gpcOutputFormat);
        if (_tcscmp(gpcOutputFormat, OUT_FORMAT_STR_XML) == 0) {
            iOutFileFormat = XML_FORMAT;
        } else {
            iOutFileFormat = CSV_FORMAT;
        }
    }

    // STRUCT_FUNC_OPTION
    if (pcFuncOpt == NULL) {
        iFuncRet = cdmtrCntPropertiesGetProfileString(_T("STRUCT_FUNC_OPTION"), FUNC_OPTION_PARAM, ptProp, &pcFuncOpt, &iFoundKey);
        if (iFuncRet == RET_NG) {
            goto FUNC_END;
        }
        if (_tcslen(pcFuncOpt) == 0) {
            CDMtrLibUtilFreeW((void **)&pcFuncOpt);
            iFuncRet = CDMtrLibUtilMallocW((void **)&pcFuncOpt, (_tcslen(FUNC_OPTION_PARAM) + 1) * sizeof(_TCHAR));
            if (iFuncRet != RET_OK) {
                goto FUNC_END;
            }
            _tcscpy(pcFuncOpt, FUNC_OPTION_PARAM);
        }
        CDMtrLibUtilTolowerW(pcFuncOpt);
        if (_tcscmp(pcFuncOpt, FUNC_OPTION_NONE) == 0) {
        } else if (_tcscmp(pcFuncOpt, FUNC_OPTION_PARAM) == 0) {
        } else {
            CDMtrLibUtilFreeW((void **)&pcFuncOpt);
            iFuncRet = CDMtrLibUtilMallocW((void **)&pcFuncOpt, (_tcslen(FUNC_OPTION_PARAM) + 1) * sizeof(_TCHAR));
            if (iFuncRet != RET_OK) {
                goto FUNC_END;
            }
            _tcscpy(pcFuncOpt, FUNC_OPTION_PARAM);
        }
    }

    // STRUCT_FUNC_DQRT
    if (gpcQrtLiteral == NULL) {
        /* STRUCT_FUNC_DQRT̎wl̎擾 */
        /*   [] EXCEL(Kl)ł̂ݓ */
        iFuncRet = cdmtrCntPropertiesGetProfileString(_T(""), QRT_LITERAL_STR_ADD, ptProp, &gpcQrtLiteral, &iFoundKey);
        if (iFuncRet == RET_NG) {
            goto FUNC_END;
        }
        if (_tcslen(gpcQrtLiteral) == 0) {
            CDMtrLibUtilFreeW((void **)&gpcQrtLiteral);
            iFuncRet = CDMtrLibUtilMallocW((void **)&gpcQrtLiteral, (_tcslen(QRT_LITERAL_STR_ADD) + 1) * sizeof(_TCHAR));
            if (iFuncRet != RET_OK) {
                goto FUNC_END;
            }
            _tcscpy(gpcQrtLiteral, QRT_LITERAL_STR_ADD);
        }
        CDMtrLibUtilTolowerW(gpcQrtLiteral);
        if (_tcscmp(gpcQrtLiteral, QRT_LITERAL_STR_NOTHING) == 0) {
            giQrtOutFlg = CDMTR_FALSE;
        } else {
            giQrtOutFlg = CDMTR_TRUE;
        }
    }

    // COMMENT_CASE_SENSITIVE
    iFuncRet = cdmtrCntPropertiesGetProfileString(_T("COMMENT_CASE_SENSITIVE"), CNT_STR_TRUE,
               ptProp, &pcCmntCase, &iFoundKey);
    if (iFuncRet == RET_NG) {
        goto FUNC_END;
    }
    if (_tcslen(pcCmntCase) == 0) {
        CDMtrLibUtilFreeW((void **)&pcCmntCase);
        iFuncRet = CDMtrLibUtilMallocW((void **)&pcCmntCase, (_tcslen(CNT_STR_TRUE) + 1) * sizeof(_TCHAR));
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
        _tcscpy(pcCmntCase, CNT_STR_TRUE);
    }
    CDMtrLibUtilTolowerW(pcCmntCase);
    if (_tcscmp(pcCmntCase, CNT_STR_FALSE) == 0) {
        giCmntCaseFlag = CDMTR_FALSE;
    } else {
        giCmntCaseFlag = CDMTR_TRUE;
    }

    // STMT
    iFuncRet = cdmtrCntPropertiesGetProfileString(_T("STMT"), CNT_STR_TRUE, ptProp, &pcStmtMode, &iFoundKey);
    if (iFuncRet == RET_NG) {
        goto FUNC_END;
    }
    if (_tcslen(pcStmtMode) == 0) {
        CDMtrLibUtilFreeW((void **)&pcStmtMode);
        iFuncRet = CDMtrLibUtilMallocW((void **)&pcStmtMode, (_tcslen(CNT_STR_TRUE) + 1) * sizeof(_TCHAR));
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
        _tcscpy(pcStmtMode, CNT_STR_TRUE);
    }
    CDMtrLibUtilTolowerW(pcStmtMode);
    if (_tcscmp(pcStmtMode, CNT_STR_FALSE) == 0) {
        giStmtMode = CDMTR_FALSE;
    } else {
        giStmtMode = CDMTR_TRUE;
    }

    // STRUCT_FAN_IN_OUT
    iFuncRet = cdmtrCntPropertiesGetProfileString(_T("STRUCT_FAN_IN_OUT"), CNT_STR_TRUE, ptProp, &pcFanIOMode, &iFoundKey);
    if (iFuncRet == RET_NG) {
        goto FUNC_END;
    }
    if (_tcslen(pcFanIOMode) == 0) {
        CDMtrLibUtilFreeW((void **)&pcFanIOMode);
        iFuncRet = CDMtrLibUtilMallocW((void **)&pcFanIOMode, (_tcslen(CNT_STR_TRUE) + 1) * sizeof(_TCHAR));
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
        _tcscpy(pcFanIOMode, CNT_STR_TRUE);
    }
    CDMtrLibUtilTolowerW(pcFanIOMode);
    if (_tcscmp(pcFanIOMode, CNT_STR_FALSE) == 0) {
        giFANIOMode = CDMTR_FALSE;
    } else {
        giFANIOMode = CDMTR_TRUE;
    }

    // CHARSET_OUT_CSV
    if (pcResultCodeOpts == NULL) {
        iFuncRet = cdmtrCntPropertiesGetProfileString(_T("CHARSET_OUT_CSV"), NULL, ptProp, &pcCharsetOutCsv_prop, &iFoundKey);
        if (iFuncRet == RET_NG) {
            goto FUNC_END;
        }
        if ((pcCharsetOutCsv_prop != NULL) && (_tcslen(pcCharsetOutCsv_prop) > 0)) {
            chkCharset = CDMtrLibUtilCheckOutputCharsetW(pcCharsetOutCsv_prop);
            if (chkCharset) {
                pcResultCodeOpts = chkCharset;
                chkCharset = NULL;
            }
        }
        if (pcResultCodeOpts == NULL) {
            pcResultCodeOpts = CDMtrLibUtilCopyStringW(ENCODING_SYSTEM);
            if (pcResultCodeOpts == NULL) {
                iFuncRet = RET_NG;
                goto FUNC_END;
            }
        }
    }

    // CHARSET_OUT_LOG
    if (pcLogCodeOpts == NULL) {
        iFuncRet = cdmtrCntPropertiesGetProfileString(_T("CHARSET_OUT_LOG"), NULL, ptProp, &pcCharsetOutLog_prop, &iFoundKey);
        if (iFuncRet == RET_NG) {
            goto FUNC_END;
        }
        if ((pcCharsetOutLog_prop != NULL) && (_tcslen(pcCharsetOutLog_prop) > 0)) {
            chkCharset = CDMtrLibUtilCheckOutputCharsetW(pcCharsetOutLog_prop);
            if (chkCharset) {
                pcLogCodeOpts = chkCharset;
                chkCharset = NULL;
            }
        }
        if (pcLogCodeOpts == NULL) {
            pcLogCodeOpts = CDMtrLibUtilCopyStringW(ENCODING_SYSTEM);
            if (pcLogCodeOpts == NULL) {
                iFuncRet = RET_NG;
                goto FUNC_END;
            }
        }
    }

    // NESTS_COUNT
    if (iNestsCount == NUM_NESTS_COUNT_NONE) {
        iNestsCount = NUM_NESTS_COUNT_INNERBLOCK;
        iFuncRet = cdmtrCntPropertiesGetProfileString(_T("NESTS_COUNT"), NULL, ptProp, &pcTmp, &iFoundKey);
        if (iFuncRet == RET_NG) {
            goto FUNC_END;
        }
        if (pcTmp != NULL) {
            if (_tcslen(pcTmp) > 0) {
                CDMtrLibUtilTolowerW(pcTmp);
                if (_tcscmp(pcTmp, CNT_STR_NESTS_COUNT_ALLBLOCK) == 0) {
                    iNestsCount = NUM_NESTS_COUNT_ALLBLOCK;
                }
            }
            CDMtrLibUtilFreeW((void **)&pcTmp);
        }
    }

    // DIFF_MODE_DETAIL_OUT
    if (iDiffModeDetailOut == DIFF_MODE_DETAIL_OUT_NONE) {
        iDiffModeDetailOut = CDMTR_TRUE;
        iFuncRet = cdmtrCntPropertiesGetProfileString(PROP_DIFF_MODE_DETAIL_OUT, CNT_STR_TRUE, ptProp, &pcTmp, &iFoundKey);
        if (iFuncRet == RET_NG) {
            goto FUNC_END;
        }
        if (_tcslen(pcTmp) > 0) {
            CDMtrLibUtilTolowerW(pcTmp);
            if (_tcscmp(pcTmp, CNT_STR_FALSE) == 0) {
                iDiffModeDetailOut = CDMTR_FALSE;
            }
        }
        CDMtrLibUtilFreeW((void **)&pcTmp);
    }

    // NCM_DEBUG
    iFuncRet = cdmtrCntPropertiesGetProfileString(_T("NCM_DEBUG"), NULL, ptProp, &pcNcmDebugProp, &iFoundKey);
    if (iFuncRet == RET_NG) {
        goto FUNC_END;
    }
    if (pcNcmDebugProp != NULL) {
        _TCHAR *cpTrmTmp = pcNcmDebugProp;
        SKIP_WHITE_SPACE(&cpTrmTmp);
        if ((_tcslen(pcNcmDebugProp) == 0) || (cpTrmTmp == NULL) || (_tcslen(cpTrmTmp) == 0)) {
            CDMtrLibUtilFreeW((void **)&pcNcmDebugProp);
        } else {
        }
    }
    iRet = RET_OK;
    FUNC_END:
    CDMtrLibUtilFreeW((void **)&pcVal);
    return iRet;
}

/*!
    @brief          vpeBt@C[LANG]̍ڂݒ肷
*/
static int cdmtrCntPropertiesReadProfileLang(_PropInfoList *ptPropList)
{
    int iRet = RET_NG;
    int iFuncRet;
    int i;
    int iType;
    CDMtrCntLangInitInfo();
    if (ptPropList == NULL) {
        iFuncRet = CDMtrCntLangRegDefault();
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
    } else {
        for (i = 0; i < ptPropList->iNum; i++) {
            if (!cdmtrCntPropertiesCheckLangAttr(ptPropList->ptPropInfo[i]->pcAttr)) {
                continue;
            }
            iType = CDMtrCntLangGetTypeFromLangName(ptPropList->ptPropInfo[i]->pcAttr);
            iFuncRet = CDMtrCntLangRegInfo(iType,
                                           ptPropList->ptPropInfo[i]->pcAttr,
                                           ptPropList->ptPropInfo[i]->pcVal
                                          );
            if (iFuncRet != RET_OK) {
                goto FUNC_END;
            }
        }
    }
    iRet = RET_OK;
FUNC_END:
    return iRet;
}

/*!
    @brief          vpeBt@C[FIRSTLINE_STR]̍ڂݒ肷
*/
static int cdmtrCntPropertiesReadProfileFirstLine(_PropInfoList *ptPropList)
{
    int iRet = RET_NG;
    int iFuncRet;
    int i;
    CDMtrCntFirstLineInit();
    if (ptPropList == NULL) {
    } else {
        for (i = 0; i < ptPropList->iNum; i++) {
            if (CDMtrCntFirstLineIsInvalidID(ptPropList->ptPropInfo[i]->pcAttr)) {
                continue;
            }
            iFuncRet = CDMtrCntFirstLineRegInfo(
                           ptPropList->ptPropInfo[i]->pcAttr,
                           ptPropList->ptPropInfo[i]->pcVal
                       );
            if (iFuncRet != RET_OK) {
                goto FUNC_END;
            }
        }
    }
    iRet = RET_OK;
FUNC_END:
    return iRet;
}

/*!
    @brief          vpeBt@C̑ɐݒ肳Ăl()擾
*/
static int cdmtrCntPropertiesGetProfileString(_TCHAR *pcAttrName, _TCHAR *pcDefault, _PropInfoList *ptPropList,
        _TCHAR **pcReturnedString, int *piFoundKey)
{
    int iRet = RET_NG;
    int iFuncRet;
    int i;
    size_t szBufferSize;
    *piFoundKey = CDMTR_FALSE;
    if (*pcReturnedString != NULL) {
        iRet = RET_OK;
        goto FUNC_END;
    }
    if (ptPropList != NULL) {
        for (i = 0; i < ptPropList->iNum; i++) {
            if (CDMtrLibUtilCompString(pcAttrName, ptPropList->ptPropInfo[i]->pcAttr)) {
                szBufferSize = _tcslen(ptPropList->ptPropInfo[i]->pcVal);
                iFuncRet = CDMtrLibUtilMallocW((void **)pcReturnedString, (szBufferSize + 1) * sizeof(_TCHAR));
                if (iFuncRet != RET_OK) {
                    goto FUNC_END;
                }
                _tcscpy(*pcReturnedString, ptPropList->ptPropInfo[i]->pcVal);
                (*pcReturnedString)[szBufferSize] = _T('\0');
                *piFoundKey = CDMTR_TRUE;
                break;
            }
        }
    } else {
    }
    if (*pcReturnedString == NULL) {
        if (pcDefault != NULL) {
            szBufferSize = _tcslen(pcDefault);
            iFuncRet = CDMtrLibUtilMallocW((void **)pcReturnedString, (szBufferSize + 1) * sizeof(_TCHAR));
            if (iFuncRet != RET_OK) {
                goto FUNC_END;
            }
            _tcscpy(*pcReturnedString, pcDefault);
            (*pcReturnedString)[szBufferSize] = _T('\0');
        } else {
        }
    }
    iRet = RET_OK;
FUNC_END:
    return iRet;
}

/*!
    @brief          ̐ݒLmF
*/
static int cdmtrCntPropertiesFindProfileString(_TCHAR *pcAttrName, _PropInfoList *ptPropList)
{
    int iRet = CDMTR_FALSE;
    int i;
    if (ptPropList != NULL) {
        for (i = 0; i < ptPropList->iNum; i++) {
            if (CDMtrLibUtilCompString(pcAttrName, ptPropList->ptPropInfo[i]->pcAttr)) {
                iRet = CDMTR_TRUE;
                break;
            }
        }
    } else {
    }
    return iRet;
}

/*!
    @brief          vpeBt@CSYSINCwl(J}؂)CN[hIvV̍쐬s
*/
static int cdmtrCntPropertiesCreateIncPath(const _TCHAR *pcVal, _TCHAR **ppcInc)
{
    int iRet = RET_NG;
    int iFuncRet;
    _TCHAR *pcValCopy = NULL;
    _TCHAR *pcOpt = NULL;
    _TCHAR *pcTop, *pcEnd, *pcComma;
    unsigned int uiPathNum;
    unsigned int uiLen;
    if (pcVal == NULL) {
        goto FUNC_END;
    }
    if (ppcInc == NULL) {
        goto FUNC_END;
    }
    *ppcInc = NULL;
    pcValCopy = CDMtrLibUtilCopyString(pcVal);
    if (NULL == pcValCopy) {
        goto FUNC_END;
    }
    uiPathNum = 1;
    pcComma = pcValCopy;
    while (1) {
        pcComma = _tcsstr(pcComma, COMMA);
        if (pcComma == NULL) {
            break;
        }
        uiPathNum++;
        pcComma++;
    }
    pcTop = pcValCopy;
    while (1) {
        SKIP_WHITE_SPACE(&pcTop);
        pcComma = _tcsstr(pcTop, COMMA);
        if (pcComma == NULL) {
            break;
        }
        SKIPBACK_WHITE_SPACE(pcTop, &pcComma);
        if (pcTop == pcComma) {
            pcTop++;
            continue;
        }
        pcEnd = pcComma;
        uiLen = pcEnd - pcTop;
        if (uiLen > 0) {
            iFuncRet = cdmtrCntPropertiesCreateSysInc(pcTop, uiLen, &pcOpt);
            if (RET_OK != iFuncRet) {
                goto FUNC_END;
            }
        }
        pcTop = pcComma + 1;
    }
    pcEnd = pcTop + _tcslen(pcTop);
    uiLen = pcEnd - pcTop;
    if (uiLen > 0) {
        iFuncRet = cdmtrCntPropertiesCreateSysInc(pcTop, uiLen, &pcOpt);
        if (RET_OK != iFuncRet) {
            goto FUNC_END;
        }
    }
    *ppcInc = pcOpt;
    iRet = RET_OK;
FUNC_END:
    if (RET_OK != iRet) {
        CDMtrLibUtilFreeW((void **)&pcOpt);
    }
    CDMtrLibUtilFreeW((void **)&pcValCopy);
    return iRet;
}

/*!
    @brief          CN[hIvV̍쐬s
*/
static int cdmtrCntPropertiesCreateSysInc(_TCHAR *pcStr, unsigned int uiLen, _TCHAR **ppcSysInc)
{
    int iFuncRet = RET_NG;
    int isDQStr = CDMTR_FALSE;
    int isUserSet = CDMTR_FALSE;
    _TCHAR *pcDQtop, *pcDQend;
    _TCHAR *pcSrcInfo = NULL;
    _TCHAR *pcShortPath = NULL;
    if (NULL == pcStr || NULL == ppcSysInc ||  0 == uiLen) {
        return RET_NG;
    }
    pcDQtop = pcDQend = NULL;
    pcDQtop = _tcschr(pcStr, _T('\"'));
    if (pcDQtop) {
        if (pcDQtop < pcStr + uiLen) {
            pcDQend = _tcschr(pcDQtop + 1, _T('\"'));
            if (pcDQend) {
                if (pcDQend < pcStr + uiLen) {
                    pcSrcInfo = pcDQtop + 1;
                    *pcDQend = _T('\0');
                    isDQStr = CDMTR_TRUE;
                } else {
                    isUserSet = CDMTR_TRUE;
                }
            } else {
                isUserSet = CDMTR_TRUE;
            }
        }
    }
    if (CDMTR_TRUE != isDQStr) {
        pcSrcInfo = pcStr;
        *(pcStr + uiLen) = _T('\0');
    }
    if (CDMTR_TRUE != isUserSet) {
        iFuncRet = CDMtrLibFileConvertIncludePathW(pcSrcInfo, &pcShortPath);
        if (RET_OK == iFuncRet) {
            iFuncRet = CDMtrLibUtilCreateStringW(ppcSysInc, OPTION_I_INCLUDE, pcShortPath, NULL);
            if (RET_OK != iFuncRet) {
                goto FUNC_END;
            }
        } else {
            if (isDQStr) {
                pcSrcInfo = pcStr;
                *pcDQend = _T('\"');
                *(pcStr + uiLen) = _T('\0');
                isDQStr = CDMTR_FALSE;
            }
            isUserSet = CDMTR_TRUE;
        }
    }
    if (isUserSet) {
        iFuncRet = CDMtrLibUtilCreateStringW(ppcSysInc, OPTION_I_INCLUDE, pcSrcInfo, NULL);
        if (RET_OK != iFuncRet) {
            goto FUNC_END;
        }
    }
FUNC_END:
    CDMtrLibUtilFreeW((void **)&pcShortPath);
    return iFuncRet;
}

/*!
    @brief          vpeBt@C[LANG]ёmF
*/
static int cdmtrCntPropertiesCheckLangAttr(const _TCHAR *pcName)
{
    int iRet;
    _TCHAR *p;
    unsigned int uiLen;
    iRet = RET_TRUE;
    uiLen = _tcslen(pcName);
    if (uiLen > PROP_LANG_ATTR_SIZE) {
        iRet = RET_FALSE;
        goto FUNC_END;
    }
    p = (_TCHAR *)pcName;
    if (!CDMtrLibUtilIsAlpha(*p)) {
        iRet = RET_FALSE;
        goto FUNC_END;
    }
    p++;
    while (!IS_NULL_CHAR(p)) {
        if (!(CDMtrLibUtilIsAlpha(*p) || CDMtrLibUtilIsDigit(*p))) {
            iRet = RET_FALSE;
            break;
        }
        p++;
    }
FUNC_END:
    return iRet;
}

/*!
    @brief      vpeBt@CpXmF
*/
static int cdmtrCntPropertiesCheckProfileName(void)
{
    int iRet = RET_NG;
    int iFuncRet;
    FILE *fp = NULL;
    _TCHAR *pcAbsolutePath = NULL;

    if (pcProfFileName) {
        /** IvVŎw肳ꂽvpeBt@CmF */
        if (CDMtrLibFileIsDir(pcProfFileName)) {
            CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000116, pcProfFileNameLogOut); //* MSG_LOG_ID_C_00000116
            goto FUNC_END;
        }
        if ((fp = _tfopen(pcProfFileName, _T("r"))) == NULL) {
            CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000117, pcProfFileNameLogOut); //* MSG_LOG_ID_C_00000117
            goto FUNC_END;
        }
    } else {
        /** JgtH_ɃvpeBt@C݂邩mF */
        pcProfFileName = _tgetcwd(NULL, 0);
        iFuncRet = CDMtrLibUtilCreateStringW(&pcProfFileName, FOLDER_SEPALATE, PROPERTY_FILE_NAME, NULL);
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
        if ((fp = _tfopen(pcProfFileName, _T("r"))) == NULL) {
            /** CXg[tH_ɃvpeBt@C݂邩mF */
            CDMtrLibUtilFreeW((void **)&pcProfFileName);
            iFuncRet = CDMtrLibUtilCreateStringW(&pcProfFileName, pcObjectPath, ENVIRONMENT_PATH, PROPERTY_FILE_NAME, NULL);
            if (iFuncRet != RET_OK) {
                goto FUNC_END;
            }
            if ((fp = _tfopen(pcProfFileName, _T("r"))) == NULL) {
                /* JgtH_ɃvpeBt@C݂邩mF */
                CDMtrLibUtilFreeW((void **)&pcProfFileName);
                iFuncRet = CDMtrLibUtilCreateStringW(&pcProfFileName, PROPERTY_FILE_NAME, NULL);
                if (iFuncRet != RET_OK) {
                    goto FUNC_END;
                }
                if ((fp = _tfopen(pcProfFileName, _T("r"))) == NULL) {
                    CDMtrLibUtilFreeW((void **)&pcProfFileName);
                    iRet = RET_OK;
                    goto FUNC_END;
                }
            }
        }
        /** ΃pXɕϊ */
        iFuncRet = CDMtrLibFileGetAbsolutePath(pcProfFileName, &pcAbsolutePath);
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }

        /** vpeBt@Cݒ肷 */
        CDMtrLibUtilFreeW((void **)&pcProfFileName);
        pcProfFileName = pcAbsolutePath;
        pcAbsolutePath = NULL;  // h~
        /** vpeBt@C(Oo͗p)ݒ肷 */
        pcProfFileNameLogOut = CDMtrLibFileRemoveLongPathMarkW(pcProfFileName);
    }
    /** mF̂߃I[vvpeBt@CN[Y */
    if (fp) {
        fclose(fp);
        fp = NULL;
    }
    iRet = RET_OK;
FUNC_END:
    return iRet;
}

