/*
 *  source code metrics counter
 *  Copyright (C) 2015  NEC Corporation.
 *  
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <windows.h>

#include "CDMtrExtCmn.h"
#include "CDMtrExtMain.h"
#include "CDMtrExtLine.h"
#include "CDMtrExtTake.h"
#include "CDMtrExtProp.h"

#include "CDMtrLibCmnW.h"
#include "CDMtrLibUtilW.h"
#include "CDMtrLibFileW.h"
#include "CDMtrLibSigW.h"
#include "CDMtrMessage.h"

_LINECOUNT  gtCount;
FILE *gFileCountTarget = NULL;
_OPTINFO gtOptInfo_lc;
_LINECOUNT_LIST *gptLCList;
extern int giRestyleBothFlg;

static int cdmtrExtMainExecFile(const _TCHAR *pcInfile);

/*!
    @brief          {C̃JEgs
*/
int cdmtrExtMain(_LINECOUNT_LIST *ptLineCountlist)
{
    int iRet, iFuncRet;
    _FileList *pTargetList;
    char *pcReadPropName;
    iRet = RET_NG;
    pTargetList = NULL;
    pcReadPropName = NULL;
    memset(&gtCount, 0x00, sizeof(_LINECOUNT));
    gtOptInfo_lc.iLangType = CDMtrExtPropGetType(gtOptInfo_lc.pcLangName);
    gptLCList = ptLineCountlist;
    iFuncRet = cdmtrExtMainExecFile(gtOptInfo_lc.pcInputpath);
    switch (iFuncRet) {
    case RET_NG:
        CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000488); //* MSG_LOG_ID_C_00000488
        goto FUNC_END;
        break;
    case RET_OK:
    default:
        iRet = RET_OK;
        break;
    }
    CDMtrLibCmnTrcLogOut(MSG_LOG_ID_C_00000491); //* MSG_LOG_ID_C_00000491
FUNC_END:
    return iRet;
}



/*!
    @brief          {C̃JEgs
*/
static int cdmtrExtMainExecFile(const _TCHAR *pcInfile)
{
    int iRet, iFuncRet;
    const _TCHAR *pcInfileLogOut = NULL;
    iRet = RET_NG;
    MACRO_PERFORMANCE_PUTLOG(PERFORMANCE_LVL7, _T("OpenFile : [input] <S>")); //* MSG_LOG_ID_C_00000494
    pcInfileLogOut = CDMtrLibFileRemoveLongPathMarkW(pcInfile);
    gFileCountTarget = _tfopen(pcInfile, _T("r, ccs=UTF-8"));
    MACRO_PERFORMANCE_PUTLOG(PERFORMANCE_LVL7, _T("OpenFile : [input] <E>")); //* MSG_LOG_ID_C_00000495
    if ( gFileCountTarget != NULL ) {
        CDMtrLibCmnTrcLogOut(MSG_LOG_ID_C_00000492, pcInfileLogOut); //* MSG_LOG_ID_C_00000492
        iFuncRet = CDMtrExtLineInitSetComment(gtOptInfo_lc.pcProppath, gtOptInfo_lc.pcLangName);
        if (iFuncRet != RET_OK) {
            CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000489); //* MSG_LOG_ID_C_00000489
            goto FUNC_END;
        }
        iRet = CDMtrExtLineExtractLines(gFileCountTarget);
        if (iRet != RET_OK) {
            CDMtrLibCmnLogOut(MSG_LOG_ID_C_00000490, pcInfileLogOut); //* MSG_LOG_ID_C_00000490
            goto FUNC_END;
        }
        CDMtrLibCmnTrcLogOut(MSG_LOG_ID_C_00000493); //* MSG_LOG_ID_C_00000493
    } else {
        iRet = RET_NG;
    }
FUNC_END:
    if (gFileCountTarget != NULL) {
        fclose(gFileCountTarget);
        gFileCountTarget = NULL;
    }
    return iRet;
}
