/*
 *  source code metrics counter
 *  Copyright (C) 2015  NEC Corporation.
 *  
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */


#ifndef _CDMTRCNTFORMAT_H_
#define _CDMTRCNTFORMAT_H_

#include <tchar.h>


#define FUNCINFO_NAME _T("_FuncInfo.csv")

#define LINEINFO_NAME _T("_LineInfo.csv")



#define FUNCDTL_STATUS_NORMAL      (0)
#define FUNCDTL_STATUS_ERROR       (1)
#define FUNCDTL_STATUS_ERROR_PARSE (2)


#define LINEDTL_STATUS_NORMAL      (0)
#define LINEDTL_STATUS_ERROR       (1)
#define LINEDTL_STATUS_ERROR_PARSE (2)

#define LINEDTL_NAMESPACE_DELIM_NONE  (0x00000000)
#define LINEDTL_NAMESPACE_DELIM_START (0x00000001)
#define LINEDTL_NAMESPACE_DELIM_END   (0x00000002)

#define LINEDTL_CLASS_DELIM_NONE      (0x00000000)
#define LINEDTL_CLASS_DELIM_START     (0x00000001)
#define LINEDTL_CLASS_DELIM_END       (0x00000002)

#define LINEDTL_FUNC_DELIM_NONE      (0x00000000)
#define LINEDTL_FUNC_DELIM_START     (0x00000001)
#define LINEDTL_FUNC_DELIM_END       (0x00000002)

#define LINEDTL_FUNC_LINE_IN         (1)
#define LINEDTL_FUNC_LINE_OUT        (0)

#define LINEDTL_EFFECTIVE_LINE       (1)
#define LINEDTL_EFFECTIVE_NONE       (0)

#define LINEDTL_COMMENT_LINE         (1)
#define LINEDTL_COMMENT_NONE         (0)

#define LINEDTL_COMMENT_CONTINUATION_TRUE (1)
#define LINEDTL_COMMENT_CONTINUATION_NONE (0)

#define LINEDTL_BLANK_LINE           (1)
#define LINEDTL_BLANK_NONE           (0)

#define LINEDTL_ELOC_KIND_CODE       (1)
#define LINEDTL_ELOC_KIND_PREP       (2)
#define LINEDTL_ELOC_KIND_SKIP       (3)
#define LINEDTL_ELOC_KIND_OTHER      (0)

#define LINEDTL_PREP_NONE            (0)
#define LINEDTL_PREP_CONST           (1)
#define LINEDTL_PREP_EXTSOURCE       (2)
#define LINEDTL_PREP_IF              (3)
#define LINEDTL_PREP_REGION          (4)
#define LINEDTL_PREP_EXTCHKSUM       (5)
#define LINEDTL_PREP_OTHER           (6)

#define LINEDTL_CLOC_KIND_NOMAL      (0x00000001)
#define LINEDTL_CLOC_KIND_NONE       (0x00000000)

#define LINEDTL_CONTINUATION_LINE    (1)
#define LINEDTL_CONTINUATION_NONE    (0)



enum {
    FUNCINFO_CSV_FUNC_ID           = 0,
    FUNCINFO_CSV_FUNC_NAME,
    FUNCINFO_CSV_FUNC_STARTLINE,
    FUNCINFO_CSV_FUNC_ENDLINE,
    FUNCINFO_CSV_PARAM_CNT,
    FUNCINFO_CSV_PARAM_NAME,
    FUNCINFO_CSV_INTERNALFUNC,
    FUNCINFO_CSV_STATUS,

    FUNCINFO_CSV_END
} FUNCINFO_CSV_E;


enum {
    FUNCINFO_FUNC_ID          = 0,
    FUNCINFO_FUNC_STARTLINE,
    FUNCINFO_FUNC_ENDLINE,
    FUNCINFO_PARAM_CNT,
    FUNCINFO_INTERNALFUNC,
    FUNCINFO_STATUS,

    FUNCINFO_NUM_END
} FUNCINFO_ITEM_NUM_E;

enum {
    FUNCINFO_FUNC_NAME        = 0,
    FUNCINFO_PARAM_NAME,

    FUNCINFO_STR_END
} FUNCINFO_ITEM_STR_E;


typedef struct {
    int   iState;
    int   iCnt[FUNCINFO_NUM_END];
    _TCHAR *pcStr[FUNCINFO_STR_END];
} FUNCINFO_T;



enum {
    LINEINFO_CSV_LINE_NUMBER  = 0,
    LINEINFO_CSV_STATUS,
    LINEINFO_CSV_NAMESPACE_DELIM,
    LINEINFO_CSV_CLASS_DELIM,
    LINEINFO_CSV_FUNC_DELIM,
    LINEINFO_CSV_FUNC_ID,
    LINEINFO_CSV_FUNC_LINE,
    LINEINFO_CSV_EFFECTIVE_LINE,
    LINEINFO_CSV_COMMENT_LINE,
    LINEINFO_CSV_BLANK_LINE,
    LINEINFO_CSV_ELOC_KIND,
    LINEINFO_CSV_PREP_KIND,
    LINEINFO_CSV_CLOC_KIND,
    LINEINFO_CSV_STATEMENTS,
    LINEINFO_CSV_CONTROL_STATEMENTS,
    LINEINFO_CSV_CYCLOWC,
    LINEINFO_CSV_CONTROL_KIND,
    LINEINFO_CSV_BRANCHES,
    LINEINFO_CSV_CNDOPS,
    LINEINFO_CSV_NEST_LEVEL,
    LINEINFO_CSV_LINE_CONTINUATION,
    LINEINFO_CSV_COMMENT_CONTINUATION,
    LINEINFO_CSV_ATTIBUTE_LINE,
    LINEINFO_CSV_EVALS,
    LINEINFO_CSV_EVALR,
    LINEINFO_CSV_AVALS,

    LINEINFO_CSV_END
} LINEINFO_CSV_E;

enum {
    LINEINFO_LINE_NUMBER      = 0,
    LINEINFO_STATUS,
    LINEINFO_NAMESPACE_DELIM,
    LINEINFO_CLASS_DELIM,
    LINEINFO_FUNC_DELIM,
    LINEINFO_FUNC_ID,
    LINEINFO_FUNC_LINE,
    LINEINFO_EFFECTIVE_LINE,
    LINEINFO_COMMENT_LINE,
    LINEINFO_BLANK_LINE,
    LINEINFO_ELOC_KIND,
    LINEINFO_PREP_KIND,
    LINEINFO_CLOC_KIND,
    LINEINFO_STATEMENTS,
    LINEINFO_CONTROL_STATEMENTS,
    LINEINFO_CYCLOWC,
    LINEINFO_CONTROL_KIND,
    LINEINFO_BRANCHS,
    LINEINFO_CNDOPS,
    LINEINFO_NEST_LEVEL,
    LINEINFO_LINE_CONTINUATION,
    LINEINFO_COMMENT_CONTINUATION,
    LINEINFO_ATTIBUTE_LINE,
    LINEINFO_EVALS,
    LINEINFO_EVALR,
    LINEINFO_AVALS,

    LINEINFO_END
} LINEINFO_ITEM_E;

typedef struct {
    int   iState;
    int   iCnt[LINEINFO_END];
} LINEINFO_T;


enum {
    OUTINFO_FLOC          = 0,
    OUTINFO_ELOC,
    OUTINFO_CLOC,
    OUTINFO_BLOC,
    OUTINFO_SKIP,
    OUTINFO_STMT,
    OUTINFO_CYCLO,
    OUTINFO_CYCLOWC,
    OUTINFO_BRANCHS,
    OUTINFO_CNDOPS,
    OUTINFO_NESTS,
    OUTINFO_EVALR,
    OUTINFO_EVALS,
    OUTINFO_AVALS,

    OUTINFO_END
} OUTINFO_E;


typedef struct {
    int   iCnt[OUTINFO_END];
} OUTINFO_T;

#endif
