/*
 *  source code metrics counter
 *  Copyright (C) 2015  NEC Corporation.
 *  
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#include <string.h>

#define LOG_FILENAME_FORMAT "[ERR] FILE : %s\n"

static char *spcTargetFilePath = NULL;



/*!
    @brief          mۏ
*/
void *CDMtrLibCmnMalloc(size_t szLen)
{
    char *pcBuffer;
    pcBuffer = (char *)malloc(szLen);
    if (pcBuffer == NULL) {
        goto FUNC_END;
    }
    memset(pcBuffer, 0, szLen);
FUNC_END:
    return (void *)pcBuffer;
}


/*!
    @brief          
*/
void CDMtrLibCmnFree(void **ppcBuffer)
{
    if (ppcBuffer == NULL) {
        goto FUNC_END;
    }
    if (*ppcBuffer != NULL) {
        free(*ppcBuffer);
        *ppcBuffer = NULL;
    }
FUNC_END:
    return;
}


/*!
    @brief          Oɏo͂Ώۃt@CpXݒ
*/
void CDMtrLibCmnSetTargetName(const char *pcFilePath)
{
    spcTargetFilePath = (char *)pcFilePath;
    return;
}


/*!
    @brief      Oɏo͂Ώۃt@CpX
*/
void CDMtrLibCmnClearTargetName(void)
{
    spcTargetFilePath = NULL;
    return;
}


/*!
    @brief          Oo
*/
void CDMtrLibCmnLogOut(
    const char *pFormat,
    ...)
{
    va_list ap;
    if (pFormat == NULL) {
        goto FUNC_END;
    }
    va_start(ap, pFormat);
    vfprintf(stdout, pFormat, ap);
    va_end(ap);
FUNC_END:
    return;
}


/*!
    @brief          G[Oo
*/
void CDMtrLibCmnErrLogOut(
    const char *pFormat,
    ...)
{
    va_list ap;
    if (pFormat == NULL) {
        goto FUNC_END;
    }
    if (spcTargetFilePath != NULL) {
        fprintf(stdout, LOG_FILENAME_FORMAT, spcTargetFilePath);
    } else {
    }
    va_start(ap, pFormat);
    vfprintf(stdout, pFormat, ap);
    va_end(ap);
FUNC_END:
    return;
}


/*!
    @brief          fobOOo
*/
void CDMtrLibCmnDebugLogOut(int iOutFlg,
                            const char *pFormat,
                            ...)
{
    va_list ap;
    if ( iOutFlg == 0 || pFormat == NULL ) {
        goto FUNC_END;
    }
    va_start(ap, pFormat);
    vfprintf(stdout, pFormat, ap);
    va_end(ap);
FUNC_END:
    return;
}


/*!
    @brief          g[XOo
*/
void CDMtrLibCmnTrcLogOut(
    const char *pFormat,
    ...)
{
#ifdef CDMTR_DEBUG
    va_list ap;
    if (pFormat == NULL) {
        goto FUNC_END;
    }
    va_start(ap, pFormat);
    vfprintf(stdout, pFormat, ap);
    va_end(ap);
FUNC_END:
#endif
    return;
}
