/*
 *  source code metrics counter
 *  Copyright (C) 2015  NEC Corporation.
 *  
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
#define _CRT_SECURE_NO_WARNINGS
#include <string.h>
#include <stdlib.h>

#include "CDMtrLibOpt.h"


#define False (0)
#define True  (1)


static OptionInfo *sptOptionInfo = NULL;

static int siOptionNum = 0;

static int siCurPos = 1;

static int cdmtrLibOptCopyStrings(char *pcFromStr, char **ppcToStr);

/*!
    @brief          w蕶Rs[ꏊmۂāARs[
*/
static int cdmtrLibOptCopyStrings(char *pcFromStr, char **ppcToStr)
{
    unsigned int uiStrLen = 0;
    if (ppcToStr == NULL) {
        return False;
    }
    if (pcFromStr == NULL) {
        return False;
    }
    uiStrLen = strlen(pcFromStr);
    *ppcToStr = (char *)malloc(sizeof(char) * (uiStrLen + 1));
    if (NULL == *ppcToStr) {
        *ppcToStr = NULL;
        return False;
    }
    strncpy(*ppcToStr, pcFromStr, uiStrLen);
    (*ppcToStr)[uiStrLen] = '\0';
    return True;
}






/*!
    @brief      IvV͂̑O
*/
void CDMtrLibOptInitGetParameter(OptionInfo *pOptInfo, int iOptNum)
{
    sptOptionInfo = pOptInfo;
    siOptionNum   = iOptNum;
    siCurPos      = 1;
    return;
}

/*!
    @brief      IvV͂̌㏈
*/
void CDMtrLibOptFinishGetParameter(void)
{
    sptOptionInfo = NULL;
    siOptionNum   = 0;
    siCurPos      = 1;
    return;
}


/*!
    @brief      IvV͂
*/
int CDMtrLibOptGetParameter(int iArgNum, char *ppcArgStr[], char **ppcParamStr)
{
    if (NULL == sptOptionInfo) {
        return OPTION_NOINIT;
    }
    if (NULL == ppcParamStr) {
        return OPTION_ERROR;
    }
    if (NULL == ppcArgStr) {
        *ppcParamStr = NULL;
        return OPTION_ERROR;
    }
    if (1 == iArgNum) {
        *ppcParamStr = NULL;
        return OPTION_END;
    }
    if (siCurPos >= iArgNum) {
        *ppcParamStr = NULL;
        return OPTION_END;
    }
    if (NULL == ppcArgStr[siCurPos]) {
        *ppcParamStr = NULL;
        return OPTION_ERROR;
    }
    if ('-' == ppcArgStr[siCurPos][0]) {
        char *pcOptStr = ppcArgStr[siCurPos] + 1;
        int   iLenOptStr;
        int   iCurOpt;
        int   iResCmp;
        for (iCurOpt = 0; iCurOpt < siOptionNum; iCurOpt++) {
            OptionInfo *ptCurOpt = sptOptionInfo + iCurOpt;
            iLenOptStr = strlen(ptCurOpt->pcOptionStr);
            iResCmp = strncmp(ptCurOpt->pcOptionStr, pcOptStr, iLenOptStr);
            if (0 == iResCmp) {
                if (OPT_HAS_PARAM == ptCurOpt->iHasOption) {
                    if ('=' == *(pcOptStr + iLenOptStr)) {
                        iLenOptStr++;
                    }
                    if ('\0' != *(pcOptStr + iLenOptStr)) {
                        if (True != cdmtrLibOptCopyStrings(pcOptStr + iLenOptStr, ppcParamStr)) {
                            *ppcParamStr = NULL;
                            return OPTION_ERROR;
                        }
                    } else {
                        siCurPos++;
                        if (siCurPos >= iArgNum) {
                            if (True != cdmtrLibOptCopyStrings(ppcArgStr[siCurPos - 1], ppcParamStr)) {
                                *ppcParamStr = NULL;
                                return OPTION_ERROR;
                            }
                            if ('=' == *(*ppcParamStr + strlen(*ppcParamStr) - 1)) {
                                *(*ppcParamStr + strlen(*ppcParamStr) - 1) = '\0';
                            }
                            return OPTION_MUSTPARAM;
                        }
                        if ('-' == ppcArgStr[siCurPos][0]) {
                            if (True != cdmtrLibOptCopyStrings(ppcArgStr[siCurPos - 1], ppcParamStr)) {
                                *ppcParamStr = NULL;
                                return OPTION_ERROR;
                            }
                            if ('=' == *(*ppcParamStr + strlen(*ppcParamStr) - 1)) {
                                *(*ppcParamStr + strlen(*ppcParamStr) - 1) = '\0';
                            }
                            return OPTION_MUSTPARAM;
                        } else if ('=' == ppcArgStr[siCurPos][0]) {
                            if ('\0' != ppcArgStr[siCurPos][1]) {
                                if (True != cdmtrLibOptCopyStrings(&ppcArgStr[siCurPos][1], ppcParamStr)) {
                                    *ppcParamStr = NULL;
                                    return OPTION_ERROR;
                                }
                            } else {
                                siCurPos++;
                                if (siCurPos >= iArgNum) {
                                    if (True != cdmtrLibOptCopyStrings(ppcArgStr[siCurPos - 2], ppcParamStr)) {
                                        *ppcParamStr = NULL;
                                        return OPTION_ERROR;
                                    }
                                    return OPTION_MUSTPARAM;
                                }
                                if ('-' == ppcArgStr[siCurPos][0]) {
                                    if (True != cdmtrLibOptCopyStrings(ppcArgStr[siCurPos - 2], ppcParamStr)) {
                                        *ppcParamStr = NULL;
                                        return OPTION_ERROR;
                                    }
                                    return OPTION_MUSTPARAM;
                                } else {
                                    if (True != cdmtrLibOptCopyStrings(ppcArgStr[siCurPos], ppcParamStr)) {
                                        *ppcParamStr = NULL;
                                        return OPTION_ERROR;
                                    }
                                }
                            }
                        } else {
                            if (True != cdmtrLibOptCopyStrings(ppcArgStr[siCurPos], ppcParamStr)) {
                                *ppcParamStr = NULL;
                                return OPTION_ERROR;
                            }
                        }
                    }
                } else {
                    if ('\0' != *(pcOptStr + iLenOptStr)) {
                        if (True != cdmtrLibOptCopyStrings(ppcArgStr[siCurPos], ppcParamStr)) {
                            *ppcParamStr = NULL;
                            return OPTION_ERROR;
                        }
                        siCurPos++;
                        return OPTION_UNKNOWN;
                    } else {
                        *ppcParamStr = NULL;
                    }
                }
                siCurPos++;
                return (sptOptionInfo + iCurOpt)->iOptionID;
            }
        }
        if (True != cdmtrLibOptCopyStrings(ppcArgStr[siCurPos], ppcParamStr)) {
            *ppcParamStr = NULL;
            return OPTION_ERROR;
        }
        siCurPos++;
        return OPTION_UNKNOWN;
    } else {
        if (True != cdmtrLibOptCopyStrings(ppcArgStr[siCurPos], ppcParamStr)) {
            *ppcParamStr = NULL;
            return OPTION_ERROR;
        }
        siCurPos++;
        return OPTION_NOOPTION;
    }
    *ppcParamStr = NULL;
    return OPTION_ERROR;
}


