/*
 *  source code metrics counter
 *  Copyright (C) 2015  NEC Corporation.
 *  
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
#ifndef CDMTRLIBCMN_W_H_
#define CDMTRLIBCMN_W_H_

#define DEFINE_MEMORY_NCMETER_NAME _T("ncmeter.exe")

//* MSG_LOG_ID_C_00000534
#define DEFINE_MEMORY_TITLE _T("ProcessID, ProcessHandle, PeakWorkingSetSize, WorkingSetSize, \
QuotaPeakPagedPoolUsage ,QuotaPagedPoolUsage ,QuotaPeakNonPagedPoolUsage, QuotaNonPagedPoolUsage, \
PagefileUsage, PeakPagefileUsage, PageFaultCount, Module, Comments")

//* MSG_LOG_ID_C_00000535
#define MACRO_MEMORY_TITLE_PUTLOG(lvl) \
    if(giPerformance & lvl){\
        CDMtrLibCmnLogOut(_T("[MEMORY],%s\n"),DEFINE_MEMORY_TITLE);\
    }

#define MACRO_MEMORY_PUTLOG(lvl, module, comment, pshandle, psid) \
    if(giPerformance & lvl){\
        CDMtrLibCmnProcessMemory(module, comment, pshandle, psid);\
    }

#if defined(UNICODE)
#define CDMtrLibCmnMalloc           CDMtrLibCmnMallocW
#define CDMtrLibCmnFree             CDMtrLibCmnFreeW
#define CDMtrLibCmnSetTargetName    CDMtrLibCmnSetTargetNameW
#define CDMtrLibCmnClearTargetName  CDMtrLibCmnClearTargetNameW
#define CDMtrLibCmnLogOut           CDMtrLibCmnLogOutW
#define CDMtrLibCmnErrLogOut        CDMtrLibCmnErrLogOutW
#define CDMtrLibCmnDebugLogOut      CDMtrLibCmnDebugLogOutW
#define CDMtrLibCmnTrcLogOut        CDMtrLibCmnTrcLogOutW
#define CDMtrLibCmnSetLogCharset	CDMtrLibCmnSetLogCharsetW
#define CDMtrLibCmnProcessMemory    CDMtrLibCmnProcessMemoryW
#endif

void *CDMtrLibCmnMallocW(size_t szLen);
void CDMtrLibCmnFreeW(void **ppcBuffer);
void CDMtrLibCmnSetTargetNameW(const wchar_t *pcFilePath);
void CDMtrLibCmnClearTargetNameW(void);
void CDMtrLibCmnLogOutW(const wchar_t *pFormat, ...);
void CDMtrLibCmnErrLogOutW(const wchar_t *pFormat, ...);
void CDMtrLibCmnDebugLogOutW(int iOutFlg, const wchar_t *pFormat, ...);
void CDMtrLibCmnTrcLogOutW(const wchar_t *pFormat, ...);
void CDMtrLibCmnSetLogCharsetW(const wchar_t *pcCharset);
void CDMtrLibCmnProcessMemoryW(_TCHAR *mdl, _TCHAR *cmt, const HANDLE hProcess, const DWORD dwProcessID);
#endif
