/*
 *  source code metrics counter
 *  Copyright (C) 2015  NEC Corporation.
 *  
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
#ifndef CDMTRLIBFILE_W_H_
#define CDMTRLIBFILE_W_H_
#include <stdlib.h>
#define FILE_PATH_SIZE (2048)

typedef struct tag_FileList {
    int count;
    wchar_t *filename[1];
} _FileList;

#if defined(UNICODE)
#define CDMtrLibFileGetDirName      CDMtrLibFileGetDirNameW
#define CDMtrLibFileGetFileName     CDMtrLibFileGetFileNameW
#define CDMtrLibFileSetDirFileName  CDMtrLibFileSetDirFileNameW
#define CDMtrLibFileGetAbsolutePath CDMtrLibFileGetAbsolutePathW
#define CDMtrLibFileIsDir           CDMtrLibFileIsDirW
#define CDMtrLibFileIsFile          CDMtrLibFileIsFileW
#define CDMtrLibFileGetFileList     CDMtrLibFileGetFileListW
#define CDMtrLibFileFreeFileList    CDMtrLibFileFreeFileListW

#define CDMtrLibFileGetShortPathName    CDMtrLibFileGetShortPathNameW
#define CDMtrLibFileGetLongPathName     CDMtrLibFileGetLongPathNameW
#define CDMtrLibFileGetFullPathName     CDMtrLibFileGetFullPathNameW
#define CDMtrLibFileIsMaxPath           CDMtrLibFileIsMaxPathW

#define CDMtrLibFileCreateDir       CDMtrLibFileCreateDirW
#define CDMtrLibFileDeleteDir       CDMtrLibFileDeleteDirW
#define CDMtrLibFileDeleteDirAll    CDMtrLibFileDeleteDirAllW
#define CDMtrLibFileDelete          CDMtrLibFileDeleteW
#define CDMtrLibFileRename          CDMtrLibFileRenameW
#define CDMtrLibFileCreateTempFile  CDMtrLibFileCreateTempFileW
#define CDMtrLibFileCopy            CDMtrLibFileCopyW

#define CDMtrLibFileGetLineOfFile               CDMtrLibFileGetLineOfFileW
#define CDMtrLibFileGetFileSize                 CDMtrLibFileGetFileSizeW
#define CDMtrLibFileConvertAccessiblePath       CDMtrLibFileConvertAccessiblePathW
#define CDMtrLibFileConvertIncludePath          CDMtrLibFileConvertIncludePathW
#define CDMtrLibFileGetShortPathWithinMaxpath   CDMtrLibFileGetShortPathWithinMaxpathW
#endif


extern int iNumOfUnrecognized ;


int CDMtrLibFileGetDirNameW(const wchar_t *pcpath, wchar_t *pcdir);
int CDMtrLibFileGetFileNameW(const wchar_t *pcpath, wchar_t *pcfile);
int CDMtrLibFileSetDirFileNameW(const wchar_t *pcDir, const wchar_t *pcFile, wchar_t **ppcPath);
int CDMtrLibFileGetAbsolutePathW(const wchar_t *pcfile, wchar_t **ppcpath);
int CDMtrLibFileIsDirW(const wchar_t *pcdir);
int CDMtrLibFileIsFileW(const wchar_t *pcfile);
int CDMtrLibFileGetFileListW(const wchar_t *pcdir, _FileList **ppflist);
void CDMtrLibFileFreeFileListW(_FileList **ppflist);

int CDMtrLibFileGetShortPathNameW(const wchar_t *pwInPath, wchar_t **ppwPath);
int CDMtrLibFileGetLongPathNameW(const wchar_t *pwInPath, wchar_t **ppwPath);
int CDMtrLibFileGetFullPathNameW(const wchar_t *pwInPath, wchar_t **ppwPath);
int CDMtrLibFileIsMaxPathW(const wchar_t *pwPath);
const wchar_t *CDMtrLibFileRemoveLongPathMarkW(const wchar_t *pcPath);

int CDMtrLibFileCreateDirW(const wchar_t *pcDirpath);
int CDMtrLibFileDeleteDirW(const wchar_t *pcDirpath);
int CDMtrLibFileDeleteDirAllW(const wchar_t *pcDirpath, int iDelFlg);
int CDMtrLibFileDeleteW(const wchar_t *pcTargetfile);
int CDMtrLibFileRenameW(const wchar_t *pcOldPath, const wchar_t *pcNewPath);
int CDMtrLibFileCreateTempFileW(wchar_t **ppcpath);
int CDMtrLibFileCopyW(wchar_t *pcDest, wchar_t *pcSrc);

int CDMtrLibFileGetLineOfFileW(const _TCHAR *pcFileName);
long CDMtrLibFileGetFileSizeW(_TCHAR *pcFileName);
int CDMtrLibFileConvertAccessiblePathW(_TCHAR *psFilePath, _TCHAR *psCopyFileName, _TCHAR *psTempFolderName, int iShortpathFlg, _TCHAR **ppsOutFilePath);
int CDMtrLibFileConvertIncludePathW(const _TCHAR *pcSrcPath, _TCHAR **ppcDistPath);
int CDMtrLibFileGetShortPathWithinMaxpathW(const _TCHAR *pcOrgPath, _TCHAR **pcShortPath);
#endif
