/*
 *  source code metrics counter
 *  Copyright (C) 2015  NEC Corporation.
 *  
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
#ifndef INCLUDE_CHECK_OPT_W_H
#define INCLUDE_CHECK_OPT_W_H

#include <tchar.h>
#define OPT_HAS_OPTPARAM   (2)
#define OPT_HAS_PARAM      (1)
#define OPT_HAS_NOPARAM (0)


/*! @brief IvV^Cv */
typedef enum {
    OPTION_ERROR        = -6,
    OPTION_NOINIT       = -5,
    OPTION_NOOPTION     = -4,
    OPTION_MUSTPARAM    = -3,
    OPTION_UNKNOWN      = -2,
    OPTION_END          = -1,
    OPTION_NONE         = 0,
    OPTION_EXECUTION_ROW,   //!< -row
    OPTION_EXECUTION_DIFF,  //!< -diff
    OPTION_EXECUTION_STRUCT,//!< -struct
    OPTION_F_OUTPUT_MODE,   //!< -F
    OPTION_TFO_OUTFILE,     //!< -Tfo
    OPTION_TFP_PROPFILE,    //!< -Tfp
    OPTION_D_MACRO,         //!< -D
    OPTION_U_MACRO,         //!< -U
    OPTION_I_DIR,           //!< -I
    OPTION_V_SHOWDETAILS,   //!< -v
    OPTION_HELP_USAGE,      //!< --help
    OPTION_RESTYLE,         //!< -RESTYLE
    OPTION_STMT,            //!< -stmt
    OPTION_TTC,             //!< -Ttc
    OPTION_LCDEBUG,         //!< -detail
    OPTION_DEBUG,           //!< -debug
    OPTION_HEADER,          //!< -header
    OPTION_MAKE,            //!< -make
    OPTION_FOOTER,          //!< -footer
    OPTION_STDATE,          //!< -STDATE
    OPTION_EDDATE,          //!< -EDDATE
    OPTION_HEADER_ADD,      //!< -header_add
    OPTION_STRUCT_STD,      //!< -struct_std
    OPTION_STRUCT_SMP,      //!< -struct_smp
    OPTION_SPS_DEBUG,       //!< -debug2
    OPTION_CHARSET,         //!< -charset
    OPTION_DIFF_BLANK,      //!< -diff_blank
    OPTION_EXECUTION_CK,    //!< -ck
    OPTION_OPT_CLASS,       //!< -optclass
    OPTION_RESULT_CODE,     //!< -Qrc
    OPTION_LOG_CODE,        //!< -Qlg
    OPTION_DIFF_FILE,       //!< -diff_file
    OPTION_DIFF_FUNC,       //!< -diff_func
    OPTION_PERFORMANCE      //!< --performance
} OptionType;


typedef struct tag_OptionInfo {
    int   iOptionID;
    _TCHAR *pcOptionStr;
    int   iHasOption;
} OptionInfo;

#if defined(UNICODE)
#define CDMtrLibOptInitGetParameter     CDMtrLibOptInitGetParameterW
#define CDMtrLibOptGetParameter         CDMtrLibOptGetParameterW
#define CDMtrLibOptFinishGetParameter   CDMtrLibOptFinishGetParameterW
#define CDMtrLibOptCheckDispLang		CDMtrLibOptCheckDispLangW
#endif

extern void CDMtrLibOptInitGetParameterW(OptionInfo *pOptInfo, int iOptNum);
extern int  CDMtrLibOptGetParameterW(int iArgNum, _TCHAR *ppcArgStr[], _TCHAR **ppcParamStr);
extern void CDMtrLibOptFinishGetParameterW(void);
extern int  CDMtrLibOptCheckDispLangW(_TCHAR *pcStr);

#endif
