/*
 *  source code metrics counter
 *  Copyright (C) 2015  NEC Corporation.
 *  
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
#ifndef CDMTRLIBPROP_H_
#define CDMTRLIBPROP_H_

#include <tchar.h>

typedef struct tag_PropInfoW {
    _TCHAR *pcAttr;
    _TCHAR *pcVal;
} _PropInfoW;

typedef struct tag_PropInfoListW {
    int iNum;
    _PropInfoW *ptPropInfo[1];
} _PropInfoListW;

#if defined(UNICODE)
#define _PropInfoList          _PropInfoListW
#define CDMtrLibPropGetList     CDMtrLibPropGetListW
#define CDMtrLibPropFreeList    CDMtrLibPropFreeListW
#endif

int CDMtrLibPropGetListW(const _TCHAR *pcFileName, const _TCHAR *pcGroupName, _PropInfoListW **pptPropList);
void CDMtrLibPropFreeListW(_PropInfoListW **pptPropList);

#endif
