/*
 *  source code metrics counter
 *  Copyright (C) 2015  NEC Corporation.
 *  
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
#define _CRT_SECURE_NO_WARNINGS
#include <string.h>
#include <stdlib.h>

#include "CDMtrLibOptW.h"


#define False (0)
#define True  (1)


static OptionInfo *sptOptionInfo = NULL;

static int siOptionNum = 0;

static int siCurPos = 1;

static int cdmtrLibOptCopyStrings(_TCHAR *pcFromStr, _TCHAR **ppcToStr);

/*!
    @brief          w蕶Rs[ꏊmۂāARs[
*/
static int cdmtrLibOptCopyStrings(_TCHAR *pcFromStr, _TCHAR **ppcToStr)
{
    unsigned int uiStrLen = 0;
    if (ppcToStr == NULL) {
        return False;
    }
    if (pcFromStr == NULL) {
        return False;
    }
    uiStrLen = _tcslen(pcFromStr);
    *ppcToStr = (_TCHAR *)malloc(sizeof(_TCHAR) * (uiStrLen + 1));
    if (NULL == *ppcToStr) {
        *ppcToStr = NULL;
        return False;
    }
    _tcsncpy(*ppcToStr, pcFromStr, uiStrLen);
    (*ppcToStr)[uiStrLen] = _T('\0');
    return True;
}






/*!
    @brief      IvV͂̑O
*/
void CDMtrLibOptInitGetParameter(OptionInfo *pOptInfo, int iOptNum)
{
    sptOptionInfo = pOptInfo;
    siOptionNum   = iOptNum;
    siCurPos      = 1;
    return;
}

/*!
    @brief      IvV͂̌㏈
*/
void CDMtrLibOptFinishGetParameter(void)
{
    sptOptionInfo = NULL;
    siOptionNum   = 0;
    siCurPos      = 1;
    return;
}


/*!
    @brief      IvV͂
*/
int CDMtrLibOptGetParameter(int iArgNum, _TCHAR *ppcArgStr[], _TCHAR **ppcParamStr)
{
    if (NULL == sptOptionInfo) {
        return OPTION_NOINIT;
    }
    if (NULL == ppcParamStr) {
        return OPTION_ERROR;
    }
    if (NULL == ppcArgStr) {
        *ppcParamStr = NULL;
        return OPTION_ERROR;
    }
    if (1 == iArgNum) {
        *ppcParamStr = NULL;
        return OPTION_END;
    }
    if (siCurPos >= iArgNum) {
        *ppcParamStr = NULL;
        return OPTION_END;
    }
    if (NULL == ppcArgStr[siCurPos]) {
        *ppcParamStr = NULL;
        return OPTION_ERROR;
    }
    if (_T('-') == ppcArgStr[siCurPos][0]) {
        _TCHAR *pcOptStr = ppcArgStr[siCurPos] + 1;
        int   iLenOptStr;
        int   iCurOpt;
        int   iResCmp;
        for (iCurOpt = 0; iCurOpt < siOptionNum; iCurOpt++) {
            OptionInfo *ptCurOpt = sptOptionInfo + iCurOpt;
            iLenOptStr = _tcslen(ptCurOpt->pcOptionStr);
            iResCmp = _tcsncmp(ptCurOpt->pcOptionStr, pcOptStr, iLenOptStr);
            if (0 == iResCmp) {
                if (OPT_HAS_PARAM == ptCurOpt->iHasOption || OPT_HAS_OPTPARAM == ptCurOpt->iHasOption) {
                    if (_T('=') == *(pcOptStr + iLenOptStr)) {
                        iLenOptStr++;
                    }
                    if (_T('\0') != *(pcOptStr + iLenOptStr)) {
                        if (True != cdmtrLibOptCopyStrings(pcOptStr + iLenOptStr, ppcParamStr)) {
                            *ppcParamStr = NULL;
                            return OPTION_ERROR;
                        }
                    } else {
                        siCurPos++;
                        if (siCurPos >= iArgNum) {
                            if (OPT_HAS_PARAM == ptCurOpt->iHasOption) {
                                if (True != cdmtrLibOptCopyStrings(ppcArgStr[siCurPos - 1], ppcParamStr)) {
                                    *ppcParamStr = NULL;
                                    return OPTION_ERROR;
                                }
                                if (_T('=') == *(*ppcParamStr + _tcslen(*ppcParamStr) - 1)) {
                                    *(*ppcParamStr + _tcslen(*ppcParamStr) - 1) = _T('\0');
                                }
                                return OPTION_MUSTPARAM;
                            } else {
                                if (_T('=') == *(pcOptStr + iLenOptStr - 1)) {
                                    if (True != cdmtrLibOptCopyStrings(ppcArgStr[siCurPos - 1], ppcParamStr)) {
                                        *ppcParamStr = NULL;
                                        return OPTION_ERROR;
                                    }
                                    return OPTION_UNKNOWN;
                                } else {
                                    *ppcParamStr = NULL;
                                    return (sptOptionInfo + iCurOpt)->iOptionID;
                                }
                            }
                        }
                        if (_T('-') == ppcArgStr[siCurPos][0]) {
                            if (OPT_HAS_OPTPARAM == ptCurOpt->iHasOption) {
                                *ppcParamStr = NULL;
                                return (sptOptionInfo + iCurOpt)->iOptionID;
                            } else {
                                if (True != cdmtrLibOptCopyStrings(ppcArgStr[siCurPos - 1], ppcParamStr)) {
                                    *ppcParamStr = NULL;
                                    return OPTION_ERROR;
                                }
                                if (_T('=') == *(*ppcParamStr + _tcslen(*ppcParamStr) - 1)) {
                                    *(*ppcParamStr + _tcslen(*ppcParamStr) - 1) = _T('\0');
                                }
                                return OPTION_MUSTPARAM;
                            }
                        } else if (_T('=') == ppcArgStr[siCurPos][0]) {
                            if (_T('\0') != ppcArgStr[siCurPos][1]) {
                                if (True != cdmtrLibOptCopyStrings(&ppcArgStr[siCurPos][1], ppcParamStr)) {
                                    *ppcParamStr = NULL;
                                    return OPTION_ERROR;
                                }
                            } else {
                                siCurPos++;
                                if (siCurPos >= iArgNum) {
                                    if (True != cdmtrLibOptCopyStrings(ppcArgStr[siCurPos - 2], ppcParamStr)) {
                                        *ppcParamStr = NULL;
                                        return OPTION_ERROR;
                                    }
                                    return OPTION_MUSTPARAM;
                                }
                                if (_T('-') == ppcArgStr[siCurPos][0]) {
                                    if (True != cdmtrLibOptCopyStrings(ppcArgStr[siCurPos - 2], ppcParamStr)) {
                                        *ppcParamStr = NULL;
                                        return OPTION_ERROR;
                                    }
                                    return OPTION_MUSTPARAM;
                                } else {
                                    if (True != cdmtrLibOptCopyStrings(ppcArgStr[siCurPos], ppcParamStr)) {
                                        *ppcParamStr = NULL;
                                        return OPTION_ERROR;
                                    }
                                }
                            }
                        } else {
                            if (True != cdmtrLibOptCopyStrings(ppcArgStr[siCurPos], ppcParamStr)) {
                                *ppcParamStr = NULL;
                                return OPTION_ERROR;
                            }
                        }
                    }
                } else {
                    if (_T('\0') != *(pcOptStr + iLenOptStr)) {
                        if (True != cdmtrLibOptCopyStrings(ppcArgStr[siCurPos], ppcParamStr)) {
                            *ppcParamStr = NULL;
                            return OPTION_ERROR;
                        }
                        siCurPos++;
                        return OPTION_UNKNOWN;
                    } else {
                        *ppcParamStr = NULL;
                    }
                }
                siCurPos++;
                return (sptOptionInfo + iCurOpt)->iOptionID;
            }
        }
        if (True != cdmtrLibOptCopyStrings(ppcArgStr[siCurPos], ppcParamStr)) {
            *ppcParamStr = NULL;
            return OPTION_ERROR;
        }
        siCurPos++;
        return OPTION_UNKNOWN;
    } else {
        if (True != cdmtrLibOptCopyStrings(ppcArgStr[siCurPos], ppcParamStr)) {
            *ppcParamStr = NULL;
            return OPTION_ERROR;
        }
        siCurPos++;
        return OPTION_NOOPTION;
    }
    *ppcParamStr = NULL;
    return OPTION_ERROR;
}

/*!
    @brief      \iHELP̃Tup[^j̍\`FbN
*/
int CDMtrLibOptCheckDispLang(_TCHAR *pcStr)
{
    unsigned int i;
    unsigned int iMax;
    iMax = _tcslen(pcStr);
    if (iMax > 10 || iMax <= 1) {
        return OPTION_UNKNOWN;
    }
    for (i = 0; i < iMax; i++) {
        if (_istalpha(*(pcStr + i)) == 0) {
            if (_tcsncicmp(pcStr + i, _T("-"), 1) != 0) {
                return OPTION_UNKNOWN;
            }
        }
    }
    return OPTION_END;
}

