/*
 *  source code metrics counter
 *  Copyright (C) 2015  NEC Corporation.
 *  
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <math.h>

#include <Windows.h>

#include "CDMtrCmn.h"
#include "CDMtrExtCmn.h"
#include "CDMtrLibCmnW.h"
#include "CDMtrLibUtilW.h"
#include "CDMtrMessage.h"

#define VAL_STR_FALSE _T("false")

/*!
    @brief          Delimiter󔒕܂łĎ擾
*/
int CDMtrLibUtilGetStringNextDelimSPW(_TCHAR **string, _TCHAR **startp,
                                      _TCHAR **endp, _TCHAR delimiter)
{
    _TCHAR *p;
    int iRet = RET_NG;
    if (string == NULL || startp == NULL || endp == NULL) {
        goto FUNC_END;
    }
    if (*string == NULL) {
        goto FUNC_END;
    }
    p = *string;
    *startp = *string;
    *endp = *string;
    while (1) {
        if (*p == delimiter || IS_WHITE_SPACE(p)) {
            *endp = p;
            *string = p;
            iRet = RET_OK;
            goto FUNC_END;
        } else if (IS_NULL_CHAR(p)) {
            break;
        }
        p++;
    }
FUNC_END:
    return iRet;
}


/*!
    @brief          ݍs̈ʒu|C^ = ؂蕶Ƃƒl̃|C^ʒu擾
*/
int CDMtrExtPropGetAttributePosW(_TCHAR **currentp, _TCHAR **name_top, _TCHAR **name_end,
                                 _TCHAR **val_top, _TCHAR **val_end)
{
    _TCHAR *p, *old_p;
    _TCHAR *ntop, *nend, *vtop, *vend;
    int iRet;
    iRet = RET_NG;
    ntop = NULL;
    nend = NULL;
    vtop = NULL;
    vend = NULL;
    *name_top = NULL;
    *name_end = NULL;
    *val_top = NULL;
    *val_end = NULL;
    p = *currentp;
    old_p = p;
    ntop = p;
    while (1) {
        if (IS_BREAK_LINE(p) || IS_NULL_CHAR(p)) {
            goto FUNC_END;
        } else if (IS_WHITE_SPACE(p)) {
            SKIP_WHITE_SPACE(&p);
            continue;
        } else if (IS_EQUAL(p)) {
            nend = old_p;
            if (ntop == p) {
                goto FUNC_END;
            }
            p++;
            break;
        }
        old_p = p;
        p++;
    }
    iRet = RET_OK;
    old_p = p;
    SKIP_WHITE_SPACE(&p);
    vtop = p;
    vend = p;
    old_p = p;
    while (1) {
        if (IS_BREAK_LINE(p) || IS_NULL_CHAR(p)) {
            break;
        } else if (IS_WHITE_SPACE(p)) {
            SKIP_WHITE_SPACE(&p);
            continue;
        }
        old_p = p;
        p++;
    }
    if (vtop == p) {
        vtop = NULL;
        vend = NULL;
    } else {
        vend = old_p;
    }
    *currentp = p;
    *name_top = ntop;
    *name_end = nend;
    *val_top = vtop;
    *val_end = vend;
FUNC_END:
    return iRet;
}


/*!
    @brief          ̐ݒ
*/
int CDMtrLibUtilSetStringW(_TCHAR **dst, const _TCHAR *val_top, const _TCHAR *val_end)
{
    _TCHAR *p;
    int iRet;
    unsigned int uiLen;
    iRet = RET_NG;
    uiLen = 0;
    p = NULL;
    if (dst == NULL) {
        goto FUNC_END;
    }
    *dst = NULL;
    if (val_top == NULL || val_end == NULL) {
        goto FUNC_END;
    }
    if (val_top > val_end) {
        goto FUNC_END;
    }
    uiLen = val_end - val_top + 1;
    p = (_TCHAR *)CDMtrLibCmnMallocW(uiLen + 1);
    if (p == NULL) {
        goto FUNC_END;
    }
    _tcsncpy(p, val_top, uiLen);
    p[uiLen] = '\0';
    *dst = p;
    iRet = RET_OK;
FUNC_END:
    return iRet;
}


/*!
    @brief          ̐ݒ
*/
_TCHAR *CDMtrLibUtilCopyStringW(const _TCHAR *pcStr)
{
    _TCHAR *pcRet;
    unsigned int uiLen;
    pcRet = NULL;
    if (pcStr == NULL) {
        goto FUNC_END;
    }
    uiLen = _tcslen(pcStr);
    pcRet = (_TCHAR *)CDMtrLibCmnMallocW(uiLen + 1);
    if (pcRet == NULL) {
        goto FUNC_END;
    }
    _tcsncpy(pcRet, pcStr, uiLen);
FUNC_END:
    return pcRet;
}


/*!
    @brief          񂪓(啶AʂȂ)
*/
int CDMtrLibUtilCompStringW(const _TCHAR *pcDst, const _TCHAR *pcSrc)
{
    int iRet;
    unsigned int uiDstLen;
    unsigned int uiSrcLen;
    _TCHAR *pcTmpDst, *pcTmpSrc;
    iRet = RET_FALSE;
    pcTmpDst = NULL;
    pcTmpSrc = NULL;
    if (pcDst == NULL || pcSrc == NULL) {
        goto FUNC_END;
    }
    uiDstLen = _tcslen(pcDst);
    uiSrcLen = _tcslen(pcSrc);
    if (uiDstLen != uiSrcLen) {
        goto FUNC_END;
    }
    pcTmpDst = (_TCHAR *)CDMtrLibCmnMallocW(uiDstLen + 1);
    if (pcTmpDst == NULL) {
        goto FUNC_END;
    }
    _tcsncpy(pcTmpDst, pcDst, uiDstLen);
    pcTmpDst[uiDstLen] = '\0';
    CDMtrLibUtilSetLowStringW(pcTmpDst);
    pcTmpSrc = (_TCHAR *)CDMtrLibCmnMallocW(uiSrcLen + 1);
    if (pcTmpSrc == NULL) {
        goto FUNC_END;
    }
    _tcsncpy(pcTmpSrc, pcSrc, uiSrcLen);
    pcTmpSrc[uiSrcLen] = '\0';
    CDMtrLibUtilSetLowStringW(pcTmpSrc);
    if (_tcscmp(pcTmpDst, pcTmpSrc) == 0) {
        iRet = RET_TRUE;
    }
FUNC_END:
    CDMtrLibCmnFreeW((void **)&pcTmpDst);
    CDMtrLibCmnFreeW((void **)&pcTmpSrc);
    return iRet;
}

/*!
    @brief          񂪓(啶AʂȂ)
*/
int CDMtrLibUtilStrCaseCmpW(const _TCHAR *s1, const _TCHAR *s2, int n)
{
    int iRet = 0;
    iRet = _tcsnicmp(s1, s2, n);
    return iRet;
}

/*!
    @brief          ōŏɏo錟ւ̃|C^ԋp (啶AʂȂ)
*/
_TCHAR *CDMtrLibUtilStrCaseStrW(const _TCHAR *string, const _TCHAR *pattern)
{
    _TCHAR *pcRet;
    int strpos;
    int ptnpos;
    pcRet = NULL;
    if (string == NULL || pattern == NULL) {
        goto FUNC_END;
    }
    strpos = 0;
    while (string[strpos] != '\0') {
        if (tolower (string[strpos]) == tolower (pattern[0])) {
            ptnpos = 1;
            while ( (string[strpos + ptnpos]  != '\0') &&
                    (pattern[ptnpos]  != '\0') &&
                    (tolower(string[strpos + ptnpos])
                     == tolower(pattern[ptnpos])) ) {
                ptnpos++;
            }
            if (pattern[ptnpos] == '\0') {
                pcRet = (_TCHAR *)(string + strpos);
                goto FUNC_END;
            }
        }
        strpos++;
    }
FUNC_END:
    return pcRet;
}


/*!
    @brief          ^Ul̔
*/
int CDMtrLibUtilIsStringFalseW(const _TCHAR *val_top, const _TCHAR *val_end)
{
    _TCHAR *pcAttr;
    int iFuncRet;
    int iRet;
    iRet = RET_FALSE;
    pcAttr = NULL;
    if (val_top == NULL || val_end == NULL) {
        goto FUNC_END;
    }
    iFuncRet = CDMtrLibUtilSetStringW(&pcAttr, val_top, val_end);
    if (iFuncRet != RET_OK) {
        goto FUNC_END;
    }
    CDMtrLibUtilSetLowStringW(pcAttr);
    if (_tcscmp(VAL_STR_FALSE, pcAttr) == 0) {
        iRet = RET_TRUE;
    }
FUNC_END:
    CDMtrLibCmnFreeW((void **)&pcAttr);
    return iRet;
}


/*!
    @brief          v邩
*/
int CDMtrLibUtilMatchPatternW(const _TCHAR *pcStr, const _TCHAR *pcReg)
{
    int iRet;
    int iSeachType;
    int iCopyFlag;
    _TCHAR *pcTmpStr;
    _TCHAR *pcTmpReg;
    _TCHAR *pcRegComp;
    _TCHAR *p;
    unsigned int uiRegIndex;
    unsigned int uiRegLen;
    unsigned int uiPosLen;
    iRet = RET_FALSE;
    pcTmpStr = NULL;
    pcTmpReg = NULL;
    pcRegComp = NULL;
    if (pcStr == NULL || pcReg == NULL) {
        goto FUNC_END;
    }
    uiRegLen = _tcslen(pcReg);
    if (uiRegLen == 0) {
        goto FUNC_END;
    }
    if (uiRegLen == 1 && pcReg[uiRegLen - 1] == REGEX_ASTARISK_CHAR) {
        iRet = RET_TRUE;
        goto FUNC_END;
    }
    pcTmpReg = CDMtrLibUtilCopyStringW(pcReg);
    if (pcTmpReg == NULL) {
        goto FUNC_END;
    }
    CDMtrLibUtilSetLowStringW(pcTmpReg);
    pcTmpStr = CDMtrLibUtilCopyStringW(pcStr);
    if (pcTmpStr == NULL) {
        goto FUNC_END;
    }
    CDMtrLibUtilSetLowStringW(pcTmpStr);
    pcRegComp = (_TCHAR *)CDMtrLibCmnMallocW(uiRegLen + 1);
    if (pcRegComp == NULL) {
        goto FUNC_END;
    }
    uiRegIndex = 0;
    p = pcRegComp;
    iSeachType = SEARCH_COMPLETE;
    iCopyFlag = CDMTR_TRUE;
    while (uiRegIndex < uiRegLen) {
        switch (pcTmpReg[uiRegIndex]) {
        case REGEX_ASTARISK_CHAR:
            if (uiRegIndex == 0) {
                iSeachType = SEARCH_SUFFIX;
                iCopyFlag = CDMTR_FALSE;
            } else if (uiRegIndex == (uiRegLen - 1)) {
                if (iSeachType == SEARCH_SUFFIX) {
                    iSeachType = SEARCH_PART;
                } else {
                    iSeachType = SEARCH_PREFIX;
                }
                iCopyFlag = CDMTR_FALSE;
            } else {
            }
            break;
        case REGEX_ESCAPE_CHAR:
            break;
        default:
            break;
        }
        if (iCopyFlag) {
            *p = pcTmpReg[uiRegIndex];
            p++;
        }
        iCopyFlag = CDMTR_TRUE;
        uiRegIndex++;
    }
    uiRegLen = _tcslen(pcRegComp);
    switch (iSeachType) {
    case SEARCH_COMPLETE:
        if (_tcscmp(pcTmpStr, pcRegComp) == 0) {
            iRet = RET_TRUE;
        }
        break;
    case SEARCH_PREFIX:
        if (_tcsncmp(pcTmpStr, pcRegComp, uiRegLen) == 0) {
            iRet = RET_TRUE;
        }
        break;
    case SEARCH_SUFFIX:
        uiPosLen = _tcslen(pcTmpStr);
        while (1) {
            if (uiRegLen == 0) {
                iRet = RET_TRUE;
                break;
            }
            if (uiPosLen == 0) {
                break;
            }
            if (pcTmpStr[uiPosLen - 1] != pcRegComp[uiRegLen - 1]) {
                break;
            }
            uiPosLen--;
            uiRegLen--;
        }
        break;
    case SEARCH_PART:
        if (_tcsstr(pcTmpStr, pcRegComp) != NULL) {
            iRet = RET_TRUE;
        }
        break;
    default:
        break;
    }
FUNC_END:
    CDMtrLibCmnFreeW((void **)&pcTmpStr);
    CDMtrLibCmnFreeW((void **)&pcTmpReg);
    CDMtrLibCmnFreeW((void **)&pcRegComp);
    return iRet;
}


/*!
    @brief          ɕϊ
*/
int CDMtrLibUtilSetLowStringW(_TCHAR *dst)
{
    _TCHAR *p;
    if (dst == NULL) {
        return RET_NG;
    }
    p = dst;
    while (!IS_NULL_CHAR(p)) {
        *p = tolower(*p);
        p++;
    }
    return RET_OK;
}


/*!
    @brief          啶ɕϊ
*/
int CDMtrLibUtilSetUpperStringW(_TCHAR *dst)
{
    _TCHAR *p;
    if (dst == NULL) {
        return RET_NG;
    }
    p = dst;
    while (!IS_NULL_CHAR(p)) {
        *p = toupper(*p);
        p++;
    }
    return RET_OK;
}


/*!
    @brief          piA`ZAa`zjǂ
*/
int CDMtrLibUtilIsAlphaW(_TCHAR c)
{
    int iRet;
    iRet = RET_FALSE;
    if (isalpha(c)) {
        iRet = RET_TRUE;
    }
    return iRet;
}


/*!
    @brief          i0`9jǂ
*/
int CDMtrLibUtilIsDigitW(_TCHAR c)
{
    int iRet;
    iRet = RET_FALSE;
    if (isdigit(c)) {
        iRet = RET_TRUE;
    }
    return iRet;
}

/*!
    @brief          R[hϊ (MBCS to Unicode)
*/
int CDMtrLibUtilMBCStoUNICODEW(wchar_t **new_char, const char **org_str, _TCHAR *charSet)
{
    int   iRet = RET_NG;
    int   wLength;
    int   i_result;
    UINT  orgCodePage;
    if ((new_char != NULL) && (org_str != NULL) && (charSet != NULL) ) {
        if (iDebug == DEBUG_ON) {
            CDMtrLibCmnTrcLogOut(MSG_LOG_ID_C_00000599, charSet); //* MSG_LOG_ID_C_00000599
        }
    } else {
        goto FUNC_END;
    }
    wLength  = 0;
    i_result = 0;
    orgCodePage = CP_ACP;
    CDMtrLibUtilCheckSupportCharsetW(charSet, &orgCodePage);
    if (*org_str && (strlen(*org_str) >= 0)) {
        if (*new_char != NULL && wcslen(*new_char) >= 0) {
            return iRet;
        }
        wLength = MultiByteToWideChar(orgCodePage, 0, *org_str, -1, NULL, 0);
        if (wLength <= 0) {
            goto FUNC_END;
        }
        *new_char = (wchar_t *)CDMtrLibCmnMallocW(wLength);
        if (NULL == *new_char) {
            goto FUNC_END;
        }
        i_result = MultiByteToWideChar(orgCodePage, 0, *org_str, -1, *new_char, wLength);
        if (i_result <= 0) {
            goto FUNC_END;
        }
        iRet = RET_OK;
    }
FUNC_END:
    return iRet;
}

/*!
    @brief          R[hϊ (Unicode to MBCS)
*/
int CDMtrLibUtilUNICODEtoMBCSW(char **new_char, const wchar_t **org_str, _TCHAR *charSet)
{
    int   iRet = RET_NG;
    int   cLength;
    int   i_result;
    UINT   CodePage;
    if ((new_char != NULL) && (org_str != NULL) && (charSet != NULL) ) {
        if (iDebug == DEBUG_ON) {
            CDMtrLibCmnTrcLogOut(MSG_LOG_ID_C_00000600, charSet); //* MSG_LOG_ID_C_00000600
        }
    } else {
        goto FUNC_END;
    }
    cLength  = 0;
    i_result = 0;
    CodePage = CP_ACP;
    CDMtrLibUtilCheckSupportCharsetW(charSet, &CodePage);
    if (*org_str && (wcslen(*org_str) >= 0)) {
        if (*new_char != NULL && strlen(*new_char) >= 0) {
            return iRet;
        }
        cLength = WideCharToMultiByte(CodePage, 0, *org_str, -1, NULL, 0, NULL, NULL);
        if (cLength <= 0) {
            goto FUNC_END;
        }
        *new_char = (char *)malloc(sizeof(char) * (cLength));
        if (NULL == *new_char) {
            goto FUNC_END;
        }
        memset(*new_char, 0, sizeof(char) * (cLength));
        i_result = WideCharToMultiByte(CodePage, 0, *org_str, -1, *new_char, cLength, NULL, NULL);
        if (i_result <= 0) {
            goto FUNC_END;
        }
        iRet = RET_OK;
    }
FUNC_END:
    return iRet;
}

/*!
    @brief          T|[gZbg(R[h)mF
*/
int CDMtrLibUtilCheckSupportCharsetW(_TCHAR *cpCharset, unsigned int *uipCodePage)
{
    int iRet = RET_NG;
    unsigned int CodePage = CP_ACP;
    long x = 0;
    _TCHAR *endptr = NULL;
    if (NULL == cpCharset) {
        return RET_NG;
    }
    if (_tcscmp(cpCharset, ENCODING_EUC_JP) == 0) {
        iRet = RET_OK;
        CodePage = 20932;
    } else if (_tcscmp(cpCharset, ENCODING_SHIFT_JIS) == 0) {
        iRet = RET_OK;
        CodePage = 932;
    } else if (_tcscmp(cpCharset, ENCODING_UTF_8) == 0) {
        iRet = RET_OK;
        CodePage = CP_UTF8;
    } else if (_tcscmp(cpCharset, ENCODING_SYSTEM) == 0) {
        iRet = RET_OK;
        CodePage = CP_ACP;
    } else {
        if ( (_tcslen(cpCharset) > 2) &&
                *(cpCharset + 0) == _T('C') &&
                *(cpCharset + 1) == _T('P') ) {
            x = _tcstol((cpCharset + 2), &endptr, 10);
            if (_T('\0') != *endptr) {
                iRet = RET_NG;
                goto FUNC_END;
            }
            if (0 <= x && x <= UINT_MAX) {
                CodePage = x;
            } else {
                iRet = RET_NG;
                goto FUNC_END;
            }
        } else {
            iRet = RET_NG;
            goto FUNC_END;
        }
    }
    if (0 != IsValidCodePage(CodePage)) {
        iRet = RET_OK;
    }
    if ((uipCodePage != NULL) && (iRet == RET_OK)) {
        *uipCodePage = CodePage;
    }
FUNC_END:
    return iRet;
}


/*!
    @brief          쐬
*/
int CDMtrLibUtilCreateStringW(_TCHAR **psBuffer, ...)
{
    int iRet = RET_NG;
    va_list list;
    _TCHAR *psNewBuffer = NULL;
    size_t szBufferLength = 0;
    _TCHAR *psString;
    if (*psBuffer) {
        szBufferLength += _tcslen(*psBuffer);
    }
    va_start(list, psBuffer);
    while (1) {
        psString = va_arg(list, _TCHAR *);
        if (psString) {
            szBufferLength += _tcslen(psString);
        } else {
            break;
        }
    }
    va_end(list);
    va_start(list, psBuffer);
    psNewBuffer = (_TCHAR *)CDMtrLibCmnMalloc(szBufferLength + 1);
    if (psNewBuffer == NULL) {
        goto FUNC_END;
    }
    if (*psBuffer) {
        _tcscat(psNewBuffer, *psBuffer);
    }
    while (1) {
        psString = va_arg(list, _TCHAR *);
        if (psString) {
            _tcscat(psNewBuffer, psString);
        } else {
            break;
        }
    }
    va_end(list);
    CDMtrLibCmnFree((void **)psBuffer);
    *psBuffer = psNewBuffer;
    iRet = RET_OK;
FUNC_END:
    va_end(list);
    return iRet;
}

/*!
    @brief          Ώە񂪁AŊJnĂ邩`FbNB
*/
const _TCHAR *CDMtrLibUtilCheckPrefixW(const _TCHAR *psStr, const _TCHAR *psPrefix)
{
    const _TCHAR *pRet = NULL;
    const _TCHAR *pFuncRet = NULL;
    int lenStr = 0;
    int lenPrefix = 0;
    if (psStr == NULL || psPrefix == NULL) {
        return pRet;
    }
    lenStr = _tcslen(psStr);
    lenPrefix = _tcslen(psPrefix);
    if (lenStr >= lenPrefix) {
        pFuncRet = _tcsstr(psStr, psPrefix);
        if (pFuncRet != NULL &&
                pFuncRet == psStr) {
            pRet = pFuncRet;
        }
    }
    return pRet;
}

/*!
    @brief          w肳ꂽŐAw肵R[hɕϊB
*/
char *CDMtrLibUtilConvertStringW(const wchar_t *charset, const wchar_t *pFormat, ...)
{
    char *pRet = NULL;
    va_list ap;
    int wLength = 0;
    int wBufSize = 0;
    wchar_t *wcBuf = NULL;
    char *cBuf = NULL;
    int iFuncRet = RET_NG;
    if (charset == NULL && pFormat == NULL) {
        return pRet;
    }
    va_start(ap, pFormat);
    wLength = _vscwprintf(pFormat, ap);
    wBufSize = (wLength + 1) * sizeof(wchar_t);
    wcBuf = (wchar_t *)malloc(wBufSize);
    if (NULL == wcBuf) {
        goto FUNC_END;
    }
    memset(wcBuf, 0x00, wBufSize);
    vswprintf(wcBuf, wBufSize, pFormat, ap);
    iFuncRet = CDMtrLibUtilUNICODEtoMBCSW(&cBuf, &wcBuf, (wchar_t *)charset);
    if (iFuncRet == RET_NG) {
        goto FUNC_END;
    }
    pRet = cBuf;
FUNC_END:
    if (wcBuf != NULL) {
        free((void *)wcBuf);
    }
    va_end(ap);
    return pRet;
}

/*!
    @brief          ɕϊ
    @param[in,out]  pcStr   
    @note   œnꂽpcStr̒gXVB
*/
void CDMtrLibUtilTolowerW(_TCHAR *pcStr)
{
    unsigned int i;
    for (i = 0; i < _tcslen(pcStr); i++) {
        *(pcStr + i) = tolower(*(pcStr + i));
    }
}

/*!
    @brief          啶ɕϊ
    @param[in,out]  pcStr   
    @note   œnꂽpcStr̒gXVB
*/
void CDMtrLibUtilToupperW(_TCHAR *pcStr)
{
    unsigned int i;
    for (i = 0; i < _tcslen(pcStr); i++) {
        *(pcStr + i) = toupper(*(pcStr + i));
    }
}

/*!
    @brief          ľ擾
    @param[in]      lNum        擾鐔l
    @retval         0ȏ       w肳ꂽľ
*/
int CDMtrLibUtilGetNumSizeW(long lNum)
{
    int iRet;
    if (lNum == 0) {
        iRet = 1;
    } else {
        iRet = (int)log10(abs(lNum)) + 1;
    }
    if (lNum < 0) {
        iRet++;
    }
    return iRet;
}

/*!
    @brief          R[h̕ϊ (Unicode to oCgz())
    @param[out]     new_char           ϊ̕ (oCgz())
    @param[in]      org_char           ϊO̕ (Unicode)
    @retval         RET_OK             I
    @retval         RET_NG             ُI
    @note           Unicode(2oCg)A1oCgPʂ16iŕ\ɕϊB
                    new_char͌ďoŉ邱ƁB
*/
int CDMtrLibUtilUNICODEtoBYTEW(wchar_t **new_char, wchar_t **org_str)
{
    int iRet = RET_NG;
    int i, ret;
    int wlen = 0;
    int size = 0;
    unsigned char *pt = NULL;
    wchar_t wcHigh[3];
    wchar_t wcLow[3];
    wchar_t *ptWchar = NULL;
    wlen = wcslen(*org_str);
    size = sizeof(wchar_t) * (((wlen + 1) * 2) * 2);
    ret = CDMtrLibUtilMallocW((void **)new_char, size);
    if (ret != RET_OK) {
        return iRet;
    }
    memset(*new_char, 0x0, size);
    pt = (unsigned char *)(*org_str);
    ptWchar = *new_char;
    for (i = 0; i < wlen; i++) {
        wsprintf( wcHigh, L"%02x", *pt++);
        wsprintf( wcLow, L"%02x", *pt++);
        wcscat(ptWchar, wcLow);
        ptWchar += wcslen(wcLow);
        wcscat(ptWchar, wcHigh);
        ptWchar += wcslen(wcHigh);
    }
    ptWchar = L'\0';
    iRet = RET_OK;
    return iRet;
}

/*!
    @brief          茋ʃt@C(CSV)o͕Zbg̃T|[gmF
    @param[in]      pcCharset	o͗pZbg
    @retval         NULLȊO	Zbg(T|[g)
    @retval         NULL		T|[g
    @note           ߂l NULLłȂꍇA|C^ɗ̈悪mۂĂB
                    ďoŉ邱ƁB
*/
_TCHAR *CDMtrLibUtilCheckOutputCharsetW(_TCHAR *pcCharset)
{
    _TCHAR *retCharset = NULL;
    int isSupport = RET_NG;
    if (pcCharset == NULL) {
        return NULL;
    }
    isSupport = CDMtrLibUtilCheckSupportCharsetW(pcCharset, NULL);
    if (isSupport == RET_OK) {
        retCharset = CDMtrLibUtilCopyStringW(pcCharset);
    }
    return retCharset;
}

/*!
    @brief          mۏ
*/
int CDMtrLibUtilMallocW(void **pcBuffer, size_t szLen)
{
    int iRet = RET_NG;
    *pcBuffer = (void *)malloc(szLen);
    if (*pcBuffer == NULL) {
        CDMtrLibCmnErrLogOut(MSG_LOG_ID_C_00000449); //* MSG_LOG_ID_C_00000449
        goto FUNC_END;
    }
    memset(*pcBuffer, 0, szLen);
    iRet = RET_OK;
FUNC_END:
    return iRet;
}


/*!
    @brief          
*/
void CDMtrLibUtilFreeW(void **pcBuffer)
{
    if (*pcBuffer != NULL) {
        free(*pcBuffer);
    }
    *pcBuffer = NULL;
    return;
}

/*!
    @brief          ̃obt@i[(obt@g@\t)
*/
int CDMtrLibUtilCopyStringToCmdOptBuffW(_TCHAR **pcBuffer, size_t *szBufSize, ...)
{
    int iRet = RET_NG;
    int iFuncRet;
    va_list list;
    size_t szCurrentSize = 0;
    size_t szUseLen = 0;
    size_t szStringLen = 0;
    _TCHAR *pcString;
    size_t szTmpSize = 0;
    _TCHAR *pcTmpBuffer = NULL;
    if (NULL == pcBuffer || NULL == szBufSize) {
        return RET_NG;
    }
    if (NULL == *pcBuffer) {
        iFuncRet = CDMtrLibUtilMallocW((void **)pcBuffer, BUFF_LINE_SIZE);
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
        szCurrentSize = BUFF_LINE_SIZE;
        *szBufSize = szCurrentSize;
    } else {
        szUseLen = _tcslen(*pcBuffer);
        szCurrentSize = *szBufSize;
    }
    va_start(list, szBufSize);
    while (1) {
        pcString = va_arg(list, _TCHAR *);
        if (pcString) {
            szStringLen += _tcslen(pcString);
        } else {
            break;
        }
    }
    va_end(list);
    szTmpSize = szCurrentSize;
    while (((szUseLen + szStringLen + 1) * sizeof(_TCHAR)) > szTmpSize) {
        szTmpSize += BUFF_LINE_SIZE;
    }
    if (szTmpSize != szCurrentSize) {
        iFuncRet = CDMtrLibUtilMallocW((void **)&pcTmpBuffer, szTmpSize);
        if (iFuncRet != RET_OK) {
            goto FUNC_END;
        }
        _tcscpy(pcTmpBuffer, *pcBuffer);
        CDMtrLibUtilFreeW((void **)pcBuffer);
        *pcBuffer = pcTmpBuffer;
        pcTmpBuffer = NULL;
        szCurrentSize += szTmpSize;
        *szBufSize = szCurrentSize;
    }
    va_start(list, szBufSize);
    while (1) {
        pcString = va_arg(list, _TCHAR *);
        if (pcString) {
            _tcscat(*pcBuffer, pcString);
        } else {
            break;
        }
    }
    va_end(list);
    iRet = RET_OK;
FUNC_END:
    va_end(list);
    return iRet;
}
