%{
    /*----------------------------------------------------------------------------*/
    /* include                                                                    */
    /*----------------------------------------------------------------------------*/
    #include <stdio.h>
    #include <stdlib.h>
    #include <string.h>
    #include "CDMtrSpsBison.h"
    #include "CDMtrSpsCmn.h"
    #include "CDMtrSpsIface.h"
    #include "CDMtrSps.h"

    /*----------------------------------------------------------------------------*/
    /* define declaration                                                         */
    /*----------------------------------------------------------------------------*/
    /* BISONfobOp */
//  #define YYDEBUG 1 //for debug

    #define _PECHO_(complex) ParsCase(yytoken, yylval, yyval, yylen, yytname[yytoken], yytname[yyr1[yyn]],complex)
    #define _PECHO_KEYWORD_(complex) setKeyword(yytoken, yylval, yyval, yylen, yytname[yytoken], yytname[yyr1[yyn]],complex)
    #define _PECHO_TOKEN_(complex)     stackToken(yytoken, yylval, yyval, yylen, yytname[yytoken], yytname[yyr1[yyn]],complex)
    #define _PECHO_DELIMITALINE_(complex) setDelimitaLine(yytoken, yylval, yyval, yylen, yytname[yytoken], yytname[yyr1[yyn]],complex)

    #ifdef _WIN32
    #ifndef YYMALLOC
    #define YYMALLOC malloc
    #endif /* YYMALLOC */

    #ifndef YYFREE
    #define YYFREE free
    #endif /* YYFREE */
    #endif /* _WIN32 */


    /*----------------------------------------------------------------------------*/
    /* Function declaration                                                       */
    /*----------------------------------------------------------------------------*/
    static int chkArryBuff(char ***pszBuff, int *piMax, int piNum);
    static int replaceAryyBuffString(char ***pszBuff, int piNum, char *pszText);
    static int addAryyBuffString(char ***pszBuff, int piBufsz, int piNum, char *pszText);

    int addCodeLineStmt(char ***pszBuff, int *piMax, int piNum, char *pszText);
    int setToken(char ***pszBuff, int *piMax, int piNum, char *pszText);
    int getCodeLineStmtLength(char ***pszBuff, int *piMax, int piNum);
    char* getCodeLineStmt(char ***pszBuff, int *piMax, int piNum);
    void freeCodeLineStmt(char ***pszBuff, int *piMax);

    int chkNonNestKeywd(int istacknum, int icntnonnest);
    int chkArryTokenNumInfo(int ***pszArray, int *piMax, int piNum);
    void ClearArryTokenNumInfo(int ***pszArray, int *piMax);
    void freeArryTokenNumInfo(int ***pszArray, int *piMax);
    void getFunctionName(char *pszbuf, int istacknum, char* strparam);
    int chkArgumentParam(int tknid);

    int setDelimitaLine(int yytoken,int yylval,int yyval,int yylen, const char *yystr, const char *upername, const char *complex);
    int setKeyword(int yytoken,int yylval,int yyval,int yylen, const char *yystr, const char *upername, const char *complex);
    int invalidStackToken(int inum, int imax, int md);
    int getStackToken(int inum);
    void clearStackToken();
    int stackToken(int yytoken,int yylval,int yyval,int yylen, const char *yystr, const char *upername, const char *complex);
    int ParsCase(int yytoken,int yylval,int yyval,int yylen, const char *yystr, const char *upername, const char *complex);
    

    void call_setParamState();


    void GetStackTokens(int *** , int* );

    void yyerror(char* s);







    extern char yytext[];
    extern int column;
    extern int yylineno;

    int iProtoKeywordID = 0;

    typedef enum {
        COUNTTYPE_CASE_NONE = 0,
        COUNTTYPE_CASE_FUNCTION,
        COUNTTYPE_CASE_FUNCNOCOUNT,
    } COUNTTYPE_CASE_ID;
    int iCodeCountType = 0;

    typedef struct {
        int  pars_method_parennest_cnt;
        int  pars_method_param_cnt;
        int  pars_method_startline_no;
        int  pars_method_endline_no;
        int  pars_if_cnt;
        int  pars_for_cnt;
        int  pars_while_cnt;
        int  pars_switch_cnt;
        int  pars_case_condition_cnt;
        int  pars_if_condition_cnt;
        int  pars_for_condition_cnt;
        int  pars_while_condition_cnt;
        int  pars_method_nest_cnt;
        int  pars_method_nonnest_cnt;
        int  pars_method_maxnest_cnt;
        int  pars_method_stmt_cnt;
        int  pars_method_code_cnt;
        int  pars_outer_nest_cnt;
        int  pars_outer_maxnest_cnt;
        int  pars_outer_stmt_cnt;
        int  pars_outer_code_cnt;
    } PARS_CODE_INFO;
    PARS_CODE_INFO pciParsCodeInfo ={0,0,0,0,0,0,0,0,0,0,
                                     0,0,0,0,0,0,0,0,0,0,0};


    typedef struct {
        int  imagine_funcname_point;
        int  imagine_parennest_cnt;
        int  imagine_param_cnt;
        int  imagine_param_statement;
        int  imagine_startline_no;
        int  imagine_endline_no;
        int  imagine_StackCodesCnt;
        int  imagine_StackTokensCnt;
        int  imagine_StackTokenNumInfoCnt;
        int  imagine_StackCodesNext;
        int  imagine_StackTokensNext;
        int  imagine_StackTokenNumInfoNext;
    } PROTOTYPE_CODE_INFO;
    PROTOTYPE_CODE_INFO iciProtoCodeInfo ={0,0,0,0,0,0,0,0,0,0,0,0};

    int icntconditionparen = 0;
    int icntconditionexp = 0;
    int icntforopt = 0;
    int icntassop = 0;

    int oldKeywoedID = -1;
    int oldTokenID = -1;
    char strfuncName[CDMTRSPS_MAX_LINE_BUF];
    int iStackTokensIdentifier = 0 ;
    int iCntArgument = 0;
    int iCntArgumentToken = 0;
    

    char  strParams[CDMTRSPS_MAX_LINE_BUF];
    char* pStArg = NULL;
    char* pEndArg = NULL;
    int param_escape[CDMTRSPS_MAX_STACK_SIZE ];



    char **ppStackCodes = NULL ;
    char **ppStackTokens = NULL ;
    int **ppStackTokenNumInfo = NULL ;
    int iStackCodesNum = CDMTRSPS_MAX_STACK_SIZE ;
    int iStackTokensNum = CDMTRSPS_MAX_STACK_SIZE ;
    int iStackTokenNumInfoNum = CDMTRSPS_MAX_TKN_NUMARY ;
    int iStackCodesCnt = 0 ;
    int iStackTokensCnt = 0 ;
    int iStackTokenNumInfoCnt = 0 ;

    
    /*----------------------------------------------------------------------------*/
    /* function declaration                                                         */
    /*----------------------------------------------------------------------------*/
    
%}
%token_table

%token IDENTIFIER CONSTANT STRING_LITERAL SIZEOF
%token PTR_OP INC_OP DEC_OP LEFT_OP RIGHT_OP LE_OP GE_OP EQ_OP NE_OP ASS_OP TILDE_OP ETC_OP
%token AND_OP OR_OP MUL_ASSIGN DIV_ASSIGN MOD_ASSIGN ADD_ASSIGN
%token SUB_ASSIGN LEFT_ASSIGN RIGHT_ASSIGN AND_ASSIGN
%token XOR_ASSIGN OR_ASSIGN TYPE_NAME

%token ASM CATCH CLASS CONST_CAST DELETE_WD DYNAMIC_CAST EXPLICIT EXPORT
%token FALSE_WD FRIEND MUTABLE NAMESPACE NEW OPERATOR PRIVATE PROTECTED PUBLIC
%token REINTERPRET_CAST STATIC_CAST TEMPLATE THIS_WD THROW TRUE_WD TRY TYPEID
%token TYPENAME USING VIRTUAL WCHAR_T 
%token TYPEDEF EXTERN STATIC AUTO REGISTER INLINE RESTRICT
%token CHAR SHORT INT LONG SIGNED UNSIGNED FLOAT DOUBLE CONST_WD VOLATILE VOID_WD
%token BOOL COMPLEX IMAGINARY
%token STRUCT UNION ENUM ELLIPSIS

%token CASE DEFAULT IF ELSE SWITCH WHILE DO FOR GOTO CONTINUE BREAK RETURN
%token SEMICOLON PARENST BRACEST PARENED BRACEED COMMA DCOLON COLON 

%token BOM

%start sourcecode_bom
%%

sourcecode_bom
    :
    | BOM sourcecode { if(_PECHO_("BOM sourcecode") != CDMTRSPS_RET_OK) YYABORT ; }
    | sourcecode { if(_PECHO_("sourcecode") != CDMTRSPS_RET_OK) YYABORT ; }
    ;

sourcecode
    :
    | sourcecode postfix_expression     { if(_PECHO_DELIMITALINE_("sourcecode postfix_expression") != CDMTRSPS_RET_OK) YYABORT ; }
    ;

postfix_expression
    : delimita_semicolon        { if(_PECHO_("delimita_semicolon") != CDMTRSPS_RET_OK) YYABORT ; }
    | delimita_parenst          { if(_PECHO_("delimita_parenst") != CDMTRSPS_RET_OK) YYABORT ; }
    | delimita_parened          { if(_PECHO_("delimita_parened") != CDMTRSPS_RET_OK) YYABORT ; }
    | delimita_bracest          { if(_PECHO_("delimita_bracest") != CDMTRSPS_RET_OK) YYABORT ; }
    | delimita_braceed          { if(_PECHO_("delimita_braceed") != CDMTRSPS_RET_OK) YYABORT ; }
    | delimita_comma            { if(_PECHO_("delimita_comma") != CDMTRSPS_RET_OK) YYABORT ; }
    ;

others
    : other                     { if(_PECHO_("other") != CDMTRSPS_RET_OK) YYABORT ; }
    | others other              { if(_PECHO_("others other") != CDMTRSPS_RET_OK) YYABORT ; }
    ;

delimita_semicolon
    : SEMICOLON                 { if(_PECHO_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | others SEMICOLON          { if(_PECHO_("others SEMICOLON") != CDMTRSPS_RET_OK) YYABORT ; }
    ;

delimita_parenst
    : PARENST                   { if(_PECHO_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | others PARENST            { if(_PECHO_("others PARENST") != CDMTRSPS_RET_OK) YYABORT ; }
    ;

delimita_parened
    : PARENED                   { if(_PECHO_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | others PARENED            { if(_PECHO_("others PARENED") != CDMTRSPS_RET_OK) YYABORT ; }
    ;

delimita_bracest
    : BRACEST                   { if(_PECHO_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | others BRACEST            { if(_PECHO_("others BRACEST") != CDMTRSPS_RET_OK) YYABORT ; }
    ;

delimita_braceed
    : BRACEED                   { if(_PECHO_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | others BRACEED            { if(_PECHO_("others BRACEED") != CDMTRSPS_RET_OK) YYABORT ; }
    ;

delimita_comma
    : COMMA                     { if(_PECHO_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | others COMMA              { if(_PECHO_("others COMMA") != CDMTRSPS_RET_OK) YYABORT ; }
    ;

other
    : IDENTIFIER        { if(_PECHO_KEYWORD_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | IF                { if(_PECHO_KEYWORD_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | FOR               { if(_PECHO_KEYWORD_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | WHILE             { if(_PECHO_KEYWORD_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | SWITCH            { if(_PECHO_KEYWORD_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | ELSE              { if(_PECHO_KEYWORD_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | DO                { if(_PECHO_KEYWORD_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | CASE              { if(_PECHO_KEYWORD_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | DEFAULT           { if(_PECHO_KEYWORD_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | DCOLON            { if(_PECHO_KEYWORD_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | COLON             { if(_PECHO_KEYWORD_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | ASM               { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | CATCH             { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | CLASS             { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | CONST_CAST        { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | DELETE_WD         { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | DYNAMIC_CAST      { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | EXPLICIT          { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | EXPORT            { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | FALSE_WD          { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | FRIEND            { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | MUTABLE           { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | NAMESPACE         { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | NEW               { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | OPERATOR          { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | PRIVATE           { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | PROTECTED         { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | PUBLIC            { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | REINTERPRET_CAST  { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | STATIC_CAST       { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | TEMPLATE          { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | THIS_WD               { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | THROW             { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | TRUE_WD           { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | TRY               { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | TYPEID            { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | TYPENAME          { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | USING             { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | VIRTUAL           { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | WCHAR_T           { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | CONSTANT          { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | STRING_LITERAL    { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | SIZEOF            { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | PTR_OP            { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | INC_OP            { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | DEC_OP            { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | LEFT_OP           { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | RIGHT_OP          { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | LE_OP             { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | GE_OP             { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | EQ_OP             { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | NE_OP             { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | ASS_OP            { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | TILDE_OP          { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | ETC_OP            { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | AND_OP            { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | OR_OP             { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | MUL_ASSIGN        { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | DIV_ASSIGN        { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | MOD_ASSIGN        { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | ADD_ASSIGN        { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | SUB_ASSIGN        { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | LEFT_ASSIGN       { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | RIGHT_ASSIGN      { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | AND_ASSIGN        { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | XOR_ASSIGN        { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | OR_ASSIGN         { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | TYPE_NAME         { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | TYPEDEF           { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | EXTERN            { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | STATIC            { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | AUTO              { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | REGISTER          { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | INLINE            { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | RESTRICT          { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | CHAR              { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | SHORT             { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | INT               { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | LONG              { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | SIGNED            { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | UNSIGNED          { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | FLOAT             { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | DOUBLE            { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | CONST_WD          { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | VOLATILE          { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | VOID_WD           { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | BOOL              { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | COMPLEX           { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | IMAGINARY         { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | STRUCT            { if(_PECHO_KEYWORD_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | UNION             { if(_PECHO_KEYWORD_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | ENUM              { if(_PECHO_KEYWORD_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | ELLIPSIS          { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | GOTO              { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | CONTINUE          { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | BREAK             { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    | RETURN            { if(_PECHO_TOKEN_("") != CDMTRSPS_RET_OK) YYABORT ; }
    ;


%%

void yyerror(char* s)
{

}

void cdmtrSpsParsesInit()
{
    icntconditionparen = 0;
    icntconditionexp = 0;
    icntforopt = 0;
    icntassop = 0;
    oldKeywoedID = -1;
    oldTokenID = -1;
    iStackTokensIdentifier = 0 ;
    iCntArgument = 0;
    iCntArgumentToken = 0;

    iProtoKeywordID = 0;
    iCodeCountType = 0;

    memset(&strfuncName, 0x00, CDMTRSPS_MAX_LINE_BUF);
    memset(&iciProtoCodeInfo, 0, sizeof(iciProtoCodeInfo));
    memset(&pciParsCodeInfo, 0, sizeof(pciParsCodeInfo));
    
    memset(&strParams, 0x00, CDMTRSPS_MAX_LINE_BUF);

    freeCodeLineStmt(&ppStackCodes, &iStackCodesNum);
    iStackCodesCnt = 0;
    freeCodeLineStmt(&ppStackTokens, &iStackTokensNum);
    iStackTokensCnt = 0 ;
    freeArryTokenNumInfo(&ppStackTokenNumInfo, &iStackTokenNumInfoNum);
    iStackTokenNumInfoCnt = 0 ;


    iStackCodesNum = CDMTRSPS_MAX_STACK_SIZE ;
    iStackTokensNum = CDMTRSPS_MAX_STACK_SIZE ;
    iStackTokenNumInfoNum = CDMTRSPS_MAX_TKN_NUMARY ;

    clearStackToken();
    return;
}


int setDelimitaLine(int yytoken,int yylval,int yyval,int yylen, const char *yystr, const char *upername, const char *complex)
{
    int tokenid = yytoken + 255 ;
    int ii,jj;
    int ires = 0 ;
    int codebuffLen = 0 ;
    int iflg_statement = CDMTRSPS_FLAG_OFF ;
    char *pszCodeLine;
    char swkbuff[CDMTRSPS_MAX_LINE_BUF]={0};

    switch(tokenid){
    case SEMICOLON:
        ires = stackToken(yytoken,yylval,yyval,yylen, yystr, upername, complex);
        if(ires != CDMTRSPS_RET_OK) return ires;
    




        iflg_statement = CDMTRSPS_FLAG_ON ;
        switch(iProtoKeywordID){
        case KEYWOR_CASE_FUNC_DECLARATION:
            if(iciProtoCodeInfo.imagine_param_statement > iciProtoCodeInfo.imagine_param_cnt){


                iflg_statement = CDMTRSPS_FLAG_ON ;

                if(p_method->pefFuncToStatement != NULL){
                    (*(p_method->pefFuncToStatement))(ppStackTokenNumInfo, iStackTokenNumInfoCnt, ppStackTokenNumInfo[0][0],yylineno, strfuncName, getCodeLineStmt(&ppStackCodes, &iStackCodesNum, iStackCodesCnt));
                }
            } else {

                if(iciProtoCodeInfo.imagine_StackTokenNumInfoCnt == iStackTokenNumInfoCnt-1){

                    iflg_statement = CDMTRSPS_FLAG_ON ;

                    if(p_method->pefFuncToStatement != NULL){
                        (*(p_method->pefFuncToStatement))(ppStackTokenNumInfo, iStackTokenNumInfoCnt, ppStackTokenNumInfo[0][0],yylineno, strfuncName, getCodeLineStmt(&ppStackCodes, &iStackCodesNum, iStackCodesCnt));
                    }



                    
                } else {
                    if(ppStackTokenNumInfo[iciProtoCodeInfo.imagine_StackTokenNumInfoCnt][4] == ASS_OP){


                        iflg_statement = CDMTRSPS_FLAG_ON ;

                        if(p_method->pefFuncToStatement != NULL){
                            (*(p_method->pefFuncToStatement))(ppStackTokenNumInfo, iStackTokenNumInfoCnt, ppStackTokenNumInfo[0][0],yylineno, strfuncName, getCodeLineStmt(&ppStackCodes, &iStackCodesNum, iStackCodesCnt));
                        }




                    } else {

                        iflg_statement = CDMTRSPS_FLAG_OFF ;



                        jj = iciProtoCodeInfo.imagine_StackCodesNext ;

                        codebuffLen = getCodeLineStmtLength(&ppStackCodes, &iStackCodesNum, iStackCodesCnt);
                        pszCodeLine = getCodeLineStmt(&ppStackCodes, &iStackCodesNum, iStackCodesCnt);

                        if(codebuffLen > jj) {
                            ii = codebuffLen - jj;
                        } else {
                            ii = codebuffLen ;
                            jj = 0;
                        }
                        if(CDMTRSPS_MAX_LINE_BUF < (ii+1)){

                            ii = CDMTRSPS_MAX_LINE_BUF - 1;
                        }
                        strncpy(swkbuff, pszCodeLine + jj, ii);
                        swkbuff[ii]='\0';


                        if(p_method->pefFuncToStatement != NULL){
                            (*(p_method->pefFuncToStatement))(ppStackTokenNumInfo, iStackTokenNumInfoCnt, ppStackTokenNumInfo[0][0],yylineno, strfuncName, swkbuff);
                        }




                        iciProtoCodeInfo.imagine_StackCodesNext  = codebuffLen ;
                        iciProtoCodeInfo.imagine_StackTokensNext = iStackTokensCnt ;
                        iciProtoCodeInfo.imagine_StackTokenNumInfoNext = iStackTokenNumInfoCnt ;

                    }
                }
            }
            iciProtoCodeInfo.imagine_param_statement++;
            break;
        case KEYWOR_CASE_FOR:
            icntforopt++ ;
            if((icntforopt > 0) && (icntforopt <= 2)){
                iflg_statement = CDMTRSPS_FLAG_OFF ;
            }
            break;
        default:

            if(p_method->pefStatement != NULL){
                (*(p_method->pefStatement))(ppStackTokenNumInfo, iStackTokenNumInfoCnt, ppStackTokenNumInfo[0][0], yylineno, getCodeLineStmt(&ppStackCodes, &iStackCodesNum, iStackCodesCnt));
            }
            break;
        }

        if(iflg_statement == CDMTRSPS_FLAG_ON){


            clearStackToken();
            iProtoKeywordID = KEYWOR_CASE_NONE ;


            iciProtoCodeInfo.imagine_parennest_cnt = 0 ;
            iciProtoCodeInfo.imagine_param_cnt = 0 ;
            iciProtoCodeInfo.imagine_param_statement = 0 ;
            iciProtoCodeInfo.imagine_startline_no = 0 ;
            iciProtoCodeInfo.imagine_endline_no = 0 ;
            iciProtoCodeInfo.imagine_StackCodesCnt = 0 ;
            iciProtoCodeInfo.imagine_StackTokensCnt = 0 ;
            iciProtoCodeInfo.imagine_StackTokenNumInfoCnt = 0 ;
            iciProtoCodeInfo.imagine_StackCodesNext = 0 ;
            iciProtoCodeInfo.imagine_StackTokensNext = 0 ;
            iciProtoCodeInfo.imagine_StackTokenNumInfoNext = 0 ;



            oldKeywoedID = -1;
            oldTokenID = -1;
            strfuncName[0] = '\0';
            iCntArgumentToken = 0 ;
            icntassop = 0;
            

            strParams[0] = '\0';
            pStArg = NULL;
            pEndArg = NULL;

        }

        break ;
    case PARENST:


        switch(getStackToken(1)){
        case IDENTIFIER:

            if(iProtoKeywordID == KEYWOR_CASE_NONE && icntassop == 0 && (0 == invalidStackToken(0,iStackTokenNumInfoCnt - 2,1))){

                iProtoKeywordID = KEYWOR_CASE_IDENTIFIER ;

                cdmtrSpsStrcpyToArray(strfuncName,
                     getCodeLineStmt(&ppStackTokens, &iStackTokensNum, 
                                     iStackTokensCnt - 1),
                     CDMTRSPS_MAX_LINE_BUF);

                iciProtoCodeInfo.imagine_parennest_cnt = 0;
                iciProtoCodeInfo.imagine_param_cnt = 0 ;
                iciProtoCodeInfo.imagine_param_statement = 0 ;
                iciProtoCodeInfo.imagine_startline_no = ppStackTokenNumInfo[0][0];
                iciProtoCodeInfo.imagine_funcname_point = iStackTokensCnt - 1 ;
                iCntArgumentToken = 0 ;

                strParams[0] = '\0';
                pStArg = NULL;





            }
            break;
        case IF:
            iProtoKeywordID = KEYWOR_CASE_IF ;
            icntconditionparen = 0;
            icntconditionexp = 0;
            iCntArgumentToken = 0;
            

            if(p_method->pefBranchCandidate != NULL){
                (*(p_method->pefBranchCandidate))(iProtoKeywordID, ppStackTokenNumInfo[0][0],
                    yylineno, getCodeLineStmt(&ppStackCodes, &iStackCodesNum, iStackCodesCnt));
            }




            break;
        case FOR:
            iProtoKeywordID = KEYWOR_CASE_FOR ;
            icntconditionparen = 0;
            icntconditionexp = 0;
            icntforopt = 0;
            iCntArgumentToken = 0;
            

            if(p_method->pefBranchCandidate != NULL){
                (*(p_method->pefBranchCandidate))(iProtoKeywordID, ppStackTokenNumInfo[0][0],
                    yylineno, getCodeLineStmt(&ppStackCodes, &iStackCodesNum, iStackCodesCnt));
            }




            break;
        case WHILE:
            iProtoKeywordID = KEYWOR_CASE_WHILE ;
            icntconditionparen = 0;
            icntconditionexp = 0;
            iCntArgumentToken = 0;
            

            if(p_method->pefBranchCandidate != NULL){
                (*(p_method->pefBranchCandidate))(iProtoKeywordID, ppStackTokenNumInfo[0][0],
                    yylineno, getCodeLineStmt(&ppStackCodes, &iStackCodesNum, iStackCodesCnt));
            }




            break;
        case SWITCH:
            iProtoKeywordID = KEYWOR_CASE_SWITCH ;
            icntconditionparen = 0;
            icntconditionexp = 0;
            iCntArgumentToken = 0;
            

            if(p_method->pefBranchCandidate != NULL){
                (*(p_method->pefBranchCandidate))(iProtoKeywordID, ppStackTokenNumInfo[0][0],
                    yylineno, getCodeLineStmt(&ppStackCodes, &iStackCodesNum, iStackCodesCnt));
            }




            break;
        default:
            break;
        }

        switch(iProtoKeywordID){
        case KEYWOR_CASE_IDENTIFIER:
            pciParsCodeInfo.pars_method_parennest_cnt++;
            iciProtoCodeInfo.imagine_parennest_cnt++ ;
            break;
        case KEYWOR_CASE_IF:
        case KEYWOR_CASE_WHILE:
        case KEYWOR_CASE_SWITCH:
        case KEYWOR_CASE_FOR:
            icntconditionparen++;
            break;
        }
        ires = stackToken(yytoken,yylval,yyval,yylen, yystr, upername, complex);
        if(ires != CDMTRSPS_RET_OK) return ires;


        if(pStArg == NULL){


            pStArg = getCodeLineStmt(&ppStackTokens, &iStackTokensNum, iStackTokensCnt - 1);
        }


        if(p_method->pefParenNest != NULL){
            (*(p_method->pefParenNest))(tokenid, ppStackTokenNumInfo[0][0], yylineno,\
                iciProtoCodeInfo.imagine_parennest_cnt, icntconditionparen, \
                getCodeLineStmt(&ppStackCodes, &iStackCodesNum, iStackCodesCnt));
        }




        codebuffLen = getCodeLineStmtLength(&ppStackCodes, &iStackCodesNum, iStackCodesCnt);




        break ;
    case PARENED:

        ires = stackToken(yytoken,yylval,yyval,yylen, yystr, upername, complex);
        if(ires != CDMTRSPS_RET_OK) return ires;
        

        pEndArg = getCodeLineStmt(&ppStackTokens, &iStackTokensNum, iStackTokensCnt-1);






        switch(iProtoKeywordID){
        case KEYWOR_CASE_IDENTIFIER:
            iciProtoCodeInfo.imagine_parennest_cnt-- ;

            if(iciProtoCodeInfo.imagine_parennest_cnt <= 0){
                iProtoKeywordID = KEYWOR_CASE_FUNC_DECLARATION ;
                if(iciProtoCodeInfo.imagine_param_cnt > 0){
                    iciProtoCodeInfo.imagine_param_cnt++ ;
                } else {
                    if(iCntArgumentToken > 0){
                        iciProtoCodeInfo.imagine_param_cnt = 1 ;
                    } else {
                        iciProtoCodeInfo.imagine_param_cnt = 0 ;
                    }
                }
                iciProtoCodeInfo.imagine_endline_no = yylineno;
                iciProtoCodeInfo.imagine_StackCodesNext = iciProtoCodeInfo.imagine_StackCodesCnt = getCodeLineStmtLength(&ppStackCodes, &iStackCodesNum, iStackCodesCnt);
                iciProtoCodeInfo.imagine_StackTokensNext = iciProtoCodeInfo.imagine_StackTokensCnt = iStackTokensCnt ;
                iciProtoCodeInfo.imagine_StackTokenNumInfoNext = iciProtoCodeInfo.imagine_StackTokenNumInfoCnt = iStackTokenNumInfoCnt ;


                if(p_method->pefParenNest != NULL){
                    (*(p_method->pefParenNest))(tokenid, ppStackTokenNumInfo[0][0], yylineno,\
                        iciProtoCodeInfo.imagine_parennest_cnt, icntconditionparen, \
                        getCodeLineStmt(&ppStackCodes, &iStackCodesNum, iStackCodesCnt));
                }


                if(p_method->pefFuncCandidate != NULL){
                    (*(p_method->pefFuncCandidate))(iciProtoCodeInfo.imagine_startline_no, iciProtoCodeInfo.imagine_endline_no, \
                                strfuncName, iciProtoCodeInfo.imagine_param_cnt, getCodeLineStmt(&ppStackCodes, &iStackCodesNum, iStackCodesCnt));
                }




                
            }

            break;
        case KEYWOR_CASE_IF:
        case KEYWOR_CASE_WHILE:
        case KEYWOR_CASE_SWITCH:
        case KEYWOR_CASE_FOR:
            icntconditionparen--;
            if(icntconditionparen <= 0){
                if (iProtoKeywordID == KEYWOR_CASE_SWITCH) {

                } else {

                    if(icntconditionexp > 0){
                        icntconditionexp++ ;
                    } else {
                        if(iCntArgumentToken > 0){
                            icntconditionexp = 1 ;
                        } else {
                            icntconditionexp = 0 ;
                        }
                    }
                }


                if(p_method->pefParenNest != NULL){
                    (*(p_method->pefParenNest))(tokenid, ppStackTokenNumInfo[0][0], yylineno,\
                        iciProtoCodeInfo.imagine_parennest_cnt, icntconditionparen, \
                        getCodeLineStmt(&ppStackCodes, &iStackCodesNum, iStackCodesCnt));
                }


                if(p_method->pefBranchStatement != NULL){
                    (*(p_method->pefBranchStatement))(iProtoKeywordID, ppStackTokenNumInfo, iStackTokenNumInfoCnt, ppStackTokenNumInfo[0][0], yylineno, icntconditionexp, ppStackCodes[iStackCodesCnt]);
                }





                clearStackToken();
                iProtoKeywordID = KEYWOR_CASE_NONE ;


                iciProtoCodeInfo.imagine_parennest_cnt = 0 ;
                iciProtoCodeInfo.imagine_param_cnt = 0 ;
                iciProtoCodeInfo.imagine_param_statement = 0 ;
                iciProtoCodeInfo.imagine_startline_no = 0 ;
                iciProtoCodeInfo.imagine_endline_no = 0 ;
                iciProtoCodeInfo.imagine_StackCodesCnt = 0 ;
                iciProtoCodeInfo.imagine_StackTokensCnt = 0 ;
                iciProtoCodeInfo.imagine_StackTokenNumInfoCnt = 0 ;
                iciProtoCodeInfo.imagine_StackCodesNext = 0 ;
                iciProtoCodeInfo.imagine_StackTokensNext = 0 ;
                iciProtoCodeInfo.imagine_StackTokenNumInfoNext = 0 ;



                oldKeywoedID = -1;
                oldTokenID = -1;
                strfuncName[0] = '\0';
                iCntArgumentToken = 0 ;
                icntassop = 0;
                
                strParams[0] = '\0';
                pStArg = NULL;
                pEndArg = NULL;
            }
            break;
        }

        break ;
    case BRACEST:
        ires = stackToken(yytoken,yylval,yyval,yylen, yystr, upername, complex);
        if(ires != CDMTRSPS_RET_OK) return ires;

        if(iProtoKeywordID == KEYWOR_CASE_FUNC_DECLARATION && iStackTokenNumInfoCnt > 4){

            jj = iciProtoCodeInfo.imagine_StackTokenNumInfoCnt ;
            if((0 < invalidStackToken(jj,jj,2)) || (0 < invalidStackToken(iStackTokenNumInfoCnt-2,iStackTokenNumInfoCnt-2,3))){


                iProtoKeywordID = KEYWOR_CASE_NONE ;
            }
        }
        
        if(iProtoKeywordID == KEYWOR_CASE_FUNC_DECLARATION){


            if( (p_set_method) && 
                (p_set_method->psfGetFunctionStartFlag())
              )
            {
                iProtoKeywordID = KEYWOR_CASE_NONE ;
            }
        }

        if(iProtoKeywordID == KEYWOR_CASE_FUNC_DECLARATION){

            iciProtoCodeInfo.imagine_endline_no = yylineno;


            iCodeCountType = COUNTTYPE_CASE_FUNCTION ;
            pciParsCodeInfo.pars_method_nest_cnt = 1;
            pciParsCodeInfo.pars_method_maxnest_cnt = 1;
            
            ii=iciProtoCodeInfo.imagine_funcname_point;

            getFunctionName(strfuncName, ii, strParams);


            if(p_method->pefFunction != NULL){
                (*(p_method->pefFunction))(ppStackTokenNumInfo, iStackTokenNumInfoCnt, iciProtoCodeInfo.imagine_startline_no, iciProtoCodeInfo.imagine_endline_no, strfuncName, strParams, iciProtoCodeInfo.imagine_param_cnt, ppStackCodes[iStackCodesCnt], ii);
            }


            if(p_method->pefBraceNest != NULL){
                (*(p_method->pefBraceNest))(tokenid, ppStackTokenNumInfo, iStackTokenNumInfoCnt, ppStackTokenNumInfo[0][0], yylineno, \
                    pciParsCodeInfo.pars_method_nest_cnt, pciParsCodeInfo.pars_outer_nest_cnt, \
                    pciParsCodeInfo.pars_method_maxnest_cnt, pciParsCodeInfo.pars_outer_maxnest_cnt, \
                    getCodeLineStmt(&ppStackCodes, &iStackCodesNum, iStackCodesCnt));
            }














            clearStackToken();
            iProtoKeywordID = KEYWOR_CASE_NONE ;


            iciProtoCodeInfo.imagine_parennest_cnt = 0 ;
            iciProtoCodeInfo.imagine_param_cnt = 0 ;
            iciProtoCodeInfo.imagine_param_statement = 0 ;
            iciProtoCodeInfo.imagine_startline_no = 0 ;
            iciProtoCodeInfo.imagine_endline_no = 0 ;
            iciProtoCodeInfo.imagine_StackCodesCnt = 0 ;
            iciProtoCodeInfo.imagine_StackTokensCnt = 0 ;
            iciProtoCodeInfo.imagine_StackTokenNumInfoCnt = 0 ;
            iciProtoCodeInfo.imagine_StackCodesNext = 0 ;
            iciProtoCodeInfo.imagine_StackTokensNext = 0 ;
            iciProtoCodeInfo.imagine_StackTokenNumInfoNext = 0 ;


            oldKeywoedID = -1;
            oldTokenID = -1;
            icntassop = 0;

        } else {

            if(iCodeCountType == COUNTTYPE_CASE_FUNCTION){
                if(chkNonNestKeywd(iStackTokenNumInfoCnt,pciParsCodeInfo.pars_method_nonnest_cnt) == CDMTRSPS_RET_OK){
                    pciParsCodeInfo.pars_method_nest_cnt++;
                    if(pciParsCodeInfo.pars_method_nest_cnt > pciParsCodeInfo.pars_method_maxnest_cnt){
                        pciParsCodeInfo.pars_method_maxnest_cnt = pciParsCodeInfo.pars_method_nest_cnt ;
                    }
                } else {
                    pciParsCodeInfo.pars_method_nonnest_cnt++;
                }
            } else {
                pciParsCodeInfo.pars_outer_nest_cnt++;
                if(pciParsCodeInfo.pars_outer_nest_cnt > pciParsCodeInfo.pars_outer_maxnest_cnt){
                    pciParsCodeInfo.pars_outer_maxnest_cnt = pciParsCodeInfo.pars_outer_nest_cnt ;
                }
            }


            if(p_method->pefBraceNest != NULL){
                (*(p_method->pefBraceNest))(tokenid, ppStackTokenNumInfo, iStackTokenNumInfoCnt, \
                    ppStackTokenNumInfo[0][0], yylineno, \
                    pciParsCodeInfo.pars_method_nest_cnt, pciParsCodeInfo.pars_outer_nest_cnt, \
                    pciParsCodeInfo.pars_method_maxnest_cnt, pciParsCodeInfo.pars_outer_maxnest_cnt, \
                    getCodeLineStmt(&ppStackCodes, &iStackCodesNum, iStackCodesCnt));
            }







            if(iStackTokenNumInfoCnt == 1){

                clearStackToken();
                oldKeywoedID = -1;
                oldTokenID = -1;
                iCntArgumentToken = 0 ;
                icntassop = 0;
            }
        }


        break ;
    case BRACEED:

        ires = stackToken(yytoken,yylval,yyval,yylen, yystr, upername, complex);
        if(ires != CDMTRSPS_RET_OK) return ires;

        iflg_statement = CDMTRSPS_FLAG_OFF ;
        if(iCodeCountType == COUNTTYPE_CASE_FUNCTION){
            if(pciParsCodeInfo.pars_method_nonnest_cnt > CDMTRSPS_RET_OK){
                pciParsCodeInfo.pars_method_nonnest_cnt--;
            } else {
                if(pciParsCodeInfo.pars_method_nest_cnt > 0){
                    pciParsCodeInfo.pars_method_nest_cnt--;
                }
                if(pciParsCodeInfo.pars_method_nest_cnt <= 0){
                    iCodeCountType = COUNTTYPE_CASE_NONE ;

                    if(p_method->pefFuncEnd != NULL){
                        (*(p_method->pefFuncEnd))(ppStackTokenNumInfo, iStackTokenNumInfoCnt, yylineno, yylineno, pciParsCodeInfo.pars_method_maxnest_cnt);
                    }
                    iflg_statement = CDMTRSPS_FLAG_ON ;



                }
            }
        } else {
            if(pciParsCodeInfo.pars_outer_nest_cnt > 0){
                pciParsCodeInfo.pars_outer_nest_cnt--;

                iflg_statement = CDMTRSPS_FLAG_ON;
            }
        }


        if(p_method->pefBraceNest != NULL){
            (*(p_method->pefBraceNest))(tokenid, ppStackTokenNumInfo, iStackTokenNumInfoCnt, \
                ppStackTokenNumInfo[0][0], yylineno, \
                pciParsCodeInfo.pars_method_nest_cnt, pciParsCodeInfo.pars_outer_nest_cnt, \
                pciParsCodeInfo.pars_method_maxnest_cnt, pciParsCodeInfo.pars_outer_maxnest_cnt, \
                getCodeLineStmt(&ppStackCodes, &iStackCodesNum, iStackCodesCnt));
        }






        if(iStackTokenNumInfoCnt == 1){

            clearStackToken();
            oldKeywoedID = -1;
            oldTokenID = -1;
            icntassop = 0;
        }

        if(iflg_statement == CDMTRSPS_FLAG_ON){


            clearStackToken();
            iProtoKeywordID = KEYWOR_CASE_NONE ;


            memset(&iciProtoCodeInfo, 0, sizeof(iciProtoCodeInfo));
            
            pciParsCodeInfo.pars_method_parennest_cnt = 0 ;
            pciParsCodeInfo.pars_method_param_cnt = 0 ;
            pciParsCodeInfo.pars_method_startline_no = 0 ;
            pciParsCodeInfo.pars_method_endline_no = 0 ;
            pciParsCodeInfo.pars_if_cnt = 0 ;
            pciParsCodeInfo.pars_for_cnt = 0 ;
            pciParsCodeInfo.pars_while_cnt = 0 ;
            pciParsCodeInfo.pars_switch_cnt = 0 ;
            pciParsCodeInfo.pars_case_condition_cnt = 0 ;
            pciParsCodeInfo.pars_if_condition_cnt = 0 ;
            pciParsCodeInfo.pars_for_condition_cnt = 0 ;
            pciParsCodeInfo.pars_while_condition_cnt = 0 ;
            pciParsCodeInfo.pars_method_nest_cnt = 0 ;
            pciParsCodeInfo.pars_method_nonnest_cnt = 0 ;
            pciParsCodeInfo.pars_method_maxnest_cnt = 0 ;
            pciParsCodeInfo.pars_method_stmt_cnt = 0 ;
            pciParsCodeInfo.pars_method_code_cnt = 0 ;

            icntconditionparen = 0;
            icntconditionexp = 0;
            icntforopt = 0;
            icntassop = 0;


            oldKeywoedID = -1;
            oldTokenID = -1;
            memset(&strfuncName, 0x00, CDMTRSPS_MAX_LINE_BUF);

            iStackTokensIdentifier = 0 ;
            iCntArgument = 0;
            iCntArgumentToken = 0;

            oldKeywoedID = -1;
            oldTokenID = -1;
            strfuncName[0] = '\0';
            iCntArgumentToken = 0 ;

            memset(&strParams, 0x00, CDMTRSPS_MAX_LINE_BUF);
            strParams[0] = '\0';
            pStArg = NULL;
            pEndArg = NULL;

        }

        break ;
    case COMMA:
        ires = stackToken(yytoken,yylval,yyval,yylen, yystr, upername, complex);
        if(ires != CDMTRSPS_RET_OK) return ires;

        if(iProtoKeywordID == KEYWOR_CASE_IDENTIFIER){
            iciProtoCodeInfo.imagine_param_cnt++ ;
        }
        break ;
    }
    return CDMTRSPS_RET_OK ;
}

int chkNonNestKeywd(int istacknum, int icntnonnest)
{
    int imode = CDMTRSPS_RET_OK;
#if 0
    int ii = 0 ;
    if(icntnonnest > 0){
        imode = CDMTRSPS_RET_NG;
    } else {
        while(ii <= istacknum){
            switch(ppStackTokenNumInfo[ii][4]){
            case CLASS:
              if( (p_set_method) && 
                  (p_set_method->psfGetTargetLangType() == SPS_LANG_TYPE_CPP) 
                )
              {
                break;
              }
            case STRUCT:
            case UNION:
            case ENUM:

                imode = ppStackTokenNumInfo[ii][4];
                ii=istacknum;
                break;
            }
            ii++;
        }
    }
#endif
    return (imode);
}

int setKeyword(int yytoken,int yylval,int yyval,int yylen, const char *yystr, const char *upername, const char *complex)
{
    int ires = 0 ;
    int tokenid = yytoken + 255 ;

    iCntArgumentToken = iCntArgumentToken + chkArgumentParam(tokenid);
    
    switch(tokenid){
    case IDENTIFIER:
        iStackTokensIdentifier = iStackCodesCnt;

    case IF:
    case FOR:
    case WHILE:
    case SWITCH:
    case CASE:
        oldKeywoedID = tokenid;
        oldTokenID = tokenid ;
        break;
    case STRUCT:
    case UNION:
    case ENUM:
    case ELSE:
    case DEFAULT:
        oldTokenID = tokenid ;
        break;
    case DO:
    case COLON:
    default:
        break;
    }

    ires = stackToken(yytoken,yylval,yyval,yylen, yystr, upername, complex);
    if(ires != CDMTRSPS_RET_OK) return ires;
    
    return CDMTRSPS_RET_OK ;
}





int getStackToken(int inum){
    int ires = 0;
    int icnt = 0;
    if(ppStackTokenNumInfo != NULL){
        if(iStackTokenNumInfoCnt >= inum && inum > 0){
            icnt = iStackTokenNumInfoCnt - inum ;
            ires = ppStackTokenNumInfo[icnt][4];
        }
    }
    return ires ;
}

/*!
    inumimax͈͂Ŏw肳ꂽ͈͓ɗpłȂ邩HB
    Ȃꍇ0ԋpBꍇTokenIDԋp



*/
int invalidStackToken(int inum, int imax, int md){
    int ires = 0;
    int icnt;

    if(iStackTokenNumInfoCnt >= imax && imax >= 0){
        icnt = imax ;
    } else {
        icnt = -1;
    }

    if(icnt < inum || inum < 0){
        icnt = -1;
    }

    if(ppStackTokenNumInfo != NULL || icnt >= 0){
        for(;icnt >= inum;icnt--){
            switch(ppStackTokenNumInfo[icnt][4]){
            case ETC_OP :
                if(md == 2 || md == 3) {
                    ires = ppStackTokenNumInfo[icnt][4] ;
                }
                break;           
            case BRACEED :
            case ASS_OP :
            case INC_OP :
            case DEC_OP :
            case OR_OP :
            case LE_OP :
            case GE_OP :
            case EQ_OP :
            case NE_OP :
            case RIGHT_ASSIGN :
            case LEFT_ASSIGN :
            case ADD_ASSIGN :
            case SUB_ASSIGN :
            case MUL_ASSIGN :
            case DIV_ASSIGN :
            case MOD_ASSIGN :
            case AND_ASSIGN :
            case XOR_ASSIGN :
            case OR_ASSIGN :
            case RIGHT_OP :
            case LEFT_OP :
            case PTR_OP :
                ires = ppStackTokenNumInfo[icnt][4] ;
                break;
            }
        }
    }
    return ires ;
}

void clearStackToken(){
    freeCodeLineStmt(&ppStackCodes, &iStackCodesNum);
    iStackCodesCnt = 0;
    freeCodeLineStmt(&ppStackTokens, &iStackTokensNum);
    iStackTokensCnt = 0 ;
    ClearArryTokenNumInfo(&ppStackTokenNumInfo, &iStackTokenNumInfoNum);

    iStackTokenNumInfoCnt = 0 ;
    
    pStArg = NULL;
    pEndArg = NULL;
    memset(&param_escape, 0x00, sizeof(param_escape));
}

int stackToken(int yytoken,int yylval,int yyval,int yylen, const char *yystr, const char *upername, const char *complex)
{
    int ires = 0;
    int tokenlen = 0;
    int codebuffLen = 0;
    
    int ilexTokenid = yytoken + 255 ;
    

    tokenlen = strlen(yytext);

    codebuffLen = getCodeLineStmtLength(&ppStackCodes, &iStackCodesNum, iStackCodesCnt);

    if(tokenlen <= 0){

        return CDMTRSPS_RET_OK;
    }
        

    ires = addCodeLineStmt(&ppStackCodes, &iStackCodesNum, iStackCodesCnt, yytext);
    if(ires == CDMTRSPS_RET_NG){
        return CDMTRSPS_RET_NG;
    }


    ires = addCodeLineStmt(&ppStackCodes, &iStackCodesNum, iStackCodesCnt, " ");
    if(ires == CDMTRSPS_RET_NG){
        return CDMTRSPS_RET_NG;
    }


    ires = setToken(&ppStackTokens, &iStackTokensNum, iStackTokensCnt, yytext);
    if(ires == CDMTRSPS_RET_NG){
        return CDMTRSPS_RET_NG;
    } else {
        iStackTokensCnt++;
    }


    ires = chkArryTokenNumInfo(&ppStackTokenNumInfo, &iStackTokenNumInfoNum, iStackTokenNumInfoCnt);
    if(ires == CDMTRSPS_RET_NG){
        return CDMTRSPS_RET_NG;
    } else {
        ppStackTokenNumInfo[iStackTokenNumInfoCnt][0] = yylineno ;
        ppStackTokenNumInfo[iStackTokenNumInfoCnt][1] = column ;
        ppStackTokenNumInfo[iStackTokenNumInfoCnt][2] = codebuffLen ;
        ppStackTokenNumInfo[iStackTokenNumInfoCnt][3] = tokenlen ;
        ppStackTokenNumInfo[iStackTokenNumInfoCnt][4] = ilexTokenid ;
        iStackTokenNumInfoCnt++;
    }

    switch(iProtoKeywordID){
    case KEYWOR_CASE_IF:
    case KEYWOR_CASE_WHILE:
    case KEYWOR_CASE_SWITCH:
        if(ilexTokenid == AND_OP || ilexTokenid == OR_OP){
            icntconditionexp++;
        } else {
            iCntArgumentToken = iCntArgumentToken + chkArgumentParam(ilexTokenid);
        }
        break;
    case KEYWOR_CASE_FOR:
        if(icntforopt == 1){
            if(ilexTokenid == AND_OP || ilexTokenid == OR_OP){
                icntconditionexp++;
            } else {
                iCntArgumentToken = iCntArgumentToken + chkArgumentParam(ilexTokenid);
            }
        }
        break;
    default :
        if(ilexTokenid == ASS_OP){

            icntassop++;
        }
        iCntArgumentToken = iCntArgumentToken + chkArgumentParam(ilexTokenid);
    }
    return CDMTRSPS_RET_OK;
}


int ParsCase(int yytoken,int yylval,int yyval,int yylen, const char *yystr, const char *upername, const char *complex)
{


    return (CDMTRSPS_RET_OK);
}















void getFunctionName(char *pszbuf, int istacknum, char* pszprm)
{
    int ii;
    int icnt;
    int imode = 0;

    char buff[CDMTRSPS_MAX_LINE_BUF];
    int  iLength = 0;
    int  iyylineno = 0;
    int  icolumn = 0;
    char* db_qrt = NULL;
    unsigned int j = 0;
    int iappend_len = 0;
    int icnt_parennest = 0;
    const char escapeLiteral= '\"';
    const char over_str[] = " ... )";

    pszbuf[0]='\0';
    
    ii = icnt = istacknum ;
    while(ii>=0){
        switch (ppStackTokenNumInfo[ii][4]){
        case COLON:
        case DCOLON :
            imode = 0;
            break;
        case TILDE_OP:
            imode = 0;
            icnt = ii;
            break;
        case IDENTIFIER :
            if(imode == 0){

                imode = 1;
                icnt = ii;
            } else {

                ii = -1;
            }
            break;
        default:

            ii=-1;
        }
        ii--;
    }
    for(ii=icnt;ii<=istacknum;ii++){
		cdmtrSpsStrcatToArray(pszbuf, ppStackTokens[ii], CDMTRSPS_MAX_LINE_BUF);    
    }
    



    pszprm[0] = '\0';
    if(pStArg != ppStackTokens[ii]){

      cdmtrSpsStrcpyToArray(pszprm, "( )", CDMTRSPS_MAX_LINE_BUF);
      goto FUNC_END;
    }
    if(ii < iStackTokenNumInfoCnt){
      iyylineno = ppStackTokenNumInfo[ii][0];
      icolumn = ppStackTokenNumInfo[ii][1] - ppStackTokenNumInfo[ii][3];
    }
    
    for(;ii < iStackTokensCnt && pEndArg != ppStackTokens[ii]; ii++){
      if(CDMTRSPS_MAX_LINE_BUF > strlen(ppStackTokens[ii])+1){
        cdmtrSpsStrcpyToArray(buff, ppStackTokens[ii], CDMTRSPS_MAX_LINE_BUF);
        if(CDMTRSPS_MAX_LINE_BUF < (strlen(pszprm) + strlen(buff) + 2)){
            goto FUNC_ERROR;
        } else {
           if(ii < iStackTokenNumInfoCnt){
               if(iyylineno < ppStackTokenNumInfo[ii][0]){
                   if(ii > 0 && ii <= CDMTRSPS_MAX_STACK_SIZE 
                      && param_escape[ii-1] == SET__ON_ESCAPE_FLAG){

                   } else {

                       cdmtrSpsStrcatToArray(pszprm, " ", CDMTRSPS_MAX_LINE_BUF);
                   }
               } else if(icolumn != (int)ppStackTokenNumInfo[ii][1] - (int)strlen(buff)){

                    cdmtrSpsStrcatToArray(pszprm, " ", CDMTRSPS_MAX_LINE_BUF);
               } else {

               }
             
             if(giQrt_Out_Flg_ext == CDMTRSPS_FLAG_OFF){
                  cdmtrSpsStrcatToArray(pszprm, buff, CDMTRSPS_MAX_LINE_BUF);
             } else {

                db_qrt = strchr(buff, escapeLiteral);
                if(db_qrt != NULL){

                    iappend_len = strlen(pszprm);
                    for(j = 0; j < strlen(buff); j++){
                        if(buff[j] == escapeLiteral){
                            if((iappend_len+1) < (CDMTRSPS_MAX_LINE_BUF - 1)){
                                pszprm[iappend_len++] = buff[j];
                                pszprm[iappend_len++] = buff[j];
                            } else {
                                pszprm[iappend_len] = '\0';
                                goto FUNC_ERROR;
                            }
                        } else {
                            if((iappend_len) < ( CDMTRSPS_MAX_LINE_BUF - 1 )){
                                pszprm[iappend_len++] = buff[j];
                            } else {
                                pszprm[iappend_len] = '\0';
                                goto FUNC_ERROR;
                            }
                        }
                    }
                    pszprm[iappend_len] = '\0';
                    db_qrt = NULL;
                } else {
                    if(strcmp(buff, ")") == 0){
                        icnt_parennest--;
                        if(icnt_parennest == 0){
                            cdmtrSpsStrcatToArray(pszprm, buff, CDMTRSPS_MAX_LINE_BUF);
                            break;
                        }
                    } else if (strcmp(buff, "(") == 0){
                        icnt_parennest++;
                    }
                    cdmtrSpsStrcatToArray(pszprm, buff, CDMTRSPS_MAX_LINE_BUF);
                }
             }
          } else {

            cdmtrSpsStrcatToArray(pszprm, " ", CDMTRSPS_MAX_LINE_BUF);
            cdmtrSpsStrcatToArray(pszprm, buff, CDMTRSPS_MAX_LINE_BUF);
          }
       }
      } else {
          goto FUNC_ERROR;
      }
      if(ii < iStackTokenNumInfoCnt){
        iyylineno = ppStackTokenNumInfo[ii][0];
        icolumn = ppStackTokenNumInfo[ii][1];
      }
    }
    if(pEndArg == ppStackTokens[ii]){
      iLength = strlen(pszprm);
      if( CDMTRSPS_MAX_LINE_BUF > (iLength + 2) ){
        cdmtrSpsStrcatToArray(pszprm, ")", CDMTRSPS_MAX_LINE_BUF);
      } else {

        iLength = strlen(over_str)+ 1;
        iLength = strlen(pszprm) - iLength;
        pszprm[iLength] = '\0';
        cdmtrSpsStrcatToArray(pszprm, (char*)over_str, CDMTRSPS_MAX_LINE_BUF);
      }
    }
FUNC_END:
    return;

FUNC_ERROR:

  if(CDMTRSPS_MAX_LINE_BUF < (strlen(pszprm) + strlen(over_str)+ 1)){
      iLength = strlen(over_str)+ 1;
      iLength = strlen(pszprm) - iLength;
      pszprm[iLength] = '\0';
      cdmtrSpsStrcatToArray(pszprm, (char*)over_str, CDMTRSPS_MAX_LINE_BUF);
  } else {
      cdmtrSpsStrcatToArray(pszprm, (char*)over_str, CDMTRSPS_MAX_LINE_BUF);
  }
  return;


}








int chkArgumentParam(int tknid)
{
    int ires = 0;
    switch(tknid){
    case PARENST:
    case PARENED:
    case COMMA:
        break;
    default:
        ires = 1;
        break;
    }
    return ires ;
}

/*!
    @brief X^bN̈̍쐬^giw蕶̃X^bNj




*/
static int chkArryBuff(char ***pszBuff, int *piMax, int piNum)
{
    char **pszwk = NULL ;

    if(*pszBuff == NULL){

        *pszBuff = (char **)malloc(sizeof(char *) * CDMTRSPS_MAX_STACK_SIZE);
        if(*pszBuff == NULL) {

            return(CDMTRSPS_RET_NG);
        } else {
            (*piMax) = CDMTRSPS_MAX_STACK_SIZE ;
            memset(&(*pszBuff)[0], 0x00, sizeof(char *) * (*piMax));
        }
    }
    if((*piMax) <= piNum){

        pszwk = (char **)realloc(*pszBuff, sizeof(char *) * ((*piMax) + CDMTRSPS_MAX_STACK_SIZE) );
        if(pszwk == NULL) {

            return(CDMTRSPS_RET_NG);
        } else {
            memset(&pszwk[(*piMax)], 0x00, sizeof(char *) * CDMTRSPS_MAX_STACK_SIZE);
            (*piMax) = (*piMax) + CDMTRSPS_MAX_STACK_SIZE ;
            *pszBuff = pszwk;
            pszwk = NULL ;
        }
    }
    return (CDMTRSPS_RET_OK);
}

/*!
    @brief X^bNu֐iw蕶̃X^bNj





*/
static int replaceAryyBuffString(char ***pszBuff, int piNum, char *pszText)
{
    int iStrLen = 0;

    if(pszText == NULL){
        iStrLen = -1;
    } else {
        iStrLen = strlen(pszText) + 1;
    }


    if((*pszBuff)[piNum] != NULL){
        free((*pszBuff)[piNum]);
        (*pszBuff)[piNum] = NULL ;
    }


    if(iStrLen > 0){

        (*pszBuff)[piNum] = (char *)malloc(sizeof(char) * (iStrLen));
        if((*pszBuff)[piNum] == NULL) {

            return(CDMTRSPS_RET_NG);
        } else {

            strcpy((*pszBuff)[piNum], pszText);
        }
    }
    return (CDMTRSPS_RET_OK);
}

/*!
    @brief X^bNǉ֐iw蕶̃X^bNj






*/
static int addAryyBuffString(char ***pszBuff, int piBufsz, int piNum, char *pszText)

{
    int iStrLen = 0;
    int iBuffLen = 0;

    if(pszText == NULL){
        iStrLen = -1;
    } else {
        iStrLen = strlen(pszText) + 1;
    }

    if(iStrLen <= 0){

        if((*pszBuff)[piNum] != NULL){
            free((*pszBuff)[piNum]);
            (*pszBuff)[piNum] = NULL ;
        }
        return(CDMTRSPS_RET_OK);
    }

    if((*pszBuff)[piNum] == NULL){
        iBuffLen = iStrLen ;

        (*pszBuff)[piNum] = (char *)malloc(sizeof(char) * (piBufsz));
        if((*pszBuff)[piNum] == NULL) {

            return(CDMTRSPS_RET_NG);
        }
        (*pszBuff)[piNum][0] = '\0';
    } else {
        iBuffLen = strlen((*pszBuff)[piNum]) + iStrLen ;
    }
    if(iBuffLen > piBufsz){

        return(CDMTRSPS_RET_NG);
    }
    if(iStrLen > 1){

        strcat((*pszBuff)[piNum], pszText);
    }
    return (CDMTRSPS_RET_OK);
}

/*!
    @brief TOKENX^bNǉ֐iw蕶̃X^bNj






*/
int addCodeLineStmt(char ***pszBuff, int *piMax, int piNum, char *pszText)

{
    int ires = 0;
    int ibuffSize = CDMTRSPS_MAX_LINE_BUF ;
    
    ires = chkArryBuff(pszBuff, piMax, piNum);
    if(ires == CDMTRSPS_RET_NG){
        return(CDMTRSPS_RET_NG);
    }

    ires = addAryyBuffString(pszBuff, ibuffSize, piNum, pszText);




    return(CDMTRSPS_RET_OK);
}

/*!
    @brief TOKENX^bNu֐iw蕶̃X^bNj







*/
int setToken(char ***pszBuff, int *piMax, int piNum, char *pszText)
{
    int ires = 0;
    
    ires = chkArryBuff(pszBuff, piMax, piNum);
    if(ires == CDMTRSPS_RET_NG){
        return(CDMTRSPS_RET_NG);
    }

    ires = replaceAryyBuffString(pszBuff, piNum, pszText);
    if(ires == CDMTRSPS_RET_NG){
        return(CDMTRSPS_RET_NG);
    }

    return (CDMTRSPS_RET_OK);
}

/*!
    @brief X^bN񂩂wʒu̕擾iw蕶̃X^bNj





*/
char* getCodeLineStmt(char ***pszBuff, int *piMax, int piNum)
{
    if((*piMax) <= piNum)
        return "\0";
    if(*pszBuff == NULL)
        return "\0";
    if((*pszBuff)[piNum] == NULL)
        return "\0";
    return ((*pszBuff)[piNum]) ;
}

/*!
    @brief X^bN񂩂wʒuɂ镶̕擾iw蕶̃X^bNj





*/
int getCodeLineStmtLength(char ***pszBuff, int *piMax, int piNum)

{
    if((*piMax) <= piNum)
        return 0;
    if(*pszBuff == NULL)
        return 0;
    if((*pszBuff)[piNum] == NULL)
        return 0;
    return (int)strlen((*pszBuff)[piNum]) ;
}

/*!
    @brief X^bN̊Jiw蕶̃X^bNj




*/
void freeCodeLineStmt(char ***pszBuff, int *piMax)
{
    int ii;

    if(*pszBuff != NULL){
        for(ii = (*piMax)-1; ii >= 0 ; --ii) {
            if((*pszBuff)[ii] != NULL){
                free((*pszBuff)[ii]);
                (*pszBuff)[ii] = NULL;
            }
        }
        free(*pszBuff); 
        *pszBuff = NULL;
    }
}

/*!
    @brief g[NX^bN̗̈mہiw萔l̃X^bNj





*/
int chkArryTokenNumInfo(int ***pszArray, int *piMax, int piNum)
{
    int iRet = CDMTRSPS_RET_NG;
    int ii,jj;
    int **pszwk = NULL ;
    
    if(*pszArray == NULL){
        *pszArray = (int **)malloc(sizeof(int *) * CDMTRSPS_MAX_TKN_NUMARY);
        if(*pszArray == NULL){

            return(CDMTRSPS_RET_NG);
        }
        (*piMax) = CDMTRSPS_MAX_TKN_NUMARY ;

        for(ii = 0; ii < (*piMax); ++ii) {
            (*pszArray)[ii] = (int *)malloc(sizeof(int) * CDMTRSPS_MAX_TKN_NUMINFO);
            if((*pszArray)[ii] == NULL) {

                return(CDMTRSPS_RET_NG);
            }
            for(jj = 0; jj < CDMTRSPS_MAX_TKN_NUMINFO; ++jj) {
                (*pszArray)[ii][jj] = -1;
            }
        }
    }

    if((*piMax) <= piNum){

        pszwk = (int **)realloc(*pszArray, sizeof(int *) * ((*piMax) + CDMTRSPS_MAX_TKN_NUMARY) );
        if(pszwk == NULL) {

            return(CDMTRSPS_RET_NG);
        }
        
        for(ii = (*piMax); ii < ((*piMax) + CDMTRSPS_MAX_TKN_NUMARY); ++ii) {
            pszwk[ii] = (int *)malloc(sizeof(int) * CDMTRSPS_MAX_TKN_NUMINFO);
            if(pszwk[ii] == NULL) {

                goto FUNC_END;
            }
            for(jj = 0; jj < CDMTRSPS_MAX_TKN_NUMINFO; ++jj) {
                pszwk[ii][jj] = -1;
            }
        }
        (*piMax) = (*piMax) + CDMTRSPS_MAX_TKN_NUMARY ;
        *pszArray = pszwk;
        pszwk = NULL ;
    }
    
    iRet = CDMTRSPS_RET_OK;
    
FUNC_END:
    if (pszwk != NULL) {
        free(pszwk);
    }
    return iRet;
}

/*!
    @brief g[NX^bN̏iw萔l̃X^bNj




*/
void ClearArryTokenNumInfo(int ***pszArray, int *piMax)
{
    int ii,jj;

    if(*pszArray == NULL){
        return ;
    }

    for(ii = 0; ii < (*piMax); ++ii) {
        if((*pszArray)[ii] == NULL) {
            break ;
        }

        if((*pszArray)[ii][0] == -1){
            break ;
        }
        for(jj = 0; jj < CDMTRSPS_MAX_TKN_NUMINFO; ++jj) {
                (*pszArray)[ii][jj] = -1;
        }
    }
    return ;
}

/*!
    @brief g[NX^bN̊Jiw萔l̃X^bNj




*/
void freeArryTokenNumInfo(int ***pszArray, int *piMax)
{
    int ii;

    if(*pszArray != NULL){
        for(ii = 0; ii < (*piMax); ++ii) {
            if((*pszArray)[ii] != NULL){
                free((*pszArray)[ii]);
                (*pszArray)[ii] = NULL ;
            }
        }
        free(*pszArray);
        *pszArray = NULL ;
    }
    return ;
}

/*!
    @brief s\R[hݒ肷



*/
void call_setParamState(){
  
  if(pStArg != NULL && iStackTokensCnt > 0 && iStackTokensCnt < (CDMTRSPS_MAX_STACK_SIZE + 1)){
    param_escape[iStackTokensCnt - 1] = SET__ON_ESCAPE_FLAG;
  }
}

/*!
    @brief ς܂Ăg[N擾



*/
void GetStackTokens(int *** iBufStackTokenInfo , int* iBufStackCnt)
{
   *iBufStackTokenInfo = ppStackTokenNumInfo;
   *iBufStackCnt = iStackTokenNumInfoCnt;
}

