/*
 *  source code metrics counter
 *  Copyright (C) 2015  NEC Corporation.
 *  
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "CDMtrSpsCmn.h"
#include "CDMtrLibCmn.h"
#include "CDMtrSparsMessage.h"

struct ParsesEventFunc *p_method = NULL;

struct ParsesSettingFunc *p_set_method = NULL;



/*!
    @brief  ֐|C^Zbg
*/
void cdmtrSpsEventFuncSet(struct ParsesEventFunc *p)
{
    p_method = p;
}

/*!
    @brief  ֐|C^Zbg
*/
void cdmtrSpsSettingFuncSet(struct ParsesSettingFunc *p)
{
    p_set_method = p;
}

/*!
    @brief          zւ̕Rs[
*/
void cdmtrSpsStrcpyToArray(char *pcArray, char *pcSrc, int iMaxArraySize)
{
    int iLen;
    iLen = strlen(pcSrc);
    if (iLen >= iMaxArraySize) {
        iLen = iMaxArraySize - 1;
        if (iSpsDebug == CDMTRSPS_FLAG_ON) {
            fprintf(strParamInfo.errfile, MSG_LOG_ID_C_00000601, pcSrc); //* MSG_LOG_ID_C_00000601
        }
    }
    strncpy(pcArray, pcSrc, iLen);
    pcArray[iLen] = '\0';
    return;
}

/*!
    @brief          zւ̕񌋍
*/
void cdmtrSpsStrcatToArray(char *pcArray, char *pcSrc, int iMaxArraySize)
{
    int iLen;
    int iArrLen;
    iLen = strlen(pcSrc);
    iArrLen = strlen(pcArray);
    if (iLen + iArrLen >= iMaxArraySize) {
        iLen = iMaxArraySize - iArrLen - 1;
        if (iSpsDebug == CDMTRSPS_FLAG_ON) {
            fprintf(strParamInfo.errfile, MSG_LOG_ID_C_00000602, pcSrc); //* MSG_LOG_ID_C_00000602
        }
    }
    strncat(pcArray, pcSrc, iLen);
    pcArray[iArrLen + iLen] = '\0';
    return;
}
