%{
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <setjmp.h> 
#include "CDMtrSpsBison.h"
#include "CDMtrSpsCmn.h"
#include "CDMtrSpsIface.h"
#include "CDMtrLibCmn.h"


#define Flag_MACRO_TRUE    0
#define Flag_MACRO_FALSE   1
#define Flag_MACRO_SKIP    2

#define LEX_PREORDER_INIT  0
#define LEX_PREORDER_START 1
#define LEX_PREORDER_NAME  2
#define LEX_PREORDER_PARAM 3

#define LEX_LINEBREAK_NORMAL 0
#define LEX_LINEBREAK_BRANK  1
#define LEX_LINEBREAK_ESCAPE 2

#define LEX_COMMENT_START  0
#define LEX_COMMENT_TEXT   1
#define LEX_COMMENT_ESCAPE 2
#define LEX_COMMENT_END    3
#define LEX_COMMENT_EOF    4
#define LEX_COMMENT_BREAK  5

#define LEX_COMMENT_TYPE_NON  (0)
#define LEX_COMMENT_TYPE_REM  (1)
#define LEX_COMMENT_TYPE_DOC  (2)

#define LEX_MACRO_START   0
#define LEX_MACRO_TEXT    1
#define LEX_MACRO_ESCAPE  2
#define LEX_MACRO_END     3
#define LEX_MACRO_EOF     4
#define LEX_MACRO_BLANK   5
#define LEX_MACRO_NUMERIC 6

#define MACRO_TYPE_NONE    0
#define MACRO_TYPE_IF      1
#define MACRO_TYPE_IF0     2
#define MACRO_TYPE_IFDEF   3
#define MACRO_TYPE_IFNDEF  4
#define MACRO_TYPE_ELIF    5
#define MACRO_TYPE_ELSE    6
#define MACRO_TYPE_ENDIF   7
#define MACRO_TYPE_INCLUDE 8
#define MACRO_TYPE_DEFINE  9
#define MACRO_TYPE_UNDEF   10
#define MACRO_TYPE_LINE    11
#define MACRO_TYPE_ERROR   12
#define MACRO_TYPE_PRAGMA  13
#define MACRO_TYPE_OTHER   90

#define LEX_SKIP_TEXT    0
#define LEX_SKIP_END     1
#define LEX_SKIP_EOF     2
#define LEX_SKIP_BREAK   3

#define LEX_STRING_START  0
#define LEX_STRING_TEXT   1
#define LEX_STRING_ESCAPE 2
#define LEX_STRING_END    3
#define LEX_STRING_EOF    4
#define LEX_STRING_BREAK  5

    extern int yylineno;

    int yywrap(void);
    
    void cntColumnStd();
    void cntColumnInitial();
    void cntLineStd();
    void cntLineInitial();
    void checkSkipIf0();
    int  chkToken(int tknid);
    void chkLineBreak(int ibranktype);
    void chkSingleComment(int icmttype);
    void chkMultiComment(int icmttype);
    void chkSkipLine(int iskiptype);
    void chkTextString(int istrtype, int tknid);

    int chkMacroEffectsIf(int imacrotype, int idefault);
    void chkMacroEffectsElse(int imacrotype, int idefault);
    void chkMacroEffectsEndif(int imacrotype);
    void chkMacroEffectsEtc(int imacrotype);
    void chkMacroLine(int ipretype);
    void setKeywordParam(char* ptkwdpm, char* pttxt);


    int lexer_tokenid = 0;
    int cntmacronest = 0;
    int macronest[CDMTRSPS_MAX_MACRO_NEST];
    int macrotype = MACRO_TYPE_NONE;
    char keywordname[CDMTRSPS_MAX_KEYWORD_NAME];
    char keywordparam[CDMTRSPS_MAX_LINE_BUF];
    
    int tkn_line_start = 0;
    int tkn_line_end = 0;
    int tkn_col_start = 0;
    int tkn_col_end = 0;

    int lineno = 1;
    int column = 0;
    int tcolumn = 0;
    int preorder = LEX_PREORDER_INIT ;
    int comment_type = 0;

    int cntstrcol = 0;
    int cntremline = 0;
    int cntdocline = 0;
    int cntprepline = 0;
    int cntrem = 0;
    int cntdoc = 0;
    int cntprep = 0;
    
    int pre_skiptokenmode = 0 ;
    struct pre_comment
    {
        int stline;
        int stcol;
        int edline;
        int edco;
    } g_pre_comment;
    
    int igSkipLine = 0;

#define YY_FATAL_ERROR(msg) my_fatal_error( msg )
static void my_fatal_error YY_PROTO(( yyconst char msg[] ));
extern jmp_buf g_cdmtrspsiface_jmp_buf;

%}


%x A MULTI_COMMENT SINGLE_COMMENT PRE SKIP STRING

D           [0-9]
L           [a-zA-Z_]
H           [a-fA-F0-9]
E           [Ee][+-]?{D}+
FS          (f|F|l|L)
IS          (u|U|l|L)*


%%
<INITIAL>^\xEF\xBB\xBF          {
                                    if (lineno == 1) {
                                      
                                      lexer_tokenid = BOM ;
                                      return(chkToken(lexer_tokenid));
                                    } else {
                                      BEGIN(INITIAL);
                                    }
                               }
<INITIAL>"/*"[*]*"*/"          {
                                    comment_type = LEX_COMMENT_TYPE_REM;
                                    cntrem++;
                                    cntremline=1;
                                    cntColumnInitial();
                                    if(p_method->pefComment != NULL){
                                        (*(p_method->pefComment))(comment_type-1,cntrem,cntremline,lineno,column-yyleng+1,lineno,column,yytext);
                                    }
//                                  printf("----[FLEX:COMMENT REM(%d),TOTAL_REM=%d,TOTAL_LINE=%d]LNO=%d(%d)-%d(%d),TEXT[%s] \n" 
//                                         ,comment_type,cntrem,cntremline,lineno,column-yyleng+1,lineno,column,yytext);
                                }
<INITIAL>"/**"                   {
                                    comment_type = LEX_COMMENT_TYPE_DOC;
                                    chkSingleComment(LEX_COMMENT_START);
                                    BEGIN(MULTI_COMMENT);
                                }
<INITIAL>"/*!"                   {
                                    comment_type = LEX_COMMENT_TYPE_DOC;
                                    chkSingleComment(LEX_COMMENT_START);
                                    BEGIN(MULTI_COMMENT);
                                }
<INITIAL>"/*!*"                   {
                                    comment_type = LEX_COMMENT_TYPE_REM;
                                    chkSingleComment(LEX_COMMENT_START);
                                    BEGIN(MULTI_COMMENT);
                                }
<INITIAL>"/*!/"                   {
                                    comment_type = LEX_COMMENT_TYPE_REM;
                                    chkSingleComment(LEX_COMMENT_START);
                                    BEGIN(MULTI_COMMENT);
                                }
<INITIAL>"/*"                   {
                                    comment_type = LEX_COMMENT_TYPE_REM;
                                    chkSingleComment(LEX_COMMENT_START);
                                    BEGIN(MULTI_COMMENT);
                                }

<INITIAL>"///"                   {
                                    comment_type = LEX_COMMENT_TYPE_DOC;
                                    chkSingleComment(LEX_COMMENT_START);
                                    BEGIN(SINGLE_COMMENT);
                                }
<INITIAL>"//!"                   {
                                    comment_type = LEX_COMMENT_TYPE_DOC;
                                    chkSingleComment(LEX_COMMENT_START);
                                    BEGIN(SINGLE_COMMENT);
                                }
<INITIAL>"//"                   {
                                    comment_type = LEX_COMMENT_TYPE_REM;
                                    chkSingleComment(LEX_COMMENT_START);
                                    BEGIN(SINGLE_COMMENT);
                                }


<INITIAL>^[ \t]*("#"|"%:"|"??=")      { 
                                    
                                    chkMacroLine(LEX_MACRO_START);
                                    BEGIN(PRE);
                                }

<INITIAL>("#"|"%:"|"??=")       {   
                                    lexer_tokenid = ETC_OP ;
                                    return(chkToken(lexer_tokenid));
                                }

<INITIAL>"asm"                  {   
                                    lexer_tokenid = ASM ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"auto"                 {
                                    lexer_tokenid = AUTO ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>[_]?"Bool"                {
                                    lexer_tokenid = BOOL ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"break"                {
                                    lexer_tokenid = BREAK ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"case"                 {
                                    lexer_tokenid = CASE ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"catch"                {   
                                    lexer_tokenid = CATCH ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"char"                 {
                                    lexer_tokenid = CHAR ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"class"                {   
                                    lexer_tokenid = CLASS ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"_Complex"             {
                                    lexer_tokenid = COMPLEX ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"const"                {
                                    lexer_tokenid = CONST_WD ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"const_cast"           {   
                                    lexer_tokenid = CONST_CAST ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"continue"             {
                                    lexer_tokenid = CONTINUE ;
                                    
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"default"              {
                                    lexer_tokenid = DEFAULT ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"delete"               {   
                                    lexer_tokenid = DELETE_WD ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"do"                   {
                                    lexer_tokenid = DO ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"double"               {
                                    lexer_tokenid = DOUBLE ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"dynamic_cast"         {   
                                    lexer_tokenid = DYNAMIC_CAST ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"else"                 {
                                    lexer_tokenid = ELSE ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"enum"                 {
                                    lexer_tokenid = ENUM ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"explicit"             {   
                                    lexer_tokenid = EXPLICIT ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"export"               {   
                                    lexer_tokenid = EXPORT ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"extern"               {
                                    lexer_tokenid = EXTERN ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"false"               {    
                                    lexer_tokenid = FALSE_WD ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"float"                {
                                    lexer_tokenid = FLOAT ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"for"                  {
                                    lexer_tokenid = FOR ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"friend"               {   
                                    lexer_tokenid = FRIEND ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"goto"                 {
                                    lexer_tokenid = GOTO ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"if"                   {
                                    lexer_tokenid = IF ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"_Imaginary"           {
                                    lexer_tokenid = IMAGINARY ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"inline"               {
                                    lexer_tokenid = INLINE ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"int"                  {
                                    lexer_tokenid = INT ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"long"                 {
                                    lexer_tokenid = LONG ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"mutable"              {   
                                    lexer_tokenid = MUTABLE ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"namespace"            {   
                                    lexer_tokenid = NAMESPACE ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"new"                  {   
                                    lexer_tokenid = NEW ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"operator"             {   
                                    lexer_tokenid = OPERATOR ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"private"             {    
                                    lexer_tokenid = PRIVATE ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"protected"             {  
                                    lexer_tokenid = PROTECTED ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"public"               {   
                                    lexer_tokenid = PUBLIC ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"register"             {
                                    lexer_tokenid = REGISTER ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"reinterpret_cast"     {   
                                    lexer_tokenid = REINTERPRET_CAST ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"restrict"             {
                                    lexer_tokenid = RESTRICT ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"return"               {
                                    lexer_tokenid = RETURN ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"short"                {
                                    lexer_tokenid = SHORT ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"signed"               {
                                    lexer_tokenid = SIGNED ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"sizeof"               {
                                    lexer_tokenid = SIZEOF ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"static"               {
                                    lexer_tokenid = STATIC ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"static_cast"          {   
                                    lexer_tokenid = STATIC_CAST ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"struct"               {
                                    lexer_tokenid = STRUCT ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"switch"               {
                                    lexer_tokenid = SWITCH ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"template"             {   
                                    lexer_tokenid = TEMPLATE ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"this"                 {   
                                    lexer_tokenid = THIS_WD ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"throw"                 {  
                                    lexer_tokenid = THROW ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"true"                 {   
                                    lexer_tokenid = TRUE_WD ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"try"                 {    
                                    lexer_tokenid = TRY ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"typedef"              {
                                    lexer_tokenid = TYPEDEF ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"typeid"                 { 
                                    lexer_tokenid = TYPEID ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"typename"             {   
                                    lexer_tokenid = TYPENAME ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"union"                {
                                    lexer_tokenid = UNION ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"unsigned"             {
                                    lexer_tokenid = UNSIGNED ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"using"             {  
                                    lexer_tokenid = USING ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"virtual"             {    
                                    lexer_tokenid = VIRTUAL ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"void"                 {
                                    lexer_tokenid = VOID_WD ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"volatile"             {
                                    lexer_tokenid = VOLATILE ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"wchar_t"             {    
                                    lexer_tokenid = WCHAR_T ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"while"                {
                                    lexer_tokenid = WHILE ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"and"                  {   
                                    lexer_tokenid = AND_OP ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"bitor"                  { 
                                    lexer_tokenid = ETC_OP ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"or"                  {    
                                    lexer_tokenid = OR_OP ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"xor"                  {   
                                    lexer_tokenid = ETC_OP ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"compl"                  { 
                                    lexer_tokenid = TILDE_OP ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"bitand"                  {    
                                    lexer_tokenid = ETC_OP ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"and_eq"                  {    
                                    lexer_tokenid = AND_ASSIGN ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"or_eq"                  { 
                                    lexer_tokenid = OR_ASSIGN ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"xor_eq"                  {    
                                    lexer_tokenid = XOR_ASSIGN ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"not"                  {   
                                    lexer_tokenid = ETC_OP ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"not_eq"                  {    
                                    lexer_tokenid = NE_OP ;
                                    return(chkToken(lexer_tokenid));
                                }

<INITIAL>{L}({L}|{D})*          {
                                    lexer_tokenid = IDENTIFIER ;
                                    return(chkToken(lexer_tokenid));
                                }

<INITIAL>0[xX]{H}+{IS}?         {
                                    lexer_tokenid = CONSTANT ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>0{D}+{IS}?             {
                                    lexer_tokenid = CONSTANT ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>{D}+{IS}?              {
                                    lexer_tokenid = CONSTANT ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>L?'(\\.|[^\\'])*'      {
                                    lexer_tokenid = CONSTANT ;
                                    return(chkToken(lexer_tokenid));
                                }

<INITIAL>{D}+{E}{FS}?           {
                                    lexer_tokenid = CONSTANT ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>{D}*"."{D}+({E})?{FS}? {
                                    lexer_tokenid = CONSTANT ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>{D}+"."{D}*({E})?{FS}? {
                                    lexer_tokenid = CONSTANT ;
                                    return(chkToken(lexer_tokenid));
                                }

<INITIAL>L?\"                   {
                                    chkTextString(LEX_STRING_START, 0);
                                    yymore();       
                                    BEGIN(STRING);
                                }

<INITIAL>"..."                  {
                                    lexer_tokenid = ELLIPSIS ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>">>="                  {
                                    lexer_tokenid = RIGHT_ASSIGN ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"<<="                  {
                                    lexer_tokenid = LEFT_ASSIGN ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"+="                   {
                                    lexer_tokenid = ADD_ASSIGN ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"-="                   {
                                    lexer_tokenid = SUB_ASSIGN ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"*="                   {
                                    lexer_tokenid = MUL_ASSIGN ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"/="                   {
                                    lexer_tokenid = DIV_ASSIGN ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"%="                   {
                                    lexer_tokenid = MOD_ASSIGN ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"&="                   {
                                    lexer_tokenid = AND_ASSIGN ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"^="                   {
                                    lexer_tokenid = XOR_ASSIGN ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"|="                   {
                                    lexer_tokenid = OR_ASSIGN ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>">>"                   {
                                    lexer_tokenid = RIGHT_OP ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"<<"                   {
                                    lexer_tokenid = LEFT_OP ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"++"                   {
                                    lexer_tokenid = INC_OP ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"--"                   {
                                    lexer_tokenid = DEC_OP ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"->"                   {
                                    lexer_tokenid = PTR_OP ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"&&"                   {
                                    lexer_tokenid = AND_OP ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"||"                   {
                                    lexer_tokenid = OR_OP ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"<="                   {
                                    lexer_tokenid = LE_OP ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>">="                   {
                                    lexer_tokenid = GE_OP ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"=="                   {
                                    lexer_tokenid = EQ_OP ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"!="                   {
                                    lexer_tokenid = NE_OP ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>";"                    {
                                    lexer_tokenid = SEMICOLON ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>("{"|"<%")             {
                                    lexer_tokenid = BRACEST ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>("}"|"%>")             {
                                    lexer_tokenid = BRACEED ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>","                    {
                                    lexer_tokenid = COMMA ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"::"                    {
                                    lexer_tokenid = DCOLON ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>":"                    {
                                    lexer_tokenid = COLON ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"="                    {
                                    lexer_tokenid = ASS_OP ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"("                    {
                                    lexer_tokenid = PARENST ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>")"                    {
                                    lexer_tokenid = PARENED ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>("["|"<:")             {
                                    lexer_tokenid = ETC_OP ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>("]"|":>")             {
                                    lexer_tokenid = ETC_OP ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"."                    {
                                    lexer_tokenid = ETC_OP ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"&"                    {
                                    lexer_tokenid = ETC_OP ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"!"                    {
                                    lexer_tokenid = ETC_OP ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"~"                    {
                                    lexer_tokenid = TILDE_OP ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"-"                    {
                                    lexer_tokenid = ETC_OP ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"+"                    {
                                    lexer_tokenid = ETC_OP ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"*"                    {
                                    lexer_tokenid = ETC_OP ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"/"                    {
                                    lexer_tokenid = ETC_OP ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"%"                    {
                                    lexer_tokenid = ETC_OP ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"<"                    {
                                    lexer_tokenid = ETC_OP ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>">"                    {
                                    lexer_tokenid = ETC_OP ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"^"                    {
                                    lexer_tokenid = ETC_OP ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"|"                    {
                                    lexer_tokenid = ETC_OP ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>"?"                    {
                                    lexer_tokenid = ETC_OP ;
                                    return(chkToken(lexer_tokenid));
                                }
<INITIAL>^[ \t\v\f]*[\r]?[\n]   {
                                    chkLineBreak(LEX_LINEBREAK_BRANK);
                                }
<INITIAL>[ \t\v\f]              {
                                    cntColumnInitial();
                                }
<INITIAL>[\\][\r]?[\n]          {
                                    chkLineBreak(LEX_LINEBREAK_ESCAPE);
                                }
<INITIAL>[\r]?[\n]              {
                                    chkLineBreak(LEX_LINEBREAK_NORMAL);
                                }
<INITIAL>.                      {
                                    
                                    lexer_tokenid = STRING_LITERAL ;
                                    return(chkToken(lexer_tokenid));
                                }

<MULTI_COMMENT>[^*\n]*          {
                                    chkMultiComment(LEX_COMMENT_TEXT);
                                }
<MULTI_COMMENT>[^*\n]*"\n"      {
                                    chkMultiComment(LEX_COMMENT_BREAK);
                                }
<MULTI_COMMENT>"*"+[^*/\n]*     {
                                    chkMultiComment(LEX_COMMENT_TEXT);
                                }
<MULTI_COMMENT>"*"+[^*/\n]*"\n" {
                                    chkMultiComment(LEX_COMMENT_BREAK);
                                }
<MULTI_COMMENT>"*"+"/"          {
                                    chkMultiComment(LEX_COMMENT_END);
                                    BEGIN(INITIAL);
                                }
<MULTI_COMMENT><<EOF>>          {
                                    chkMultiComment(LEX_COMMENT_EOF);
                                    BEGIN(INITIAL);
                                }
<SINGLE_COMMENT>[^\\\n]*        {
                                    chkSingleComment(LEX_COMMENT_TEXT);
                                }
<SINGLE_COMMENT>"\\"+[^\n]*     {
                                    chkSingleComment(LEX_COMMENT_TEXT);
                                }
<SINGLE_COMMENT>"\\"+[\r]?[\n]  {
                                    chkSingleComment(LEX_COMMENT_ESCAPE);
                                }
<SINGLE_COMMENT>"\n"            {
                                    chkSingleComment(LEX_COMMENT_END);
                                    BEGIN(INITIAL);
                                }
<SINGLE_COMMENT><<EOF>>         {
                                    chkSingleComment(LEX_COMMENT_EOF);
                                    BEGIN(INITIAL);
                                }
<PRE>"/*"                       {	
                                    if (pre_skiptokenmode == 0) {
                                        
                                        g_pre_comment.stline = lineno ;
                                        g_pre_comment.stcol = column + 1 ;
                                        g_pre_comment.edline = lineno ;
                                        g_pre_comment.edco = column + 1 ;
                                        pre_skiptokenmode = 1;  
                                    }
                                    chkMacroLine(LEX_MACRO_TEXT);
                                }
<PRE>"*/"                       {	
                                    chkMacroLine(LEX_MACRO_TEXT);
                                    if (pre_skiptokenmode == 1) {
                                        
                                        g_pre_comment.edline = lineno ;
                                        g_pre_comment.edco = column + 1 ;
                                        pre_skiptokenmode = 0;  
                                    }
                                }
<PRE>["]                       {	
                                    if (pre_skiptokenmode == 0) {
                                        
                                        g_pre_comment.stline = lineno ;
                                        g_pre_comment.stcol = column + 1 ;
                                        g_pre_comment.edline = lineno ;
                                        g_pre_comment.edco = column + 1 ;
                                        pre_skiptokenmode = 2;  
	                                    chkMacroLine(LEX_MACRO_TEXT);
                                    } else if (pre_skiptokenmode == 2) {
	                                    chkMacroLine(LEX_MACRO_TEXT);
                                        g_pre_comment.edline = lineno ;
                                        g_pre_comment.edco = column + 1 ;
                                        pre_skiptokenmode = 0;  
                                    }
                                    
                                }

<PRE>"if"                       {	
                                    int iFuncRet;
                                    iFuncRet = chkMacroEffectsIf(MACRO_TYPE_IF,
                                                              Flag_MACRO_TRUE);
                                    if(iFuncRet != CDMTRSPS_RET_OK){
                                        YY_FATAL_ERROR("[ERR] macro nest size is over flow ... "); // MSG_LOG_ID_C_00000813
                                    }
                                }
<PRE>"ifdef"                    {	
                                    int iFuncRet;
                                    iFuncRet = chkMacroEffectsIf(MACRO_TYPE_IFDEF,
                                                              Flag_MACRO_TRUE);
                                    if(iFuncRet != CDMTRSPS_RET_OK){
                                        YY_FATAL_ERROR("[ERR] macro nest size is over flow ... "); // MSG_LOG_ID_C_00000814
                                    }
                                }
<PRE>"ifndef"                   {	
                                    int iFuncRet;
                                    iFuncRet = chkMacroEffectsIf(MACRO_TYPE_IFNDEF,
                                                              Flag_MACRO_FALSE);
                                    if(iFuncRet != CDMTRSPS_RET_OK){
                                        YY_FATAL_ERROR("[ERR] macro nest size is over flow ... "); // MSG_LOG_ID_C_00000815
                                    }
                                }
<PRE>"elif"                     {	
                                    chkMacroEffectsElse(MACRO_TYPE_IFNDEF, Flag_MACRO_FALSE);
                                }
<PRE>"else"                     {	
                                    chkMacroEffectsElse(MACRO_TYPE_ELSE, Flag_MACRO_TRUE);
                                }
<PRE>"endif"                    {	
                                    chkMacroEffectsEndif(MACRO_TYPE_ENDIF);
                                }
<PRE>"include"                  {	
                                    chkMacroEffectsEtc(MACRO_TYPE_INCLUDE);
                                }
<PRE>"define"                   {	
                                    chkMacroEffectsEtc(MACRO_TYPE_DEFINE);
                                }
<PRE>"undef"                    {	
                                    chkMacroEffectsEtc(MACRO_TYPE_UNDEF);
                                }
<PRE>"line"                     {	
                                    chkMacroEffectsEtc(MACRO_TYPE_LINE);
                                }
<PRE>"error"                    {	
                                    chkMacroEffectsEtc(MACRO_TYPE_ERROR);
                                }
<PRE>"pragma"                   {	
                                    chkMacroEffectsEtc(MACRO_TYPE_PRAGMA);
                                }
<PRE>\\[\r]?[\n]                {	
                                    chkMacroLine(LEX_MACRO_ESCAPE);
                                }
<PRE>[ \t\v\f]+                 {	
                                    chkMacroLine(LEX_MACRO_BLANK);
                                }
<PRE>[\r]?[\n]                  {	
                                    if (pre_skiptokenmode == 1) {
                                        
                                        chkMacroLine(LEX_MACRO_ESCAPE);
                                    } else {
                                        
                                        chkMacroLine(LEX_MACRO_END);
                                        if(cntmacronest > 0){
                                            if(macronest[cntmacronest-1] != Flag_MACRO_TRUE){
                                                tkn_line_start = lineno ;   
                                                tkn_col_start = 1 ;         
                                                BEGIN(SKIP);
                                            } else {
                                                BEGIN(INITIAL);
                                            }
                                        } else {
                                            BEGIN(INITIAL);
                                        }
                                    }
                                }
<PRE>{L}+                       {	
                                    chkMacroLine(LEX_MACRO_TEXT);
                                }
<PRE>{D}+                       {	
                                    chkMacroLine(LEX_MACRO_NUMERIC);
                                }
<PRE>.                          {	
                                    chkMacroLine(LEX_MACRO_TEXT);
                                }
<PRE><<EOF>>                    {	
                                    chkMacroLine(LEX_MACRO_EOF);
                                    BEGIN(INITIAL);
                                }

<SKIP>^[ \t]*"#"                {
                                    
                                    igSkipLine = lineno; 
                                    chkMacroLine(LEX_MACRO_START);
                                    BEGIN(PRE);
                                }
<SKIP>[^#\n]*                   {
                                    chkSkipLine(LEX_SKIP_TEXT);         
                                }
<SKIP>\n                        {
                                    chkSkipLine(LEX_SKIP_BREAK);            
                                }
<SKIP>.                         {
                                    chkSkipLine(LEX_SKIP_TEXT);         

                                    cntColumnInitial();
                                    setKeywordParam(keywordparam,yytext);   
                                }
<SKIP><<EOF>>                   {
                                    chkSkipLine(LEX_SKIP_EOF);          
                                    BEGIN(INITIAL);
                                }
<STRING>\\[\r]?[\n]             {  
                                    chkTextString(LEX_STRING_ESCAPE,0);
                                    yymore();
                                }
<STRING>\n                      {
                                    lexer_tokenid = STRING_LITERAL ;
                                    chkTextString(LEX_STRING_BREAK,lexer_tokenid);
                                    BEGIN(INITIAL);
                                    return(lexer_tokenid);
                                }
<STRING>([^"\\\n]|\\\")*        {
                                    chkTextString(LEX_STRING_TEXT,0);
                                    yymore();
                                }
<STRING>"\\\\"                  {   
                                    chkTextString(LEX_STRING_TEXT,0);
                                    yymore();
                                }
<STRING>\"                      {
                                    lexer_tokenid = STRING_LITERAL ;
                                    chkTextString(LEX_STRING_END,lexer_tokenid);
                                    BEGIN(INITIAL);
                                    return(lexer_tokenid);
                                }
<STRING>.                       {
                                    chkTextString(LEX_STRING_TEXT,0);
                                    yymore();
                                }
<STRING><<EOF>>                 {
                                    lexer_tokenid = STRING_LITERAL ;
                                    chkTextString(LEX_STRING_EOF,lexer_tokenid);
                                    BEGIN(INITIAL);
                                    return(lexer_tokenid);
                                }

%%

void cdmtrSpsLexerInit()
{

    memset(macronest, 0x00, sizeof(macronest));
    memset(keywordname, 0x00, sizeof(keywordname));
    memset(keywordparam, 0x00, sizeof(keywordparam));

    yylineno = 1;
    lexer_tokenid = 0;
    cntmacronest = 0;
    macrotype = MACRO_TYPE_NONE;
    
    tkn_line_start = 0;
    tkn_line_end = 0;
    tkn_col_start = 0;
    tkn_col_end = 0;

    lineno = 1;
    column = 0;
    tcolumn = 0;
    preorder = LEX_PREORDER_INIT ;
    comment_type = 0;

    cntstrcol = 0;
    cntremline = 0;
    cntdocline = 0;
    cntprepline = 0;
    cntrem = 0;
    cntdoc = 0;
    cntprep = 0;

    pre_skiptokenmode = 0 ;
    
    memset(&g_pre_comment, 0x00, sizeof(struct pre_comment));
    igSkipLine = 0;
    
    if (yy_start != 0) {
        BEGIN(INITIAL);
    }
    yy_more_offset = 0;

    return;
}

/*!
    @brief }N(Ifn)̗L/֐
*/
int chkMacroEffectsIf(int imacrotype, int idefault)
{
    cntColumnStd();
    if(preorder == LEX_PREORDER_START) {
        
        macrotype = imacrotype ;
        cntmacronest++;
        if(cntmacronest >= CDMTRSPS_MAX_MACRO_NEST){
            return CDMTRSPS_RET_NG;
        }
        if(cntmacronest == 1){
            macronest[cntmacronest-1] = idefault ;
        } else {
            if(macronest[cntmacronest-2] == Flag_MACRO_TRUE){
                macronest[cntmacronest-1] = idefault ;
            } else {
                macronest[cntmacronest-1] = Flag_MACRO_SKIP ;
            }
        }
        cdmtrSpsStrcpyToArray(keywordname, yytext, CDMTRSPS_MAX_KEYWORD_NAME);
        preorder = LEX_PREORDER_PARAM ;
    } else {
        setKeywordParam(keywordparam,yytext);
        preorder++;
    }
    return CDMTRSPS_RET_OK;
}

/*!
    @brief }N(Elsen)̗L/֐
*/
void chkMacroEffectsElse(int imacrotype, int idefault)
{
    cntColumnStd();
    if(preorder == LEX_PREORDER_START) {
        macrotype = imacrotype ;
        if(cntmacronest == 0) {
            cntmacronest++;
            macronest[cntmacronest-1] = Flag_MACRO_SKIP ;
        }

        switch(macronest[cntmacronest-1]){
        case Flag_MACRO_TRUE:
            macronest[cntmacronest-1] = Flag_MACRO_SKIP;
            break;
        case Flag_MACRO_FALSE:
            macronest[cntmacronest-1] = idefault;
            break;
        }
        
        cdmtrSpsStrcpyToArray(keywordname, yytext, CDMTRSPS_MAX_KEYWORD_NAME);
        preorder = LEX_PREORDER_PARAM ;
    } else {
        setKeywordParam(keywordparam,yytext);
        preorder++;
    }
}

/*!
    @brief }N(Endifn)̊֐
*/
void chkMacroEffectsEndif(int imacrotype)
{
    cntColumnStd();
    if(preorder == LEX_PREORDER_START) {
        if(cntmacronest > 0){
            macrotype = imacrotype ;
            macronest[cntmacronest-1] = Flag_MACRO_TRUE;

            cntmacronest--;
            cdmtrSpsStrcpyToArray(keywordname, yytext, CDMTRSPS_MAX_KEYWORD_NAME);
            preorder = LEX_PREORDER_PARAM ;
        } else {
            macrotype = imacrotype ;
            cntmacronest = 0;
            cdmtrSpsStrcpyToArray(keywordname, yytext, CDMTRSPS_MAX_KEYWORD_NAME);
            preorder = LEX_PREORDER_PARAM ;
        }
    } else {
        setKeywordParam(keywordparam,yytext);
        preorder++;
    }
}

/*!
    @brief }N(̑)̊֐
*/

void chkMacroEffectsEtc(int imacrotype)
{
    cntColumnStd();
    if(preorder == LEX_PREORDER_START) {
        macrotype = imacrotype ;
        cdmtrSpsStrcpyToArray(keywordname, yytext, CDMTRSPS_MAX_KEYWORD_NAME);
        preorder = LEX_PREORDER_PARAM ;
    } else {
        setKeywordParam(keywordparam,yytext);
        preorder++;
    }

}


/*!
    @brief }N֐
*/
void chkMacroLine(int ipretype)
{
    int imccond = 0;

    switch(ipretype){
    case LEX_MACRO_START :
        keywordname[0] = '\0';
        keywordparam[0] = '\0';
        cntprepline = 1;
        cntprep++;
        tkn_line_start = lineno ;
        tkn_col_start = column + 1;
        cntColumnStd();
        preorder = LEX_PREORDER_START ;
        break;
    case LEX_MACRO_ESCAPE :
    case LEX_MACRO_BLANK :
        cntColumnStd();
        if(preorder == LEX_PREORDER_NAME) {
            preorder = LEX_PREORDER_PARAM ;
        }
        if(ipretype == LEX_MACRO_ESCAPE){
            cntLineStd();
            cntprepline++;
        } else {
            
        }
        break;
    case LEX_MACRO_TEXT :
    case LEX_MACRO_NUMERIC :
        cntColumnStd();
        if(preorder == LEX_PREORDER_START) {
            macrotype = MACRO_TYPE_OTHER ;
            cdmtrSpsStrcpyToArray(keywordname, yytext, CDMTRSPS_MAX_KEYWORD_NAME);
            preorder = LEX_PREORDER_NAME ;
        } else if(preorder == LEX_PREORDER_NAME){
            setKeywordParam(keywordname,yytext);
        } else {
            if (pre_skiptokenmode != 1){
                if(ipretype == LEX_MACRO_NUMERIC && strlen(keywordparam) == 0){
                    checkSkipIf0();
                }
                setKeywordParam(keywordparam,yytext);
                preorder++;
            }
        }
        break;
    case LEX_MACRO_END :
    case LEX_MACRO_EOF :
        if(cntmacronest > 0){
            if(macrotype == MACRO_TYPE_IF0 && preorder == LEX_PREORDER_PARAM +1 && macronest[cntmacronest-1] == Flag_MACRO_TRUE){
                imccond = macronest[cntmacronest-1] = Flag_MACRO_FALSE;
            } else {
                if(macrotype == MACRO_TYPE_IF0){
                    macrotype = MACRO_TYPE_IF ;
                }
                imccond = macronest[cntmacronest-1] ;
            }
        } else {
            imccond = Flag_MACRO_TRUE;
        }
        
        pre_skiptokenmode = 0 ;
        tkn_line_end = lineno ;
        if(ipretype == LEX_MACRO_END){
            cntColumnStd();
            tkn_col_end = column ;
            cntLineStd();
        } else {
            tkn_col_end = column ;
        }
        if(p_method->pefMacro != NULL){
            (*(p_method->pefMacro))(macrotype, cntprep, cntprepline, tkn_line_start, tkn_col_start, tkn_line_end, tkn_col_end, cntmacronest, imccond, macronest, cntmacronest, igSkipLine, keywordname, keywordparam);
        }

        tkn_line_start = 0;
        tkn_col_start = 0;
        keywordname[0]  = '\0';
        keywordparam[0] = '\0';
        macrotype = MACRO_TYPE_NONE ;
        preorder = LEX_PREORDER_INIT ;
        break;
    }
}

/*!
    @brief }`Rg֐
*/
void chkMultiComment(int icmttype)
{

    switch(icmttype){
    case LEX_COMMENT_START :
        tkn_line_start = lineno ;
        tkn_col_start = column + 1;
        cntColumnStd();
        if(comment_type == LEX_COMMENT_TYPE_REM){
            cntrem++;
            cntremline = 1;
        } else {
            cntdoc++;
            cntdocline = 1;
        }
        keywordparam[0] = '\0';
        cdmtrSpsStrcpyToArray(keywordparam, yytext, CDMTRSPS_MAX_LINE_BUF);
        break;
    case LEX_COMMENT_TEXT :
        cntColumnStd();
        setKeywordParam(keywordparam,yytext);
        break;
    case LEX_COMMENT_BREAK :
        cntColumnStd();

        if(comment_type == LEX_COMMENT_TYPE_REM){
            cntremline++;
        } else {
            cntdocline++;
        }
        setKeywordParam(keywordparam,yytext);
        cntLineStd();
        break;
    default :
        tkn_line_end = lineno ;
        if(icmttype == LEX_COMMENT_END){
            cntColumnStd();
        }
        tkn_col_end = column ;
        setKeywordParam(keywordparam,yytext);
        if(p_method->pefComment != NULL){
            if(comment_type == LEX_COMMENT_TYPE_REM){
                (*(p_method->pefComment))(comment_type-1,cntrem,cntremline,tkn_line_start,tkn_col_start,tkn_line_end,tkn_col_end,keywordparam);
            } else {
                (*(p_method->pefComment))(comment_type-1,cntdoc,cntdocline,tkn_line_start,tkn_col_start,tkn_line_end,tkn_col_end,keywordparam);
            }
        }
        comment_type = LEX_COMMENT_TYPE_NON;
        break;
    }
}


/*!
    @brief VORg֐
*/
void chkSingleComment(int icmttype)
{

    switch(icmttype){
    case LEX_COMMENT_START :
        tkn_line_start = lineno ;
        tkn_col_start = column + 1;
        cntColumnStd();
        if(comment_type == LEX_COMMENT_TYPE_REM){
            cntrem++;
            cntremline = 1;
        } else {
            cntdoc++;
            cntdocline = 1;
        }
        keywordparam[0] = '\0';
        cdmtrSpsStrcpyToArray(keywordparam, yytext, CDMTRSPS_MAX_LINE_BUF);
        break;
    case LEX_COMMENT_TEXT :
        cntColumnStd();
        setKeywordParam(keywordparam,yytext);
        break;
    case LEX_COMMENT_ESCAPE :
        cntColumnStd();
        if(comment_type == LEX_COMMENT_TYPE_REM){
            cntremline++;
        } else {
            cntdocline++;
        }
        setKeywordParam(keywordparam,yytext);
        cntLineStd();
        break;
    default :
        tkn_line_end = lineno ;
        if(icmttype == LEX_COMMENT_END){
            cntColumnStd();
            tkn_col_end = column ;
            cntLineStd();
        } else {
            tkn_col_end = column ;
        }
        if(p_method->pefComment != NULL){
            if(comment_type == LEX_COMMENT_TYPE_REM){
                (*(p_method->pefComment))(comment_type-1,cntrem,cntremline,tkn_line_start,tkn_col_start,tkn_line_end,tkn_col_end,keywordparam);
            } else {
                (*(p_method->pefComment))(comment_type-1,cntdoc,cntdocline,tkn_line_start,tkn_col_start,tkn_line_end,tkn_col_end,keywordparam);
            }
        }
        comment_type = LEX_COMMENT_TYPE_NON;
        break;
    }
}

/*!
    @brief XLbv֐
*/
void chkSkipLine(int iskiptype)
{
    cntColumnStd();
    switch(iskiptype){
    case LEX_SKIP_TEXT :
        setKeywordParam(keywordparam,yytext);
        break;
    case LEX_SKIP_BREAK :
        tkn_line_end = lineno ;
        tkn_col_end = column ;
        if(p_method->pefLineSkip != NULL){
            (*(p_method->pefLineSkip))(tkn_line_start,tkn_col_start,tkn_line_end,tkn_col_end,keywordparam);
        }
        cntLineStd();
        keywordparam[0] = '\0';
        tkn_line_start = lineno ;
        tkn_col_start = 1 ;
        break;
    case LEX_SKIP_EOF :
        tkn_line_end = lineno ;
        tkn_col_end = column ;
        if(p_method->pefLineSkip != NULL){
            (*(p_method->pefLineSkip))(tkn_line_start,tkn_col_start,tkn_line_end,tkn_col_end,keywordparam);
        }
        keywordparam[0] = '\0';
        break;
    }
}

/*!
    @brief _uNH[g񏈗֐
*/
void chkTextString(int istrtype, int tknid)
{
    int icnt = 0;

    switch(istrtype){
    case LEX_STRING_START :
        cntstrcol = yyleng ;
        cntColumnInitial();
        tkn_line_start = lineno ;
        break;
    case LEX_STRING_ESCAPE :
        icnt = yyleng - cntstrcol ;
        column = column + icnt ;
        tcolumn = tcolumn + icnt ;
        cntstrcol = yyleng ;
        cntLineStd();
        break;
    case LEX_STRING_BREAK :
        icnt = yyleng - cntstrcol ;
        tkn_col_end = column = column + icnt ;
        tcolumn = tcolumn + icnt ;
        tkn_line_end = lineno ;
        if(p_method->pefTokenString != NULL){
            (*(p_method->pefTokenString))(tknid, tkn_line_start, tkn_col_start, tkn_line_end, tkn_col_end, yytext);
        }
        cntstrcol = yyleng ;
        cntLineStd();
        break;
    case LEX_STRING_TEXT :
        icnt = yyleng - cntstrcol ;
        column = column + icnt ;
        tcolumn = tcolumn + icnt ;
        cntstrcol = yyleng ;
        break;
    case LEX_STRING_END :
        icnt = yyleng - cntstrcol ;
        tkn_col_end = column = column + icnt ;
        tcolumn = tcolumn + icnt ;
        tkn_line_end = lineno ;
        if(p_method->pefTokenString != NULL){
            (*(p_method->pefTokenString))(tknid, tkn_line_start, tkn_col_start, tkn_line_end, tkn_col_end, yytext);
        }
        cntstrcol = yyleng ;
        break;
    case LEX_STRING_EOF :
        tkn_col_end = column ;
        tkn_line_end = lineno ;
        if(p_method->pefTokenString != NULL){
            (*(p_method->pefTokenString))(tknid, tkn_line_start, tkn_col_start, tkn_line_end, tkn_col_end, yytext);
        }
        break;
    }
}


/*!
    @brief Wg[N֐
*/
int chkToken(int tknid)
{
    tkn_line_start = lineno ;
    cntColumnInitial();
    if(p_method->pefTokenString != NULL){
        (*(p_method->pefTokenString))(tknid, tkn_line_start, tkn_col_start, tkn_line_end, tkn_col_end, yytext);
    }
    return(tknid);
}

/*!
    @brief s֐
*/
void chkLineBreak(int ibranktype)
{
    tkn_line_start = lineno ;
    cntColumnInitial();
    cntLineStd();


    if(p_method->pefLineBreak != NULL){
        (*(p_method->pefLineBreak))(ibranktype, tkn_line_start,tkn_col_start,tkn_line_end,tkn_col_end);
    }
}


/*!
    @brief XLbvs
*/
void checkSkipIf0()
{
    int num;
    if(preorder == LEX_PREORDER_PARAM && macrotype == MACRO_TYPE_IF){
        num = atoi(yytext);
        if(num == 0){
            macrotype = MACRO_TYPE_IF0 ;
        }
    }
}

/*!
    @brief JEg
*/
void cntColumnInitial()
{
    tkn_col_start = column + 1;
    cntColumnStd();
    tkn_col_end = column ;
    tkn_line_end = lineno ;
}

void cntColumnStd()
{
    column += yyleng;
    tcolumn += yyleng;
}

void cntLineStd()
{
    column = 0;
    lineno++;
}

void setKeywordParam(char* ptkwdpm, char* pttxt)
{
    if(CDMTRSPS_MAX_LINE_BUF > strlen(ptkwdpm) + strlen(pttxt)){
        strcat(ptkwdpm,pttxt);
    } else {
        
    }
}

int yywrap(void)
{
    if(YY_START == INITIAL){
        if(p_method->pefFileEof != NULL){
            (*(p_method->pefFileEof))(lineno);
        }
    }
    return 1;
}

#ifdef YY_USE_PROTOS
static void my_fatal_error( yyconst char msg[] )
#else
static void my_fatal_error( msg )
char msg[];
#endif
{
	(void) fprintf( stderr, "%s\n", msg );

	yyrestart( yyin );

	longjmp(g_cdmtrspsiface_jmp_buf, -1);
}
