/*
 *  source code metrics counter
 *  Copyright (C) 2015  NEC Corporation.
 *  
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
#ifndef CDMTR_STMT_LOG_H
#define CDMTR_STMT_LOG_H

#include <stdio.h>

#include "CDMtrStmt.h"
#include "CDMtrMessage.h"

#define CDMTR_LOG_WHITE_BOX 0
#if CDMTR_LOG_WHITE_BOX
#define PASS_CHECK      printf(MSG_LOG_ID_C_00000711, __FILE__, __LINE__)    //* MSG_LOG_ID_C_00000711
#else
#define PASS_CHECK
#endif
 
#define CDMTR_STMT_LOG_FUNC(x)   if(CDMtrStmtLogLevel == CDMtrStmtLogON) { x }
 
#if defined(_DEBUG)
#define CDMTR_STMT_LOG_DEBUG(x)   if(CDMtrStmtLogLevel == CDMtrStmtLogON) { x }
#else
#define CDMTR_STMT_LOG_DEBUG(x)
#endif
 
//* MSG_LOG_ID_C_00000712
#define CDMTR_STMT_LOG_COUNT(x)   if(CDMtrStmtLogLevel == CDMtrStmtLogON) {\
        CDMtrStmtLogFileOut(MSG_LOG_ID_C_00000712, __LINE__, x);\
}

/* extern */
extern int CDMtrStmtLogLevel;
extern FILE *CDMtrStmtLogFile;

extern int CDMtrStmtLogFileOpen(const _TCHAR *);

extern void CDMtrStmtLogFileClose();

extern void CDMtrStmtLogFileOut(const char *, ...);

#endif
