/*
 *  source code metrics counter
 *  Copyright (C) 2015  NEC Corporation.
 *  
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */



#ifndef CDMTRVBIFACE_H_
#define CDMTRVBIFACE_H_

#include "CDMtrCntFormat.h"


#define VBIF_RET_OK (0)
#define VBIF_RET_NG (1)

#define VBIF_PHASE_1    (1)
#define VBIF_PHASE_2    (2)
#define VBIF_PHASE_3    (3)
#define VBIF_PHASE_4    (4)

#define VBIF_PHASE_INIT    (0)

#define VBIF_STRSIZE_MAX (1024)

#define VBIF_DEBUGMODE_NONE        0x00000000
#define VBIF_DEBUGMODE_1           0x00000001
#define VBIF_DEBUGMODE_2           0x00000002

#define IS_DEBUG1            (pParamInfo->iDebugMode & VBIF_DEBUGMODE_1)
#define IS_DEBUG2            (pParamInfo->iDebugMode & VBIF_DEBUGMODE_2)
#define IS_DEBUG             (pParamInfo->iDebugMode & (VBIF_DEBUGMODE_1 | VBIF_DEBUGMODE_2))

#define VBIF_TYPE_ADDHANDLER           (1)
#define VBIF_TYPE_CLASS                (2)
#define VBIF_TYPE_ENUM                 (3)
#define VBIF_TYPE_CUSTOMEVENT          (4)
#define VBIF_TYPE_FUNCTION             (5)
#define VBIF_TYPE_GET                  (6)
#define VBIF_TYPE_IF                   (7)
#define VBIF_TYPE_INTERFACE            (8)
#define VBIF_TYPE_MODULE               (9)
#define VBIF_TYPE_NAMESPACE            (10)
#define VBIF_TYPE_OPERATOR             (11)
#define VBIF_TYPE_PROPERTY             (12)
#define VBIF_TYPE_RAISEEVENT           (13)
#define VBIF_TYPE_REMOVEHANDLER        (14)
#define VBIF_TYPE_SELECT               (15)
#define VBIF_TYPE_SET                  (16)
#define VBIF_TYPE_STRUCTURE            (17)
#define VBIF_TYPE_SUB                  (18)
#define VBIF_TYPE_SYNCLOCK             (19)
#define VBIF_TYPE_TRY                  (20)
#define VBIF_TYPE_WHILE                (21)
#define VBIF_TYPE_WITH                 (22)
#define VBIF_TYPE_USING                (23)
#define VBIF_TYPE_CATCH                (24)
#define VBIF_TYPE_FINALLY              (25)
#define VBIF_TYPE_DO                   (26)
#define VBIF_TYPE_LOOP                 (27)
#define VBIF_TYPE_FOR                  (28)
#define VBIF_TYPE_NEXT                 (29)
#define VBIF_TYPE_ELSE                 (30)
#define VBIF_TYPE_ELSEIF               (31)
#define VBIF_TYPE_CASE                 (32)
#define VBIF_TYPE_IF2                  (33)
#define VBIF_TYPE_IIF                  (34)
#define VBIF_TYPE_IFOP                 (35)
#define VBIF_TYPE_CASEELSE             (36)

#define VBIF_TYPE_END_ADDHANDLER       (101)
#define VBIF_TYPE_END_CLASS            (102)
#define VBIF_TYPE_END_ENUM             (103)
#define VBIF_TYPE_END_CUSTOMEVENT      (104)
#define VBIF_TYPE_END_FUNCTION         (105)
#define VBIF_TYPE_END_GET              (106)
#define VBIF_TYPE_END_IF               (107)
#define VBIF_TYPE_END_INTERFACE        (108)
#define VBIF_TYPE_END_MODULE           (109)
#define VBIF_TYPE_END_NAMESPACE        (110)
#define VBIF_TYPE_END_OPERATOR         (111)
#define VBIF_TYPE_END_PROPERTY         (112)
#define VBIF_TYPE_END_RAISEEVENT       (113)
#define VBIF_TYPE_END_REMOVEHANDLER    (114)
#define VBIF_TYPE_END_SELECT           (115)
#define VBIF_TYPE_END_SET              (116)
#define VBIF_TYPE_END_STRUCTURE        (117)
#define VBIF_TYPE_END_SUB              (118)
#define VBIF_TYPE_END_SYNCLOCK         (119)
#define VBIF_TYPE_END_TRY              (120)
#define VBIF_TYPE_END_WHILE            (121)
#define VBIF_TYPE_END_WITH             (122)
#define VBIF_TYPE_END_USING            (123)

#define VBIF_TYPE_PREP_CONST           (201)
#define VBIF_TYPE_PREP_EXSOURCE        (202)
#define VBIF_TYPE_PREP_ELSE            (203)
#define VBIF_TYPE_PREP_ELSEIF          (204)
#define VBIF_TYPE_PREP_ELSEIFFALSE     (205)
#define VBIF_TYPE_PREP_REGION          (206)
#define VBIF_TYPE_PREP_IFFALSE         (207)
#define VBIF_TYPE_PREP_IF              (208)
#define VBIF_TYPE_PREP_ENDIF           (209)
#define VBIF_TYPE_PREP_ENDEXSOURCE     (210)
#define VBIF_TYPE_PREP_ENDREGION       (211)
#define VBIF_TYPE_PREP_EXTCHKSUM       (212)
#define VBIF_TYPE_PREP_OTHER           (213)


#define VBIF_STAT_ON             (1)
#define VBIF_STAT_OFF            (0)

#define BIT_CUSTOMEVENT_NONE (0x00000000)
#define BIT_CUSTOMEVENT      (0x00000001)
#define BIT_ADDHANDLER       (0x00000002)
#define BIT_RAISEEVENT       (0x00000004)
#define BIT_REMOVEHANDLER    (0x00000008)

#define BIT_NOTBLOCK_NONE      (0x00000000)
#define BIT_NOTBLOCK_INTERFACE (0x00000001)


typedef struct _NAME_T {
    struct _NAME_T *next;
    struct _NAME_T *parent;
    int             iType;
    int             iId;
    char            chName[VBIF_STRSIZE_MAX + 1];
} NAME_T;

typedef struct {
    NAME_T *pTopName;
    NAME_T *pLastName;
    NAME_T *pCurName;
    int     iMaxid;
} PREFNAME_INFO_T;

typedef struct {
    char    *pcTargetFile;
    char    *pcMetricFilePath;
    char    *pcSourceID;
    char    *pcErrorOutput;
    int        iDebugMode;



    int     iStmtFlg;
    FILE    *errfile;
} PARAM_INFO_T;

extern PARAM_INFO_T  *pParamInfo;

typedef struct {
    int     func_id;
    NAME_T *func_name;
    int     func_startline;
    int     func_endline;
    char   *param_name;
    int     status;
    int     type;
    int     startindex;
    int     endindex;
    int     effective;
} FUNCTION_TABLE_T;

extern FUNCTION_TABLE_T *pFunctionTable;

typedef struct {
    int   line_number;
    int   status;
    int   namespace_delim;
    int   class_delim;
    int   func_delim;
    int   func_id;
    int   func_line;
    int   effective_line;
    int   comment_line;
    int   blank_line;
    int   eloc_kind;
    int   prep_kind;
    int   cloc_kind;
    int   statements;
    int   control_statements;
    int   cyclowc;
    int   branches;
    int   cndops;
    int   nest_level;
    int   line_continuation;
    int   comment_continuation;
    int   index;
    int   offset;
    int   type;
    int   nameid;
}  METRIC_TABLE_T;

extern METRIC_TABLE_T *pMetricTable;

typedef struct {
    char *pcSource;
    int  iSize;
    int  iMaxIndex;
    int  iMaxLineno;
    int  iMaxFuncid;
    int  iFuncCnt;
} SOURCE_INFO_T;

extern SOURCE_INFO_T    *pSourceInfo;

typedef struct {
    char *pcStart;
    int  iCurIndex;
    int  iCurPos;
    int  iSize;
    int  iCurFuncid;
    int  iCustomEvent;
    int  iNotBlock;
} PARSE_INFO_T;

extern PARSE_INFO_T *pParseInfo;

typedef struct {
    int (*pefSourceInput)(char *buffer, int max_size);
    int (*pefGetFuncID)();
    NAME_T *(*pefGetNameInfo)(int itype);
    void (*pefEndNameInfo)();
    void (*pefDebugLog)(int idebugmode, char *pFormat, ...);
} ParsesEventFunc;


int cdmtrVBIfaceInit(PARAM_INFO_T *pcfilepath);

void cdmtrVBIfaceFinal();

int cdmtrVBIfaceParses(int iphase);

int cdmtrVBIfaceOutput();

#endif
