/*
 *  source code metrics counter
 *  Copyright (C) 2015  NEC Corporation.
 *  
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#ifndef _CDMTRVBTYPEDEF_H_
#define _CDMTRVBTYPEDEF_H_

#define VBF_STRSIZE_MAX (1024)
#define VBF_TRUE      1
#define VBF_FALSE     0

#define VBF_FUNCDTL_NONE            (0x0000)
#define VBF_FUNCDTL_NAMEONLY        (0x0001)
#define VBF_FUNCDTL_PARAMONLY       (0x0002)
#define VBF_FUNCDTL_ALL             (VBF_FUNCDTL_NAMEONLY | VBF_FUNCDTL_PARAMONLY)

typedef struct {
    int itype;
    int ikind;
    int idetail;
    int iname_idx;
    int iparam_idx;
    char str_name[VBF_STRSIZE_MAX];
    char str_param[VBF_STRSIZE_MAX];
} VBF_FUNCINFO_T;

extern VBF_FUNCINFO_T *pFuncInfo;

typedef struct {
    int itype;
    int istatements;
    int iprepkind;
    int ibranches;
    int icontrols;
    int icyclowc;
    int inests;
    int icndops;
} VBF_STATINFO_T;
extern VBF_STATINFO_T *pStatInfo;

#endif
